/*
 * Accordeur.java
 *
 * Created on 9 octobre 2006, 12:14
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author ygorra
 */

public class Accordeur extends javax.swing.JFrame{
    int width;
    int height;
    ContexteFlts Contexte;
    AnalyseDeSon sender;
    JFrame f;
    JPanel PanelApplications;
    AccordeurPlotPanel accordeur;
    JButton jButton_dictee_2_notes_ascendant;
    JButton jButton_choix_intervalles;
    JButton jButton_accordeur;
    JCheckBox jCheckBox_cle_de_sol;
    JCheckBox jCheckBox_cle_de_fa;
    JCheckBox jCheckBox_piano;
    JPanel PanelAff;
    JPanel PanelParam;
    JPanel PanelHaut;
    JCheckBox jCheckBox_recale;

    public caracteristiques_intervalle caract_intervalles=null;
    public Accordeur(AnalyseDeSon sender_, ContexteFlts Contexte_,TargetDataLine line1,AudioFormat format,int w,int h){
        width=w;
        height=h;
        Contexte=Contexte_;
        sender=sender_;
        f =this;
        f.setName("ACCORDEUR DE F0="+String.valueOf(sender.F_MINI)+"Hz a F1="+String.valueOf(sender.F_MAXI_A_GARDER)+" Hz");
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                for (int i=0;i<f.getContentPane().getComponents().length;i++) {
                    if (f.getContentPane().getComponent(i).getName()=="accordeur") {
                        AccordeurPlotPanel accordeur =(AccordeurPlotPanel) f.getContentPane().getComponent(i);
                        if (accordeur.Contexte!=null) {
                            accordeur.Contexte.running=false;
                        }
                    }
                }
                f.setVisible(false);
                f.dispose();
            }
        });
        NotesEtFrequences notes =new NotesEtFrequences(10f,20f,440);
        caract_intervalles=new caracteristiques_intervalle();
        caract_intervalles.intervalles=new boolean[ notes.INTERVALLE_MAX+1];
        for (int i=0;i<caract_intervalles.intervalles.length;i++) {
           caract_intervalles.intervalles[i]=false; 
        }
        caract_intervalles.intervalles[0]=true;
        caract_intervalles.intervalles[2]=true;
        caract_intervalles.ascendant=true;
        caract_intervalles.descendant=false;
        caract_intervalles.dune_note_a_la_suivante=false;
        caract_intervalles.nb_notes=2;
        caract_intervalles.begin_at_0=true;        
        // f.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        // Boutons et Reglage
        
        jButton_dictee_2_notes_ascendant=new JButton();
        jButton_dictee_2_notes_ascendant.setText("Lancer Dictee d intervalles");
        jButton_dictee_2_notes_ascendant.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_dictee_2_notes_ascendant_ActionPerformed(evt);
            }
        });
        jButton_choix_intervalles=new JButton();
        jButton_choix_intervalles.setText("Parametres de la Dictee d intervalles");
        jButton_choix_intervalles.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_choix_intervalles_ActionPerformed(evt);
            }
        });

        jButton_accordeur=new JButton();
        jButton_accordeur.setText("Accordeur");
        jButton_accordeur.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_accordeur_ActionPerformed(evt);
            }
        });
     // CheckBox Cle de Sol
        jCheckBox_cle_de_sol=new JCheckBox();
        jCheckBox_cle_de_sol.setText(" affichage notes en cle de sol");
        jCheckBox_cle_de_sol.setSelected(true);
        jCheckBox_cle_de_sol.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox_cle_de_sol_ActionPerformed(evt);
            }
        });
     // CheckBox Cle de fa
        jCheckBox_cle_de_fa=new JCheckBox();
        jCheckBox_cle_de_fa.setText(" affichage notes en cle de fa");
        jCheckBox_cle_de_fa.setSelected(false);
        jCheckBox_cle_de_fa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jCheckBox_cle_de_fa_ActionPerformed(evt);
            }
        });
     // CheckBox piano
        jCheckBox_piano=new JCheckBox();
        jCheckBox_piano.setText(" affichage clavier piano");
        jCheckBox_piano.setSelected(true);
     // CheckBox recale
        jCheckBox_recale=new JCheckBox();
        jCheckBox_recale.setText("recaler hms/note pour dictee");
        jCheckBox_recale.setSelected(true);

     // Applications  
        PanelApplications =new JPanel();
        PanelApplications.setLayout(new GridLayout(4,1));
        PanelApplications.setBorder (javax.swing.BorderFactory.createTitledBorder("Applications"));
        PanelApplications.add(jButton_accordeur);
        PanelApplications.add(jButton_dictee_2_notes_ascendant);
   // Affichage
        this.PanelAff=new JPanel();
        PanelAff.setBorder (javax.swing.BorderFactory.createTitledBorder("Affichage"));
        PanelAff.setLayout(new GridLayout(4,1));
        PanelAff.add(this.jCheckBox_cle_de_sol);
        PanelAff.add(this.jCheckBox_cle_de_fa);
        PanelAff.add(this.jCheckBox_piano);
        

   // Parametres
        this.PanelParam=new JPanel();
        PanelParam.setBorder (javax.swing.BorderFactory.createTitledBorder("Parametres"));
        PanelParam.setLayout(new GridLayout(4,1));
        PanelParam.add(jButton_choix_intervalles);
        PanelParam.add(this.jCheckBox_recale);
   // Panel En Haut     
        PanelHaut=new JPanel();
        PanelHaut.setLayout(new GridLayout(1,3));
        PanelHaut.add(PanelApplications);
        PanelHaut.add(PanelAff);
        PanelHaut.add(PanelParam);
        
   // Accordeur en bas
        accordeur = new AccordeurPlotPanel(sender,Contexte,line1,format,width,height);
   // PanelPrincipal
        Container c = f.getContentPane();
        c.setLayout(new GridLayout(2,1));
        c.add(PanelHaut);
        c.add( accordeur );

        f.pack();
        f.setSize(640,480);
        f.setLocation(20,20);
        f.setVisible(true);
        
    }
      private void jButton_dictee_2_notes_ascendant_ActionPerformed(java.awt.event.ActionEvent evt) {
        accordeur.stop_and_wait();
        // arret du thread de l'accordeur 
        accordeur.setName(jButton_dictee_2_notes_ascendant.getText());
        accordeur.x0_partition_relative=0.01f;
        accordeur.x1_partition_relative=0.9f;
        accordeur.y0_partition_relative=0.1f;
        accordeur.y1_partition_relative=0.9f;
        accordeur.COEFF_PIANO=0f;
        if (this.jCheckBox_piano.isSelected()) {
            accordeur.COEFF_PIANO=0.25f;
        }
        accordeur.TYPE_CLE=ctes_notes.CLE_DE_FA;
        if (this.jCheckBox_cle_de_sol.isSelected()) {
            accordeur.TYPE_CLE=ctes_notes.CLE_DE_SOL;
        }
       accordeur.RECALE_HMS=this.jCheckBox_recale.isSelected();
    

     // definition de la dictee
        NotesDictee nd=new NotesDictee();
        nd.descendant=this.caract_intervalles.descendant;
        nd.ascendant=this.caract_intervalles.ascendant;
        nd.begin_at_0=this.caract_intervalles.begin_at_0;
        accordeur.nb_notes_a_chanter=this.caract_intervalles.nb_notes;
        nd.set_intervalles(this.caract_intervalles.intervalles);
      // transmission a l'accordeur et execution  
        accordeur.notes_dictee=nd;
        accordeur.restart(accordeur.DICTEE_MUSICALE);
     }    
  
     private void jButton_choix_intervalles_ActionPerformed(java.awt.event.ActionEvent evt) {
        choix_intervalles c1=new choix_intervalles(this.caract_intervalles);
     }    
     private void jButton_accordeur_ActionPerformed(java.awt.event.ActionEvent evt) {
        accordeur.stop_and_wait();  
         // arret du thread de l'accordeur 
        accordeur.x0_partition_relative=0.01f;
        accordeur.x1_partition_relative=0.4f;
        accordeur.y0_partition_relative=0.01f;
        accordeur.y1_partition_relative=0.9f;
        accordeur.x0_module_relative=accordeur.x1_partition_relative;
        accordeur.x1_module_relative=accordeur.x0_module_relative+0.1f;
        accordeur.x0_decal_relative=accordeur.x1_module_relative+0.05f;
        accordeur.x1_decal_relative=0.99f;
        accordeur.COEFF_PIANO=0f;
        if (this.jCheckBox_piano.isSelected()) {
            accordeur.COEFF_PIANO=0.25f;
        }
        accordeur.TYPE_CLE=ctes_notes.CLE_DE_FA;
        if (this.jCheckBox_cle_de_sol.isSelected()) {
            accordeur.TYPE_CLE=ctes_notes.CLE_DE_SOL;
        }
        accordeur.RECALE_HMS=this.jCheckBox_recale.isSelected();

        accordeur.setName(jButton_accordeur.getText());
        accordeur.restart(accordeur.ACCORDEUR);
     }    
   private void jCheckBox_cle_de_sol_ActionPerformed(java.awt.event.ActionEvent evt) {
     this.jCheckBox_cle_de_fa.setSelected(!this.jCheckBox_cle_de_sol.isSelected());
   }    
   private void jCheckBox_cle_de_fa_ActionPerformed(java.awt.event.ActionEvent evt) {
     this.jCheckBox_cle_de_sol.setSelected(!this.jCheckBox_cle_de_fa.isSelected());
   }    

}
