/*
 * Drawing.java
 *
 * Created on 18 octobre 2006, 08:10
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Graphics;

/**
 *
 * @author ygorra
 */
public class Drawing {
    
    /** Creates a new instance of Drawing */
    public Drawing() {
    }
public static void draw_float( String Title,
            Graphics g,
            Color ColorTitle,
            Color ColorBackGround,
            Color ColorLine,
            float[] data,
            min_max_float minmaxf,
            float x0f,float y0f,float x1f,float y1f,
            int n0,int n1,
            int width,int height){
        if (data==null) {return;}
        int l=data.length-1;
        if (n1>=l) {n1=l;};
        if (n0<0) {n0=0;}
        if (n1<=n0) { return;}
        echelle_graphique echelle_y=new echelle_graphique(y0f,y1f,
                height-1,1,
                minmaxf.min_data,minmaxf.max_data
                );
        echelle_graphique echelle_x=new echelle_graphique(x0f,x1f,
                1,width-1,
                n0,n1
                );
        // Trace du fond et du cadre
        
        g.setColor(ColorBackGround);
        g.fillRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        g.setColor(ColorTitle);
        g.drawRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        // trace des donnees
        int xf,yf;
        
        g.setColor(ColorLine);
        int i=n0;
        int xd=(int)echelle_x.getPixel((float)i);
        int yd=(int)echelle_y.getPixel((float)data[i]);
        for (i=n0+1;i<=n1;i++) {
            xf=(int)echelle_x.getPixel((float)i);
            yf=(int)echelle_y.getPixel((float)data[i]);
            g.drawLine(xd,yd,xf,yf);
            xd=xf;yd=yf;
        }
        // titre de la courbe
        g.setColor(ColorTitle);
        float xs=(float)(n1+n0)/2;
        float ys=(float)(minmaxf.max_data+minmaxf.min_data)/2.0f;
        xf=(echelle_x.max_pixel+echelle_x.min_pixel)/2;
        yf=(echelle_y.max_pixel+echelle_y.min_pixel)/2;
        g.drawString(Title +",max="+String.valueOf(echelle_y.max_value)+",min="+String.valueOf(echelle_y.min_value),xf,yf);
    }
    public static void draw_float_xy( String Title,
            Graphics g,
            Color ColorTitle,
            Color ColorBackGround,
            Color ColorLine,
            float[] data_x,float[] data_y,
            min_max_float minmaxf_x,min_max_float minmaxf_y,
            float x0f,float y0f,float x1f,float y1f,
            int n0,int n1,
            int width,int height){
        if (data_y==null) {return;}
        if (data_x==null) {return;}
        int l=data_y.length-1;
        if (l!=data_x.length-1){return;}
        
        if (n1>=l) {n1=l;};
        if (n0<0) {n0=0;}
        if (n1<=n0) { return;}
        echelle_graphique echelle_y=new echelle_graphique(y0f,y1f,
                height-1,1,
                minmaxf_y.min_data,minmaxf_y.max_data
                );
        echelle_graphique echelle_x=new echelle_graphique(x0f,x1f,
                1,width-1,
                minmaxf_x.min_data,minmaxf_x.max_data
                );
        // Trace du fond et du cadre
        
        g.setColor(ColorBackGround);
        g.fillRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        g.setColor(ColorTitle);
        g.drawRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        // trace des donnees
        int xf,yf;
        g.setColor(ColorLine);
        int i=n0;
        int xd=(int)echelle_x.getPixel((float)data_x[i]);
        int yd=(int)echelle_y.getPixel((float)data_y[i]);
        for (i=n0+1;i<=n1;i++) {
            xf=(int)echelle_x.getPixel((float)data_x[i]);
            yf=(int)echelle_y.getPixel((float)data_y[i]);
            g.drawLine(xd,yd,xf,yf);
            xd=xf;yd=yf;
        }
        // titre de la courbe
        g.setColor(ColorTitle);
        xf=(echelle_x.max_pixel+echelle_x.min_pixel)/2;
        yf=(echelle_y.max_pixel+echelle_y.min_pixel)/2;
        g.drawString(Title +",max="+String.valueOf(echelle_y.max_value)+",min="+String.valueOf(echelle_y.min_value),xf,yf);
    }
    public static void draw_short( String Title,
            Graphics g,
            Color ColorTitle,
            Color ColorBackGround,
            Color ColorLine,
            short[] data,
            min_max_short minmaxf,
            float x0f,float y0f,float x1f,float y1f,
            int n0,int n1,
            int width,int height){
        if (data==null) {return;}
        int l=data.length-1;
        if (n1>=l) {n1=l;};
        if (n0<0) {n0=0;}
        if (n1<=n0) { return;}
        echelle_graphique echelle_y=new echelle_graphique(y0f,y1f,
                height-1,1,
                minmaxf.min_data,minmaxf.max_data
                );
        echelle_graphique echelle_x=new echelle_graphique(x0f,x1f,
                1,width-1,
                n0,n1
                );
        // Trace du fond et du cadre
        
        g.setColor(ColorBackGround);
        g.fillRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        g.setColor(ColorTitle);
        g.drawRect(echelle_x.x0,echelle_y.x0,echelle_x.largeur+1,echelle_y.largeur+1);
        // trace des donnees
        int xf,yf;
        g.setColor(ColorLine);
        int i=n0;
        int xd=(int)echelle_x.getPixel((float)i);
        int yd=(int)echelle_y.getPixel((float)data[i]);
        for (i=n0+1;i<=n1;i++) {
            xf=(int)echelle_x.getPixel((float)i);
            yf=(int)echelle_y.getPixel((float)data[i]);
            g.drawLine(xd,yd,xf,yf);
            xd=xf;yd=yf;
        }
        // titre de la courbe
        g.setColor(ColorTitle);
        float xs=(float)(n1+n0)/2;
        float ys=(float)(minmaxf.max_data+minmaxf.min_data)/2.0f;
        xf=(echelle_x.max_pixel+echelle_x.min_pixel)/2;
        yf=(echelle_y.max_pixel+echelle_y.min_pixel)/2;
        g.drawString(Title +",max="+String.valueOf(echelle_y.max_value)+",min="+String.valueOf(echelle_y.min_value),xf,yf);
    }
    
}
