/*
 * GetDataWav.java
 *
 * Created on 9 octobre 2006, 11:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;
/**
 *
 * @author ygorra
 */
import java.io.DataInputStream;
import java.io.File;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioFormat.Encoding;

import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.SourceDataLine;
import javax.sound.sampled.UnsupportedAudioFileException;

/**
 * An example of loading and playing a sound using a Clip. This complete class
 * isn't in the book ;)
 */
public class GetDataWav {
/**
   * Opens a sound from a file.
   */
  private AudioFormat format;  
  private byte [] samples;
  private String filename;
  /**
   * Gets the samples from an AudioInputStream as an array of bytes.
   */
  private void getSamples(AudioInputStream audioStream) {
    // get the number of bytes to read
    int length = (int) (audioStream.getFrameLength() * format
        .getFrameSize());

    // read the entire stream
    samples = new byte[length];
    DataInputStream is = new DataInputStream(audioStream);
    try {
      is.readFully(samples);
    } catch (IOException ex) {
      ex.printStackTrace();
    }

    // return the samples
  }

  private void init_data_wav() {
     samples=null;
      try {
      // open the audio input stream
      AudioInputStream stream = AudioSystem.getAudioInputStream(new File(
          filename));

      format = stream.getFormat();
            if ( format.getEncoding() !=Encoding.PCM_SIGNED) {
                System.out.print("Bad Encoding:");System.out.println(format.getEncoding());
            }
            if ( format.getSampleSizeInBits() !=16) {
                System.out.print("Bad Sample Size:");System.out.println(format.getSampleSizeInBits());
            }

      // get the audio samples
      getSamples(stream);
    } catch (UnsupportedAudioFileException ex) {
      ex.printStackTrace();
    } catch (IOException ex) {
      ex.printStackTrace();
    }
  }    
public byte [] getSamples(){
    return samples;
}  
public AudioFormat getFormat(){
    return format;
}  
public void play(AudioInputStream source) {

    // use a short, 100ms (1/10th sec) buffer for real-time
    // change to the sound stream
    int bufferSize = format.getFrameSize()
        * Math.round(format.getSampleRate() / 10);
    byte[] buffer = new byte[bufferSize];

    // create a line to play to
    SourceDataLine line;
    try {
      DataLine.Info info = new DataLine.Info(SourceDataLine.class, format);
      line = (SourceDataLine) AudioSystem.getLine(info);
      line.open(format, bufferSize);
    } catch (LineUnavailableException ex) {
      ex.printStackTrace();
      return;
    }

    // start the line
    line.start();

    // copy data to the line
    try {
      int numBytesRead = 0;
      while (numBytesRead != -1) {
        numBytesRead = source.read(buffer, 0, buffer.length);
        if (numBytesRead != -1) {
          line.write(buffer, 0, numBytesRead);
        }
      }
    } catch (IOException ex) {
      ex.printStackTrace();
    }

    // wait until all data is played, then close the line
    line.drain();
    line.close();

  }


  public GetDataWav(String file_name) {
    filename=file_name;
    init_data_wav();
    // specify the sound to play
    // (assuming the sound can be played by the audio system)

  }

}        