/*
 * NotesEtFrequences.java
 *
 * Created on 18 octobre 2006, 08:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.LinkedList;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.Border;
class caracteristiques_intervalle{
    public boolean[] intervalles=null;
    public boolean ascendant=true;
    public boolean descendant=false;
    public boolean dune_note_a_la_suivante=true;
    public boolean begin_at_0=true;
    int nb_notes=2;
    
    public  caracteristiques_intervalle(){
        
    }

}
/**
 *
 * @author ygorra
 */
interface ctes_notes{
    public final int CLE_DE_SOL=1;
    public final int CLE_DE_FA=2;
    
}
class choix_intervalles extends javax.swing.JFrame{
   private choix_intervalles f;
   private NotesEtFrequences notes;
   private JCheckBox[] boutons=null;
   JPanel PanelIntervalles;

    private JPanel PanelAscendantDescendant;

    private JCheckBox bouton_descendant;

    private JCheckBox bouton_ascendant;
    private JCheckBox bouton_begin_at_0;
    
    private JTextField jTextFieldNbNotes;
    public caracteristiques_intervalle c_it=null;
   public choix_intervalles(caracteristiques_intervalle c_it_){
       if (c_it_==null) return;
       this.c_it=c_it_;
       if (c_it.intervalles==null) return;
       notes =new NotesEtFrequences(10f,20f,440);
        if (notes==null) return;
        boutons=new JCheckBox[notes.INTERVALLE_MAX+1];
        if (boutons.length!=c_it.intervalles.length) return;
        for (int i=0;i<boutons.length;i++) {
            boutons[i]=new JCheckBox();
            boutons[i].setText(notes.NOM_INTERVALLE[i]);
            boutons[i].setSelected(c_it.intervalles[i]);
        }
        
        f =this;
        f.setName("parametres dictee musicale");
        f.setTitle("Dictees Musicales et Accordeur ");
        f.setSize(500,500);
        f.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                f.valid_selected_intervals(c_it); 
                f.setVisible(false);
                f.dispose();
            }
        });
        Container c = f.getContentPane();
        c.setLayout(new GridLayout(1,2));
        PanelAscendantDescendant =new JPanel();
        PanelAscendantDescendant.setLayout(new GridLayout(4,1));
        bouton_descendant=new JCheckBox();
        bouton_descendant.setText("autotiser les intervalles descendants");
        bouton_descendant.setSelected(c_it_.descendant);
        bouton_ascendant=new JCheckBox();
        bouton_ascendant.setText("autotiser les intervalles ascendants");
        bouton_ascendant.setSelected(c_it.ascendant);
        bouton_begin_at_0=new JCheckBox();
        bouton_begin_at_0.setText("toujours commencer par la fondamentale");
        bouton_begin_at_0.setSelected(c_it.begin_at_0);
        jTextFieldNbNotes=new JTextField();
        jTextFieldNbNotes.setBorder(javax.swing.BorderFactory.createTitledBorder("nombres de notes"));
        jTextFieldNbNotes.setText(String.valueOf((int)c_it.nb_notes));
        PanelAscendantDescendant.add(bouton_ascendant);
        PanelAscendantDescendant.add(bouton_descendant);
        PanelAscendantDescendant.add(bouton_begin_at_0);
        PanelAscendantDescendant.setAutoscrolls(true); 
        PanelAscendantDescendant.add(jTextFieldNbNotes);
        c.add(this.PanelAscendantDescendant);
        // reglages de la dictee
        PanelIntervalles =new JPanel();
        PanelIntervalles.setName("parametres de la dictee musicale");
        PanelIntervalles.setAutoscrolls(true);
        PanelIntervalles.setLayout(new GridLayout(boutons.length,1));
        for (int i=0;i<boutons.length;i++) {
          PanelIntervalles.add(boutons[i]);
        }
        c.add(PanelIntervalles);
        f.setVisible(true);
    }
        public void valid_selected_intervals(caracteristiques_intervalle c_it) {
          if (notes==null) return;
          if (boutons==null) return;
          if (c_it==null) return;
          if (boutons.length!=c_it.intervalles.length) return;
          for (int i=0;i<boutons.length;i++) {
              c_it.intervalles[i]=boutons[i].isSelected();
          }
          c_it.ascendant=this.bouton_ascendant.isSelected();
          c_it.descendant=this.bouton_descendant.isSelected();
          c_it.begin_at_0=this.bouton_begin_at_0.isSelected();
          int nb_notes=(int) Math.round(Float.parseFloat(this.jTextFieldNbNotes.getText()));        
          if (nb_notes>=2) c_it.nb_notes=nb_notes;
        }

}
class note_detaillee{
    public note_detaillee(){
        
    }
    int   note_modulo_octave;
    int   octave;
    float decalage_en_demi_ton;
    String nom_note_modulo_octave;
    String nom_note_global;
    float frequence_note;
}
public class NotesEtFrequences {
    String [] FREQUENCES;
    final int NB_NOTES_PAR_OCTAVE=12;
    final int NB_NOTES_PIANO_PAR_OCTAVE=7;
    final int NB_NOTES_CLE_PAR_OCTAVE=7;
    final int NOTE_EN_DEMI_TON_MIN_CLE_SOL_FROM_DO0=3;  //MIb0
    final int NOTE_EN_DEMI_TON_MAX_CLE_SOL_FROM_DO0=6+NB_NOTES_PAR_OCTAVE;//FA#1  
    final int NOTE_EN_DEMI_TON_MIN_CLE_FA_FROM_DO0=6;  //SOLb0
    final int NOTE_EN_DEMI_TON_MAX_CLE_FA_FROM_DO0=10+NB_NOTES_PAR_OCTAVE;//LA#1  
    final int NB_NOTES_EN_DEMI_TON_PAR_CLE=2*NB_NOTES_PAR_OCTAVE;
    double F_MINI_ABS=30.0f;
    double F_MAXI_ABS=12000.0f;
    double LOG_DEMI_TON;//=(float) Math.log(2.0)/NB_NOTES_PAR_OCTAVE;
    double LOG_OCTAVE;//=(float) Math.log(2.0);
    double LOG_DO_0;//=(float) Math.log(2.0);
    double LA_4;//=(float) 440.0f;
    double LA_0;//=(float) Math.exp(log(LA_4)-4*LOG_OCTAVE);
    double DO_0;//=(float) Math.exp(log(LA_1)-8*LOG_DEMI_TON);
    double DO_7;
    double SI_7;
        public final int seconde_mineure=1;
    public final int seconde_majeure=2;
    public final int tierce_mineure=3;
    public final int tierce_majeure=4;
    public final int quatrieme=5;
    public final int cinquieme_mineure=6;
    public final int cinquieme=7;
    public final int sixieme_mineure=8;
    public final int sixieme=9;
    public final int septieme_mineure=10;
    public final int septieme=10;
    public final int septieme_majeure=11;
    public final int huitieme=12;
    public final int neuvieme_bemol=seconde_mineure+12;
    public final int neuvieme= seconde_majeure+12;
    public final int INTERVALLE_MAX=neuvieme;

    String NOM_INTERVALLE[];
    String NOM_NOTE_MODULO_OCTAVE_DIESE[];
    String NOM_NOTE_MODULO_OCTAVE_BEMOL[];
    
    double F_MINI_EN_COURS;
    double F_MAXI_EN_COURS;
    int NOTE_MINI_FROM_DO_0_ABS;
    int NOTE_MAXI_FROM_DO_0_ABS;
    int NOTE_MINI_FROM_DO_0_EN_COURS;
    int NOTE_MAXI_FROM_DO_0_EN_COURS;
    
    double LOG_DO_0_EN_DEMI_TON;
    echelle_graphique echelle_x_partition=null;
    echelle_graphique echelle_y_partition=null;
    echelle_graphique echelle_y_cle=null;
    echelle_graphique echelle_x_piano=null;
    echelle_graphique echelle_x_lien_piano_part=null;
    
    echelle_graphique echelle_y_piano=null;
    boolean HAS_PIANO=false;
    private float COEFF_X_PIANO=0.25f; // le quart de la partoche est reserve a l'affichage du clavier
    
    private MyRect[] rect_note_piano=null;
    
    float x0_partition_relative;
    float x1_partition_relative;
    
    public int TYPE_CLE=ctes_notes.CLE_DE_SOL;

    int hauteur_note;

     public void draw_note_cle(Graphics g,float note_en_demi_ton,boolean diese_preferred,int x0,Color color) {
      if (diese_preferred) {draw_note_cle_diese(g,note_en_demi_ton,x0,color);}
      else {draw_note_cle_bemol(g,note_en_demi_ton,x0,color);}      
   }
 
   public void draw_note_cle(Graphics g,float note_en_demi_ton,int x0,Color color) {
      draw_note_cle_diese(g,note_en_demi_ton,x0,color);
   }
     public void draw_note_cle_diese(Graphics g,float note_en_demi_ton,int x0,Color color) {
        int x1;
        int y0,y1;
        hauteur_note=0;
        if (this.echelle_y_cle==null) return;
        Color old_color=g.getColor();
        g.setColor(color);
        boolean is_diese=this.is_diese_ou_bemol(note_en_demi_ton);
        float note_cle=this.note_cle(note_en_demi_ton);
        float hauteur_all_notes=Math.abs(this.echelle_y_cle.max_value-this.echelle_y_cle.min_value);
        if (hauteur_all_notes>0f) hauteur_note=(int)Math.round(2f*this.echelle_y_cle.largeur/hauteur_all_notes);
        // trace des intervalles
        y0=this.echelle_y_cle.getPixel(note_cle);
        y1=y0;
        g.fillOval(x0,y0-hauteur_note/2,hauteur_note,hauteur_note);
        if (is_diese) {
          x0+=hauteur_note;  
          x1=x0+hauteur_note;
          g.drawLine(x0,y0+hauteur_note/2,x0+hauteur_note/4,y0-hauteur_note/2);
          g.drawLine(x1-hauteur_note/4,y0+hauteur_note/2,x1,y0-hauteur_note/2);
          g.drawLine(x0,y0-hauteur_note/4,x1,y0-hauteur_note/4);
          g.drawLine(x0,y0+hauteur_note/4,x1,y0+hauteur_note/4);
      }
      g.setColor(old_color);
   }
      public void draw_note_cle_bemol(Graphics g,float note_en_demi_ton,int x0,Color color) {
        int x1;
        int y0,y1;
        hauteur_note=0;
        if (this.echelle_y_cle==null) return;
        Color old_color=g.getColor();
        g.setColor(color);
        boolean is_diese=this.is_diese_ou_bemol(note_en_demi_ton);
        
        float note_cle=this.note_cle(note_en_demi_ton);
        if (is_diese ) note_cle++;
        float hauteur_all_notes=Math.abs(this.echelle_y_cle.max_value-this.echelle_y_cle.min_value);
        if (hauteur_all_notes>0f) hauteur_note=(int)Math.round(2f*this.echelle_y_cle.largeur/hauteur_all_notes);
        // trace des intervalles
        y0=this.echelle_y_cle.getPixel(note_cle);
        y1=y0;
        g.fillOval(x0,y0-hauteur_note/2,hauteur_note,hauteur_note);
        if (is_diese) {
          x0+=hauteur_note;  
          x1=x0+hauteur_note/2;
          g.drawLine(x0,y0-hauteur_note/2,x0,y0+hauteur_note/2);
          g.drawLine(x0,y0+hauteur_note/2,x1,y0+hauteur_note/2);
          g.drawLine(x0,y0+hauteur_note/4,x1,y0+hauteur_note/4);
          g.drawLine(x1,y0+hauteur_note/4,x1,y0+hauteur_note/2);
      }
      g.setColor(old_color);
   }
   public int get_hauteur_note() {
       return this.hauteur_note;
   }
    public float note_cle(float note_demi_ton) {
    // 0=> DO, 6 => SI + 7.OCTAVE
        float decal=note_demi_ton -Math.round(note_demi_ton);
        return (float) Math.floor(this.note_piano(note_demi_ton))+decal;
      
    }
    public Color ColorLigneNoteCle(int note_cle) {
        if (this.TYPE_CLE==ctes_notes.CLE_DE_FA) return ColorLigneNoteCleFa(note_cle);
         return ColorLigneNoteCleSol(note_cle);        
    }
    public Color ColorLigneNoteCleSol(int note_cle){
      int num_octave=note_cle/this.NB_NOTES_CLE_PAR_OCTAVE;
      int num_2_octave=num_octave/2;
      int note_mod_2_octave=note_cle-2*this.NB_NOTES_CLE_PAR_OCTAVE*num_2_octave;
      if ((note_mod_2_octave&1)==1) return Color.WHITE;
      if ((note_mod_2_octave<=1)
          ||(note_mod_2_octave>=11)) return Color.LIGHT_GRAY;
      return Color.BLACK;
    }
    public Color ColorLigneNoteCleFa(int note_cle){
      int num_octave=note_cle/this.NB_NOTES_CLE_PAR_OCTAVE;
      int num_2_octave=num_octave/2;
      int note_mod_2_octave=note_cle-2*this.NB_NOTES_CLE_PAR_OCTAVE*num_2_octave;
      if ((note_mod_2_octave&1)==1) return Color.WHITE;
      if ((note_mod_2_octave<=3)
          ||(note_mod_2_octave>=13)) return Color.LIGHT_GRAY;
      return Color.BLACK;
    }
   
    public float note_piano(float note_demi_ton) {
        int Note=(int)Math.round(note_demi_ton);
        int Octave=Note/this.NB_NOTES_PAR_OCTAVE;
        int note_mod_octave=Note-Octave*this.NB_NOTES_PAR_OCTAVE;
        while (note_mod_octave<0) {
            note_mod_octave+=this.NB_NOTES_PAR_OCTAVE;
            Octave-=1;
        }
        float note_piano_mod_octave;
        switch(note_mod_octave) {
            case 0:note_piano_mod_octave=0;  break;//DO
            case 1:note_piano_mod_octave=0.5f;break;//DO#
            case 2:note_piano_mod_octave=1;  break;//RE
            case 3:note_piano_mod_octave=1.5f;  break;//RE#
            case 4:note_piano_mod_octave=2;  break;//MI
            case 5:note_piano_mod_octave=3;  break;//FA
            case 6:note_piano_mod_octave=3.5f;  break;//FA#
            case 7:note_piano_mod_octave=4;  break;//SOL
            case 8:note_piano_mod_octave=4.5f;  break;//SOL#
            case 9:note_piano_mod_octave=5;  break;//LA
            case 10:note_piano_mod_octave=5.5f;  break;//LA#
            case 11:note_piano_mod_octave=6; break; //SI
            default :
                note_piano_mod_octave=0;
                System.err.println("erreur dans evaluation note piano=>NotesEtFrequences.note_piano("+String.valueOf(note_demi_ton)+")");
                
        }
        return note_piano_mod_octave+Octave*this.NB_NOTES_PIANO_PAR_OCTAVE;
    }
    public boolean is_diese_ou_bemol(int note_demi_ton) {
        int Note=note_demi_ton;
        int Octave=Note/this.NB_NOTES_PAR_OCTAVE;
        int note_mod_octave=Note-Octave*this.NB_NOTES_PAR_OCTAVE;
        while (note_mod_octave<0) {
            note_mod_octave+=this.NB_NOTES_PAR_OCTAVE;
            Octave-=1;
        }
        boolean is_diese=(note_mod_octave==1)
        ||(note_mod_octave==3)
        ||(note_mod_octave==6)
        ||(note_mod_octave==8)
        ||(note_mod_octave==10);
        return is_diese;
    }
    public float NoteCleModuloUneCle(float note_en_demi_ton) {
      return note_cle(NoteEnDemiTonModuloUneCle(note_en_demi_ton));     
    }
    public float NoteEnDemiTonModuloUneCle(float note_en_demi_ton) {
      while (note_en_demi_ton<0f) note_en_demi_ton+=NB_NOTES_EN_DEMI_TON_PAR_CLE;  
      while (note_en_demi_ton>=NB_NOTES_CLE_PAR_OCTAVE) note_en_demi_ton-=NB_NOTES_EN_DEMI_TON_PAR_CLE;  
      return note_en_demi_ton;
        
    }
    public int note_en_demi_ton_cle_min_from_DO0() {
        if (this.TYPE_CLE==ctes_notes.CLE_DE_FA) {
          return this.NOTE_EN_DEMI_TON_MIN_CLE_FA_FROM_DO0;  
        }
        return this.NOTE_EN_DEMI_TON_MIN_CLE_SOL_FROM_DO0;
    }
    public int note_en_demi_ton_cle_max_from_DO0() {
        if (this.TYPE_CLE==ctes_notes.CLE_DE_FA) {
          return this.NOTE_EN_DEMI_TON_MAX_CLE_FA_FROM_DO0;  
        }
        return this.NOTE_EN_DEMI_TON_MAX_CLE_SOL_FROM_DO0;
    }
    
    public NotesEtFrequences NotesContenantAuMoinsUneCle(NotesEtFrequences Notes) {
      float note_mini=Notes.NoteEnDemiTonModuloUneCle(Notes.NOTE_MINI_FROM_DO_0_EN_COURS);  
   // note debut
      double f_mini=Notes.F_MINI_EN_COURS;
      if ((note_mini >=this.note_en_demi_ton_cle_min_from_DO0())
         &&(note_mini <=this.note_en_demi_ton_cle_max_from_DO0())) {
          float ecart=Notes.NOTE_MINI_FROM_DO_0_EN_COURS-note_mini;
          note_mini=this.note_en_demi_ton_cle_min_from_DO0()-4f;
          note_mini=(int) Math.round(note_mini+ecart);
          f_mini=Notes.frequence_note((double) note_mini);
      }
   // note_fin
      double f_maxi=Notes.F_MAXI_EN_COURS;
      float note_maxi=Notes.NoteEnDemiTonModuloUneCle(Notes.NOTE_MAXI_FROM_DO_0_EN_COURS);  
      if ((note_maxi >=this.note_en_demi_ton_cle_min_from_DO0())
         &&(note_maxi <=this.note_en_demi_ton_cle_max_from_DO0())) {
          float ecart=Notes.NOTE_MINI_FROM_DO_0_EN_COURS-note_maxi;
          note_maxi=this.note_en_demi_ton_cle_max_from_DO0()+4f;
          note_maxi=(int) Math.round(note_maxi+ecart);
          f_maxi=Notes.frequence_note((double) note_maxi);
      }
      
      return new NotesEtFrequences(f_mini,f_maxi,Notes.LA_4);   
    }
    public boolean is_diese_ou_bemol(float note_demi_ton) {
        return is_diese_ou_bemol((int)Math.round(note_demi_ton));
    }
    public void CalculeNotesJustes(LinkedList Notes) {
        if (Notes==null) return ;
        Object[] tab =Notes.toArray();
        for (int i=0;i<tab.length;i++) {
          Object O=tab[i];
          if (O!=null) {
            InfoTrack info_ok=(InfoTrack) O;
            note_detaillee detail=this.details_note(info_ok.f_reelle_super_track);
            
            info_ok.f_ajustee=(float)this.frequence_note(detail.note_modulo_octave,detail.octave);
          }
        }
      
    }
    public void draw_touche_piano_active(Graphics g,float f_reelle_en_demi_ton){
        if (!this.HAS_PIANO) return;  
       
        int note_en_demi_ton=(int) Math.round(f_reelle_en_demi_ton);
            // trace note piano
            MyRect rn=Rect_TouchePiano(note_en_demi_ton);
            Color old_color=g.getColor();
            g.setColor(Color.RED);
            g.fillRect(rn.x0,rn.y0,rn.width,rn.height);
            if (!is_diese_ou_bemol(note_en_demi_ton)) {
                if (is_diese_ou_bemol(note_en_demi_ton+1)) {
                    g.setColor(Color.BLACK);
                    rn=Rect_TouchePiano(note_en_demi_ton+1);
                    g.fillRect(rn.x0,rn.y0,rn.width,rn.height);
                }
                if (is_diese_ou_bemol(note_en_demi_ton-1)) {
                    g.setColor(Color.BLACK);
                    rn=Rect_TouchePiano(note_en_demi_ton-1);
                    g.fillRect(rn.x0,rn.y0,rn.width,rn.height);
                }
                
            }
           g.setColor(old_color);
        
    }
    public void init_echelles_partition(
            int note_min_demi_ton,int note_max_demi_ton,
            int width,int height,
            float x0f,float y0f,
            float x1f,float y1f,float coeff_piano){
        this.HAS_PIANO=coeff_piano>0f;
        if (this.HAS_PIANO) { this.COEFF_X_PIANO=coeff_piano; }
        echelle_y_partition=new echelle_graphique(
                y0f,y1f,
                height-1,1,
                (float) note_min_demi_ton,(float) note_max_demi_ton               );
        echelle_y_cle=new echelle_graphique(
                y0f,y1f,
                height-1,1,
                (float) note_cle(note_min_demi_ton),(float) note_cle(note_max_demi_ton)               );
        if (this.HAS_PIANO) {
            this.x0_partition_relative=x0f+this.COEFF_X_PIANO*(x1f-x0f);
            this.x1_partition_relative=x1f;
            echelle_x_piano=new echelle_graphique(
                    x0f,x0f+this.COEFF_X_PIANO*2f/3f*(x1f-x0f),
                    1,width-1,
                    0f,1f        // data x entre 0 et 1
                    );
            this.echelle_x_lien_piano_part=new echelle_graphique(
                    x0f+this.COEFF_X_PIANO*2f/3f*(x1f-x0f),x1f,
                    1,width-1,
                    0f,1f        // data x entre 0 et 1
                    );
            echelle_y_piano=new echelle_graphique(
                    y0f,y1f,
                    height-1,1,
                    note_piano(note_min_demi_ton),note_piano(note_max_demi_ton)               );
            if (note_max_demi_ton >= note_min_demi_ton) {
                rect_note_piano=new MyRect[note_max_demi_ton-note_min_demi_ton+1];
                for(int i=note_min_demi_ton;i<note_max_demi_ton;i++) {
                    rect_note_piano[i-note_min_demi_ton]=this.Rect_TouchePiano(i);
                }
            }
        } else {
            this.x0_partition_relative=x0f;
            this.x1_partition_relative=x1f;
            
        }
        echelle_x_partition=new echelle_graphique(
                x0_partition_relative,x1_partition_relative,
                1,width-1,
                0f,1f        // data x entre 0 et 1
                );
    }
    public void draw_partition(Graphics g,
            int note_min_demi_ton,int note_max_demi_ton,
            int width,int height,
            float x0f,float y0f,
            float x1f,float y1f,float coeff_piano){
        int i_f;
        int y0;
  
        this.init_echelles_partition(
                note_min_demi_ton,note_max_demi_ton,
                width,height,
                x0f,y0f,
                x1f,y1f,coeff_piano);
        this.draw_partition(g,note_min_demi_ton,note_max_demi_ton);
    }
    public void draw_partition(Graphics g,int note_min_demi_ton,int note_max_demi_ton){
        int i_f;
        int y0;
        if (echelle_x_partition==null) return;
        if (echelle_y_partition==null) return;
        
        for (i_f=note_min_demi_ton;i_f<=note_max_demi_ton;i_f++) {
            g.setColor(Color.LIGHT_GRAY);
            if ( (i_f /NB_NOTES_PAR_OCTAVE)*NB_NOTES_PAR_OCTAVE  ==i_f ) {
                g.setColor(Color.DARK_GRAY);
            }
            y0=echelle_y_partition.getPixel((float) i_f);
            g.drawLine(echelle_x_partition.x0,y0,echelle_x_partition.x1,y0);
        }
        String Nom_Do=new String(this.NOM_NOTE_MODULO_OCTAVE_DIESE[0]);
        g.setColor(Color.BLUE);
        int height_chars=g.getFontMetrics().getHeight();
        for (i_f=(note_min_demi_ton+this.NB_NOTES_PAR_OCTAVE-1)/this.NB_NOTES_PAR_OCTAVE;i_f<=note_max_demi_ton/this.NB_NOTES_PAR_OCTAVE;i_f++) {
            y0=echelle_y_partition.getPixel((float) i_f*NB_NOTES_PAR_OCTAVE);
            g.drawString(Nom_Do+String.valueOf(i_f),echelle_x_partition.x0+1,
                    y0+height_chars/4);
        }
        draw_clavier_piano(g,note_min_demi_ton,note_max_demi_ton);        
    }
       public void draw_partition_cle_de_sol(Graphics g,int note_min_demi_ton,int note_max_demi_ton){
        int note_cle;
        int y0;
        if (echelle_x_partition==null) return;
        if (echelle_y_partition==null) return;
        Color color;
        int note_cle_min=(int) Math.round(note_cle(note_min_demi_ton));
        int note_cle_max=(int) Math.round(note_cle(note_max_demi_ton));
        for (note_cle=note_cle_min;note_cle<=note_cle_max;note_cle++) {
            color=this.ColorLigneNoteCleSol(note_cle);  
            if (color!=Color.WHITE) {
            g.setColor(color);
            y0=this.echelle_y_cle.getPixel((float) note_cle);
            g.drawLine(echelle_x_partition.x0,y0,echelle_x_partition.x1,y0);
            }       
         }
        String Nom_Do=new String(this.NOM_NOTE_MODULO_OCTAVE_DIESE[0]);
        g.setColor(Color.BLUE);
        int height_chars=g.getFontMetrics().getHeight();
        for (int i_f=(note_min_demi_ton+this.NB_NOTES_PAR_OCTAVE-1)/this.NB_NOTES_PAR_OCTAVE;i_f<=note_max_demi_ton/this.NB_NOTES_PAR_OCTAVE;i_f++) {
 
            y0=echelle_y_cle.getPixel((float) this.note_cle(i_f*NB_NOTES_PAR_OCTAVE));
            g.drawString(Nom_Do+String.valueOf(i_f),echelle_x_partition.x0+1,
                    y0+height_chars/4);
        }
        draw_clavier_piano(g,note_min_demi_ton,note_max_demi_ton);        
    }
    
    public void draw_partition_cle(Graphics g,int note_min_demi_ton,int note_max_demi_ton){
      if (this.TYPE_CLE==ctes_notes.CLE_DE_FA) {
          draw_partition_cle_de_fa(g,note_min_demi_ton,note_max_demi_ton);
          return;
      }  
      draw_partition_cle_de_sol(g,note_min_demi_ton,note_max_demi_ton);
   
    }
     public void draw_partition_cle_de_fa(Graphics g,int note_min_demi_ton,int note_max_demi_ton){
        int note_cle;
        int y0;
        if (echelle_x_partition==null) return;
        if (echelle_y_partition==null) return;
        Color color;
        int note_cle_min=(int) Math.round(note_cle(note_min_demi_ton));
        int note_cle_max=(int) Math.round(note_cle(note_max_demi_ton));
        for (note_cle=note_cle_min;note_cle<=note_cle_max;note_cle++) {
            color=this.ColorLigneNoteCleFa(note_cle);  
            if (color!=Color.WHITE) {
            g.setColor(color);
            y0=this.echelle_y_cle.getPixel((float) note_cle);
            g.drawLine(echelle_x_partition.x0,y0,echelle_x_partition.x1,y0);
            }       
         }
        String Nom_Do=new String(this.NOM_NOTE_MODULO_OCTAVE_DIESE[0]);
        g.setColor(Color.BLUE);
        int height_chars=g.getFontMetrics().getHeight();
        for (int i_f=(note_min_demi_ton+this.NB_NOTES_PAR_OCTAVE-1)/this.NB_NOTES_PAR_OCTAVE;i_f<=note_max_demi_ton/this.NB_NOTES_PAR_OCTAVE;i_f++) {
            y0=echelle_y_cle.getPixel((float) this.note_cle(i_f*NB_NOTES_PAR_OCTAVE));
            g.drawString(Nom_Do+String.valueOf(i_f),echelle_x_partition.x0+1,
                    y0+height_chars/4);
        }
        draw_clavier_piano(g,note_min_demi_ton,note_max_demi_ton);        
    }

    public void draw_clavier_piano(Graphics g,int note_min_demi_ton,int note_max_demi_ton) {
        if (this.HAS_PIANO==false) return;
        // trace du clavierde piano
        MyRect r1=this.Rect_TouchePiano(note_min_demi_ton);
        MyRect r0=this.Rect_TouchePiano(note_max_demi_ton);
        g.setColor(Color.WHITE);
        g.fillRect(this.echelle_x_piano.x0,this.echelle_y_piano.x0,this.echelle_x_piano.largeur,this.echelle_y_piano.largeur );
        g.setColor(Color.BLACK);
        for (int i_f=note_min_demi_ton;i_f<=note_max_demi_ton;i_f++) {
            MyRect r=this.Rect_TouchePiano(i_f);
            if (is_diese_ou_bemol((float) i_f)) {
                g.fillRect(r.x0,r.y0,r.width,r.height);
            } else {
                g.drawRect(r.x0,r.y0,r.width,r.height);
            }
        }
        
    }
    public MyRect Rect_TouchePiano(int note_demi_ton) {
        if (echelle_x_piano==null) return null;
        if (echelle_y_piano==null) return null;
        float note_piano=this.note_piano(note_demi_ton);
        
        int x0_piano,x1_piano;
        float hauteur_touche;
        if (note_piano-Math.floor(note_piano)<0.25f) {
            // ce n'est pas un diese
            x0_piano=echelle_x_piano.x0;
            x1_piano=echelle_x_piano.x1;
            hauteur_touche=0.5f;
            
        } else {
            // c'est un diese
            x0_piano=echelle_x_piano.x0;
            x1_piano=echelle_x_piano.x0+(int)Math.round(0.6*(echelle_x_piano.x1-echelle_x_piano.x0));
            hauteur_touche=0.3f;
        }
        int  y0_piano = echelle_y_piano.getPixel(note_piano-hauteur_touche);
        int  y1_piano = echelle_y_piano.getPixel(note_piano+hauteur_touche);
        return new MyRect(x0_piano,x1_piano,y0_piano,y1_piano);
    }
    
    /** Creates a new instance of NotesEtFrequences */
    public NotesEtFrequences(double F_MINI_,double F_MAXI_,double FREQ_LA4_HERTZ) {
        F_MINI_EN_COURS=F_MINI_;
        F_MAXI_EN_COURS=F_MAXI_;
        this.init_constantes_son(FREQ_LA4_HERTZ);
    }
    public NotesEtFrequences(double FREQ_LA4_HERTZ) {
        F_MINI_EN_COURS=this.F_MINI_ABS;
        F_MAXI_EN_COURS=this.F_MAXI_ABS;
        this.init_constantes_son(FREQ_LA4_HERTZ);
    }
    public NotesEtFrequences(){
        F_MINI_EN_COURS=this.F_MINI_ABS;
        F_MAXI_EN_COURS=this.F_MAXI_ABS;
        double F_LA4=440.0;
        this.init_constantes_son(F_LA4);
    }
    public double frequence_note_from_do0_en_demi_ton(double f_reelle) {
        return Math.log(f_reelle)/LOG_DEMI_TON-this.LOG_DO_0_EN_DEMI_TON;
    }
    public double frequence_note(double i_note,double octave) {
        return Math.exp((i_note*LOG_DEMI_TON+octave*LOG_OCTAVE+LOG_DO_0));
    }
    public double frequence_note(double i_note) {
        return Math.exp((i_note*LOG_DEMI_TON+LOG_DO_0));
    }
   public  note_detaillee details_note(double f_reelle,boolean preferred_diese){
        double note_demi_ton=this.frequence_note_from_do0_en_demi_ton(f_reelle);
        int note_demi_ton_int=(int) Math.round(note_demi_ton);
        note_detaillee details=new note_detaillee();
        details.octave=(int) Math.floor(note_demi_ton/this.NB_NOTES_PAR_OCTAVE);
        details.note_modulo_octave=note_demi_ton_int-this.NB_NOTES_PAR_OCTAVE*details.octave;
        while (details.note_modulo_octave<0) {
            details.octave-=1;
            details.note_modulo_octave+=this.NB_NOTES_PAR_OCTAVE;
        }
        while (details.note_modulo_octave>=this.NB_NOTES_PAR_OCTAVE) {
            details.octave+=1;
            details.note_modulo_octave-=this.NB_NOTES_PAR_OCTAVE;
        }
        details.decalage_en_demi_ton=(float) (note_demi_ton-note_demi_ton_int);
        if (preferred_diese) {
          details.nom_note_modulo_octave=new String(this.NOM_NOTE_MODULO_OCTAVE_DIESE[details.note_modulo_octave]);
        }
        else {
          details.nom_note_modulo_octave=new String(this.NOM_NOTE_MODULO_OCTAVE_BEMOL[details.note_modulo_octave]);
            
        }
        details.nom_note_global=new String(details.nom_note_modulo_octave+String.valueOf(details.octave));
        details.frequence_note=(float) f_reelle;
        return details;
    }
    
    public  note_detaillee details_note(double f_reelle){
        double note_demi_ton=this.frequence_note_from_do0_en_demi_ton(f_reelle);
        int note_demi_ton_int=(int) Math.round(note_demi_ton);
        note_detaillee details=new note_detaillee();
        details.octave=(int) Math.floor(note_demi_ton/this.NB_NOTES_PAR_OCTAVE);
        details.note_modulo_octave=note_demi_ton_int-this.NB_NOTES_PAR_OCTAVE*details.octave;
        while (details.note_modulo_octave<0) {
            details.octave-=1;
            details.note_modulo_octave+=this.NB_NOTES_PAR_OCTAVE;
        }
        while (details.note_modulo_octave>=this.NB_NOTES_PAR_OCTAVE) {
            details.octave+=1;
            details.note_modulo_octave-=this.NB_NOTES_PAR_OCTAVE;
        }
        details.decalage_en_demi_ton=(float) (note_demi_ton-note_demi_ton_int);
        details.nom_note_modulo_octave=new String(this.NOM_NOTE_MODULO_OCTAVE_DIESE[details.note_modulo_octave]);
        details.nom_note_global=new String(details.nom_note_modulo_octave+String.valueOf(details.octave));
        details.frequence_note=(float) f_reelle;
        return details;
    }
    
    public void init_constantes_son(double f_la4){
        int octave,note_mod_12,interv=0;
        
        this.NOM_INTERVALLE=new String[INTERVALLE_MAX+1];
        NOM_INTERVALLE[interv++]="0 demi-ton => meme note";
        NOM_INTERVALLE[interv++]="1 demi-ton => seconde mineure";
        NOM_INTERVALLE[interv++]="2 demi-ton => seconde majeure";
        NOM_INTERVALLE[interv++]="3 demi-ton => tierce mineure";
        NOM_INTERVALLE[interv++]="4 demi-ton => tierce majeure";
        NOM_INTERVALLE[interv++]="5 demi-ton => quatrieme";
        NOM_INTERVALLE[interv++]="6 demi-ton => cinquieme mineure";
        NOM_INTERVALLE[interv++]="7 demi-ton => cinquieme";
        NOM_INTERVALLE[interv++]="8 demi-ton => sixieme mineure";
        NOM_INTERVALLE[interv++]="9 demi-ton => sixieme";
        NOM_INTERVALLE[interv++]="10 demi-ton => septieme mineure";
        NOM_INTERVALLE[interv++]="11 demi-ton => septieme MAJEURE";
        NOM_INTERVALLE[interv++]="12 demi-ton => huitieme (Octave)";
        NOM_INTERVALLE[interv++]="13 demi-ton => neuvieme mineure";
        NOM_INTERVALLE[interv++]="14 demi-ton => neuvieme";
        
        NOM_NOTE_MODULO_OCTAVE_DIESE=new String[NB_NOTES_PAR_OCTAVE];
        note_mod_12=0;
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="DO";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="DO#";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="RE";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="RE#";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="MI";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="FA";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="FA#";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="SOL";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="SOL#";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="LA";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="LA#";
        NOM_NOTE_MODULO_OCTAVE_DIESE[note_mod_12++]="SI";
        
        NOM_NOTE_MODULO_OCTAVE_BEMOL=new String[NB_NOTES_PAR_OCTAVE];
        note_mod_12=0;
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="DO";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="REb";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="RE";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="MIb";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="MI";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="FA";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="SOLb";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="SOL";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="LAb";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="LA";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="SIb";
        NOM_NOTE_MODULO_OCTAVE_BEMOL[note_mod_12++]="SI";
        
        LOG_DEMI_TON= Math.log(2.0)/NB_NOTES_PAR_OCTAVE;
        LOG_OCTAVE= Math.log(2.0);
        LA_4= f_la4;
        LA_0= Math.exp(Math.log(LA_4)-4*LOG_OCTAVE);
        DO_0= Math.exp(Math.log(LA_0)-9*LOG_DEMI_TON);
        LOG_DO_0= Math.log(DO_0);
        LOG_DO_0_EN_DEMI_TON=LOG_DO_0/LOG_DEMI_TON;
        DO_7= Math.exp(Math.log(DO_0)+7*LOG_OCTAVE);
        SI_7= Math.exp(Math.log(DO_7)-1*LOG_DEMI_TON);
        NOTE_MINI_FROM_DO_0_ABS=(int) Math.round((Math.log(F_MINI_ABS)-Math.log(DO_0))/LOG_DEMI_TON);
        NOTE_MAXI_FROM_DO_0_ABS=(int) Math.round((Math.log(F_MAXI_ABS)-Math.log(DO_0))/LOG_DEMI_TON);
        NOTE_MINI_FROM_DO_0_EN_COURS=(int) Math.round((Math.log(F_MINI_EN_COURS)-Math.log(DO_0))/LOG_DEMI_TON);
        NOTE_MAXI_FROM_DO_0_EN_COURS=(int) Math.round((Math.log(F_MAXI_EN_COURS)-Math.log(DO_0))/LOG_DEMI_TON);
        
        
    }
    
    String nom_intervalle_demi_ton(int i) {
      if (i>this.INTERVALLE_MAX) {
         return "inconnu >"+this.NOM_INTERVALLE[INTERVALLE_MAX]+" ascendante"    ;
      } 
      if (i<-this.INTERVALLE_MAX) {
         return "inconnu <"+this.NOM_INTERVALLE[INTERVALLE_MAX]+" descendante"   ; 
      } 
      
      if (i>0) return NOM_INTERVALLE[i]+" ascendante";
      if (i<0) return NOM_INTERVALLE[-i]+" descendante";
      return NOM_INTERVALLE[i];
    }
    
}
