/*
 * Parametres.java
 *
 * Created on 13 octobre 2006, 08:53
 */

package AnaSon;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 *
 * @author  ygorra
 */
public class Parametres extends java.awt.Frame {
    String [] FREQUENCES;
    AnalyseDeSon sender;
    NotesEtFrequences notes;
    public void init_constantes_son(double f_la4){
        notes=new NotesEtFrequences(this.sender.F_MINI,this.sender.F_MAXI,f_la4);
        note_detaillee detail;
        double freq_note;
        this.jComboBoxF_MAXI.removeAllItems();
        this.jComboBoxF_MINI.removeAllItems();
        int i_selected_mini=0;
        int i_selected_maxi=0;
        int k=0;
        for (int i_note=notes.NOTE_MAXI_FROM_DO_0_ABS;i_note>=notes.NOTE_MINI_FROM_DO_0_ABS;i_note--) {
            freq_note=notes.frequence_note((double)i_note);
            detail=notes.details_note(freq_note);
            this.jComboBoxF_MAXI.addItem(detail.nom_note_global+", freq="+String.valueOf(Math.round(10.0*freq_note)/10.0))  ;
            this.jComboBoxF_MINI.addItem(detail.nom_note_global+", freq="+String.valueOf(Math.round(10.0*freq_note)/10.0));
            if (i_note==notes.NOTE_MINI_FROM_DO_0_EN_COURS) {
                i_selected_mini=k;
            }
            if (i_note==notes.NOTE_MAXI_FROM_DO_0_EN_COURS) {
                i_selected_maxi=k;
            }
            k++;
        }
        this.jComboBoxF_MAXI.setSelectedIndex(i_selected_maxi);
        this.jComboBoxF_MINI.setSelectedIndex(i_selected_mini);
            
    }

    public void init_nb_filtres(){
        int i_selected,i,k;
        // INIT NB_CEL_BES
        i_selected=0;
        this.jComboBoxNB_CEL_BES.removeAllItems();
        for ( i=1;i<=5;i++) {
            this.jComboBoxNB_CEL_BES.addItem(String.valueOf(i));
            if (i ==sender.NB_CEL_BES) {
                i_selected=i-1;
            }
        }
        this.jComboBoxNB_CEL_BES.setSelectedIndex(i_selected);
        // INIT NB_CEL_BUT
        i_selected=0;
        this.jComboBoxNB_CEL_BUT.removeAllItems();
        for ( i=1;i<=5;i++) {
            this.jComboBoxNB_CEL_BUT.addItem(String.valueOf(i));
            if (i ==sender.NB_CEL_BUT) {
                i_selected=i-1;
            }
        }
        this.jComboBoxNB_CEL_BUT.setSelectedIndex(i_selected);
        // INIT NB_FILTRE
        // INIT Intems dans ComboBox
        this.jComboBoxNB_FILTRES.removeAllItems();
        this.jComboBoxNB_FILTRES.addItem("2");
        this.jComboBoxNB_FILTRES.addItem("4");
        this.jComboBoxNB_FILTRES.addItem("6");
        this.jComboBoxNB_FILTRES.addItem("8");
        this.jComboBoxNB_FILTRES.addItem("10");
        this.jComboBoxNB_FILTRES.addItem("12");
        this.jComboBoxNB_FILTRES.addItem("16");
        this.jComboBoxNB_FILTRES.addItem("20");
        this.jComboBoxNB_FILTRES.addItem("24");
        // Select The Good Item
        i_selected=0;
        for ( i=0;i<this.jComboBoxNB_FILTRES.getItemCount();i++) {
            k=(int) Math.round(Float.parseFloat(this.jComboBoxNB_FILTRES.getItemAt(i).toString()));
            if (k ==sender.NB_FILTRES) {
                i_selected=i;
            }
        }
        
        this.jComboBoxNB_FILTRES.setSelectedIndex(i_selected);
        
        
    }
    public void valid_edits() {
        sender.stocke_data_wav=this.jComboBoxStockeDataWav.getSelectedIndex()==0;
        sender.SEUIL_MODU=Float.parseFloat(this.jTextFieldSEUIL_MODU.getText());
        sender.SEUIL_MOD2_RELATIVE=Float.parseFloat(this.jTextFieldSEUIL_MODU_RELATIVE.getText());
        sender.SEUIL_MOD2_RELATIVE*=sender.SEUIL_MOD2_RELATIVE;

        sender.SEUIL_MOINS_DERIVF=Float.parseFloat(this.jTextFieldSEUIL_MOINS_DERIVF.getText());
        sender.SEUIL_PLUS_DERIVF=Float.parseFloat(this.jTextFieldSEUIL_PLUS_DERIVF.getText());

        sender.TEMPS_MINI_NB_OK=Float.parseFloat(this.jTextFieldTEMPS_MINI_NB_OK.getText());
        sender.TEMPS_MINI_NB_ATTENTE=Float.parseFloat(this.jTextFieldTEMPS_MINI_NB_ATTENTE.getText());

        sender.SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE=Float.parseFloat(this.jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE.getText());
        sender.SEUIL_NB_OK_RELATIVE_RETARD_GROUPE=Float.parseFloat(this.jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE.getText());

        sender.SEUIL_W_ATTENTE_RELATIVE_DEMI_TON=Float.parseFloat(this.jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON.getText());
        sender.SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS=Float.parseFloat(this.jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS.getText());

        sender.COEFF_RECOUVREMENT_NOTES_SYNCHRONES=Float.parseFloat(this.jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES.getText());
        sender.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON=Float.parseFloat(this.jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON.getText());

        sender.SEUIL_TEMPS_NOTES_ASYNCHRONES=Float.parseFloat(this.jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES.getText());
        sender.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON=Float.parseFloat(this.jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON.getText());
        
    }
    public void init_edits() {
        if (sender.stocke_data_wav) {
            this.jComboBoxStockeDataWav.setSelectedIndex(0);
        }
        else {
            this.jComboBoxStockeDataWav.setSelectedIndex(1);           
        }
        this.jTextFieldSEUIL_MODU.setText(String.valueOf(sender.SEUIL_MODU));
        this.jTextFieldSEUIL_MODU_RELATIVE.setText(String.valueOf(Math.sqrt(sender.SEUIL_MOD2_RELATIVE)));

        this.jTextFieldSEUIL_MOINS_DERIVF.setText(String.valueOf(sender.SEUIL_MOINS_DERIVF));
        this.jTextFieldSEUIL_PLUS_DERIVF.setText(String.valueOf(sender.SEUIL_PLUS_DERIVF));

        this.jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE.setText(String.valueOf(sender.SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE));
        this.jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE.setText(String.valueOf(sender.SEUIL_NB_OK_RELATIVE_RETARD_GROUPE));
 
        this.jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON.setText(String.valueOf(sender.SEUIL_W_ATTENTE_RELATIVE_DEMI_TON));
        this.jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS.setText(String.valueOf(sender.SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS));
        this.jTextFieldSEUIL_W_INST_RELATIVE_6DB.setText(String.valueOf(sender.SEUIL_W_INST_RELATIVE_6DB));

        this.jTextFieldTEMPS_MINI_NB_ATTENTE.setText(String.valueOf(sender.TEMPS_MINI_NB_ATTENTE));
        this.jTextFieldTEMPS_MINI_NB_OK.setText(String.valueOf(sender.TEMPS_MINI_NB_OK));
 
        this.jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON.setText(String.valueOf(sender.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON));
        this.jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES.setText(String.valueOf(sender.COEFF_RECOUVREMENT_NOTES_SYNCHRONES));

        this.jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON.setText(String.valueOf(sender.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON));
        this.jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES.setText(String.valueOf(sender.SEUIL_TEMPS_NOTES_ASYNCHRONES));

    }
    public void setParametres(AnalyseDeSon sender_) {
        sender=sender_;
        // Constantes son et choix des frequences
        init_constantes_son(440.0);
        init_nb_filtres();
        init_edits();
        // ComboBoxF_LA
        this.jComboBoxF_LA.removeAllItems();
        this.jComboBoxF_LA.addItem("LA 440Hz");
        this.jComboBoxF_LA.addItem("LA 442Hz");
        if (sender.F_LA<=441) {
            this.jComboBoxF_LA.setSelectedIndex(0);
        } else {
            this.jComboBoxF_LA.setSelectedIndex(1);
        }
        
        
    }
    /** Creates new form Parametres */
    public Parametres() {
        initComponents();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPopupMenu1 = new javax.swing.JPopupMenu();
        jMenuItemVALIDER = new javax.swing.JMenuItem();
        jMenuItemRESET = new javax.swing.JMenuItem();
        jPanelStandard = new javax.swing.JPanel();
        jPanelFreq = new javax.swing.JPanel();
        jComboBoxF_MINI = new javax.swing.JComboBox();
        jComboBoxF_MAXI = new javax.swing.JComboBox();
        jComboBoxF_LA = new javax.swing.JComboBox();
        jPanelFiltres = new javax.swing.JPanel();
        jComboBoxNB_CEL_BUT = new javax.swing.JComboBox();
        jComboBoxNB_CEL_BES = new javax.swing.JComboBox();
        jComboBoxNB_FILTRES = new javax.swing.JComboBox();
        jPanelDetection = new javax.swing.JPanel();
        jPanelSeuilDeltaF = new javax.swing.JPanel();
        jTextFieldSEUIL_PLUS_DERIVF = new javax.swing.JTextField();
        jTextFieldSEUIL_MOINS_DERIVF = new javax.swing.JTextField();
        jPanelSeuilW = new javax.swing.JPanel();
        jTextFieldSEUIL_W_INST_RELATIVE_6DB = new javax.swing.JTextField();
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS = new javax.swing.JTextField();
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON = new javax.swing.JTextField();
        jPanelSeuilMODU = new javax.swing.JPanel();
        jTextFieldSEUIL_MODU = new javax.swing.JTextField();
        jTextFieldSEUIL_MODU_RELATIVE = new javax.swing.JTextField();
        jComboBoxStockeDataWav = new javax.swing.JComboBox();
        jPanelSeuilTempEtRegroup = new javax.swing.JPanel();
        jPanelSeuilTEMPS = new javax.swing.JPanel();
        jTextFieldTEMPS_MINI_NB_OK = new javax.swing.JTextField();
        jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE = new javax.swing.JTextField();
        jTextFieldTEMPS_MINI_NB_ATTENTE = new javax.swing.JTextField();
        jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE = new javax.swing.JTextField();
        jPanelRegroup = new javax.swing.JPanel();
        jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES = new javax.swing.JTextField();
        jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON = new javax.swing.JTextField();
        jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES = new javax.swing.JTextField();
        jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON = new javax.swing.JTextField();

        jPopupMenu1.getAccessibleContext().setAccessibleParent(this);
        jMenuItemVALIDER.setText("Valider");
        jPopupMenu1.add(jMenuItemVALIDER);

        jMenuItemRESET.setText("Reset Values");
        jPopupMenu1.add(jMenuItemRESET);

        setLayout(new java.awt.GridLayout(1, 3));

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                MyExitForm(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jPanelStandard.setLayout(new java.awt.GridLayout(2, 1));

        jPanelStandard.setBorder(javax.swing.BorderFactory.createTitledBorder("Parametres Standard"));
        jPanelFreq.setLayout(new java.awt.GridLayout(3, 1));

        jPanelFreq.setBorder(javax.swing.BorderFactory.createTitledBorder("Frequences"));
        jComboBoxF_MINI.setBackground(new java.awt.Color(0, 204, 51));
        jComboBoxF_MINI.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxF_MINI.setToolTipText("Frequence Minimum de detection\nOn indique a la fois la note et l'octave  au format Midi\nEt la frequence reelle correspondantepour un LA a 440Hz\n( cette frequence est ensuite calculee conformement \n  a la frequence du LA que vous avez retenue)");
        jComboBoxF_MINI.setBorder(javax.swing.BorderFactory.createTitledBorder("Frequence Minimum"));
        jPanelFreq.add(jComboBoxF_MINI);

        jComboBoxF_MAXI.setBackground(new java.awt.Color(51, 204, 0));
        jComboBoxF_MAXI.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxF_MAXI.setToolTipText("Frequence Maximum de detection\nOn indique a la fois la note et l'octave  au format Midi\nEt la frequence reelle correspondantepour un LA a 440Hz\n( cette frequence est ensuite calculee conformement \n  a la frequence du LA que vous avez retenue)\n");
        jComboBoxF_MAXI.setBorder(javax.swing.BorderFactory.createTitledBorder("Frequence Maximum"));
        jComboBoxF_MAXI.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxF_MAXIActionPerformed(evt);
            }
        });

        jPanelFreq.add(jComboBoxF_MAXI);

        jComboBoxF_LA.setBackground(new java.awt.Color(51, 204, 0));
        jComboBoxF_LA.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxF_LA.setToolTipText("Frequence de reference pour la Note LA\nNormalement 440Hz,\npar contre nombreuses sont les personnes qui preferent 442Hz pour les pianos,\n a vous de voir\n");
        jComboBoxF_LA.setBorder(javax.swing.BorderFactory.createTitledBorder("Frequence du LA"));
        jComboBoxF_LA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxF_LAActionPerformed(evt);
            }
        });

        jPanelFreq.add(jComboBoxF_LA);

        jPanelStandard.add(jPanelFreq);

        jPanelFiltres.setLayout(new java.awt.GridLayout(3, 1));

        jPanelFiltres.setBorder(javax.swing.BorderFactory.createTitledBorder("Filtres De Detection"));
        jComboBoxNB_CEL_BUT.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxNB_CEL_BUT.setToolTipText("Nombre de cellules elementaires d'ordre 2,\npour chacun des filtres de decimation ( Butterworth)\nplus il y a de cellules, et plus la decimation est efficace,\net plus on augmente le temps de calcul\n4 cellules (ordre 8) est raisonnable\n");
        jComboBoxNB_CEL_BUT.setBorder(javax.swing.BorderFactory.createTitledBorder("Nb Cellules Butterworth"));
        jPanelFiltres.add(jComboBoxNB_CEL_BUT);

        jComboBoxNB_CEL_BES.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxNB_CEL_BES.setToolTipText("Nombre de cellules elementaires d'ordre 2,\npour chacun des filtres passe_bas apres demodulation ( Bessel)\nplus il y a de cellules, et plus lle filtrage  est efficace (temps de retard de groupe constant),\net plus on augmente le temps de calcul\n4 cellules (ordre 8) est raisonnable\n");
        jComboBoxNB_CEL_BES.setBorder(javax.swing.BorderFactory.createTitledBorder("Nombre de Cellules Bessel"));
        jPanelFiltres.add(jComboBoxNB_CEL_BES);

        jComboBoxNB_FILTRES.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxNB_FILTRES.setToolTipText("nombre de filtres de demodulation par octave,\nquand  ce nombre grandit , \n  1-la detection devient plus robuste au bruit et aux interferences,\nmais le temps de detection augmente, ainsi que le temps de calcul\non peut admettre raisonnablement 4 a 12 filtres / Octave\n(pour info il y a 12 notes a detecter par octave, ca ne signifie pas qu'il faut 12 filtres !...)\n ");
        jComboBoxNB_FILTRES.setBorder(javax.swing.BorderFactory.createTitledBorder("Nombre de Filtres par Octave"));
        jComboBoxNB_FILTRES.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxNB_FILTRESActionPerformed(evt);
            }
        });

        jPanelFiltres.add(jComboBoxNB_FILTRES);

        jPanelStandard.add(jPanelFiltres);

        add(jPanelStandard);

        jPanelDetection.setLayout(new java.awt.GridLayout(4, 1));

        jPanelDetection.setBorder(javax.swing.BorderFactory.createTitledBorder("Parametres de Detection des pistes"));
        jPanelSeuilDeltaF.setLayout(new java.awt.GridLayout(2, 1));

        jPanelSeuilDeltaF.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil DFMes/DFDEMODU"));
        jTextFieldSEUIL_PLUS_DERIVF.setText("jTextField1");
        jTextFieldSEUIL_PLUS_DERIVF.setToolTipText("seuil maximum accepte sur la derivee de la frequence instantanee\npar rapport a la frequence de demodulation\n( idealement, on doit trouver une valeur de 1 pour cette grandeur,\n lorsque la frequence instantanee est exploitable)\nvaleurs raisonnables de 1.25 a 1.75\n");
        jTextFieldSEUIL_PLUS_DERIVF.setBorder(javax.swing.BorderFactory.createTitledBorder("max dwinst / dwmodu"));
        jPanelSeuilDeltaF.add(jTextFieldSEUIL_PLUS_DERIVF);

        jTextFieldSEUIL_MOINS_DERIVF.setText("jTextField1");
        jTextFieldSEUIL_MOINS_DERIVF.setToolTipText("seuil minimum accepte sur la derivee de la frequence instantanee\npar rapport a la frequence de demodulation\n( idealement, on doit trouver une valeur de 1 pour cette grandeur,\n lorsque la frequence instantanee est exploitable)\nvaleurs raisonnables de 0.25 a 0.75\n");
        jTextFieldSEUIL_MOINS_DERIVF.setBorder(javax.swing.BorderFactory.createTitledBorder("min dwinst/dwmodu"));
        jPanelSeuilDeltaF.add(jTextFieldSEUIL_MOINS_DERIVF);

        jPanelDetection.add(jPanelSeuilDeltaF);

        jPanelSeuilW.setLayout(new java.awt.GridLayout(3, 1));

        jPanelSeuilW.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuil de Detection Frequences"));
        jTextFieldSEUIL_W_INST_RELATIVE_6DB.setText("jTextField1");
        jTextFieldSEUIL_W_INST_RELATIVE_6DB.setToolTipText("seuil relatif entre la frequence maximum detectee\net la frequence de coupure a 6db du filtre\nvaleurs raisonnables entre 1 et 4");
        jTextFieldSEUIL_W_INST_RELATIVE_6DB.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil w_inst/ w_6db"));
        jPanelSeuilW.add(jTextFieldSEUIL_W_INST_RELATIVE_6DB);

        jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS.setText("jTextField1");
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS.setToolTipText("ecart en frequence pour lequel on decide d'une coupure\nde piste, apres une attente, relativement a\nla bande de frequences acceptee par le filtre\n valeur raisonnable entre\n        0.05 => cree beaucoup de pistes\n        0.2   => regroupe trop de pistes  ");
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil w _att/w_plus"));
        jPanelSeuilW.add(jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS);

        jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON.setText("jTextField1");
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON.setToolTipText("ecart en demi_ton au dela duquel on decide\nde separer des notes, apres attente\nvaleur raisonnable 0.25 ( un quart de demi-ton )\n ");
        jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil w_att/demi_ton"));
        jPanelSeuilW.add(jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON);

        jPanelDetection.add(jPanelSeuilW);

        jPanelSeuilMODU.setLayout(new java.awt.GridLayout(2, 1));

        jPanelSeuilMODU.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuil de Detection Amplitude"));
        jTextFieldSEUIL_MODU.setText("jTextField1");
        jTextFieldSEUIL_MODU.setToolTipText("seuil de detection sur l'amplitude du signal pour detection\n10 par defaut , \n( sachant que les signaux sont codes en general entre -32768 et 32768, c'est un seuil tres faible...)");
        jTextFieldSEUIL_MODU.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil module"));
        jPanelSeuilMODU.add(jTextFieldSEUIL_MODU);

        jTextFieldSEUIL_MODU_RELATIVE.setText("jTextField1");
        jTextFieldSEUIL_MODU_RELATIVE.setToolTipText("Seuil de detection en amplitude, relativement a la plus grande amplitude \ndetectee\nvaleurs raisonnables entre\n 0.01 (-40db)=> les notes d'amplitude tres faibles sont detectees\n 0.3  (-10db) => seules les notes de grande amplitude sont detectees");
        jTextFieldSEUIL_MODU_RELATIVE.setBorder(javax.swing.BorderFactory.createTitledBorder("seuil module/module maxi"));
        jPanelSeuilMODU.add(jTextFieldSEUIL_MODU_RELATIVE);

        jPanelDetection.add(jPanelSeuilMODU);

        jComboBoxStockeDataWav.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "OUI", "NON" }));
        jComboBoxStockeDataWav.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder("Stocker Chaque filtre pour Wav")));
        jPanelDetection.add(jComboBoxStockeDataWav);

        add(jPanelDetection);

        jPanelSeuilTempEtRegroup.setLayout(new java.awt.GridLayout(2, 1));

        jPanelSeuilTempEtRegroup.setBorder(javax.swing.BorderFactory.createTitledBorder("Parametres de regroupement des pistes"));
        jPanelSeuilTEMPS.setLayout(new java.awt.GridLayout(4, 1));

        jPanelSeuilTEMPS.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuil de Detection Temporels"));
        jTextFieldTEMPS_MINI_NB_OK.setText("jTextField1");
        jTextFieldTEMPS_MINI_NB_OK.setToolTipText("Temps minimum en secondes,\ndurant lequel tous les seuils de detection doivent etre respectes \npour accepter une note\nvaleur par defaut 0.1s");
        jTextFieldTEMPS_MINI_NB_OK.setBorder(javax.swing.BorderFactory.createTitledBorder("temps mini ok"));
        jPanelSeuilTEMPS.add(jTextFieldTEMPS_MINI_NB_OK);

        jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE.setText("jTextField1");
        jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE.setToolTipText("Temps minimum en secondes,\ndurant lequel tous les seuils de detection doivent etre respectes \npour accepter une note,\nrelativement au retard de groupe du filtre de detection concern\u00e9\nvaleurs raisonnables entre \n        0.25 ( les notes breves en haute frequence(inaudibles) risquent d'etre detectees)\net 4 ( les notes breves en basses frequence risquent de ne pas etre detectees)");
        jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE.setBorder(javax.swing.BorderFactory.createTitledBorder("temps min ok /retard grp"));
        jPanelSeuilTEMPS.add(jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE);

        jTextFieldTEMPS_MINI_NB_ATTENTE.setText("jTextField1");
        jTextFieldTEMPS_MINI_NB_ATTENTE.setToolTipText("Temps minimum de jonction entre 2 notes ,en secondes\n\nlorsque 2 notes tres rapprochees sont detectees, on les regroupe en une seule,\na condition que leurs frequences soient suffisamment proches,\net qu'elles soient temporellement assez proches,\nc'est ce temps que l'on regle ici, relativement au retard de groupe du filtre\n\n\nvaleurs raisonnables entre \n        0.01s ( risque de regrouper des notes qui n'auraient pas du l'etre)\net 0.5s  (risque de ne pas regrouper des notes qui auraient du l'etre)");
        jTextFieldTEMPS_MINI_NB_ATTENTE.setBorder(javax.swing.BorderFactory.createTitledBorder("temps mini att"));
        jPanelSeuilTEMPS.add(jTextFieldTEMPS_MINI_NB_ATTENTE);

        jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE.setText("jTextField1");
        jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE.setToolTipText("Temps minimum de jonction entre 2 notes ,\nrelativement au retard de groupe du filtre de detection concern\u00e9\nlorsque 2 notes tres rapprochees sont detectees, on les regroupe en une seule,\na condition que leurs frequences soient suffisamment proches,\net qu'elles soient temporellement assez proches,\nc'est ce temps que l'on regle ici, relativement au retard de groupe du filtre\n\n\nvaleurs raisonnables entre \n        0.1 ( risque de regrouper des notes qui n'auraient pas du l'etre)\net 0.5 (risque de ne pas regrouper des notes qui auraient du l'etre) ");
        jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE.setBorder(javax.swing.BorderFactory.createTitledBorder("temps mini att / retard grp"));
        jPanelSeuilTEMPS.add(jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE);

        jPanelSeuilTempEtRegroup.add(jPanelSeuilTEMPS);

        jPanelRegroup.setLayout(new java.awt.GridLayout(4, 1));

        jPanelRegroup.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuils De Regroupement des pistes"));
        jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES.setText("jTextField1");
        jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES.setToolTipText("fixe le temps relatif de recouvremetn, en dela duquel 2 pistes sont considerees  synchrones");
        jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES.setBorder(javax.swing.BorderFactory.createTitledBorder("Temps Relatif De Recouvrement pistes synchrones"));
        jPanelRegroup.add(jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES);

        jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON.setText("jTextField1");
        jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON.setToolTipText("seuil en demi-ton en dessous duquel 2 pistes synchrones sont regroupees");
        jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuil de Regroupement pistes synchrones en demi-ton"));
        jPanelRegroup.add(jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON);

        jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES.setText("jTextField1");
        jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES.setToolTipText("tempsen secondes au dessus duquel 2 notes asynchrones ne peuvent et etre regroupees");
        jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES.setBorder(javax.swing.BorderFactory.createTitledBorder("temps regroupement pistes asynchrones (en secondes)"));
        jPanelRegroup.add(jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES);

        jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON.setText("jTextField1");
        jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON.setToolTipText("Seuil frequentiel de regroupement de notes asynchrones, en demi ton");
        jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON.setBorder(javax.swing.BorderFactory.createTitledBorder("Seuil regroupement pistes asynchrones en demi-ton"));
        jPanelRegroup.add(jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON);

        jPanelSeuilTempEtRegroup.add(jPanelRegroup);

        add(jPanelSeuilTempEtRegroup);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBoxNB_FILTRESActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxNB_FILTRESActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxNB_FILTRESActionPerformed

    private void jComboBoxF_LAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxF_LAActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxF_LAActionPerformed

    private void jComboBoxF_MAXIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxF_MAXIActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxF_MAXIActionPerformed
    
    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
// TODO add your handling code here:
    }//GEN-LAST:event_formWindowOpened
    private void valid_frequences(){
        double freq_note;
        int i_la;
      // frequence du LA Retenue
        i_la=this.jComboBoxF_LA.getSelectedIndex();
        
        if (i_la==0) {sender.F_LA=440f;}
        else         {sender.F_LA=442f;}
      // Calcul F_MAXI
        int i_note_F_MAXI= notes.NOTE_MAXI_FROM_DO_0_ABS-this.jComboBoxF_MAXI.getSelectedIndex();
        freq_note=notes.frequence_note(i_note_F_MAXI);
        sender.F_MAXI=(float)(freq_note*sender.F_LA/notes.LA_4);
        int i_note_F_MINI= notes.NOTE_MAXI_FROM_DO_0_ABS-this.jComboBoxF_MINI.getSelectedIndex();
        freq_note=notes.frequence_note(i_note_F_MINI);
        sender.F_MINI=(float)(freq_note*sender.F_LA/notes.LA_4);
         
    }
    private void valid_nb_filtres(){
        double d;
        d=Double.parseDouble((String)(this.jComboBoxNB_CEL_BES.getSelectedItem()));
        sender.NB_CEL_BES=(int)Math.round(d); 

        d=Double.parseDouble((String)(this.jComboBoxNB_CEL_BUT.getSelectedItem()));
        sender.NB_CEL_BUT=(int)Math.round(d); 

        d=Double.parseDouble((String)(this.jComboBoxNB_FILTRES.getSelectedItem()));
        sender.NB_FILTRES=(int)Math.round(d); 
    }
    private void MyExitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_MyExitForm
// TODO add your handling code here:
        valid_frequences();
        this.valid_edits();
        this.valid_nb_filtres();
        setVisible(false);
        dispose();
        
    }//GEN-LAST:event_MyExitForm
    
    /** Exit the Application */
    /**
     * @param args the command line arguments
     */
    
        
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox jComboBoxF_LA;
    private javax.swing.JComboBox jComboBoxF_MAXI;
    private javax.swing.JComboBox jComboBoxF_MINI;
    private javax.swing.JComboBox jComboBoxNB_CEL_BES;
    private javax.swing.JComboBox jComboBoxNB_CEL_BUT;
    private javax.swing.JComboBox jComboBoxNB_FILTRES;
    private javax.swing.JComboBox jComboBoxStockeDataWav;
    private javax.swing.JMenuItem jMenuItemRESET;
    private javax.swing.JMenuItem jMenuItemVALIDER;
    private javax.swing.JPanel jPanelDetection;
    private javax.swing.JPanel jPanelFiltres;
    private javax.swing.JPanel jPanelFreq;
    private javax.swing.JPanel jPanelRegroup;
    private javax.swing.JPanel jPanelSeuilDeltaF;
    private javax.swing.JPanel jPanelSeuilMODU;
    private javax.swing.JPanel jPanelSeuilTEMPS;
    private javax.swing.JPanel jPanelSeuilTempEtRegroup;
    private javax.swing.JPanel jPanelSeuilW;
    private javax.swing.JPanel jPanelStandard;
    private javax.swing.JPopupMenu jPopupMenu1;
    private javax.swing.JTextField jTextFieldCOEFF_RECOUVREMENT_NOTES_SYNCHRONES;
    private javax.swing.JTextField jTextFieldSEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON;
    private javax.swing.JTextField jTextFieldSEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON;
    private javax.swing.JTextField jTextFieldSEUIL_MODU;
    private javax.swing.JTextField jTextFieldSEUIL_MODU_RELATIVE;
    private javax.swing.JTextField jTextFieldSEUIL_MOINS_DERIVF;
    private javax.swing.JTextField jTextFieldSEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE;
    private javax.swing.JTextField jTextFieldSEUIL_NB_OK_RELATIVE_RETARD_GROUPE;
    private javax.swing.JTextField jTextFieldSEUIL_PLUS_DERIVF;
    private javax.swing.JTextField jTextFieldSEUIL_TEMPS_NOTES_ASYNCHRONES;
    private javax.swing.JTextField jTextFieldSEUIL_W_ATTENTE_RELATIVE_DEMI_TON;
    private javax.swing.JTextField jTextFieldSEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS;
    private javax.swing.JTextField jTextFieldSEUIL_W_INST_RELATIVE_6DB;
    private javax.swing.JTextField jTextFieldTEMPS_MINI_NB_ATTENTE;
    private javax.swing.JTextField jTextFieldTEMPS_MINI_NB_OK;
    // End of variables declaration//GEN-END:variables
    
}
