/*
 * PlotDataAndNotesCanvas.java
 *
 * Created on 18 octobre 2006, 07:52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.LinkedList;

/**
 *
 * @author ygorra
 */
public class PlotDataAndNotesCanvas extends Canvas {
    LinkedList infos_ok;
    int width, height;
    final int SIGNAL=0;
    final int FREQUENCE=1;
    int TypeTrace;
    
    MemoireClcDetect [] local_tab_memoire_detect;
    short min_value,max_value;
    short [] local_data;
    short [] local_buffer_short;
    byte [] local_buffer_byte;
    /* for frequency */
    
    float MIN_LOG_FREQUENCE;
    float MAX_LOG_FREQUENCE;
    float [] frequ_en_demi_ton;
    Object [] tab_infos_ok;
    float amp_frequence[];
    int ind_frequence[];
    float max_frequence_en_demi_ton;
    
    float min_frequence_en_demi_ton;
    
    private float min_amp_frequence;
    
    private float max_amp_frequence;
    
    private int max_n0_reel;
    
    private int min_n0_reel;
    
    private int min_n1_reel;
    
    private int max_n1_reel;
    NotesEtFrequences notes;
    float[] tab_f_moins_en_demi_ton;
    float[] tab_f_plus_en_demi_ton;
    
    
    float F_ECH;
    
    ContexteFlts Contexte;
    
    float x0_partition_relative=0f;
    float x1_partition_relative=1f;
    float y0_partition_relative=0f;
    float y1_partition_relative=1f;
    
    int min_frequence_en_demi_ton_int;
    
    
    int max_frequence_en_demi_ton_int;
    
    private AnalyseDeSon sender;
    
    
    
    int n0,n1;
    public void compute_min_max_frequence(int n0,int n1) {
        InfoTrack info_ok;
        if (this.frequ_en_demi_ton==null) {return;}
        if (n0<0) {n0=0;}
        if (n1>frequ_en_demi_ton.length-1) {n1=frequ_en_demi_ton.length-1;}
        if ( n1<n0 ) {return;}
        min_frequence_en_demi_ton=frequ_en_demi_ton[n0];
        max_frequence_en_demi_ton=frequ_en_demi_ton[n0];
        info_ok=(InfoTrack ) (tab_infos_ok[n0]);
        max_n0_reel=min_n0_reel=info_ok.n0_reel;
        max_n1_reel=min_n1_reel=info_ok.n1_reel;
        min_amp_frequence=amp_frequence[n0];
        max_amp_frequence=amp_frequence[n0];
        for (int i=n0;i<=n1;i++){
            info_ok=(InfoTrack) tab_infos_ok[i];
            min_n0_reel=Math.min(min_n0_reel,info_ok.n0_reel);
            max_n0_reel=Math.max(max_n0_reel,info_ok.n0_reel);
            min_n1_reel=Math.min(min_n1_reel,info_ok.n1_reel);
            max_n1_reel=Math.max(max_n1_reel,info_ok.n1_reel);
            min_frequence_en_demi_ton=Math.min(min_frequence_en_demi_ton,frequ_en_demi_ton[i]);
            max_frequence_en_demi_ton=Math.max(max_frequence_en_demi_ton,frequ_en_demi_ton[i]);
            min_amp_frequence=Math.min(min_amp_frequence,amp_frequence[i]);
            max_amp_frequence=Math.max(max_amp_frequence,amp_frequence[i]);
        }
        if (max_frequence_en_demi_ton==min_frequence_en_demi_ton) { max_frequence_en_demi_ton+=0.5f ;min_frequence_en_demi_ton-=0.5f;}
        if (max_n1_reel==min_n0_reel) { max_n1_reel+=1 ;min_n0_reel-=1;}
    }
    
    public void compute_min_max(int n0,int n1) {
        if (n1>=n0) {
            min_value=local_data[n0];
            max_value=local_data[n0];
        } else {
            min_value=-1;
            max_value=1;
            
        }
        for (int i=n0;i<=n1;i++){
            if (local_data[i]<min_value) { min_value=local_data[i];}
            if (local_data[i]>max_value) { max_value=local_data[i];}
        }
        if (max_value==min_value) { max_value+=1 ;min_value-=1;}
    }
    PlotDataAndNotesCanvas(int w, int h, short[] data,short[] buffer_short,byte []buffer_byte,float F_ECH_,float F_LA_) {
        this.TypeTrace=this.SIGNAL;
        setSize(width = w, height = h);
        int nb_data=0;
        int nb_buffer_short=0;
        int nb_buffer_byte=0;
        F_ECH=F_ECH_;
        notes=null;
        if (data==null) {
            local_data=null;
            
        } else {
            nb_data=data.length;
            local_data=new short[nb_data];
        }
        if (buffer_short==null) {
            local_buffer_short=new short[2];
            
        } else {
            nb_buffer_short=buffer_short.length;
            if (nb_buffer_short>16) {nb_buffer_short=16;}
            local_buffer_short=new short[nb_buffer_short];
            for (int i=0;i<local_buffer_short.length;i++){
                local_buffer_short[i]=buffer_short[i];
            }
        }
        if (buffer_byte==null) {
            local_buffer_byte=new byte[2];
            
        } else {
            nb_buffer_byte=buffer_byte.length;
            if (nb_buffer_byte>16) {nb_buffer_byte=16;}
            local_buffer_byte=new byte[nb_buffer_byte];
            for (int i=0;i<local_buffer_byte.length;i++){
                local_buffer_byte[i]=buffer_byte[i];
            }
        }
        
        int nb_byte;
        n0=0;
        this.n0=0;
        this.n1=-1;
        if ( local_data!=null ) {
            this.n1=local_data.length-1;
            for (int i=n0;i<=n1;i++){
                local_data[i]=data[i];
            }
        }
        compute_min_max(n0,n1);
    }
    public int GetNB_FREQUENCES() {
        if (infos_ok==null) {return 0;}
        return infos_ok.size();
    }
    public void init_info_ok_detection() {
        MemoireClcDetect[] tab_mem=Contexte.tab_memoire_detect;
        MemoireClcDetect mem;
        float f_reelle,f_reelle_en_demi_ton;
        int i,i_f;
        InfoDetection info_detection;
        InfoTrack info_ok;
        Iterator iterator;
        max_frequence_en_demi_ton=-1000.0f;
        min_frequence_en_demi_ton=1000.0f;
        if (tab_mem==null) {
            infos_ok=null;
            frequ_en_demi_ton=null;
            amp_frequence=null;
            ind_frequence=null;
            return;
        }
        
        Contexte.compute_super_tracks(Contexte.infos_tracks);// marquage des meilleures notes
        infos_ok=Contexte.infos_tracks;
        int NB_FREQUENCES=GetNB_FREQUENCES();
        if (NB_FREQUENCES >0) {
            tab_infos_ok= infos_ok.toArray();
            frequ_en_demi_ton  =new float[NB_FREQUENCES];
            amp_frequence  =new float[NB_FREQUENCES];
            ind_frequence  =new int[NB_FREQUENCES];
            i_f=0;
            iterator = infos_ok.iterator();
            while (iterator.hasNext()) {
                info_ok=  (InfoTrack)(iterator.next());
                mem=info_ok.mem;
                info_detection=mem.info_detection;
                f_reelle=info_ok.sum_w_inst/info_ok.sum_mod_square;
                f_reelle*=mem.freq_reelle_sur_w_inst;
                f_reelle+=mem.info_detection.FCentraleReelle;
                ind_frequence[i_f]=mem.info_detection.indice_filtre;
                frequ_en_demi_ton[i_f]=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                
                amp_frequence[i_f]=(float) Math.sqrt(info_ok.mean_mod_square);
                i_f++;
                compute_min_max_frequence(0,frequ_en_demi_ton.length-1);
            }
        } else {
            tab_infos_ok=null;
            frequ_en_demi_ton=null;
            amp_frequence=null;
            ind_frequence=null;
        }
        if (tab_mem !=null) {
            tab_f_plus_en_demi_ton=new float[tab_mem.length-1];
            tab_f_moins_en_demi_ton=new float[tab_mem.length-1];
            for (i=1;i<tab_mem.length;i++) {
                mem= tab_mem[i];
                if (mem.is_in_interval) {
                    f_reelle= (float)(mem.seuil_plus_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    tab_f_plus_en_demi_ton[i-1]=f_reelle_en_demi_ton;
                    
                    f_reelle= (float)(mem.seuil_moins_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    tab_f_moins_en_demi_ton[i-1]=f_reelle_en_demi_ton;
                }
            }
        } else {
            tab_f_plus_en_demi_ton=null;
            tab_f_moins_en_demi_ton=null;
        }
        if (max_frequence_en_demi_ton <=min_frequence_en_demi_ton) {
            max_frequence_en_demi_ton=0.5f;
            min_frequence_en_demi_ton=-0.5f;
        }
        
    }
    
    PlotDataAndNotesCanvas(int w, int h, ContexteFlts Contexte_,AnalyseDeSon sender_) {
        sender=sender_;
        this.TypeTrace=this.FREQUENCE;
        Contexte=Contexte_;
        F_ECH=Contexte.F_ECH;
        notes =new NotesEtFrequences(Contexte.F_MINI,Contexte.F_MAXI,Contexte.F_LA);
        max_frequence_en_demi_ton_int=notes.NOTE_MAXI_FROM_DO_0_EN_COURS;
        min_frequence_en_demi_ton_int=notes.NOTE_MINI_FROM_DO_0_EN_COURS;;
        
        setSize(width = w, height = h);
        init_info_ok_detection();
        this.n0=0;
        this.n1=-1;
        if ( frequ_en_demi_ton!=null ) {
            this.n1=frequ_en_demi_ton.length-1;
        }
    }
    public void paintData(Graphics g){
        int i;
        width = getSize().width;
        height = getSize().height;
        int x0,x1;
        int y0,y1;
        double echelle_x=1.0;
        double echelle_y=1.0;
        // draw the rows
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        if (local_data==null) {
            g.setColor(Color.RED);
            g.drawString("NO DATA TO DRAW",width/2,height/2);
            return;
        }
        int n0=0;
        int n1=this.local_data.length-1;
        if (n1>n0) {
            echelle_y = (double)(height-1) / (double)(max_value-min_value);
            echelle_x = (double)(width-1) / (double)(n1-n0);
        }
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        g.setColor(Color.GRAY);
        for (i = n0; i < n1; i++) {
            y0=height-1-(int) Math.round((local_data[i]-min_value)*echelle_y);
            y1=height-1-(int) Math.round((local_data[i+1]-min_value)*echelle_y);
            x0=(int) Math.round((i-n0)*echelle_x);
            x1=(int) Math.round((i+1-n0)*echelle_x);
            g.drawLine(x0, y0, x1, y1);
        }
        g.setColor(Color.RED);
        g.setColor(Color.RED);
        for (i=0;i<local_buffer_short.length;i++) {
            g.drawString("Short["+String.valueOf(i)+"] ="+String.valueOf(local_buffer_short[i]),100,20+i*(height-21)/(local_buffer_short.length+1));
        }
        for (i=0;i<local_buffer_byte.length;i+=2) {
            g.drawString("byte["+String.valueOf(i)+"] ="+String.valueOf(local_buffer_byte[i]),200,20+i*(height-21)/(local_buffer_byte.length+1));
            g.drawString("byte["+String.valueOf(i+1)+"] ="+String.valueOf(local_buffer_byte[i+1]),300,20+i*(height-21)/(local_buffer_byte.length+1));
        }
        g.setColor(Color.BLUE);
        g.drawString("max ="+String.valueOf(max_value),1,20);
        g.drawString("min ="+String.valueOf(min_value),1,height-1-20);
        
        
    }
    public void paintFrequence(Graphics g){
        InfoTrack info_ok;
        int i;
        int i_color=0;
        width = getSize().width;
        height = getSize().height;
        int x0,x1;
        int y0,y1;
        // w ou h peuvent changer => reinit systematique des echelles
        notes.init_echelles_partition(this.min_frequence_en_demi_ton_int,
                this.max_frequence_en_demi_ton_int,
                width,height,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative,
                0.05f);
        echelle_graphique echelle_x = new echelle_graphique(
                0f,1f,
                notes.echelle_x_partition.x0     ,notes.echelle_x_partition.x1    ,
                min_n0_reel, max_n1_reel);
        
        
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        g.setColor(Color.WHITE);
        g.fillRect(notes.echelle_x_partition.x0     ,notes.echelle_y_partition.x0,
                notes.echelle_x_partition.largeur,notes.echelle_y_partition.largeur);
        if (this.sender.stocke_data_wav==true) {
            if (tab_f_moins_en_demi_ton!=null){
                i_color=0;
                for (i = 0; i < tab_f_moins_en_demi_ton.length; i++) {
                    i_color=(i+1) & 1;
                    switch(i_color){
                        case 0:g.setColor(Color.YELLOW);break;
                        case 1:g.setColor(Color.ORANGE);break;
                    }
                    i_color++;
                    if (i_color==2) {i_color=0;}
                    y0=notes.echelle_y_partition.getPixel(tab_f_moins_en_demi_ton[i]);
                    y1=notes.echelle_y_partition.getPixel(tab_f_plus_en_demi_ton[i]);
                    
                    x0=echelle_x.getPixel(min_n0_reel);
                    x1=echelle_x.getPixel(max_n1_reel);
                    g.fillRect(x0, y0, x1-x0+1, y0-y1+1);
                    
                }
            }
        }
        notes.draw_partition(g,min_frequence_en_demi_ton_int,max_frequence_en_demi_ton_int);
        if (frequ_en_demi_ton==null) {
            g.setColor(Color.RED);
            g.drawString("NO FREQUENCY TRACK TO DRAW",width/2,height/2);
        } else {
            // trace des meilleures notes synchrones
            g.setColor(Color.RED);
            for (i = n0; i < n1; i++) {
                info_ok=(InfoTrack) tab_infos_ok[i];
                if ((info_ok.is_a_super_track==true)&&(info_ok.nb_tracks_in_super_track!=1)) {
                    
                    y0=notes.echelle_y_partition.getPixel((float) notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track));
                    y1=y0;
                    x0=echelle_x.getPixel(info_ok.n0_reel_super_track);
                    x1=echelle_x.getPixel(info_ok.n1_reel_super_track);
                    g.drawLine(x0, y0, x1, y0);
                    g.drawLine(x0, y0-3, x0, y0+3);
                    g.drawLine(x1, y0-3, x1, y0+3);
                }
            }
            // trace de toutes les notes
            for (i = n0; i < n1; i++) {
                info_ok=(InfoTrack) tab_infos_ok[i];
                if ( !info_ok.is_a_super_track ) {
                    i_color=(int) (info_ok.numero_super_track&3);
                    switch(i_color){
                        case 0:g.setColor(Color.CYAN);break;
                        case 1:g.setColor(Color.BLUE);break;
                        case 2:g.setColor(Color.GREEN);break;
                        case 3:g.setColor(Color.LIGHT_GRAY);break;
                    }
                } else {
                    g.setColor(Color.BLACK); // reserve aux notes solitaires
                }
                y0=notes.echelle_y_partition.getPixel(this.frequ_en_demi_ton[i]);
                y1=y0;
                x0=echelle_x.getPixel(info_ok.n0_reel);
                x1=echelle_x.getPixel(info_ok.n1_reel);
                g.drawLine(x0, y0, x1, y1);
            }
        }
        
        if ((frequ_en_demi_ton!=null)||(tab_f_moins_en_demi_ton!=null)) {
            g.setColor(Color.RED);
            // note maxi
            double f_reelle= notes.frequence_note(this.max_frequence_en_demi_ton);
            note_detaillee detail=notes.details_note(f_reelle);
            y0=notes.echelle_y_partition.getPixel(detail.note_modulo_octave+notes.NB_NOTES_PAR_OCTAVE*detail.octave);
            g.drawString("Note Maxi ="+detail.nom_note_global+", Frequence ="+String.valueOf(Math.round(100.0*detail.frequence_note)/100.0),1,y0+g.getFontMetrics().getHeight());
            // note mini
            f_reelle= notes.frequence_note(this.min_frequence_en_demi_ton);
            detail=notes.details_note(f_reelle);
            y0=notes.echelle_y_partition.getPixel(detail.note_modulo_octave+notes.NB_NOTES_PAR_OCTAVE*detail.octave);
            g.drawString("Note Mini ="+detail.nom_note_global+", Frequence ="+String.valueOf(Math.round(100.0*detail.frequence_note)/100.0),1,y0);
        }
    }
    
    public void paint(Graphics g) {
        if (TypeTrace==SIGNAL) {
            paintData(g);
        } else {
            paintFrequence(g);
        }
    }
}
