/*
 * PlotFiltersAndData.java
 *
 * Created on 10 octobre 2006, 07:43
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Iterator;
import javax.swing.JComboBox;
import javax.swing.JFrame;

/**
 *
 * @author ygorra
 */
public class PlotFiltersAndData extends JFrame{
    ContexteFlts Contexte;
    short[] buffer_short;
    float[][] tab_mod2_plus;
    float[][] tab_mod2_moins;
    float[][] tab_w_inst_plus;
    float[][] tab_w_inst_moins;
    float[][] tab_delta_w_inst;
    float[][] tab_retard_de_groupe;
    float[][] tab_x;
    private JComboBox jComboBoxMem;
    private PlotFiltersAndDataCanvas draw_canvas ;

    boolean stocke_data=false;
    private void jComboBoxMemActionPerformed(java.awt.event.ActionEvent evt) {
// TODO add your handling code here:
        if (draw_canvas==null){return;}
        int index=jComboBoxMem.getSelectedIndex()+1;
        draw_canvas.set_memoire(index);
    }
    
    private void init_components() {
        int w=this.getContentPane().getWidth();
        int h=this.getContentPane().getHeight();
        jComboBoxMem=new javax.swing.JComboBox();
        jComboBoxMem.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        jComboBoxMem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxMemActionPerformed(evt);
            }
        });
        
        this.init_items_mem();
        jComboBoxMem.setBounds(1,1,this.getWidth(),this.getHeight()/20) ;
        draw_canvas = new PlotFiltersAndDataCanvas(this);
        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
                layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .add(draw_canvas, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 689, Short.MAX_VALUE)
                .addContainerGap())
                .add(layout.createSequentialGroup()
                .add(jComboBoxMem, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 553, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(146, 146, 146))))
                );
        layout.setVerticalGroup(
                layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                .add(layout.createSequentialGroup()
                .add(draw_canvas, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 393, Short.MAX_VALUE)
                .add(31, 31, 31)
                .add(jComboBoxMem)
                .addContainerGap())
                );
        
        
    }
    public PlotFiltersAndData(String Title, int x0,int y0,int w,int h,short []buffer_short_,ContexteFlts Contexte_,boolean stocke_data_wav) {
        this.stocke_data=stocke_data_wav; 
        this.init_frame(buffer_short_,Contexte_);
        this.setTitle(Title);
        this.setLocation(x0,y0);
        this.setSize(w,h);
        this.init_components();
        // Now create a Canvas and add it to the Frame.
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                setVisible(false);
                dispose();
            }
        });
        
        // Normal end ... pack it up!
        pack();
        this.setVisible(true);
        
    }
    
    private void init_tabs_results(){
        int i_mem;
        MemoireClcDetect mem;
        int longueur_init_result=(buffer_short.length/Contexte.LGN_BUFFER)*Contexte.LGN_BUFFER;
        
        tab_mod2_plus=new float[Contexte.tab_memoire_detect.length][];
        tab_mod2_moins=new float[Contexte.tab_memoire_detect.length][];
        tab_w_inst_plus=new float[Contexte.tab_memoire_detect.length][];
        tab_w_inst_moins=new float[Contexte.tab_memoire_detect.length][];
        tab_delta_w_inst=new float[Contexte.tab_memoire_detect.length][];
        tab_retard_de_groupe=new float[Contexte.tab_memoire_detect.length][];
        tab_x=new float[Contexte.tab_memoire_detect.length][];
        
        for (i_mem=1;i_mem<Contexte.tab_memoire_detect.length;i_mem++) {
            mem=Contexte.tab_memoire_detect[i_mem];
            if ((mem.is_in_interval==true )&& (this.stocke_data==true)) {
                tab_mod2_plus[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_mod2_moins[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_w_inst_plus[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_w_inst_moins[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_delta_w_inst[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_retard_de_groupe[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
                tab_x[i_mem]=new float[longueur_init_result/mem.info_detection.coeff_decimation];
            }
        }
    }
    
    private void traite_data(){
        int nb_trames,k,i_mem,k_buffer;
        MemoireClcDetect mem;
        nb_trames=0;
        int nb_buffers=buffer_short.length/Contexte.LGN_BUFFER;
        Contexte.execution_en_cours=true;
        for (k=0;k<nb_buffers;k++){
            k_buffer=k*Contexte.LGN_BUFFER;
            Contexte.set_new_source(buffer_short,k_buffer);
            Contexte.execute_instructions(Contexte.instructions);
            for (i_mem=1;i_mem<Contexte.tab_memoire_detect.length;i_mem++) {
                mem=Contexte.tab_memoire_detect[i_mem];
                int lgn_src=mem.tab_mod2_plus.length;
                int k_dst=k*lgn_src;
                float tmp=mem.SeuilPlusDeltaW;
                for (int k_src=0;k_src<lgn_src;k_src++) {
                    if (tab_mod2_plus[i_mem]!=null) {
                        tab_mod2_plus[i_mem][k_dst]=(float)Math.sqrt(mem.tab_mod2_plus[k_src]);
                        tab_mod2_moins[i_mem][k_dst]=(float)Math.sqrt(mem.tab_mod2_moins[k_src]);
                        tab_w_inst_plus[i_mem][k_dst]=Math.max(mem.seuil_moins_w_inst,Math.min(mem.seuil_plus_w_inst,mem.tab_w_inst_plus[k_src]));
                        tab_delta_w_inst[i_mem][k_dst]=(float) Math.max(mem.SeuilMoinsDeltaW,Math.min(mem.tab_delta_w_inst[k_src],mem.SeuilPlusDeltaW));
                        tab_w_inst_moins[i_mem][k_dst]=mem.tab_w_inst_plus[k_src]+mem.tab_delta_w_inst[k_src];
                        tab_w_inst_moins[i_mem][k_dst]=(float) Math.max(mem.seuil_moins_w_inst,Math.min(mem.seuil_plus_w_inst,tab_w_inst_moins[i_mem][k_dst]));
                        tab_retard_de_groupe[i_mem][k_dst]=mem.tab_retard_de_groupe[k_src];
                        tab_x[i_mem][k_dst]=k_dst;
                    }
                    k_dst++;
                }
            }
            nb_trames++;
        }
        Contexte.execution_en_cours=false;
    }
    public void init_items_mem() {
        int i_mem;
        MemoireClcDetect mem;
        if (jComboBoxMem==null) {return;}
        jComboBoxMem.removeAllItems();
        for(i_mem=1;i_mem<Contexte.tab_memoire_detect.length;i_mem++){
            mem=  Contexte.tab_memoire_detect[i_mem];
            boolean ok=mem!=null;
            if (ok) {ok=mem.is_in_interval;}
            if (ok) {
                jComboBoxMem.addItem("Mem["+String.valueOf(i_mem)+"],FC="+String.valueOf(mem.info_detection.FCentraleReelle));
            } else {
                jComboBoxMem.addItem("Mem["+String.valueOf(i_mem)+"],Unused");
                        
            }
        }
    }
    public void init_frame(short[] buffer_short_,ContexteFlts Contexte_){
        buffer_short=buffer_short_;
        Contexte=Contexte_;
        init_tabs_results();
        traite_data();
        init_items_mem();
        start_plotpanel();
    }
    public void start_plotpanel(){
        
        
        
    }
}

