/*
 * PlotNotesClePlotPanel.java
 *
 * Created on 9 octobre 2006, 12:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JPanel;

/**
 *
 * @author ygorra
 */
public class PlotNotesClePlotPanel extends JPanel implements MouseListener{
    public void mousePressed(MouseEvent e) {
        
    }
    
    public void mouseReleased(MouseEvent e) {
        
    }
    
    public void mouseEntered(MouseEvent e) {
        
    }
    public void mouseExited(MouseEvent e) {
        
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getButton()==e.BUTTON1) mouseClickedButton1(e);
        if (e.getButton()==e.BUTTON2) mouseClickedButton2(e);
        if (e.getButton()==e.BUTTON3) mouseClickedButton3(e);
    }
    public void mouseClickedButton1(MouseEvent e) {
        n_reel_mouse=0;
        if (e.getButton()!=e.BUTTON1) return;
        if (this.notes==null) return;
        int x=e.getPoint().x;
        int y=e.getPoint().y              ;
        echelle_graphique echelle_x = new echelle_graphique(
                0f,1f,
                notes.echelle_x_partition.x0     ,notes.echelle_x_partition.x1    ,
                min_n0_reel, max_n1_reel);
        int n_reel=(int) Math.round(echelle_x.getRealValue(x));
        if (n_reel>=max_n1_reel) return;
        if (n_reel<=min_n0_reel) return;
        if (ne_pas_utiliser_notes_a_afficher==true){return;}
        n_reel_mouse=n_reel;
        
        // Trace des touches piano actives
        this.repaint();
        //     MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,infos_ok);
        
    }
    public void mouseClickedButton2(MouseEvent e) {
        this.adjust_notes=false;
        if (this.notes==null) return;
        
        //     MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,this.Intervals,this.adjust_notes);
        
    }
    public void mouseClickedButton3(MouseEvent e) {
        this.adjust_notes=false;
        if (this.notes==null) return;
        
        //   MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,this.Fondamentales,this.adjust_notes);
        
    }
    
    int width, height;
    
    
    float MIN_LOG_FREQUENCE;
    float MAX_LOG_FREQUENCE;
    float [] frequ_en_demi_ton;
    Object [] tab_infos_ok;
    float amp_frequence[];
    int ind_frequence[];
    float max_frequence_en_demi_ton;
    
    float min_frequence_en_demi_ton;
    
    
    private int max_n0_reel;
    
    private int min_n0_reel;
    
    private int min_n1_reel;
    
    private int max_n1_reel;
    NotesEtFrequences notes;
    
    float F_ECH;
    
    ContexteFlts Contexte;
    
    float x0_partition_relative=0f;
    float x1_partition_relative=0.9f;
    float x0_module_relative=0.9f;
    float x1_module_relative=1f;
    float y0_partition_relative=0f;
    float y1_partition_relative=1f;
    
    int min_frequence_en_demi_ton_int;
    
    
    int max_frequence_en_demi_ton_int;
    
    private AnalyseDeSon sender;
    
    private boolean ne_pas_utiliser_notes_a_afficher=true;
    
    private AudioFormat format;
    
    
    private boolean adjust_notes;
    
    private Interval[] Intervals;
    
    private int n_reel_mouse=0;
    
    
    
    
    
    int n0;
    
    private LinkedList notes_a_afficher=null;
    
    private Interval interval_a_afficher=null;
    
    public float DECAL_MOYEN_DEMI_TON;
    
    int n1;
    
    
    
    public PlotNotesClePlotPanel(PlotNotesPlotPanel sender1_,int w,int h){
        if (sender1_==null) return;
        sender=sender1_.sender;
        this.min_n0_reel=sender1_.min_n0_reel;
        this.min_n1_reel=sender1_.min_n1_reel;
        this.max_n0_reel=sender1_.max_n0_reel;
        this.max_n1_reel=sender1_.max_n1_reel;
        Contexte=sender1_.Contexte;
        F_ECH=Contexte.F_ECH;
        format =sender1_.format;
        notes =new NotesEtFrequences(Contexte.F_MINI,Contexte.F_MAXI,Contexte.F_LA);
        max_frequence_en_demi_ton_int=notes.NOTE_MAXI_FROM_DO_0_EN_COURS;
        min_frequence_en_demi_ton_int=notes.NOTE_MINI_FROM_DO_0_EN_COURS;;
        this.Intervals=sender1_.Intervals;
        this.DECAL_MOYEN_DEMI_TON=this.decalage_moyen_des_meilleures_notes();
        setSize(width = w, height = h);
        addMouseListener(this);
        
    }
    public float decalage_moyen_des_meilleures_notes() {
        float decal=0f;
        float poids=0f;
        float decal_poids=0f;
        if (this.Intervals!=null) {
            Interval it;
            InfoNote nt;
            for (int i=0;i<Intervals.length;i++) {
                it=Intervals[i];
                if (it.notes!=null) {
                    InfoNote[] local_notes=new InfoNote[it.notes.length];
                    for (int i_n=0;i_n<local_notes.length;i_n++) local_notes[i_n]=it.notes[i_n];
                    Contexte.sort_notes_by_decreasing_sum_square_module(local_notes);
                    // affiche seulement 3 meilleures notes
                    for (int i_n=0;(i_n<local_notes.length)&&(i_n<1);i_n++) {
                        nt=local_notes[i_n];
                        if ((nt.frequences>Contexte.F_MINI)&&(nt.frequences<Contexte.F_MAXI)) {
                            float note_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(nt.frequences);
                            decal=note_en_demi_ton-Math.round(note_en_demi_ton);
                            if (decal<0f) decal+=1f;
                            decal_poids+=decal*nt.poids;
                            poids+=nt.poids;
                        }
                    }
                }
            }
        }
        if (poids>0f) {
            decal=decal_poids/poids;
            if (decal>0.5f) decal-=1f;
        }
        return decal;
    }
    
    public void paintComponent(Graphics g) {
        InfoTrack info_ok;
        int i;
        int i_color=0;
        width = getSize().width;
        height = getSize().height;
        int x0,x1;
        int y0,y1;
        int hauteur_note=0;
        float note_cle;
        // w ou h peuvent changer => reinit systematique des echelles
        notes.init_echelles_partition(this.min_frequence_en_demi_ton_int,
                this.max_frequence_en_demi_ton_int,
                width,height,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative,
                0.05f);
        float hauteur_all_notes=Math.abs(notes.echelle_y_cle.max_value-notes.echelle_y_cle.min_value);
        
        if (hauteur_all_notes>0f) hauteur_note=(int)Math.round(2f*notes.echelle_y_cle.largeur/hauteur_all_notes);
        echelle_graphique echelle_x = new echelle_graphique(
                0f,1f,
                notes.echelle_x_partition.x0     ,notes.echelle_x_partition.x1    ,
                min_n0_reel, max_n1_reel);
        
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        g.setColor(Color.WHITE);
        g.fillRect(notes.echelle_x_partition.x0     ,notes.echelle_y_partition.x0,
                notes.echelle_x_partition.largeur,notes.echelle_y_partition.largeur);
        notes.draw_partition_cle_de_sol(g,min_frequence_en_demi_ton_int,max_frequence_en_demi_ton_int);
        draw_touches_piano_actives(g);
        if (n_reel_mouse >0) {
            x0=echelle_x.x0;
            g.setColor(Color.RED);
            y0=notes.echelle_y_partition.min_pixel;
            String S="t="+String.valueOf(n_reel_mouse/Contexte.F_ECH);
            g.drawString(S,x0,y0-10);
        }
        // trace des intervalles
        if (this.Intervals!=null) {
            Interval it;
            InfoNote nt;
            for (i=0;i<Intervals.length;i++) {
                it=Intervals[i];
                if (it.notes!=null) {
                    InfoNote[] local_notes=new InfoNote[it.notes.length];
                    for (int i_n=0;i_n<local_notes.length;i_n++) local_notes[i_n]=it.notes[i_n];
                    Contexte.sort_notes_by_decreasing_sum_square_module(local_notes);
                    x0=echelle_x.getPixel(it.n0);
                    x1=echelle_x.getPixel(it.n1);
                    // affiche seulement 3 meilleures notes
                    for (int i_n=0;(i_n<local_notes.length)&&(i_n<3);i_n++) {
                        nt=local_notes[i_n];
                        if ((nt.frequences>Contexte.F_MINI)&&(nt.frequences<Contexte.F_MAXI)) {
                            float note_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(nt.frequences);
                            note_en_demi_ton-=this.DECAL_MOYEN_DEMI_TON; 
                            note_cle=notes.note_cle(note_en_demi_ton);
                            y0=notes.echelle_y_cle.getPixel(note_cle);
                            y1=y0;
                            switch (i_n) {
                                case 0:g.setColor(Color.BLACK);break;
                                case 1:g.setColor(Color.GRAY);break;
                                case 2:g.setColor(Color.LIGHT_GRAY);break;
                                default:g.setColor(Color.CYAN);
                                
                            }
                            if (!notes.is_diese_ou_bemol(note_en_demi_ton)) {
                                g.fillOval(x0,y0-hauteur_note/2,hauteur_note,hauteur_note);
                            } else {
                                x1=x0+hauteur_note;
                                g.drawLine(x0,y0-hauteur_note/2,x0+hauteur_note/4,y0+hauteur_note/2);
                                g.drawLine(x1-hauteur_note/4,y0-hauteur_note/2,x1,y0+hauteur_note/2);
                                g.drawLine(x0,y0-hauteur_note/4,x1,y0-hauteur_note/4);
                                g.drawLine(x0,y0+hauteur_note/4,x1,y0+hauteur_note/4);
                            }
                            //    g.drawLine(x0,y0-5,x0,y0+5);
                            //    g.drawLine(x1,y0-5,x1,y0+5);
                            
                        }
                    }
                }
            }
        }
        
    }
    public void draw_note_cle(Graphics g,float note_en_demi_ton,int x0,Color color) {
        int x1;
        int y0,y1;
        int hauteur_note=0;
        if (notes.echelle_y_cle==null) return;
        Color old_color=g.getColor();
        g.setColor(color);
        boolean is_diese=notes.is_diese_ou_bemol(note_en_demi_ton);
        float note_cle=notes.note_cle(note_en_demi_ton);
        float hauteur_all_notes=Math.abs(notes.echelle_y_cle.max_value-notes.echelle_y_cle.min_value);
        if (hauteur_all_notes>0f) hauteur_note=(int)Math.round(2f*notes.echelle_y_cle.largeur/hauteur_all_notes);
        // trace des intervalles
        y0=notes.echelle_y_cle.getPixel(note_cle);
        y1=y0;
        g.fillOval(x0,y0-hauteur_note/2,hauteur_note,hauteur_note);
        if (is_diese) {
          x0+=hauteur_note;  
          x1=x0+hauteur_note;
          g.drawLine(x0,y0-hauteur_note/2,x0+hauteur_note/4,y0+hauteur_note/2);
          g.drawLine(x1-hauteur_note/4,y0-hauteur_note/2,x1,y0+hauteur_note/2);
          g.drawLine(x0,y0-hauteur_note/4,x1,y0-hauteur_note/4);
          g.drawLine(x0,y0+hauteur_note/4,x1,y0+hauteur_note/4);
      }
      g.setColor(old_color);
   }
    
    private void draw_touches_piano_actives(Graphics g) {
        Color old_color;
        note_detaillee detail;
        InfoTrack info_ok;
        // trace des touches de piano active
        this.ne_pas_utiliser_notes_a_afficher=true ;
        old_color=g.getColor();
        boolean ok;
        float f_reelle_en_demi_ton;
        String noms_notes="";
        if (notes_a_afficher!=null ) {
            
            Contexte.sort_tracks_by_increasing_better_f_reelle(notes_a_afficher);
            Iterator iterator= notes_a_afficher.iterator();
            while (iterator.hasNext()) {
                Object O= iterator.next();
                ok=O!=null;
                if (ok) {
                    
                    info_ok=  (InfoTrack) O;
                    f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track);
                    detail= notes.details_note(notes.frequence_note(f_reelle_en_demi_ton));
                    if (noms_notes=="") {
                        noms_notes="notes reperees = "+detail.nom_note_global;
                    } else{
                        noms_notes=noms_notes+","+detail.nom_note_global;
                    }
                    notes.draw_touche_piano_active(g,f_reelle_en_demi_ton);
                }
            }
        }
        if (interval_a_afficher!=null) {
            if (interval_a_afficher.notes!=null) {
                f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(interval_a_afficher.notes[0].frequences);
                detail= notes.details_note(notes.frequence_note(f_reelle_en_demi_ton));
                if (noms_notes=="") {
                    noms_notes="note retenue  = "+detail.nom_note_global;
                } else{
                    noms_notes="note retenue = "+detail.nom_note_global+" , "+noms_notes;
                }
                notes.draw_touche_piano_active(g,f_reelle_en_demi_ton);
            }
        }
        if (noms_notes!="") {
            g.setColor(Color.RED);
            g.drawString(noms_notes,notes.echelle_x_partition.x0,notes.echelle_y_partition.x0+g.getFontMetrics().getHeight());
        }
        g.setColor(old_color);
        
        this.ne_pas_utiliser_notes_a_afficher=false ;
    }
    
    
    
    
}

