/*
 * Sound2ScoresPlotPanel.java
 *
 * Created on 9 octobre 2006, 12:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Iterator;
import java.util.LinkedList;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JPanel;
import javax.sound.sampled.AudioFormat.Encoding;

/**
 *
 * @author ygorra
 */
public class Sound2ScoresPlotPanel extends JPanel implements Runnable{


    double DUREE_AFFICHAGE=6.0; // largeur temporelle du panneau d'affichage
    min_max_int[] n0_n1;
    min_max_int[] debut_fin_liste;
    
    ContexteFlts Contexte;
    Object[] tab_infos_ok;
    LinkedList local_infos_ok;
    TargetDataLine line_acquisition;
    AudioFormat format;
    int buffer_size;
    int LGN_BUF;
    byte  buffer_byte[];// = new byte[buffer_size];
    short buffer_short[];// = new short[LGN_BUF];
    int frame_size;//=format.getChannels();
    
    boolean is_big_endian;//=true;
    AnalyseDeSon sender;
    int nb_plot;
    long refresh_time_ms;
    NotesEtFrequences notes;
    echelle_graphique echelle_x_module=null;
    echelle_graphique echelle_x_n0_n1=null;
    float x0_partition_relative=0.0f;
    float x1_partition_relative=0.8f;
    float y0_partition_relative=0.05f;
    float y1_partition_relative=0.95f;
    
    float x0_decal_relative=0.5f;
    float x1_decal_relative=0.9f;
    float decal_min_demi_ton=-0.5f;
    float decal_max_demi_ton=0.5f;
    
    private float max_frequence_en_demi_ton;
    
    private float min_frequence_en_demi_ton;
    int i_min_log_frequence;
    int i_max_log_frequence;
    
    
    float max_module=0.5f;
    
    float last_f_reelle=0.0f;
    
    int last_y0=0;
    
    float last_f_reelle_en_demi_ton=0.0f;
    
    float last_decal_f_reelle_en_demi_ton=0.0f;
    
    float last_int_f_reelle_en_demi_ton=0.0f;
    
    InfoTrack last_info_ok=null;
    
    public int etat;
    final int ATTENTE_LANCEMENT=1;
    
    final int ATTENTE_FLT_PASSE_HAUT=2;
    
    final int MESURE_NOISE=3;
    final int WORKING=4;
    
    int NB_LISTE_A_AFFICHER;
    
    private int numero_liste_aff;
    
    private int max_indice_liste_ok;
    
    private int dernier_debut_liste_ok;
    
    private int min_indice_liste_ok;

    private boolean component_has_been_painted;

    private boolean is_signed;

    private int nb_bytes;
 
    private LinkedList global_infos_ok=null;  
    
    public void init_info_ok_detection(ContexteFlts Contexte) {
        float f_reelle,f_reelle_en_demi_ton;
        int i,i_f;
        MemoireClcDetect mem;
        InfoDetection info_detection;
       
        InfoTrack info_ok;
        Iterator iterator;
        max_frequence_en_demi_ton=-1000.0f;
        min_frequence_en_demi_ton=1000.0f;
        max_module=1.0f;
        global_infos_ok=new LinkedList();
        notes=new NotesEtFrequences(Contexte.F_MINI,Contexte.F_MAXI,Contexte.F_LA);
        MemoireClcDetect [] tab=Contexte.tab_memoire_detect;
        if (tab !=null) {
            for (i=1;i<tab.length;i++) {
                mem= tab[i];
                if (mem.is_in_interval) {
                    f_reelle= (float)(mem.seuil_plus_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    f_reelle= (float)(mem.seuil_moins_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                }
            }
        }
        if (max_frequence_en_demi_ton <=min_frequence_en_demi_ton) {
            max_frequence_en_demi_ton=0.5f;
            min_frequence_en_demi_ton=-0.5f;
        }
        min_frequence_en_demi_ton=(float) Math.floor(min_frequence_en_demi_ton);
        max_frequence_en_demi_ton=(float) Math.ceil(max_frequence_en_demi_ton);
        i_min_log_frequence=Math.round(min_frequence_en_demi_ton);
        i_max_log_frequence=Math.round(max_frequence_en_demi_ton);
        
        
    }
    public void init_liste_aff(){
        NB_LISTE_A_AFFICHER=(int) Math.ceil(this.DUREE_AFFICHAGE/(Contexte.LGN_BUFFER/Contexte.F_ECH));
        if (NB_LISTE_A_AFFICHER <0) {NB_LISTE_A_AFFICHER=1;}
        this.debut_fin_liste=new min_max_int[NB_LISTE_A_AFFICHER];
        for (int i=0;i<debut_fin_liste.length;i++) {
            debut_fin_liste[i]=new min_max_int();
            // min>max => liste vide
            debut_fin_liste[i].max_data=0;
            debut_fin_liste[i].min_data=1;
        }
        
    }
    public Sound2ScoresPlotPanel(AnalyseDeSon sender_,ContexteFlts Contexte_,TargetDataLine line_acquisition_,AudioFormat format_,int w,int h){
        sender=sender_;
        Contexte=Contexte_;
        line_acquisition=line_acquisition_;
        format=format_;
        local_infos_ok=new LinkedList();
        this.refresh_time_ms=Math.round(2.0*Contexte.TEMPS_MAXI_NB_OK*1000.0);
        if (this.refresh_time_ms<500) {
            this.refresh_time_ms=500;
        }
        this.init_liste_aff();
        this.init_info_ok_detection(Contexte);
        nb_plot=0;
        init_acquisition();
        start_acquisition();
    }
    public void    met_a_jour_debut_fin_liste(Object[] tab_infos_ok){
        min_max_int df,min_max;
        
        df=debut_fin_liste[numero_liste_aff];
        df.min_data=local_infos_ok.size();
        int k=0,i;
        for (i=0;i<tab_infos_ok.length;i++) {
            if (tab_infos_ok[i]!=null) {
                local_infos_ok.add(tab_infos_ok[i]);
                k++;
            }
        }
        df.max_data=local_infos_ok.size()-1;
        dernier_debut_liste_ok=df.min_data;
        numero_liste_aff++;
        if (numero_liste_aff>=NB_LISTE_A_AFFICHER) {numero_liste_aff=0;}
        max_indice_liste_ok=-1;
        min_indice_liste_ok= local_infos_ok.size()+1;
        // calcul des min et max des pistes
        for (i=0;i<debut_fin_liste.length;i++) {
            df= debut_fin_liste[i];
            if (df.max_data>=df.min_data) {
                min_indice_liste_ok=(min_indice_liste_ok<df.min_data)?min_indice_liste_ok:df.min_data;
                max_indice_liste_ok=(max_indice_liste_ok>df.max_data)?max_indice_liste_ok:df.max_data;
            }
        }
        // elimination des infos inutiles dans la liste locale, pour empecher depassement memoire
        if ((min_indice_liste_ok>0)&&(min_indice_liste_ok<=max_indice_liste_ok)) {
            // elimination des elts inutiles dans la liste
            int a_eliminer=min_indice_liste_ok;
            for (i=0;i<a_eliminer;i++) {
                local_infos_ok.removeFirst();// elimine premier elet
            }
            // recalage des indices
            for (i=0;i<debut_fin_liste.length;i++) {
                df= debut_fin_liste[i];
                if (df.max_data>=df.min_data) {
                    df.max_data-=a_eliminer;
                    df.min_data-=a_eliminer;
                }
            }
            min_indice_liste_ok-=a_eliminer;
            max_indice_liste_ok-=a_eliminer;
        }
        // si min_indice_liste_ok > max_indice_liste_ok, ne pas tracer
    }
    public void paintComponent(Graphics g) {
        InfoTrack info_ok,best_info_ok;
        int best_y0=0;
        float best_f_reelle_en_demi_ton=0.0f;
        float best_int_f_reelle_en_demi_ton=0.0f;
        float best_decal_f_reelle_en_demi_ton=0.0f;
        float best_f_reelle=0.0f;
        float f_reelle,f_reelle_en_demi_ton,module;
        int i,i_f;
        int w,h;
        int x0,x1,y0,y1;
        float echelle_x,echelle_y;
        //   Contexte.compute_super_tracks(Contexte.infos_tracks);// marquage liste_info_ok;
       
        w=this.getWidth();
        h=this.getHeight();
        g.setColor(Color.GRAY);
        g.fillRect(0,0,w,h);
        g.setColor(Color.BLUE);
        if (Contexte==null) {
            g.drawString("PAS DE CONTEXTE DEFINI",20,50);
            return;
        }
        if (!Contexte.running) {
            g.drawString("ATTENTE DEMARRAGE ACQUISITION",20,50);
            return;
        }
        if (etat==this.ATTENTE_FLT_PASSE_HAUT) {
            g.drawString("ATTENTE FIN REGIME TRANSITOIRE FILTRE PASSE_HAUT",20,50);
            g.drawString("SILENCE SVP!.. L'EVALUATION DES NIVEAUX DE BRUIT VA COMMENCER ",20,50+2*g.getFontMetrics().getHeight());
            return;
        }
        if (etat==this.MESURE_NOISE) {
            g.drawString("SILENCE SVP!.. EVALUATION DES NIVEAUX DE BRUIT EN COURS ",20,50);
            return;
        }
        int height_chars=g.getFontMetrics().getHeight();
        float decal_f_reelle_en_demi_ton=0.0f;
        float int_f_reelle_en_demi_ton=0.0f;
        float min_f_reelle_en_demi_ton_2=-0.5f;
        float max_f_reelle_en_demi_ton_2=0.5f;
        // pour decalage / note parfaite
        echelle_graphique echelle_decal_x=new echelle_graphique(
                x0_decal_relative,x1_decal_relative,
                1,w-1,
                this.decal_min_demi_ton,this.decal_max_demi_ton
                );
        int x_central_2=echelle_decal_x.getPixel(0f);
        
        
        
        Contexte.compute_super_tracks(Contexte.infos_tracks);
        //      min_max_float min_max_n0_n1=Contexte.get_min_max_n0_n1_reel(Contexte.infos_tracks);
        tab_infos_ok=Contexte.infos_tracks.toArray();
        for (int i_tab=0;i_tab<tab_infos_ok.length;i_tab++) {
            if (tab_infos_ok[i_tab]!=null) {
              global_infos_ok.add(tab_infos_ok[i_tab]);
            }
        }
        Contexte.infos_tracks.clear();
        met_a_jour_debut_fin_liste(tab_infos_ok);
        // Trace des notes exactes
        // w ou h peuvent changer => reinit systematique des echelles
        notes.init_echelles_partition(i_min_log_frequence,i_max_log_frequence,
                w,h,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative
                ,0.25f); // 0.25 => Piano sur 0.25/1 de la largeur
        
  /*      echelle_x_module=new echelle_graphique(
                x0_partition_relative,x1_partition_relative,
                1,w-1,
                0f,max_module
                );
   */
        echelle_x_n0_n1= new echelle_graphique(
                notes.x0_partition_relative,notes.x1_partition_relative,
                1,w-1,
                (Contexte.nb_trames-this.NB_LISTE_A_AFFICHER)*Contexte.LGN_BUFFER,
                (Contexte.nb_trames)*Contexte.LGN_BUFFER
                );
        g.setColor(Color.WHITE);
        g.fillRect(notes.echelle_x_partition.x0     ,notes.echelle_y_partition.x0,
                notes.echelle_x_partition.largeur,notes.echelle_y_partition.largeur);
        
        g.setColor(Color.CYAN);
        g.drawString(" Ecart type signal ="+String.valueOf(Math.round(Math.sqrt(Contexte.mod_square_moy))),1,1+height_chars);
        notes.draw_partition(g,i_min_log_frequence,i_max_log_frequence);
        // affichage nb appels
        
        // Trace echelle diapason
        g.setColor(Color.LIGHT_GRAY);
        f_reelle_en_demi_ton=(float) this.i_min_log_frequence;
        y0=notes.echelle_y_partition.x0;// pixel associe a i_min
        y1=notes.echelle_y_partition.x1;// pixel associe a y_max;
        g.fillRect(echelle_decal_x.x0,y0,echelle_decal_x.largeur,y0-y1);
        
        // Trace des notes relevees
        g.setColor(Color.BLUE);
        best_info_ok=null;// meilleure info sur la derniere trame
        // Trace des pistes elementaires
        if (min_indice_liste_ok <=max_indice_liste_ok) {
            Iterator it =local_infos_ok.listIterator(this.min_indice_liste_ok);
            i=min_indice_liste_ok;
            
            while ((it.hasNext())&&(i<=max_indice_liste_ok)){
                Object O=it.next();
                if (O!=null) {
                    info_ok=(InfoTrack) O;
                    // on n'affiche pas les notes isolees
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle);
                    //    g.drawString("frequence ="+String.valueOf(f_reelle),5,20+30*i_f);
                    // module=(float) Math.sqrt(mem.sum_square_mod_plus/mem.nb_ok_decim);
                    x0=echelle_x_n0_n1.getPixel(info_ok.n0_reel);
                    x1=echelle_x_n0_n1.getPixel(info_ok.n1_reel);
                    y0=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
                    y1=y0;
                    g.setColor(Color.BLUE);
                    g.drawLine(x0,y0,x1,y1);
                    // Decalage / Note Parfaite
                    decal_f_reelle_en_demi_ton=(float)Math.IEEEremainder(f_reelle_en_demi_ton,1.0);
                    int_f_reelle_en_demi_ton=f_reelle_en_demi_ton-decal_f_reelle_en_demi_ton;
                    if ((info_ok.is_a_super_track==true)&&(info_ok.nb_tracks_in_super_track>1)) { // on garde la plus basse frequence, sinon module > best_module
                        g.setColor(Color.RED);
                        x0=echelle_x_n0_n1.getPixel(info_ok.n0_reel_super_track);
                        x1=echelle_x_n0_n1.getPixel(info_ok.n1_reel_super_track);
                        f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track);
                        y0=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
                        y1=y0;
                        g.drawLine(x0,y0,x1,y1);
                        if (i>=dernier_debut_liste_ok) {
                            if (best_info_ok==null) {
                                best_info_ok=info_ok;
                            } else {
                                if (info_ok.f_reelle_super_track<best_info_ok.f_reelle_super_track) {
                                    best_info_ok=info_ok;// on garde info_ok de frequence la plus basse
                                }
                            }
                        }
                    }
                }
                i++;
            }
        }// si il y a des infos ok a tracer
        //------------------------------------------------------------------
        // AFFICHAGE MEILLEURE FREQUENCE => ACCORDEUR
        //------------------------------------------------------------------
        if (best_info_ok !=null) {last_info_ok=best_info_ok;}
        if (last_info_ok !=null) {
            note_detaillee detail=notes.details_note(last_info_ok.f_reelle_super_track);
            g.setColor(Color.RED);
            int note_en_demi_ton=notes.NB_NOTES_PAR_OCTAVE*detail.octave
                    +detail.note_modulo_octave;
            f_reelle_en_demi_ton=note_en_demi_ton
                    +detail.decalage_en_demi_ton;
            notes.draw_touche_piano_active(g,f_reelle_en_demi_ton);
            y0=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
            //    g.drawLine(echelle_x_module.min_pixel,y0,x1,y0);
            // DESACCORDAGE / FREQUENCE PARFAITE
            
            x1=echelle_decal_x.getPixel(detail.decalage_en_demi_ton);
            y1=y0+5;
            int y_0=y0-5;
            
            
            g.setColor(Color.RED);
            
            g.drawString(detail.nom_note_global
                    +","+String.valueOf(Math.round((double)detail.frequence_note*10)/10.0+" Hz")
                    ,notes.echelle_x_partition.x1+2,y_0+height_chars/2);
            
            
        }
        Contexte.infos_tracks.clear();
    }
    public boolean un_pas_acquisition(){
        int count=0;
        for(;count==0;) {
            count =line_acquisition.read(buffer_byte, 0, buffer_byte.length);
            if (count > 0) {
                sender.ConversionToShort(buffer_short,buffer_byte,frame_size,is_big_endian,is_signed,nb_bytes);
                Contexte.execute_instructions(Contexte.instructions);
                Contexte.nb_trames++;
            }
        }
        
        return true;
    }
    public void init_acquisition() {
        int nb_channels;
        LGN_BUF=Contexte.LGN_BUFFER;
        buffer_size=LGN_BUF*format.getFrameSize();
        Contexte.F_ECH=format.getSampleRate();
        buffer_byte= new byte[buffer_size];
        buffer_short= new short[LGN_BUF];
        frame_size=format.getFrameSize();
        is_big_endian=this.sender.getBigEndian(sender.CHOIX_BIG_ENDIAN,format);
        is_signed=format.getEncoding()==Encoding.PCM_SIGNED;
        nb_channels=format.getChannels();
        nb_bytes=frame_size/nb_channels;
        // longueur du buffer, 0.5s maxi, en puissance de 2
        Contexte.set_new_source(buffer_short,0);
        Contexte.running = true;
        System.out.print("Line Running : ");System.out.println(line_acquisition.isRunning());
        System.out.print("Buffer Length : ");System.out.println(buffer_byte.length);
        long start_time=System.currentTimeMillis();
        int k=0;
        Contexte.execution_en_cours=true;
    }
    public void start_acquisition() {
        try {
            line_acquisition.open(format,this.buffer_size);
        } catch (LineUnavailableException ex) {
            ex.printStackTrace();
        }
        line_acquisition.start();
    }
    public void stop_acquisition(){
        line_acquisition.stop();
        line_acquisition.close();
        System.out.println("DETECTION TERMINEE");
    }
    
    public void start() {
        Thread t = new Thread(this);
        //    t.setPriority(Thread.MIN_PRIORITY); // priorite minimale
        //	startTime = System.currentTimeMillis();
        t.start();
        
    }
    
    public void run() {
        long previous_time,current_time;
        double temps_attente_ms;
        this.etat=ATTENTE_LANCEMENT;
        repaint();
        // Attente de 5. Cte de tps du filtre passe haut
        this.etat=ATTENTE_FLT_PASSE_HAUT;
        repaint();
        temps_attente_ms=1000f*5.0f/(2*Math.PI*Contexte.FREQU_COUPURE_PASSE_HAUT);
        temps_attente_ms=Math.max(temps_attente_ms,2000.0);
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // Reset des modules maxi
        Contexte.reset_max_mod_square_and_seuil_mod2();
        // mesure des modules maxi pendant 3s
        this.etat=MESURE_NOISE;
        repaint();
        previous_time=System.currentTimeMillis();
        temps_attente_ms=3000f;
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // mise a jour des seuils
        Contexte.met_a_jour_seuils_sur_bruit();
        Contexte.infos_tracks.clear();
         
        // acquisition
        this.etat=WORKING;
        previous_time=System.currentTimeMillis();
        int old_nb_trames=Contexte.nb_trames;
        while (Contexte.running) {
            if (un_pas_acquisition()==true) {
                repaint();
            }
        }
        // fin d'acquisition
        this.stop_acquisition();
        Contexte.infos_tracks.clear();
 
        //     new PlotDataAndNotes("Notes Detectees =f(t)", 500, 500,Contexte).setVisible(true);
        
   
         
        Contexte.infos_tracks=this.global_infos_ok; 
        new PlotNotes("Notes Detectees =f(t)", 500, 500,Contexte,this.sender,this.format);
        
    }
    
    
}

