/*
 * echelle_graphique.java
 *
 * Created on 18 octobre 2006, 08:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;
public class echelle_graphique{
    float largeur_pixels;
    int min_pixel;     // min_pixel peut etre superieur a max_pixel = pixel associe a min_value
    int max_pixel;
    int x0,x1,largeur; // x0 est forcement < x1, largeur est forcement > 0
    float min_value;   // min_value peut etre superieure a max_value
    float max_value;
    float echelle;
    public int getPixel(float value) {
        if (max_value > min_value){
            value =Math.max(min_value,Math.min(max_value,value));
        } else {
            value =Math.min(min_value,Math.max(max_value,value));
        }
        return (int) Math.round(( value-min_value)*echelle + min_pixel) ;
    }
    public float getRealValue(int Pixel) {
            
        float v= (Pixel-this.min_pixel)/this.echelle+this.min_value; 
        if (max_value > min_value){
            v =Math.max(min_value,Math.min(max_value,v));
        } else {
            v =Math.min(min_value,Math.max(max_value,v));
        }
        return v;
        }
    public echelle_graphique(float x0_relative,float x1_relative,
            int   x0_ecran     ,int x1_ecran     ,
            float min_value_,float max_value_ ){
        min_value=min_value_;
        max_value=max_value_;
        if (max_value == min_value) {
            float delta=(max_value-min_value);
            if (delta==0.0f) {
                delta=1.0e-9f;
                max_value+=delta;
                min_value-=delta;
            }
        }
        largeur_pixels= (float)x1_ecran - (float) x0_ecran;
        x0=Math.round(Math.min((float) min_pixel,(float)max_pixel));
        min_pixel=(int)Math.round(x0_relative*largeur_pixels)+x0_ecran;
        max_pixel=(int)Math.round(x1_relative*largeur_pixels)+x0_ecran;
        echelle=((float) ((float) max_pixel-(float) min_pixel))/( max_value - min_value);
        x0=(int)Math.round(Math.min((float) min_pixel,(float)max_pixel));
        x1=(int)Math.round(Math.max((float) min_pixel,(float)max_pixel));
        largeur=x1-x0;
    }
    
}
