/*
 * AccordeurPlotPanel.java
 *
 * Created on 9 octobre 2006, 12:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JPanel;
import javax.sound.sampled.AudioFormat.Encoding;
interface ctes_accordeur {
    public final int _UNKNOWN=0;
    public final int _DICTEE_2_NOTES_ASCENDANTES=2;
    public final int _DICTEE_2_NOTES_DESCENDANTES=3;
    
    
}
/**
 *
 * @author ygorra
 */
public class AccordeurPlotPanel extends JPanel implements Runnable,MouseListener {
    public void mousePressed(MouseEvent e) {
        
    }
    
    public void mouseReleased(MouseEvent e) {
        
    }
    
    public void mouseEntered(MouseEvent e) {
        
    }
    public void mouseExited(MouseEvent e) {
        
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getButton()==e.BUTTON1) {
            if (this.notes_a_chanter==null) return;
            for (int i=0;i<notes_a_chanter.length;i++) {
                NoteDictee nt=notes_a_chanter[i];
                System.out.println(
                        "note["+String.valueOf(i)+"]"
                        +", nbess="+String.valueOf(nt.nb_essais)
                        +", ref ="+String.valueOf(nt.note_en_demi_ton)
                        +", realisee ="+String.valueOf(nt.note_en_demi_ton+nt.ecart_en_demi_ton)
                        +", entendue="+String.valueOf(nt.note_is_entendue)
                        +", ok ="+String.valueOf(nt.note_is_ok)
                        );
                
                
            }
        }
        
    }
    
    
    
    double DUREE_AFFICHAGE=3.0; // largeur temporelle du panneau d'affichage
    min_max_int[] n0_n1;
    min_max_int[] debut_fin_liste;
    
    ContexteFlts Contexte;
    Object[] tab_infos_tracks;
    LinkedList local_infos_tracks;
    TargetDataLine line_acquisition;
    AudioFormat format;
    int buffer_size;
    int LGN_BUF;
    byte  buffer_byte[];// = new byte[buffer_size];
    short buffer_short[];// = new short[LGN_BUF];
    int frame_size;//=format.getChannels();
    
    boolean is_big_endian;//=true;
    AnalyseDeSon sender;
    int nb_plot;
    long refresh_time_ms;
    NotesEtFrequences notes;
    NotesEtFrequences notes_pour_aff;
    echelle_graphique echelle_x_module=null;
    echelle_graphique echelle_x_n0_n1=null;
    float x0_partition_relative=0.0f;
    float x1_partition_relative=0.3f;
    float y0_partition_relative=0.05f;
    float y1_partition_relative=0.95f;
    float x0_module_relative=0.31f;
    float x1_module_relative=0.5f;
    
    float x0_decal_relative=0.51f;
    float x1_decal_relative=0.99f;
    boolean TRACE_MODULE=true;
    
    float decal_min_demi_ton=-0.5f;
    float decal_max_demi_ton=0.5f;
    
    private float max_frequence_en_demi_ton;
    private float max_frequence_a_garder_en_demi_ton;
    
    private float min_frequence_en_demi_ton;
    int i_min_log_frequence;
    int i_max_log_frequence;
    
    
    float max_module=0.5f;
    
    float last_f_reelle=0.0f;
    
    int last_y0=0;
    
    float last_f_reelle_en_demi_ton=0.0f;
    
    float last_decal_f_reelle_en_demi_ton=0.0f;
    
    float last_int_f_reelle_en_demi_ton=0.0f;
    
    InfoTrack last_info_ok=null;
    
    public int etat;
    final int ATTENTE_LANCEMENT=1;
    
    final int ATTENTE_FLT_PASSE_HAUT=2;
    
    final int MESURE_NOISE=3;
    final int WORKING=4;
    final int ERROR=5;
    int NB_LISTE_A_AFFICHER;
    
    private int numero_liste_aff;
    
    private int max_indice_liste_ok;
    
    private int dernier_debut_liste_ok;
    
    private int min_indice_liste_ok;
    
    private boolean component_has_been_painted;
    
    private boolean is_signed;
    
    private int nb_bytes;
    
    private Interval[] Intervals=null;
    
    private Interval interval_a_afficher=null;
    
    
    
    
    
    private Interval old_interval_a_afficher=null;
    
    private int min_n_reel;
    
    private int max_n_reel;
    
    private float MAX_MOD_SQUARE=1f;
    
    
    private float LOG_MIN_MOD_SQUARE;
    
    private float LOG_MAX_MOD_SQUARE;
    
    private float[] tab_MAX_LOG_MOD=null;
    
    public boolean thread_termine=true;
    public InfoNote[] notes_to_play=null;
    public NotesDictee notes_dictee=null;
    public NoteDictee[] notes_a_chanter=null;
    public int nb_notes_a_chanter=3;
    
    private float DECALAGE_EN_DEMI_TON=0f;
    
    public final int DICTEE_MUSICALE=1;
    public final int ACCORDEUR=2;
    public int type_dictee=ACCORDEUR;
    
    public int N0_INTERVAL_FOR_DICTEE=0;
    
    public float TEMPS_ATTENTE_ENTRE_2_NOTES_FOR_DICTEE=0.3f;
    
    private float t_new=0f;
    
    private int NB_ESSAIS_MAX=3;
    
    public int NB_DICTEES=0;
    public int NB_DICTEES_REUSSIES=0;
    
    
    private boolean NOUVELLE_DICTEE;
    
    public float COEFF_PIANO=0.25f;
    public int TYPE_CLE=-1;
    
    public boolean RECALE_HMS=true;
    
    private float HMS_3_EN_DEMI_TONS,HMS_2_EN_DEMI_TONS,SEUIL_DECISION_HMS_3,SEUIL_DECISION_HMS_2;
    public void init_info_ok_detection(ContexteFlts Contexte) {
        float f_reelle,f_reelle_en_demi_ton;
        int i,i_f;
        MemoireClcDetect mem;
        InfoDetection info_detection;
        Iterator iterator;
        max_frequence_en_demi_ton=-1000.0f;
        min_frequence_en_demi_ton=1000.0f;
        max_module=1.0f;
        notes=new NotesEtFrequences(Contexte.F_MINI,Contexte.F_MAXI,Contexte.F_LA);
        notes_pour_aff=notes;
        // Recalage harmoniques
        this.HMS_2_EN_DEMI_TONS=(float) notes.frequence_note_from_do0_en_demi_ton(2*notes.DO_0);
        this.HMS_3_EN_DEMI_TONS=(float) notes.frequence_note_from_do0_en_demi_ton(3*notes.DO_0);
        this.SEUIL_DECISION_HMS_2=this.HMS_2_EN_DEMI_TONS-3f;
        this.SEUIL_DECISION_HMS_3=this.HMS_3_EN_DEMI_TONS-3f;
        if (this.TYPE_CLE==-1) this.TYPE_CLE=ctes_notes.CLE_DE_SOL;
        if (this.type_dictee==this.DICTEE_MUSICALE) {
            double fmin= notes_pour_aff.note_en_demi_ton_cle_min_from_DO0()-14.0+notes_pour_aff.NB_NOTES_EN_DEMI_TON_PAR_CLE;
            
            fmin=notes_pour_aff.frequence_note(fmin);
            double fmax= notes_pour_aff.note_en_demi_ton_cle_max_from_DO0()+14.0+notes_pour_aff.NB_NOTES_EN_DEMI_TON_PAR_CLE;
            fmax=notes_pour_aff.frequence_note(fmax);
            notes_pour_aff=new NotesEtFrequences(fmin,fmax,Contexte.F_LA);
            
        }
        notes_pour_aff.TYPE_CLE=this.TYPE_CLE;
        MemoireClcDetect [] tab=Contexte.tab_memoire_detect;
        if (tab !=null) {
            for (i=1;i<tab.length;i++) {
                mem= tab[i];
                if (mem.is_in_interval) {
                    f_reelle= (float)(mem.seuil_plus_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    f_reelle= (float)(mem.seuil_moins_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                }
            }
        }
        f_reelle= (float)(Contexte.F_MAXI_A_GARDER);
        f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
        this.max_frequence_a_garder_en_demi_ton=f_reelle_en_demi_ton+1f;
        if (max_frequence_en_demi_ton <=min_frequence_en_demi_ton) {
            max_frequence_en_demi_ton=0.25f;
            min_frequence_en_demi_ton=-0.25f;
        }
        min_frequence_en_demi_ton=(float) Math.floor(min_frequence_en_demi_ton);
        max_frequence_en_demi_ton=(float) Math.ceil(max_frequence_en_demi_ton);
        i_min_log_frequence=Math.round(min_frequence_en_demi_ton);
        i_max_log_frequence=Math.round(max_frequence_en_demi_ton);
        if (TRACE_MODULE) {
            this.LOG_MIN_MOD_SQUARE=(float) Math.sqrt(0.01f);
            this.tab_MAX_LOG_MOD=new float[i_max_log_frequence+1];
            for (i=i_min_log_frequence;i<=i_max_log_frequence;i++) {
                tab_MAX_LOG_MOD[i]=LOG_MIN_MOD_SQUARE;
            }
        }
        
    }
    public void init_liste_aff(){
        NB_LISTE_A_AFFICHER=(int) Math.ceil(this.DUREE_AFFICHAGE/(Contexte.LGN_BUFFER/Contexte.F_ECH));
        if (NB_LISTE_A_AFFICHER <0) {NB_LISTE_A_AFFICHER=1;}
        this.debut_fin_liste=new min_max_int[NB_LISTE_A_AFFICHER];
        for (int i=0;i<debut_fin_liste.length;i++) {
            debut_fin_liste[i]=new min_max_int();
            // min>max => liste vide
            debut_fin_liste[i].max_data=0;
            debut_fin_liste[i].min_data=1;
        }
        
    }
    public void stop_and_wait() {
        if (!thread_termine) {
            if (Contexte.running) Contexte.running=false;
            while (!thread_termine) {
                
            }
        }
        
    }
    public void restart(int type_application) {
        stop_and_wait();
        this.type_dictee=type_application;
        Contexte.SEUIL_TEMPS_INTERFERENCES_S=sender.SEUIL_TEMPS_INTERFERENCES_S;
        Contexte.SEUIL_MOD2_RELATIVE_FOR_NOTES=sender.SEUIL_MOD2_RELATIVE_FOR_NOTES;
        Contexte.SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS=sender.SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS;
        Contexte.F_MAXI_A_GARDER=sender.F_MAXI_A_GARDER;
        Contexte.NB_TRACK_VALID_NOTE=sender.NB_TRACK_VALID_NOTE;
        
        local_infos_tracks=new LinkedList();
        this.refresh_time_ms=Math.round(2.0*Contexte.TEMPS_MAXI_NB_OK*1000.0);
        if (this.refresh_time_ms<500) {
            this.refresh_time_ms=500;
        }
        if (this.type_dictee==this.ACCORDEUR) {
            this.DUREE_AFFICHAGE=3f;
        }
        if (this.type_dictee==this.DICTEE_MUSICALE) {
            this.DUREE_AFFICHAGE=2.1f*sender.SEUIL_DUREE_MIN_INTERVAL_S;
        }
        this.init_liste_aff();
        
        this.init_info_ok_detection(Contexte);
        nb_plot=0;
        if (this.notes_dictee==null) {
            notes_dictee=new NotesDictee();
            notes_dictee.descendant=false;
            notes_dictee.ascendant=true;
            notes_dictee.add_intervalle(notes_dictee.seconde_majeure);
            notes_dictee.add_intervalle(notes_dictee.seconde_mineure);
        }
        init_acquisition();
        start_acquisition();
        start();
        
    }
    public AccordeurPlotPanel(AnalyseDeSon sender_,ContexteFlts Contexte_,TargetDataLine line_acquisition_,AudioFormat format_,int w,int h){
        sender=sender_;
        Contexte=Contexte_;
        format=format_;
        line_acquisition=line_acquisition_;
        addMouseListener(this);
        
    }
    public void    met_a_jour_debut_fin_liste(Object[] tab_infos_ok){
        min_max_int df,min_max;
        
        df=debut_fin_liste[numero_liste_aff];
        df.min_data=local_infos_tracks.size();
        int k=0,i;
        InfoTrack info_ok;
        for (i=0;i<tab_infos_ok.length;i++) {
            if (tab_infos_ok[i]!=null) {
                info_ok=(InfoTrack) tab_infos_ok[i];
                
                if (TRACE_MODULE) {
                    this.MAX_MOD_SQUARE=Math.max(info_ok.mean_mod_square,this.MAX_MOD_SQUARE);
                }
                local_infos_tracks.add(tab_infos_ok[i]);
                k++;
            }
        }
        df.max_data=local_infos_tracks.size()-1;
        dernier_debut_liste_ok=df.min_data;
        numero_liste_aff++;
        if (numero_liste_aff>=NB_LISTE_A_AFFICHER) {numero_liste_aff=0;}
        max_indice_liste_ok=-1;
        min_indice_liste_ok= local_infos_tracks.size()+1;
        // calcul des min et max des pistes
        for (i=0;i<debut_fin_liste.length;i++) {
            df= debut_fin_liste[i];
            if (df.max_data>=df.min_data) {
                min_indice_liste_ok=(min_indice_liste_ok<df.min_data)?min_indice_liste_ok:df.min_data;
                max_indice_liste_ok=(max_indice_liste_ok>df.max_data)?max_indice_liste_ok:df.max_data;
            }
        }
        // elimination des infos inutiles dans la liste locale, pour empecher depassement memoire
        if ((min_indice_liste_ok>0)&&(min_indice_liste_ok<=max_indice_liste_ok)) {
            // elimination des elts inutiles dans la liste
            int a_eliminer=min_indice_liste_ok;
            for (i=0;i<a_eliminer;i++) {
                local_infos_tracks.removeFirst();// elimine premier elet
            }
            // recalage des indices
            for (i=0;i<debut_fin_liste.length;i++) {
                df= debut_fin_liste[i];
                if (df.max_data>=df.min_data) {
                    df.max_data-=a_eliminer;
                    df.min_data-=a_eliminer;
                }
            }
            min_indice_liste_ok-=a_eliminer;
            max_indice_liste_ok-=a_eliminer;
        }
        // si min_indice_liste_ok > max_indice_liste_ok, ne pas tracer
    }
    public void paintComponent(Graphics g) {
        if (this.type_dictee==this.DICTEE_MUSICALE)  this.paintDicteeIntervalle(g);
        if (this.type_dictee==this.ACCORDEUR)  this.paintAccordeur(g);
        
    }
    public void paintAccordeur(Graphics g) {
        float log_module;
        int min_dernier_n_reel;
        InfoTrack info_ok,best_info_ok;
        int best_y0=0;
        float best_f_reelle_en_demi_ton=0.0f;
        float best_int_f_reelle_en_demi_ton=0.0f;
        float best_decal_f_reelle_en_demi_ton=0.0f;
        float best_f_reelle=0.0f;
        float f_reelle,f_reelle_en_demi_ton,module;
        int i,i_f;
        int w,h;
        int x0,x1,y0,y1;
        float echelle_x,echelle_y;
        //   Contexte.compute_super_tracks(Contexte.infos_tracks);// marquage liste_info_ok;
        
        w=this.getWidth();
        h=this.getHeight();
        if (this.etat==ERROR) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("ERREUR, DEFINISSEZ LA DICTEE A CHANTER",20,h/2);
            return;
        }
        if (Contexte==null) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("PAS DE CONTEXTE DEFINI",20,h/2);
            return;
        }
        if (!Contexte.running) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("CHOISISSEZ UNE APPLICATION",20,h/2);
            return;
        }
        if (etat==this.ATTENTE_FLT_PASSE_HAUT) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("ATTENTE FIN REGIME TRANSITOIRE FILTRE PASSE_HAUT",20,h/2);
            g.drawString("SILENCE SVP!.. L'EVALUATION DES NIVEAUX DE BRUIT VA COMMENCER ",20,h/2+2*g.getFontMetrics().getHeight());
            return;
        }
        if (etat==this.MESURE_NOISE) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("SILENCE SVP!.. EVALUATION DES NIVEAUX DE BRUIT EN COURS ",20,h/2);
            return;
        }
        
        g.setColor(Color.LIGHT_GRAY);
        g.fillRect(0,0,w,h);
        int height_chars=g.getFontMetrics().getHeight();
        float decal_f_reelle_en_demi_ton=0.0f;
        float int_f_reelle_en_demi_ton=0.0f;
        float min_f_reelle_en_demi_ton_2=-0.5f;
        float max_f_reelle_en_demi_ton_2=0.5f;
        // pour decalage / note parfaite
        echelle_graphique echelle_decal_x=new echelle_graphique(
                x0_decal_relative,x1_decal_relative,
                1,w-1,
                this.decal_min_demi_ton,this.decal_max_demi_ton
                );
        int x_central_2=echelle_decal_x.getPixel(0f);
        
        
        
        
        
//      min_max_float min_max_n0_n1=Contexte.get_min_max_n0_n1_reel(Contexte.infos_tracks);
        tab_infos_tracks=Contexte.infos_tracks.toArray();
        Contexte.infos_tracks.clear();
        met_a_jour_debut_fin_liste(tab_infos_tracks);
        Contexte.compute_super_tracks(this.local_infos_tracks);
        Intervals=Contexte.get_intervals_from_infos_tracks(this.local_infos_tracks
                ,sender.SEUIL_DUREE_MIN_INTERVAL_S
                ,sender.SEUIL_DISPARITION_NOTE_PREC_S
                ,sender.SEUIL_APPARITION_HMS_S
                ,sender.NB_PISTES_MIN_INTERVAL
                ,sender.NB_TRACK_ENERGY);
        if (Intervals!=null) {
            interval_a_afficher=Intervals[Intervals.length-1];
        } else interval_a_afficher=null;
        
        //   interval_a_afficher=null;
        
        // Trace des notes exactes
        // w ou h peuvent changer => reinit systematique des echelles
        notes_pour_aff.init_echelles_partition(notes_pour_aff.NOTE_MINI_FROM_DO_0_EN_COURS,notes_pour_aff.NOTE_MAXI_FROM_DO_0_EN_COURS,
                w,h,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative
                ,this.COEFF_PIANO); // 0.25 => Piano sur 0.25/1 de la largeur
        
        if (this.TRACE_MODULE) {
            this.LOG_MAX_MOD_SQUARE=(float)Math.sqrt(this.MAX_MOD_SQUARE);
            echelle_x_module=new echelle_graphique(
                    x0_module_relative,x1_module_relative,
                    1,w-1,
                    LOG_MIN_MOD_SQUARE,LOG_MAX_MOD_SQUARE
                    );
        }
        min_dernier_n_reel=(Contexte.nb_trames-1)*Contexte.LGN_BUFFER;
        min_n_reel=(Contexte.nb_trames-this.NB_LISTE_A_AFFICHER)*Contexte.LGN_BUFFER;
        max_n_reel=(Contexte.nb_trames)*Contexte.LGN_BUFFER;
        int seuil_n_reel=max_n_reel-Contexte.LGN_BUFFER;// les intervalles doivent terminer dans le dernier buffer pour etre valides
        echelle_x_n0_n1= new echelle_graphique(
                notes_pour_aff.x0_partition_relative,notes_pour_aff.x1_partition_relative,
                1,w-1,
                min_n_reel,
                max_n_reel
                );
        g.setColor(Color.WHITE);
        g.fillRect(notes_pour_aff.echelle_x_partition.x0     ,notes_pour_aff.echelle_y_partition.x0,
                notes_pour_aff.echelle_x_partition.largeur,notes_pour_aff.echelle_y_partition.largeur);
        int y_a_garder=(int)notes_pour_aff.echelle_y_partition.getPixel((float)notes_pour_aff.frequence_note_from_do0_en_demi_ton(sender.F_MAXI_A_GARDER));
        g.setColor(Color.YELLOW);
        g.fillRect(notes_pour_aff.echelle_x_partition.x0     ,y_a_garder,
                notes_pour_aff.echelle_x_partition.largeur,notes_pour_aff.echelle_y_partition.x1-y_a_garder);
        g.setColor(Color.WHITE);
        
        if (TRACE_MODULE){
            g.fillRect(echelle_x_module.x0     ,notes_pour_aff.echelle_y_partition.x0,
                    echelle_x_module.largeur,notes_pour_aff.echelle_y_partition.largeur);
            
        }
        g.setColor(Color.CYAN);
        g.drawString(" Ecart type signal ="+String.valueOf(Math.round(Math.sqrt(Contexte.mod_square_moy))),1,1+height_chars);
        notes_pour_aff.draw_partition(g,i_min_log_frequence,i_max_log_frequence);
        // affichage nb appels
        
        // Trace echelle diapason
        g.setColor(Color.LIGHT_GRAY);
        f_reelle_en_demi_ton=(float) this.i_min_log_frequence;
        y0=notes_pour_aff.echelle_y_partition.x0;// pixel associe a i_min
        y1=notes_pour_aff.echelle_y_partition.x1;// pixel associe a y_max;
        g.fillRect(echelle_decal_x.x0,y0,echelle_decal_x.largeur,y0-y1);
        
        // Trace des notes_pour_aff relevees
        g.setColor(Color.BLUE);
        best_info_ok=null;// meilleure info sur la derniere trame
        // Trace des pistes elementaires
        if (min_indice_liste_ok <=max_indice_liste_ok) {
            Iterator it =local_infos_tracks.listIterator(this.min_indice_liste_ok);
            i=min_indice_liste_ok;
            
            while ((it.hasNext())&&(i<=max_indice_liste_ok)){
                Object O=it.next();
                if (O!=null) {
                    info_ok=(InfoTrack) O;
                    // on n'affiche pas les notes_pour_aff isolees
                    f_reelle_en_demi_ton=(float) notes_pour_aff.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle);
                    //    g.drawString("frequence ="+String.valueOf(f_reelle),5,20+30*i_f);
                    // module=(float) Math.sqrt(mem.sum_square_mod_plus/mem.nb_ok_decim);
                    x0=echelle_x_n0_n1.getPixel(info_ok.n0_reel);
                    x1=echelle_x_n0_n1.getPixel(info_ok.n1_reel);
                    y0=notes_pour_aff.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
                    y1=y0;
                    g.setColor(Color.BLUE);
                    g.drawLine(x0,y0,x1,y1);
                    // Decalage / Note Parfaite
                    decal_f_reelle_en_demi_ton=(float)Math.IEEEremainder(f_reelle_en_demi_ton,1.0);
                    int_f_reelle_en_demi_ton=f_reelle_en_demi_ton-decal_f_reelle_en_demi_ton;
                    if ((TRACE_MODULE)&&(info_ok.n1_reel>=min_dernier_n_reel)) {
                        log_module=(float)Math.sqrt(info_ok.mean_mod_square) ;
                        int i_frq_demi_ton=(int) Math.round(int_f_reelle_en_demi_ton);
                        if ((i_frq_demi_ton >=i_min_log_frequence)&&(i_frq_demi_ton <=i_max_log_frequence)) {
                            tab_MAX_LOG_MOD[i_frq_demi_ton]=Math.max(tab_MAX_LOG_MOD[i_frq_demi_ton],log_module);
                        }
                        x0=echelle_x_module.getPixel(log_module);
                        x1=echelle_x_module.min_pixel;
                        g.drawLine(x0,y0,x1,y1);
                    }
                    if ((info_ok.is_a_super_track==true)&&(info_ok.nb_tracks_in_super_track>1)) { // on garde la plus basse frequence, sinon module > best_module
                        g.setColor(Color.RED);
                        x0=echelle_x_n0_n1.getPixel(info_ok.n0_reel_super_track);
                        x1=echelle_x_n0_n1.getPixel(info_ok.n1_reel_super_track);
                        f_reelle_en_demi_ton=(float) notes_pour_aff.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track);
                        y0=notes_pour_aff.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
                        y1=y0;
                        g.drawLine(x0,y0,x1,y1);
                        if (i>=dernier_debut_liste_ok) {
                            if (best_info_ok==null) {
                                best_info_ok=info_ok;
                            } else {
                                if (info_ok.f_reelle_super_track<best_info_ok.f_reelle_super_track) {
                                    best_info_ok=info_ok;// on garde info_ok de frequence la plus basse
                                }
                            }
                        }
                    }
                }
                i++;
            }
        }// si il y a des infos ok a tracer
        if (TRACE_MODULE) {
            i=i_min_log_frequence;
            x1=echelle_x_module.getPixel(tab_MAX_LOG_MOD[i]);
            y1=notes_pour_aff.echelle_y_partition.getPixel(i);
            i++;
            g.setColor(Color.LIGHT_GRAY);
            for (;i<=i_max_log_frequence;i++) {
                x0=x1;y0=y1;
                x1=echelle_x_module.getPixel(tab_MAX_LOG_MOD[i]);
                y1=notes_pour_aff.echelle_y_partition.getPixel(i);
                g.drawLine(x0,y0,x1,y1);
            }
        }
        //------------------------------------------------------------------
        // AFFICHAGE MEILLEURE FREQUENCE => ACCORDEUR
        //------------------------------------------------------------------
        if (best_info_ok !=null) {last_info_ok=best_info_ok;}
        last_info_ok=null; // systematiquement pour test
        boolean ok =interval_a_afficher!=null;
        if (ok) ok=interval_a_afficher.notes!=null;
        if (ok) ok=interval_a_afficher.n1>seuil_n_reel;
        if (ok) {
            old_interval_a_afficher=interval_a_afficher;
        } else {
            interval_a_afficher=null;
        }
        if (old_interval_a_afficher!=null) {
            last_info_ok=null;
            f_reelle_en_demi_ton=(float)notes_pour_aff.frequence_note_from_do0_en_demi_ton(old_interval_a_afficher.notes[0].frequences);
            note_detaillee detail=notes_pour_aff.details_note(old_interval_a_afficher.notes[0].frequences);
            g.setColor(Color.RED);
            int note_en_demi_ton=notes_pour_aff.NB_NOTES_PAR_OCTAVE*detail.octave
                    +detail.note_modulo_octave;
            f_reelle_en_demi_ton=note_en_demi_ton
                    +detail.decalage_en_demi_ton;
            notes_pour_aff.draw_touche_piano_active(g,f_reelle_en_demi_ton);
            y0=notes_pour_aff.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
            //    g.drawLine(echelle_x_module.min_pixel,y0,x1,y0);
            // DESACCORDAGE / FREQUENCE PARFAITE
            
            x1=echelle_decal_x.getPixel(detail.decalage_en_demi_ton);
            y1=y0+5;
            int y_0=y0-5;
            
            if (interval_a_afficher!=null) {
                g.setColor(Color.CYAN);
            } else {
                g.setColor(Color.GRAY);
            }
            g.fillRect(echelle_decal_x.min_pixel,y_0,x1-echelle_decal_x.min_pixel,y1-y_0);
            
            g.setColor(Color.WHITE);
            g.fillRect(x1,y_0,echelle_decal_x.max_pixel-x1,y1-y_0);
            
            g.setColor(Color.RED);
            g.drawLine(x_central_2,y_0,x_central_2,y1);
            
            g.setColor(Color.BLACK);
            g.drawRect(echelle_decal_x.min_pixel,y_0,echelle_decal_x.largeur,y1-y_0);
            
            g.setColor(Color.RED);
            
            g.drawString(detail.nom_note_global
                    +" : "+String.valueOf(Math.round((double)detail.frequence_note*10)/10.0+" Hz")
                    ,notes_pour_aff.echelle_x_partition.x1+2,y_0+height_chars/2);
            int largeur=(int)Math.round(g.getFontMetrics().getStringBounds(detail.nom_note_global,g).getWidth());
            
            g.drawString(detail.nom_note_global,x_central_2-largeur/2,y_0-1);
        }
        
        if (last_info_ok !=null) {
            note_detaillee detail=notes_pour_aff.details_note(last_info_ok.f_reelle_super_track);
            g.setColor(Color.RED);
            int note_en_demi_ton=notes_pour_aff.NB_NOTES_PAR_OCTAVE*detail.octave
                    +detail.note_modulo_octave;
            f_reelle_en_demi_ton=note_en_demi_ton
                    +detail.decalage_en_demi_ton;
            notes_pour_aff.draw_touche_piano_active(g,f_reelle_en_demi_ton);
            y0=notes_pour_aff.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
            //    g.drawLine(echelle_x_module.min_pixel,y0,x1,y0);
            // DESACCORDAGE / FREQUENCE PARFAITE
            
            x1=echelle_decal_x.getPixel(detail.decalage_en_demi_ton);
            y1=y0+5;
            int y_0=y0-5;
            
            g.setColor(Color.CYAN);
            g.fillRect(echelle_decal_x.min_pixel,y_0,x1-echelle_decal_x.min_pixel,y1-y_0);
            
            g.setColor(Color.WHITE);
            g.fillRect(x1,y_0,echelle_decal_x.max_pixel-x1,y1-y_0);
            
            g.setColor(Color.RED);
            g.drawLine(x_central_2,y_0,x_central_2,y1);
            
            g.setColor(Color.BLACK);
            g.drawRect(echelle_decal_x.min_pixel,y_0,echelle_decal_x.largeur,y1-y_0);
            
            g.setColor(Color.RED);
            
            g.drawString(detail.nom_note_global
                    +","+String.valueOf(Math.round((double)detail.frequence_note*10)/10.0+" Hz")
                    ,notes_pour_aff.echelle_x_partition.x1+2,y_0+height_chars/2);
            int largeur=(int)Math.round(g.getFontMetrics().getStringBounds(detail.nom_note_global,g).getWidth());
            
            g.drawString(detail.nom_note_global,x_central_2-largeur/2,y_0-1);
            
            
        }
        Contexte.infos_tracks.clear();
    }
    
    public void paintDicteeIntervalle(Graphics g) {
        float log_module;
        int min_dernier_n_reel;
        InfoTrack info_ok,best_info_ok;
        int best_y0=0;
        float best_f_reelle_en_demi_ton=0.0f;
        float best_int_f_reelle_en_demi_ton=0.0f;
        float best_decal_f_reelle_en_demi_ton=0.0f;
        float best_f_reelle=0.0f;
        float f_reelle,f_reelle_en_demi_ton,module;
        int i,i_f;
        int w,h;
        int x0=0,x1,y0,y1;
        float echelle_x,echelle_y;
        //   Contexte.compute_super_tracks(Contexte.infos_tracks);// marquage liste_info_ok;
        
        w=this.getWidth();
        h=this.getHeight();
        if (this.etat==ERROR) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("ERREUR, DEFINISSEZ LA DICTEE A CHANTER",20,h/2);
            return;
        }
        if (Contexte==null) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("PAS DE CONTEXTE DEFINI",20,h/2);
            return;
        }
        if (!Contexte.running) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("CHOISISSEZ UN TYPE DE DICTEE",20,h/2);
            return;
        }
        if (etat==this.ATTENTE_FLT_PASSE_HAUT) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("ATTENTE FIN REGIME TRANSITOIRE FILTRE PASSE_HAUT",20,h/2);
            g.drawString("SILENCE SVP!.. L'EVALUATION DES NIVEAUX DE BRUIT VA COMMENCER ",20,h/2+2*g.getFontMetrics().getHeight());
            return;
        }
        if (etat==this.MESURE_NOISE) {
            g.setColor(Color.WHITE);
            g.fillRect(0,0,w,h);
            g.setColor(Color.RED);
            g.drawString("SILENCE SVP!.. EVALUATION DES NIVEAUX DE BRUIT EN COURS ",20,h/2);
            return;
        }
        // DEBUT DICTEE A PROPREMENT PARLER
        g.setColor(Color.LIGHT_GRAY);
        g.fillRect(0,0,w,h);
        int height_chars=g.getFontMetrics().getHeight();
        float decal_f_reelle_en_demi_ton=0.0f;
        float int_f_reelle_en_demi_ton=0.0f;
        float min_f_reelle_en_demi_ton_2=-0.5f;
        float max_f_reelle_en_demi_ton_2=0.5f;
//      min_max_float min_max_n0_n1=Contexte.get_min_max_n0_n1_reel(Contexte.infos_tracks);
        boolean mise_a_jour_necessaire=Contexte.infos_tracks.size()>0;
        tab_infos_tracks=Contexte.infos_tracks.toArray();
        Contexte.infos_tracks.clear();
        met_a_jour_debut_fin_liste(tab_infos_tracks);
        if (mise_a_jour_necessaire) {
            Contexte.compute_super_tracks(this.local_infos_tracks);
            Intervals=Contexte.get_intervals_from_infos_tracks(this.local_infos_tracks
                    ,sender.SEUIL_DUREE_MIN_INTERVAL_S
                    ,sender.SEUIL_DISPARITION_NOTE_PREC_S
                    ,sender.SEUIL_APPARITION_HMS_S
                    ,sender.NB_PISTES_MIN_INTERVAL
                    ,sender.NB_TRACK_ENERGY);
        }
        this.met_a_jour_notes_jouees(this.notes_a_chanter,Intervals);
        
        Interval old_interval=null;
        if (Intervals!=null) {
            if (Intervals.length>0) {
                old_interval=Intervals[Intervals.length-1];
            }
        }
        // il s'est passe quelque chose, on repeint
        //   interval_a_afficher=null;
        if (notes_a_chanter==null) {
            g.setColor(Color.RED);
            g.drawString("PAS DE NOTES A AFFICHER!",10,h/2);
            return;
        }
        // Trace des notes_pour_aff exactes
        // w ou h peuvent changer => reinit systematique des echelles
        notes_pour_aff.init_echelles_partition(notes_pour_aff.NOTE_MINI_FROM_DO_0_EN_COURS,notes_pour_aff.NOTE_MAXI_FROM_DO_0_EN_COURS,
                w,h,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative
                ,this.COEFF_PIANO); // 0.25 => Piano sur 0.0/1 de la largeur
        
        
        min_dernier_n_reel=(Contexte.nb_trames-1)*Contexte.LGN_BUFFER;
        min_n_reel=(Contexte.nb_trames-this.NB_LISTE_A_AFFICHER)*Contexte.LGN_BUFFER;
        max_n_reel=(Contexte.nb_trames)*Contexte.LGN_BUFFER;
        int seuil_n_reel=max_n_reel-Contexte.LGN_BUFFER;// les intervalles doivent terminer dans le dernier buffer pour etre valides
        echelle_graphique echelle_x_notes_a_chanter= new echelle_graphique(
                notes_pour_aff.x0_partition_relative,notes_pour_aff.x1_partition_relative,
                1,w-1,
                -1f,
                (float)notes_a_chanter.length
                );
        g.setColor(Color.WHITE);
        g.fillRect(notes_pour_aff.echelle_x_partition.x0     ,notes_pour_aff.echelle_y_partition.x0,
                notes_pour_aff.echelle_x_partition.largeur,notes_pour_aff.echelle_y_partition.largeur);
        notes_pour_aff.draw_partition_cle(g,(int)notes_pour_aff.NOTE_MINI_FROM_DO_0_EN_COURS,(int)notes_pour_aff.NOTE_MAXI_FROM_DO_0_EN_COURS);
        // Info sur Dictee
        int font_height=g.getFontMetrics().getHeight();
        if (this.NB_DICTEES>0) {
            String MsgDictee="DICTEE "+String.valueOf(this.NB_DICTEES);
            MsgDictee+=", ESSAI "+String.valueOf(notes_a_chanter[0].nb_essais);
            MsgDictee+=" / "+String.valueOf(this.NB_ESSAIS_MAX);
            g.setColor(Color.RED);g.drawString(MsgDictee,1,1+font_height);
            String MsgSucces=String.valueOf(this.NB_DICTEES_REUSSIES) +" DICTEES REUSSIES / "+String.valueOf(this.NB_DICTEES-1)+" DICTEES";
            g.drawString(MsgSucces,10,h-2);
        }
        // Trace des notes_pour_aff a chanter
        Color color;
        NoteDictee nt1,nt0=null,nt_deb=null;
        note_detaillee d1=null,d0=null;
        int y_msg=notes_pour_aff.echelle_y_partition.x1+font_height;
        nt_deb=notes_a_chanter[0];
        for(i=0;i<notes_a_chanter.length;i++) {
            nt1=notes_a_chanter[i];
            x1=echelle_x_notes_a_chanter.getPixel((float) i);
            if (nt1.note_is_ok) {
                color =Color.RED;
                notes_pour_aff.draw_note_cle(g,(float) nt1.note_en_demi_ton,nt1.affiche_sous_forme_de_diese,x1,color);
            } else {
                if (nt1.note_is_entendue) {
                    // note entendue, mais fausse
                    color=Color.BLACK;
                    notes_pour_aff.draw_note_cle(g,(float) nt1.note_en_demi_ton,nt1.affiche_sous_forme_de_diese,x1,color);
                    color=Color.BLUE;
                    notes_pour_aff.draw_note_cle(g,(float) nt1.note_en_demi_ton+nt1.ecart_en_demi_ton,nt1.affiche_sous_forme_de_diese,x1,color);
                } else {
                    // note pas entenduee
                    color=Color.BLACK;
                    notes_pour_aff.draw_note_cle(g,(float) nt1.note_en_demi_ton,nt1.affiche_sous_forme_de_diese,x1,color);
                }
            }
            
            g.setColor(Color.BLUE);
            d1=notes_pour_aff.details_note(notes_pour_aff.frequence_note(nt1.note_en_demi_ton),nt1.affiche_sous_forme_de_diese);
            y1=notes_pour_aff.echelle_y_partition.getPixel(nt1.note_en_demi_ton+nt1.ecart_en_demi_ton)-font_height;
            g.drawString(d1.nom_note_modulo_octave,x1,y1)  ;
            if (nt0!=null) {
                if (!nt1.note_is_ok) {
                    if ((nt0.note_is_ok)||(i==1)) {
                        String MsgInterval=notes_pour_aff.nom_intervalle_demi_ton(nt1.note_en_demi_ton-nt0.note_en_demi_ton);
                        MsgInterval= MsgInterval.toUpperCase();
                        g.setColor(Color.RED);
                        g.drawString(MsgInterval,x0-20,notes_pour_aff.echelle_y_partition.x0-10);
                    }
                }
            }
            if (nt1.note_is_entendue) {
                float ecart=nt1.note_en_demi_ton+nt1.ecart_en_demi_ton-nt_deb.note_en_demi_ton;
                nt1.msg_real=String.valueOf(Math.round(10*ecart)/10f);
            }
            // trace touche piano et curseur de reference
            if (!nt1.note_is_entendue) {
                boolean first_to_sing=nt0==null;
                if (!first_to_sing) first_to_sing=nt0.note_is_entendue==true;
                if (first_to_sing) {
                    g.setColor(Color.CYAN);
                    notes_pour_aff.draw_touche_piano_active(g,nt1.note_en_demi_ton);
                    int x_1 = x1 + notes_pour_aff.get_hauteur_note()/2;
                    g.fillRect(x_1-2,notes_pour_aff.echelle_y_partition.x1,4,h-1-notes_pour_aff.echelle_y_partition.x1);
                }
            }
            // trace note de reference
            if (nt1.msg_real!=null) {
                g.setColor(Color.RED);
                if (nt1.note_is_entendue==false) { g.setColor(Color.BLACK);} else {
                    if (nt1.note_is_ok==false) g.setColor(Color.BLUE);
                }
                g.drawString(nt1.msg_ref+"=>"+nt1.msg_real,x1-10,y1+2*font_height+notes.get_hauteur_note());
                
            } else {
                g.setColor(Color.BLACK);g.drawString(nt1.msg_ref,x1-20,y1+2*font_height+notes.get_hauteur_note());
            }
            d0=d1;
            nt0=nt1;
            x0=x1;
            y0=y1;
        }
        if (notes_a_chanter[notes_a_chanter.length-1].note_is_ok) {
            t_new=Math.max(t_new,System.currentTimeMillis()+2000f);
        }
        
        Contexte.infos_tracks.clear();
    }
    public boolean un_pas_acquisition(){
        int count=0;
        for(;count==0;) {
            count =line_acquisition.read(buffer_byte, 0, buffer_byte.length);
            if (count > 0) {
                sender.ConversionToShort(buffer_short,buffer_byte,frame_size,is_big_endian,is_signed,nb_bytes);
                Contexte.execute_instructions(Contexte.instructions);
                Contexte.nb_trames++;
            }
        }
        
        return true;
    }
    public void init_acquisition() {
        int nb_channels;
        LGN_BUF=Contexte.LGN_BUFFER;
        buffer_size=LGN_BUF*format.getFrameSize();
        Contexte.F_ECH=format.getSampleRate();
        buffer_byte= new byte[buffer_size];
        buffer_short= new short[LGN_BUF];
        frame_size=format.getFrameSize();
        is_big_endian=this.sender.getBigEndian(sender.CHOIX_BIG_ENDIAN,format);
        is_signed=format.getEncoding()==Encoding.PCM_SIGNED;
        nb_channels=format.getChannels();
        nb_bytes=frame_size/nb_channels;
        // longueur du buffer, 0.5s maxi, en puissance de 2
        Contexte.set_new_source(buffer_short,0);
        Contexte.running = true;
        System.out.print("Line Running : ");System.out.println(line_acquisition.isRunning());
        System.out.print("Buffer Length : ");System.out.println(buffer_byte.length);
        long start_time=System.currentTimeMillis();
        int k=0;
        Contexte.execution_en_cours=true;
    }
    public void start_acquisition() {
        try {
            line_acquisition.open(format,this.buffer_size);
        } catch (LineUnavailableException ex) {
            ex.printStackTrace();
        }
        line_acquisition.start();
    }
    public void stop_acquisition(){
        line_acquisition.stop();
        line_acquisition.close();
        System.out.println("DETECTION TERMINEE");
    }
    
    public void start() {
        Thread t = new Thread(this);
        //    t.setPriority(Thread.MIN_PRIORITY); // priorite minimale
        //	startTime = System.currentTimeMillis();
        t.start();
        
    }
    public void run() {
        if (this.type_dictee==this.ACCORDEUR)     run_accordeur();
        if (this.type_dictee==this.DICTEE_MUSICALE)     run_dictee_musicale();
        
    }
    public void run_accordeur() {
        
        long previous_time,current_time;
        double temps_attente_ms;
        this.thread_termine=false;
        this.etat=ATTENTE_LANCEMENT;
        repaint();
        // Attente de 5. Cte de tps du filtre passe haut
        this.etat=ATTENTE_FLT_PASSE_HAUT;
        repaint();
        temps_attente_ms=1000f*5.0f/(2*Math.PI*Contexte.FREQU_COUPURE_PASSE_HAUT);
        temps_attente_ms=Math.max(temps_attente_ms,2000.0);
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // Reset des modules maxi
        Contexte.reset_max_mod_square_and_seuil_mod2();
        // mesure des modules maxi pendant 3s
        this.etat=MESURE_NOISE;
        repaint();
        previous_time=System.currentTimeMillis();
        temps_attente_ms=3000f;
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // mise a jour des seuils
        Contexte.met_a_jour_seuils_sur_bruit();
        Contexte.infos_tracks.clear();
        // acquisition
        this.etat=WORKING;
        previous_time=System.currentTimeMillis();
        int old_nb_trames=Contexte.nb_trames;
        while (Contexte.running) {
            if (un_pas_acquisition()==true) {
                repaint();
            }
        }
        // fin d'acquisition
        this.stop_acquisition();
        this.thread_termine=true;
        this.etat=this.ATTENTE_LANCEMENT;
        Contexte.infos_tracks.clear();
        
        //     new PlotDataAndNotes("Notes Detectees =f(t)", 500, 500,Contexte).setVisible(true);
        
    }
    public void run_dictee_musicale() {
        this.NB_DICTEES=0;this.NB_DICTEES_REUSSIES=0;
        int note_aff_mini=(int)Math.round(notes_pour_aff.NOTE_MINI_FROM_DO_0_EN_COURS+4.0);
        int note_aff_maxi=(int)Math.round(notes_pour_aff.NOTE_MAXI_FROM_DO_0_EN_COURS-4.0);
        long previous_time,current_time;
        double temps_attente_ms;
        this.thread_termine=false;
        this.etat=ATTENTE_LANCEMENT;
        repaint();
        // Attente de 5. Cte de tps du filtre passe haut
        this.etat=ATTENTE_FLT_PASSE_HAUT;
        repaint();
        temps_attente_ms=1000f*5.0f/(2*Math.PI*Contexte.FREQU_COUPURE_PASSE_HAUT);
        temps_attente_ms=Math.max(temps_attente_ms,2000.0);
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // Reset des modules maxi
        Contexte.reset_max_mod_square_and_seuil_mod2();
        // mesure des modules maxi pendant 3s
        this.etat=MESURE_NOISE;
        repaint();
        previous_time=System.currentTimeMillis();
        temps_attente_ms=3000f;
        previous_time=System.currentTimeMillis();
        while (System.currentTimeMillis()-previous_time<=temps_attente_ms){
            if (un_pas_acquisition()==true) {
                Contexte.infos_tracks.clear();
            }
        }
        // mise a jour des seuils
        Contexte.met_a_jour_seuils_sur_bruit();
        Contexte.infos_tracks.clear();
        this.NOUVELLE_DICTEE=true;
        // acquisition
        this.etat=WORKING;
        previous_time=System.currentTimeMillis();
        int old_nb_trames=Contexte.nb_trames;
        t_new=System.currentTimeMillis();
        this.N0_INTERVAL_FOR_DICTEE=0;
        while (Contexte.running) {
            boolean new_notes=(notes_a_chanter==null)||(this.NOUVELLE_DICTEE==true);
            if (!new_notes) {
                new_notes=((notes_a_chanter[notes_a_chanter.length-1].note_is_entendue)
                ||(notes_a_chanter[notes_a_chanter.length-1].note_is_ok))
                &&(notes_a_chanter[0].nb_essais>=this.NB_ESSAIS_MAX);
                
            }
            if (new_notes) new_notes=System.currentTimeMillis()>=t_new;
            if (new_notes){
                if (notes_a_chanter!=null) {
                    if (notes_a_chanter[0].nb_essais<this.NB_ESSAIS_MAX) this.NB_DICTEES_REUSSIES++;
                }
                notes_a_chanter=notes_dictee.getDictee_n_notes_from_intervalles(
                        this.nb_notes_a_chanter,
                        note_aff_mini,
                        note_aff_maxi);
                this.NOUVELLE_DICTEE=false;
                this.NB_DICTEES++;
                if (notes_a_chanter==null) {
                    Contexte.running=false;
                    this.etat=this.ERROR;
                    repaint();
                    // fin d'acquisition
                    this.stop_acquisition();
                    this.thread_termine=true;
                    Contexte.infos_tracks.clear();
                    this.etat=this.ATTENTE_LANCEMENT;
                    return;
                }
                
            }
            if (un_pas_acquisition()==true) {
                repaint();
            }
        }
        
        // fin d'acquisition
        this.stop_acquisition();
        this.thread_termine=true;
        this.etat=this.ATTENTE_LANCEMENT;
        Contexte.infos_tracks.clear();
        
        //     new PlotDataAndNotes("Notes Detectees =f(t)", 500, 500,Contexte).setVisible(true);
        
    }
    public void stop_tache() {
        if (Contexte.running) {
            Contexte.running=false;
        }
        
    }
    public void try_autre_essai(NoteDictee[] notes){
        if (notes==null) return;
        if (notes.length<2) return;
        NoteDictee nt=notes[0];
        nt.note_is_ok=false;
        nt.note_is_entendue=false;
        nt.n0_reel=0;
        nt.n1_reel=0;
        for (int i=1;i<notes.length;i++) {
            nt=notes[i];
            nt.note_is_ok=false;
            nt.note_is_entendue=false;
            nt.ecart_en_demi_ton=0f;
            nt.nb_essais=0;
            nt.n0_reel=0;
            nt.n1_reel=0;
        }
        this.NOUVELLE_DICTEE=(notes[0].nb_essais>=this.NB_ESSAIS_MAX);
    }
    private void met_a_jour_notes_jouees(NoteDictee[] notes_a_chanter, Interval[] Intervals) {
        if (notes_a_chanter==null) return;
        if (notes_a_chanter.length<1) return;
        // verification nouvelles notes
        boolean ok=true;
        int k_note=0;
        while ((k_note<notes_a_chanter.length)
        &&(notes_a_chanter[k_note].note_is_entendue)) {
            ok=ok && notes_a_chanter[k_note].note_is_ok;
            k_note++;
        }
        if (k_note>=notes_a_chanter.length)  {
            // succes, demande autre dictee
            if (ok) {
                this.NOUVELLE_DICTEE=true;
                return;
            }
            // essai suivant
            this.try_autre_essai(notes_a_chanter);
            if (notes_a_chanter==null) return;
            this.NOUVELLE_DICTEE=notes_a_chanter[0].nb_essais>=this.NB_ESSAIS_MAX;
            if (this.NOUVELLE_DICTEE) {
                return;
            }
            k_note=0;
        }
        // analyse nouvelle note
        if (Intervals==null) return;
        if (Intervals.length<1) return;
        int i=Intervals.length-1;
        Interval it=Intervals[i];
        if (it.notes[0].n0_union<=this.N0_INTERVAL_FOR_DICTEE) return;
        NoteDictee nt=notes_a_chanter[k_note];
        float vraie_freq=   it.notes[0].frequences;
        float vraie_freq_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(vraie_freq);
        if (k_note==0) {
            // calage de la premiere note => parfaite
            this.DECALAGE_EN_DEMI_TON=nt.note_en_demi_ton-vraie_freq_en_demi_ton;
            /*
            System.out.println(
                    "INIT DECAL :vraie f="
                    +String.valueOf(vraie_freq)
                    +" => vraie f en demi_ton="+String.valueOf(vraie_freq_en_demi_ton)
                    +"=> decal en demi ton="+String.valueOf(this.DECALAGE_EN_DEMI_TON)
                    +", t0="+String.valueOf(it.notes[0].n0_union/Contexte.F_ECH)
                    +", t1="+String.valueOf(it.notes[0].n1_union/Contexte.F_ECH)
                    +", poids="+String.valueOf(it.notes[0].poids)
                    );
             */
        }
        float pseudo_freq_en_demi_ton=vraie_freq_en_demi_ton+this.DECALAGE_EN_DEMI_TON;
        nt.ecart_en_demi_ton=pseudo_freq_en_demi_ton-nt.note_en_demi_ton;
        if (this.RECALE_HMS==true) {
            if (nt.ecart_en_demi_ton>=this.SEUIL_DECISION_HMS_3) {
                nt.ecart_en_demi_ton-=this.HMS_3_EN_DEMI_TONS;
            } else {
                if (nt.ecart_en_demi_ton>=this.SEUIL_DECISION_HMS_2) {
                    nt.ecart_en_demi_ton-=this.HMS_2_EN_DEMI_TONS;
                } else {
                    if (nt.ecart_en_demi_ton<=-this.SEUIL_DECISION_HMS_3) {
                        nt.ecart_en_demi_ton+=this.HMS_3_EN_DEMI_TONS;
                    } else {
                        if (nt.ecart_en_demi_ton<=-this.SEUIL_DECISION_HMS_2) {
                            nt.ecart_en_demi_ton+=this.HMS_2_EN_DEMI_TONS;
                        }
                        
                    }
                    
                }
            }
            
            //while (nt.ecart_en_demi_ton>=notes.NB_NOTES_PAR_OCTAVE/2) nt.ecart_en_demi_ton-=notes.NB_NOTES_PAR_OCTAVE;
            //while (nt.ecart_en_demi_ton<-notes.NB_NOTES_PAR_OCTAVE/2) nt.ecart_en_demi_ton+=notes.NB_NOTES_PAR_OCTAVE;
        }
        nt.note_is_ok=Math.abs(nt.ecart_en_demi_ton)<0.5f;
        nt.note_is_entendue=true;
        if (nt.note_is_entendue) {
            // note entendue
            nt.nb_essais++;
            nt.n0_reel=it.notes[0].n0_union;
            nt.n1_reel=it.notes[0].n1_union;
            this.N0_INTERVAL_FOR_DICTEE=nt.n1_reel+(int)Math.round(this.TEMPS_ATTENTE_ENTRE_2_NOTES_FOR_DICTEE*Contexte.F_ECH);
            // mais a cote de la note attendue, on degage
            /*
            System.out.println(
                    "  mesure note"+String.valueOf(k_note)
                    +":vraie f="+String.valueOf(vraie_freq)
                    +" => vraie f en demi_ton="+String.valueOf(vraie_freq_en_demi_ton)
                    +"=> decal en demi ton="+String.valueOf(this.DECALAGE_EN_DEMI_TON)
                    +", t0="+String.valueOf(it.notes[0].n0_union/Contexte.F_ECH)
                    +", t1="+String.valueOf(it.notes[0].n1_union/Contexte.F_ECH)
                    +", poids="+String.valueOf(it.notes[0].poids)
                    );
             */
            
        }
    }
    
    private boolean has_intersection(Interval it, NoteDictee[] notes_a_chanter,float delta_t) {
        boolean ok;
        if (it==null) return false;
        if (notes_a_chanter==null) return false;
        for (int i=0;i<notes_a_chanter.length;i++) {
            NoteDictee nt=notes_a_chanter[i];
            if (nt.note_is_ok==false) return false;
            ok=nt.n0_reel <= it.notes[0].n1_union;
            if (ok) ok =nt.n1_reel+delta_t*Contexte.F_ECH>=it.notes[0].n0_union;
            if (ok) return true;
        }
        return false;
    }
    
    
    
}

