/*
 * ContexteFlts.java
 *
 * Created on 9 octobre 2006, 14:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.util.Arrays;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;

/**
 *
 * @author ygorra
 */
class my_poly {
    double [] coef;
    int deg;
    public my_poly(){
        coef = new double[constantes.NPol+1];
        deg=0;
        coef[0]=1;
    }
    public my_poly times(my_poly b) {
        my_poly a = this;
        my_poly c = new my_poly();
        c.coef[0]=0;
        c.deg=a.deg+b.deg;
        for (int i = 0; i <= a.deg; i++)
            for (int j = 0; j <= b.deg; j++)
                c.coef[i+j] += (a.coef[i] * b.coef[j]);
        return c;
    }
    
    
}
class InfoNote{
    public float frequences;
    public float poids;
    
    public int n0_union,n1_union;
    public int n0_intersection,n1_intersection;
    
    public InfoNote(){
        
    }
}
class InfoDeltaF{
    public float delta_f;
    public float poids;
    public float f0;
    
    public boolean is_hm=false;
    
    public int nb_pistes=1;
    
    public int n0_union,n1_union;
    public int n0_intersection,n1_intersection;
    
    public InfoDeltaF() {
        
    }
    public InfoDeltaF(float DeltaF_,float f0_,float ampl_){
        this.delta_f=DeltaF_;
        this.f0=f0_;
        this.poids=ampl_;
    }
}
class Evt {
    public int n;
    
    public InfoTrack info_track;
    public int type_evt;
    public int nb_pistes=0;
    public InfoDeltaF info_deltaf;
    public Evt(int n_,int type_evt_,InfoTrack info_ok_) {
        this.n=n_;
        this .type_evt=type_evt_;
        this.info_track=info_ok_;
    }
    
}
class my_transfert {
    my_poly numerator;
    my_poly denominator;
    public my_transfert(){
        numerator = new my_poly();
        denominator=new my_poly();
    }
    public my_transfert transform_abcd( double a,double b,double c,double d ){
        int i,j;
        double   max_coeff_den ;
        my_poly Trv=new my_poly();
        my_poly multiplicateur=new my_poly();
        my_transfert resultat=new my_transfert();
        int Na = this.denominator.deg ;
        int Nb = this.numerator.deg ;
        int Nw = Math.max(Na , Nb);
        /** numerator = denominator = 0 , D'ordre Nw **/
        resultat.numerator.deg   = Nw ;
        resultat.denominator.deg = Nw ;
        for (i=0;i<= Nw;i++) {
            resultat.numerator.coef[i]= 0.0 ;
            resultat.denominator.coef[i]= 0.0 ;
        }
        /** Calcul de Bz et Az **/
        multiplicateur.deg = 1 ;
        for (i=0;i<=Nw;i++) {
            /** Calcul de (a+bx)^i (c+dx)^Nw-i dans Trv **/
            multiplicateur.coef[0] = a ;
            multiplicateur.coef[1] = b ;    /** multiplicateur = (a+bx) **/
            Trv.coef[0] = 1.0 ;
            Trv.deg = 0 ;    /** Trv = 1     **/
            if ( i > 0 ) {
                for( j = 1 ;j<= i;j++) Trv =Trv.times( multiplicateur );
            }
            if ( Nw - i > 0 )  {
                multiplicateur.coef[0] = c ; multiplicateur.coef[1]= d ;  /** multiplicateur = (c+dx) **/
                for (j = 1;j<= Nw - i;j++) Trv=Trv.times( multiplicateur );
            }
            /** On ajoute Bi * Trv a numerator **/
            if ( i <= Nb ) {
                for (j = 0 ;j<= Nw ;j++)  resultat.numerator.coef[j] +=  this.numerator.coef[i] * Trv.coef[j] ;
            }
            /** On ajoute Ai * Trv a denominator **/
            if ( i <= Na ) {
                for (j = 0 ;j<= Nw;j++)  resultat.denominator.coef[j] += this.denominator.coef[i] * Trv.coef[j] ;
            }
        }
        /** Normalisation **/
        max_coeff_den = Math.abs( resultat.denominator.coef[0] ) ;
        for (i = 1 ;i<= Nw;i++) {
            if ( max_coeff_den < Math.abs( resultat.denominator.coef[i] ) )
                max_coeff_den = Math.abs( resultat.denominator.coef[i] ) ;
        }
        if ( max_coeff_den > 0.0 )  {
            j = -1 ;
            for (i=0; i<= Nw;)  {
                if ( Math.abs( resultat.denominator.coef[i] / max_coeff_den ) > 1.0e-20 )  {
                    j = i ; i = Nw+1 ; max_coeff_den = resultat.denominator.coef[j] ;
                } else { i++; }
            }
            if ( j >= 0 ) {
                for (i = 0 ;i<= Nw;i++) {
                    resultat.denominator.coef[i] = resultat.denominator.coef[i] / max_coeff_den ;
                    resultat.numerator.coef[i]   = resultat.numerator.coef[i] / max_coeff_den ;
                }
            }
        }
        return resultat;
    }
}

class mul_sin_cos_k {
    float   gain_k;
    float [] lut_sin_cos;
    float [] tab_src; // Addr( Src )=Contexte.liste_decim     }
    float [] tab_dst; // Addr( Src )=Contexte.liste_decim     }
    int nb_ech           ;  // nb_ech = CONTEXTE.LGN_BUFFER Shr CONTEXTE.NB_DECIM_INIT }
    int nb_fois          ;  // Initialiser A CONTEXTE.NB_DECIM + 1 }
    int increment_temps        ;
    int size_lut_sin_cos;
    rec_cmpt_prec memoire;
    public mul_sin_cos_k(float gain_k_,
            float[] lut_sin_cos_,float[] tab_src_,float []tab_dst_,
            int longueur_,
            int nb_fois_,
            float frequence_normalisee) {
        gain_k=gain_k_;
        lut_sin_cos=lut_sin_cos_;
        size_lut_sin_cos=lut_sin_cos.length/2;
        tab_src=tab_src_;
        tab_dst=tab_dst_;
        increment_temps=(int)Math.round(frequence_normalisee*size_lut_sin_cos*constantes.COEFF_CMPT_TEMPS);
        nb_ech=longueur_;
        nb_fois=nb_fois_;
        memoire=new rec_cmpt_prec(nb_fois);
    }
    public void affiche(){
        System.out.println("MULSINCOSK");
        System.out.print("  nbech=");System.out.print(this.nb_ech);
        System.out.print(", nfois=");System.out.println(this.nb_fois);
        System.out.print("  src (ListeDecim)=");        System.out.println(tab_src);
        System.out.print("  dest (re,im)=");        System.out.println(tab_dst);
    }
    public void execute(){
        
        int    i_ech;
        float  u_n;
        int cmpt_tps;
        int k_ech=0;
        int k_dst=0;
        int nb_ech_local=nb_ech;
        int cmpt_lut;
        for (int i_fois =1;i_fois<= nb_fois;i_fois++){
            cmpt_tps=memoire.cmpt_prec[i_fois];
            for (i_ech=0;i_ech< nb_ech_local;i_ech++){
                u_n=tab_src[k_ech++]*gain_k;
                // u_n *gain_k*sin }
                cmpt_lut=cmpt_tps >> (constantes.SHIFT_CMPT_TEMPS);
                tab_dst[k_dst++]=u_n*lut_sin_cos[2*cmpt_lut];
                // u_n *gain_k*cos }
                tab_dst[k_dst++]=u_n*lut_sin_cos[2*cmpt_lut+1];
                // Temps suivant }
                cmpt_tps+=increment_temps;
                cmpt_tps&=constantes.MASK_CMPT_TEMPS;
                
            } // for i_ech
            memoire.cmpt_prec[i_fois]=cmpt_tps;
            nb_ech_local/= 2;
        } // for i_fois
    }
}
class flt_1z_re_im {
    float moins_a1,moins_a2 ;
    float [] tab_src   ;
    float [] tab_dst    ;
    int nb_ech    ;  /* nb_ech =  2^(nb_fois-1) * Increment , KEntier */
    int nb_fois   ; /* Pour le cas de filtrages Repetes */
    /* Memoires du filtre [u_n-1,y_n-1,y_n-2] , Pour Chaque Cellule */
    rec_re_im_2 memoire ;/* Array[1..NB_DECIM_MAX+1 ]  Of rec_re_im_2 */
    public flt_1z_re_im(float moins_a1_,float moins_a2_,
            float [] tab_src_,float [] tab_dst_,
            int longueur_,
            int nb_fois_) {
        moins_a1=moins_a1_;moins_a2=moins_a2_;
        tab_src=tab_src_;tab_dst=tab_dst_;
        nb_ech=longueur_;
        nb_fois=nb_fois_;
        memoire =new rec_re_im_2(nb_fois);
    }
    public void affiche(){
        System.out.println("FLT1Z_RE_IM");
        System.out.print("  nbech=");System.out.print(this.nb_ech);
        System.out.print(", nfois=");System.out.println(this.nb_fois);
        System.out.print("  src (re,im)=");System.out.println(this.tab_src);
        System.out.print("  dest (re,im)=");        System.out.println(tab_dst);
    }
    
    
    
    
    public void execute(){
        int i_ech;
        float re_n=0,re_n_1,re_n_2;
        float im_n=0,im_n_1,im_n_2;
        float u_n;
        
        int k_ech=0;
        int nb_ech_local=nb_ech;
        for (int i_fois =1 ;i_fois<= nb_fois;i_fois++) {
            re_n_1=memoire.re_n_1[i_fois];
            re_n_2=memoire.re_n_2[i_fois];
            im_n_1=memoire.im_n_1[i_fois];
            im_n_2=memoire.im_n_2[i_fois];
            
            for (i_ech=0;i_ech< nb_ech_local;i_ech++) {
                /* partie reelle */
                u_n=tab_src[k_ech];
                re_n =u_n + moins_a1 * re_n_1 + moins_a2 * re_n_2  ;
                tab_dst[k_ech++]=(re_n + 2*re_n_1 + re_n_2);
                re_n_2 = re_n_1 ; re_n_1 = re_n ;
                /* partie imaginaire */
                u_n=tab_src[k_ech];
                im_n =u_n + moins_a1 * im_n_1 + moins_a2 * im_n_2  ;
                tab_dst[k_ech++]=(im_n + 2*im_n_1 + im_n_2);
                im_n_2 = im_n_1 ; im_n_1 = im_n ;
            } //for i_ech
            memoire.re_n_1[i_fois]=re_n_1;
            memoire.re_n_2[i_fois]=re_n_2;
            memoire.im_n_1[i_fois]=im_n_1;
            memoire.im_n_2[i_fois]=im_n_2;
            nb_ech_local/= 2;
        } // for i_fois
    } // execute()
}

class RecUi1Ys1 {
    short u_n_1 ; // Integer ;
    float y_n_1 ; // Single ;
    public RecUi1Ys1(){
        y_n_1=0;u_n_1=0;
    }
}
class rec_re_im_2 {
    float []re_n_1;float[]re_n_2 ; // Single ; { memoire Filtre Re }
    float []im_n_1;float []im_n_2 ; // Single ; { memoire Filtre Im }
    public rec_re_im_2(int nb_decim){
        re_n_1=new float[nb_decim+2];
        re_n_2=new float[nb_decim+2];
        im_n_1=new float[nb_decim+2];
        im_n_2=new float[nb_decim+2];
        for (int i=0;i<nb_decim+2;i++){
            re_n_1[i]=0;re_n_2[i]=0;
            im_n_1[i]=0;im_n_2[i]=0;
        }
    }
}
class RecUiYs22 {
    int u_n_1 , u_n_2; // Integer ;
    float y_n_1,y_n_2 ; // Single ;
    public RecUiYs22(){
        u_n_1=0; u_n_2=0;
        y_n_1=0;y_n_2=0;
    }
}
class rec_cmpt_prec {
    int [] cmpt_prec  ; // Word ;
    public rec_cmpt_prec(int nb_decim){
        cmpt_prec=new int[nb_decim+2];
        for (int i=0;i<nb_decim+2;i++){cmpt_prec[i]=0;}
    }
}
class RecUsYs12 {
    float u_n_1      ; // Single ;
    float y_n_1,y_n_2 ; // Single ;
    public RecUsYs12(){
        u_n_1=0;
        y_n_1=0;y_n_2=0;
    }
}
class RecUsYs22 {
    float u_n_1 , u_n_2 ; // Single ;
    float y_n_1 , y_n_2 ; // Single ;
    public RecUsYs22(){
        u_n_1=0;u_n_2=0;
        y_n_1=0;y_n_2=0;
    }
}

class flt_passe_haut_initial {
    float y_n_1,gain_k,a1;
    short u_n,u_n_1;
    int nb_ech;
    int n0_src;
    short[] tab_src;
    float[] tab_dst;
    ContexteFlts sender;
    public flt_passe_haut_initial(float a1_,float gain_k_,
            short [] tab_src_,float[]tab_dst_,int longueur_,ContexteFlts sender_) {
        sender=sender_;
        tab_src=tab_src_;
        tab_dst=tab_dst_;
        a1=a1_;
        gain_k=gain_k_;
        nb_ech=longueur_;
        y_n_1=0;
        u_n_1=0;
        n0_src=0;
    }
    public void affiche(){
        System.out.println("FLT_PASSE_HAUT");
        System.out.print("  nbech=");System.out.println(this.nb_ech);
        System.out.print("  src (re,im)=");System.out.println(this.tab_src);
        System.out.print(", n0_src=");System.out.println(this.n0_src);
        System.out.print("  dest (re,im)=");        System.out.println(tab_dst);
    }
    
    public void execute() {
        float sum_square_mod=0f;
        int k_src=n0_src;
        for (int i_ech=0 ;i_ech < nb_ech;i_ech++) {
            u_n=tab_src[k_src++];
            y_n_1=gain_k * (u_n - u_n_1) - a1*y_n_1 ;
            tab_dst[i_ech]=y_n_1;
            sum_square_mod+=y_n_1*y_n_1;
            u_n_1=u_n;
        }
        sender.mod_square_moy=sum_square_mod/nb_ech;
    }
}

class PoidsRelatifEntreInfos{
    public InfoTrack[] if_ok;
    public float[] poids;
    public int duree[];
    public float delta_f[];
    public float poids_max;
    public PoidsRelatifEntreInfos(){
        poids_max=0f;
        poids =new float[constantes.NB_POIDS_RELATIFS]; // 0->info_0,info_0->info_1,info_0->info_2,...
        if_ok=new InfoTrack[constantes.NB_POIDS_RELATIFS];//info_0,info_1,info_2,...
        duree=new int[constantes.NB_POIDS_RELATIFS];
        delta_f=new  float[constantes.NB_POIDS_RELATIFS];
    }
    public int duree_recouvrement(int n0, int n1, int m0, int m1) {
        n0=m0>n0?m0:n0;
        n1=m1<n1?m1:n1;
        int duree=n1-n0+1;
        duree=duree>0?duree:0;
        return duree;
    }
    
    
    public void ComputePoidsRelatif(InfoTrack if_2,int i) {
        InfoTrack if_1;
        if (i==0) {
            if_1=if_2;
        } else {
            if_1=this.if_ok[0];
        }
        int duree=this.duree_recouvrement(if_1.n0_reel_super_track,if_1.n1_reel_super_track,
                if_2.n0_reel_super_track,if_2.n1_reel_super_track);
        
        
        this.poids[i]=Math.min(if_1.mean_mod_square_super_track*duree,if_2.mean_mod_square_super_track*duree);
        poids_max=poids[i]<poids_max? poids_max:poids[i];
        this.duree[i]=duree;
        this.if_ok[i]=if_2;
        if (i>0) {
            delta_f[i]=if_2.f_reelle_super_track-if_1.f_reelle_super_track;
        } else {
            delta_f[i]=if_1.f_reelle_super_track;
        }
    }
}
class flt_1z_float_float_k {
    float [] tab_src;
    float [] tab_dst;
    int n0_src,n0_dst;
    float u_n,u_n_1,y_n,y_n_1,y_n_2;
    
    public flt_1z_float_float_k(float moins_a1_,float moins_a2_,float gain_k_,
            float [] src,float [] dst,
            int longueur_,int n0_src_,int n0_dst_,
            int increment_){
        moins_a1=moins_a1_;
        moins_a2=moins_a2_;
        gain_k=gain_k_;
        tab_src=src;
        tab_dst=dst;
        n0_src=n0_src_;
        n0_dst=n0_dst_;
        nb_ech=longueur_;
        increment_decim=increment_;
        u_n=u_n_1=y_n=y_n_1=y_n_2=0;
    };
    public void affiche(){
        System.out.println("FLT_1Z_FLOAT_FLOAT_K");
        System.out.print("  nbech=");System.out.print(this.nb_ech);
        System.out.print(", increment=");System.out.println(this.increment_decim);
        System.out.print("  src (re,im)=");System.out.print(this.tab_src);
        System.out.print(", n0_src=");System.out.println(this.n0_src);
        System.out.print("  dest (re,im)=");        System.out.print(tab_dst);
        System.out.print(", n0_dst=");System.out.println(this.n0_dst);
    }
    
    public void execute() {
        int cmpt=1;
        int i_dst=n0_dst;
        int k_src=n0_src;
        for (int i_ech=0;i_ech<nb_ech;i_ech++) {
            u_n=tab_src[k_src++];
            y_n=u_n+ moins_a1*y_n_1 + moins_a2*y_n_2;
            if ((--cmpt)==0) {
                cmpt=increment_decim;
                tab_dst[i_dst++]=(y_n+2*y_n_1+y_n_2)*gain_k;
            }
            y_n_2=y_n_1;y_n_1=y_n; u_n_1=u_n;
        }
    }
    float moins_a1,moins_a2,gain_k  ;
    int nb_ech        ;// Word    ;  // nb_ech = gain_k * 2^(nb_fois-1) * increment_decim , KEntier }
    int increment_decim    ;// Byte    ;  // increment_decim en puissance entiere de 2 }
    // { Memoires du filtre [u_n-1,y_n-1,y_n-2] , Pour Chaque Cellule }
}
class InfoTrack {
    int n0_ok_decim;
    int nb_ok_decim;
    float sum_w_inst;
    float sum_mod_square;
    float f_reelle;
    MemoireClcDetect mem;
    int n0_reel;
    
    
    int n1_reel;
    
    boolean is_a_super_track;
    int numero_super_track;
    int nb_tracks_in_super_track;
    int n0_reel_super_track;
    int n1_reel_super_track;
    float f_reelle_super_track;
    float sum_mod_square_super_track;
    float max_mod_square_super_track;
    public float mean_mod_square_super_track;
    public float mean_mod_square_relative_super_track;
    
    public float f_ajustee;
    
    
    
    public boolean can_be_used;
    
    
    public int num_evt;// numero du premier evenement createur de la pise
    
    public int num_simultaneous_track;
    
    public boolean tmp_ok;// used in sort_...
    
    public float mean_mod_square;
    
    public float max_mod_square_relative_super_track;
    
    
    public InfoTrack(int n0_OK_,int nb_ok_,float w_moy_,float mod_square_,MemoireClcDetect mem_){
        n0_ok_decim=n0_OK_;
        nb_ok_decim=nb_ok_;
        mean_mod_square=mod_square_/nb_ok_decim;
        mem=mem_;
        // on met sum_mod_square et sum_w_inst a l'ech des echantillons reels
        sum_w_inst=w_moy_*mem.info_detection.coeff_decimation;
        sum_mod_square=mod_square_*mem.info_detection.coeff_decimation;
    }
}
class flt_1z_float_float {
    float [] tab_src;
    float [] tab_dst;
    int n0_src,n0_dst;
    float u_n,u_n_1,y_n,y_n_1,y_n_2;
    
    public flt_1z_float_float(float moins_a1_,float moins_a2_,
            float [] src,float [] dst,
            int longueur_,int n0_src_,int n0_dst_,
            int increment_){
        moins_a1=moins_a1_;
        moins_a2=moins_a2_;
        nb_ech=longueur_;
        increment_decim=increment_;
        tab_src=src;
        tab_dst=dst;
        n0_src=n0_src_;
        n0_dst=n0_dst_;
        u_n=u_n_1=y_n=y_n_1=y_n_2=0;
    };
    public void affiche(){
        System.out.println("FLT_1Z_FLOAT_FLOAT");
        System.out.print("  nbech=");System.out.print(this.nb_ech);
        System.out.print(", increment=");System.out.println(this.increment_decim);
        System.out.print("  src (re,im)=");System.out.print(this.tab_src);
        System.out.print(", n0_src=");System.out.println(this.n0_src);
        System.out.print("  dest (re,im)=");        System.out.print(tab_dst);
        System.out.print(", n0_dst=");System.out.println(this.n0_dst);
    }
    
    public void execute() {
        int cmpt=1;
        int i_dst=n0_dst;
        int k_src=n0_src;
        for (int i_ech=0;i_ech<nb_ech;i_ech++) {
            u_n=tab_src[k_src++];
            y_n=u_n + moins_a1*y_n_1 + moins_a2*y_n_2;
            if ((--cmpt)==0) {
                cmpt=increment_decim;
                tab_dst[i_dst++]=y_n+2*y_n_1+y_n_2;
            }
            y_n_2=y_n_1;y_n_1=y_n;u_n_1=u_n;
        }
    }
    float moins_a1,moins_a2  ;
    int nb_ech        ;// Word    ;  // nb_ech = gain_k * 2^(nb_fois-1) * increment_decim , KEntier }
    int increment_decim    ;// Byte    ;  // increment_decim en puissance entiere de 2 }
    // { Memoires du filtre [u_n-1,y_n-1,y_n-2] , Pour Chaque Cellule }
}

class Instruction {
    public Instruction(int TypeInst, int data) {
        switch (TypeInst) {
            case 1:data=1;
            default :
                data=2;
        }
        
    }
}
class  RecDemodu {
    
    double FPlus ;
    double FMoins ;
    double DeltaF_6db ;
    public RecDemodu( ) /* CONTEXTE.NB_FILTRES => TabRecDemodu */
    {
    }
}
class InfoDetection {
    int OK                    ;/* 0 Si OK */
    float FMoyenne            ;
    float ModMoyen            ;
    float retard_de_groupe_bessel              ;
    int   seuil_nb_ok            ;
    int   seuil_maxi_nb_ok;
    int seuil_nb_attente;
    int coeff_decimation;
    /* POUR SIMPLIFIER TACHE DU PP */
    float FCentraleReelle     ; /* Pour Simplifier Tache PP */
    int LongueurBuff          ;/* Idem */
    int indice_filtre          ;
    int indice_dans_tab_memoire_detect;
    
    
    
    
    public InfoDetection() {
    }
    
}

class MemoireClcDetect {
    MemoireClcDetect mem_prec,mem_suiv;
    boolean is_in_interval;
    boolean stock_info_ok;
    int n_ech_decim;
    float max_mod_square;
    float re_plus_n_1 ;
    float im_plus_n_1  ;
    float re_moins_n_1;
    float im_moins_n_1 ;// Single;
    float w_inst_ini;          // pulsation normalisee initiale
    float sum_w_inst_plus_mul_mod_square           ;// Single; // FMoy Norm * nb_ech
    float sum_square_mod_plus         ;// Single; // Mod2 Norm * nb_ech
    float  SeuilPlusDeltaW       ;// Single;
    float  SeuilMoinsDeltaW      ;// Single;
    float DeltaW;
    float  seuil_plus_w_inst            ;// Single;
    float  seuil_moins_w_inst           ;// Single;
    float  SeuilMod2             ;// Single;
    float seuil_mod2_relative_mod2_max;
    int    ok_detection                 ;// Byte  ;
    int n0_ok_decim;   // first sample wich was OK
    int nb_ok_decim;   // nb of samples wich were OK
    
    float  TrvRetGrp             ;// Single;
    float  TamponRetGrp          ;// Single ;
    float  ModuleMax             ;// Single ;
    InfoDetection info_detection;
    //  LinkedList infos_tracks; // List Of InfoTrack
    float  freq_reelle_sur_w_inst ;// Single; /* Idem */
    float  CoeffRetGrp           ;// Single ;
    float seuil_mini_nb_ok;
    float seuil_mini_nb_attente;
    
    float [] tab_w_inst_plus;
    float [] tab_mod2_plus;
    float [] tab_mod2_moins;
    float [] tab_delta_w_inst;
    float [] tab_retard_de_groupe;
    
    int nb_attente;
    
    float seuil_w_inst_w_init_attente;
    
    ContexteFlts sender;
    
    public float max_better_mean_mod_square=0f;
    
    public float max_better_mod_square=0f;
    
    float w_inst_ini_attente;
    
    
    
    
    
    
    
    public void met_a_jour_retard_de_groupe(
            ContexteFlts CONTEXTE,
            float retard_de_groupe,
            int i_decim){
        float seuil_maxi_nb_ok_;
        if (!is_in_interval) {return;}
        info_detection.retard_de_groupe_bessel  = (float)retard_de_groupe  ;
        info_detection.seuil_nb_ok=(int)Math.round(info_detection.retard_de_groupe_bessel*CONTEXTE.SEUIL_NB_OK_RELATIVE_RETARD_GROUPE);
        seuil_mini_nb_ok=CONTEXTE.TEMPS_MINI_NB_OK*CONTEXTE.F_ECH;
        
        info_detection.seuil_maxi_nb_ok=(int)Math.round(info_detection.retard_de_groupe_bessel*CONTEXTE.SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE);
        seuil_maxi_nb_ok_=CONTEXTE.TEMPS_MAXI_NB_OK*CONTEXTE.F_ECH;
        
        info_detection.seuil_nb_attente=(int)Math.round(info_detection.retard_de_groupe_bessel*CONTEXTE.SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE);
        seuil_mini_nb_attente=CONTEXTE.TEMPS_MINI_NB_ATTENTE*CONTEXTE.F_ECH;
        for (int l = 1 ;l<=CONTEXTE.NB_DECIM_INIT;l++) {
            info_detection.retard_de_groupe_bessel  *=  2.0  ;
            seuil_mini_nb_ok/=2.0f;
            seuil_maxi_nb_ok_/=2.0f;
            seuil_mini_nb_attente/=2.0f;
        }
        for( int l = 1 ;l< i_decim;l++) {
            info_detection.retard_de_groupe_bessel          *=  2.0  ;
            seuil_mini_nb_ok/=2.0f;
            seuil_maxi_nb_ok_/=2.0f;
            seuil_mini_nb_attente/=2.0f;
        }
        info_detection.seuil_nb_ok=(int)Math.round(Math.max(seuil_mini_nb_ok,(float)info_detection.seuil_nb_ok));
        info_detection.seuil_maxi_nb_ok=(int)Math.round(Math.max(seuil_maxi_nb_ok_,(float)info_detection.seuil_maxi_nb_ok));
        info_detection.seuil_nb_attente=(int)Math.round(Math.max(seuil_mini_nb_attente,(float)info_detection.seuil_nb_attente));
        
    }
    public MemoireClcDetect(ContexteFlts CONTEXTE,
            int i_filtre,
            int i_decim,
            RecDemodu demodu,
            double retard_de_groupe
            ) {
        this.sender=CONTEXTE;
        float seuil_maxi_nb_ok_;
        int LGN_BUF=CONTEXTE.LGN_BUFFER;
        this.stock_info_ok=true;
        /* reset indices echs */
        n_ech_decim=0;
        n0_ok_decim=0;
        nb_ok_decim=0;
        /* Init memoire Pour Derivee */
        re_plus_n_1 = 0 ; im_plus_n_1  =0;
        re_moins_n_1= 0 ; im_moins_n_1 =0;
        info_detection=new InfoDetection();
        info_detection.indice_filtre = i_filtre ;
        info_detection.indice_dans_tab_memoire_detect=-1; //prudence=> declenche une exception si je me gourre
        info_detection.FCentraleReelle       = (float) (demodu.FPlus * CONTEXTE.F_ECH) ; /* Pour Simplifier Tache PP */
        info_detection.retard_de_groupe_bessel                = (float)retard_de_groupe  ;
        
        // ATTENTION, ce n'est pas une erreur,
        // le seuil est lie au retard de groupe normalise,
        // puisque n0_ok_decim, nb_ok_decim correspondent au nb d'echs apres decimation
        // pour gagner en effeicacite de traitement
        info_detection.seuil_nb_ok=(int)Math.round(info_detection.retard_de_groupe_bessel*CONTEXTE.SEUIL_NB_OK_RELATIVE_RETARD_GROUPE);
        seuil_mini_nb_ok=CONTEXTE.TEMPS_MINI_NB_OK*CONTEXTE.F_ECH;
        
        seuil_maxi_nb_ok_=CONTEXTE.TEMPS_MAXI_NB_OK*CONTEXTE.F_ECH;
        
        
        
        
        info_detection.seuil_nb_attente=(int)Math.round(info_detection.retard_de_groupe_bessel*CONTEXTE.SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE);
        seuil_mini_nb_attente=CONTEXTE.TEMPS_MINI_NB_ATTENTE*CONTEXTE.F_ECH;
        freq_reelle_sur_w_inst = (float) (CONTEXTE.F_ECH / ( 2 * Math.PI ));
        /* Init ModuleMax */
        ModuleMax = 0.0f ;
        info_detection.coeff_decimation=1;
        for (int l = 1 ;l<=CONTEXTE.NB_DECIM_INIT;l++) {
            info_detection.coeff_decimation*=2;
            info_detection.FCentraleReelle /=  2.0  ;
            info_detection.retard_de_groupe_bessel          *=  2.0  ;
            seuil_mini_nb_ok/=2.0f;
            seuil_maxi_nb_ok_/=2.0f;
            
            seuil_mini_nb_attente/=2.0f;
        }
        /* Inutile */
        ok_detection                 = 255  ;
        info_detection.FMoyenne              = 1 ;
        /* Seuils FPlus Pour Estimer Detection */
        seuil_plus_w_inst = (float)(demodu.FPlus / ( demodu.FPlus - demodu.DeltaF_6db)) ;
        seuil_plus_w_inst = (float) (demodu.FPlus * ( 1.0 - 1.0 / Math.sqrt( seuil_plus_w_inst ) ));
        //icilesgars,j'ai elargi la bande   seuil_plus_w_inst *= 1.5 * 2 * Math.PI ;
        seuil_plus_w_inst *= CONTEXTE.SEUIL_W_INST_RELATIVE_6DB * 2 * Math.PI ;
        
        seuil_moins_w_inst      = - seuil_plus_w_inst ;
        seuil_w_inst_w_init_attente=(float)(CONTEXTE.SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS * seuil_plus_w_inst);
        /* Seuils Sur DeltaF Pour Estimer Detection */
        SeuilPlusDeltaW  = (float)(CONTEXTE.SEUIL_PLUS_DERIVF
                * 2 * Math.PI
                *( demodu.FPlus- demodu.FMoins)) ;
        SeuilMoinsDeltaW = (float)(CONTEXTE.SEUIL_MOINS_DERIVF
                * 2 * Math.PI
                * ( demodu.FPlus - demodu.FMoins)) ;
        DeltaW=(float)(2 * Math.PI
                * ( demodu.FPlus - demodu.FMoins));
        /*Seuil Sur Module Moyen */
        SeuilMod2 = CONTEXTE.SEUIL_MODU  * CONTEXTE.SEUIL_MODU ;
        this.seuil_mod2_relative_mod2_max=CONTEXTE.SEUIL_MOD2_RELATIVE;
        info_detection.OK                    = 255  ;   /* Pas OK par Defaut */
        for (int l = 1;l<= CONTEXTE.NB_DECIM_INIT ;l++) {
            freq_reelle_sur_w_inst/=2.0f;
            LGN_BUF/=2;
        }
        for( int l = 1 ;l< i_decim;l++) {
            LGN_BUF/=2;
            freq_reelle_sur_w_inst/=2.0f;
            info_detection.coeff_decimation*=2;
            info_detection.FCentraleReelle /=  2.0  ;
            info_detection.retard_de_groupe_bessel          *=  2.0  ;
            seuil_mini_nb_ok/=2.0f;
            seuil_maxi_nb_ok_/=2.0f;
            seuil_mini_nb_attente/=2.0f;
        }
        this.tab_w_inst_plus=new float[LGN_BUF];
        this.tab_mod2_plus=new float[LGN_BUF];
        this.tab_mod2_moins=new float[LGN_BUF];
        this.tab_delta_w_inst=new float[LGN_BUF];
        this.tab_retard_de_groupe=new float[LGN_BUF];
        info_detection.seuil_nb_ok=(int)Math.round(Math.max(seuil_mini_nb_ok,(float)info_detection.seuil_nb_ok));
        info_detection.seuil_maxi_nb_ok=(int)Math.round(seuil_maxi_nb_ok_);
        info_detection.seuil_nb_attente=(int)Math.round(Math.max(seuil_mini_nb_attente,(float)info_detection.seuil_nb_attente));
        is_in_interval=(info_detection.FCentraleReelle>=CONTEXTE.F_MINI)
        &&(info_detection.FCentraleReelle<=CONTEXTE.F_MAXI);
        if (!is_in_interval) {
            //    toute tentative d'utiliser cette memoire doit etre
            // severement reprimandee => tous les pointeurs a null
            info_detection=null;
            return;
        }
        // recalage erreur w_inst-w_attente en demi ton
        float LOG_ERR_W_ATTENTE=(float)(CONTEXTE.SEUIL_W_ATTENTE_RELATIVE_DEMI_TON*CONTEXTE.LOG_DEMI_TON);
        float coeff_w_attente_rel_demi_ton=(float)Math.exp(LOG_ERR_W_ATTENTE);
        float seuil_f_reelle_attente=(float)((coeff_w_attente_rel_demi_ton-1.0f)*this.info_detection.FCentraleReelle);
        float seuil_w_attente_rel_demi_ton=(float)(seuil_f_reelle_attente/this.freq_reelle_sur_w_inst);
        float f_verif_plus=info_detection.FCentraleReelle+this.freq_reelle_sur_w_inst*seuil_w_attente_rel_demi_ton;
        float f_verif_moins=info_detection.FCentraleReelle-this.freq_reelle_sur_w_inst*seuil_w_attente_rel_demi_ton;
        
        seuil_w_inst_w_init_attente=(float)Math.min(seuil_w_inst_w_init_attente,seuil_w_attente_rel_demi_ton);
        
    }
}
class Interval{
    public int nb_pistes;
    public InfoNote[] notes;
    public int type_evt;
    
    public int n0;
    
    public int n1;
    
    public InfoTrack[] tab_infos_tracks;
    public Interval() {
        
    }
}
class ClcDetect {
    float[] tab_plus ; /* [ Re+,Im+], -> [ ModPlus^2,wPlus] */
    float[] tab_moins;  /* [ Re-,Im-], -> [ retard_de_groupe,wPlus-wMoins] */
    int    nb_ech    ;  /* nb_ech = gain_k * 2^(nb_fois-1) * Increment , KEntier */
    /*    Increment    : Byte    ;   Increment en puissance entiere de 2 */
    /* Memoires du filtre [u_n-1,y_n-1,y_n-2] , Pour Chaque Cellule */
    MemoireClcDetect [] memoire;   //    memoire : Array[1..NB_DECIM_MAX+1 ]  Of MemoireClcDetect;
    
    int nb_decim;// pour le cas de filtrage repetes
    
    public ClcDetect(ContexteFlts CONTEXTE,int i_filtre,double retard_de_groupe) {
        MemoireClcDetect memoire_i;
        memoire =new MemoireClcDetect[CONTEXTE.NB_DECIM+2];
        tab_plus  = CONTEXTE.BufDstReImPlus  ;
        tab_moins = CONTEXTE.BufDstReImMoins ;
        nb_ech       = CONTEXTE.LGN_BUFFER >> CONTEXTE.NB_DECIM_INIT  ;
        nb_decim    = CONTEXTE.NB_DECIM + 1 ;
        /* Initialisation parametres Memoires */
        for (int i_decim = nb_decim ;i_decim>= 1;i_decim--) {
            memoire[i_decim]=new MemoireClcDetect(CONTEXTE,i_filtre,i_decim,CONTEXTE.tab_demodu[i_filtre],retard_de_groupe);
        }
    }
    public void affiche(){
        System.out.println("CLC DETECT");
        System.out.print("  nbech=");System.out.println(this.nb_ech);
        System.out.print("  tab_moins (re,im)=");System.out.println(this.tab_moins);
        System.out.print("  tab_plus (re,im)=");        System.out.println(tab_plus);
    }
    
    public void execute(){
        float w_inst_plus_moy;
        boolean ok_attente;
        float w_inst_moins_mul_mod_square;
        float w_inst_plus_mul_mod_square;
        MemoireClcDetect mem;
        int i_ech,i_ech_mem;
        float   retard_de_groupe;
        float  re_plus_n=0,im_plus_n=0,re_moins_n=0,im_moins_n=0;
        float  re_plus_n_1,im_plus_n_1,re_moins_n_1,im_moins_n_1;
        float  mod_square_plus,mod_square_moins,w_inst_plus,w_inst_moins,delta_w_inst,w_inst_ini;
        int k_ech=0;
        int nb_ech_local=nb_ech;
        for (int i_decim =1 ;i_decim<= nb_decim ;i_decim++) {
            mem=memoire[i_decim];
            if (mem.is_in_interval==true) {
                // on ne calcule que les frequences entre F_MINI et F_MAXI
                i_ech_mem=0;
                re_plus_n_1=mem.re_plus_n_1;im_plus_n_1=mem.im_plus_n_1;
                re_moins_n_1=mem.re_moins_n_1;im_moins_n_1=mem.im_moins_n_1;
                for (i_ech=0;i_ech< nb_ech_local;i_ech++) {
                    re_plus_n=tab_plus[k_ech];
                    im_plus_n=tab_plus[k_ech+1];
                    /* Calcul de FPlus = Re(n) .[Im(n)-Im(n-1)] - Im(n) . [ Re(n) - Re(n-1)] */
                    w_inst_plus_mul_mod_square= re_plus_n * (im_plus_n-im_plus_n_1) - im_plus_n *(re_plus_n-re_plus_n_1)  ;
                    
                    re_plus_n_1 = re_plus_n; im_plus_n_1 = im_plus_n;
                    /* Calcul de FMoins = Re(n) .[Im(n)-Im(n-1)] - Im(n) . [ Re(n) - Re(n-1)] */
                    re_moins_n=tab_moins[k_ech];
                    im_moins_n=tab_moins[k_ech+1];
                    w_inst_moins_mul_mod_square= re_moins_n * (im_moins_n-im_moins_n_1) - im_moins_n *(re_moins_n-re_moins_n_1);
                    re_moins_n_1 = re_moins_n; im_moins_n_1 = im_moins_n;
                    /* Calcul du Retard de Groupe = RePlus.[ImPlus - ImMoins] - ImPlus. [RePlus-ReMoins]*/
                    retard_de_groupe=re_plus_n*(im_plus_n-im_moins_n) - im_plus_n * (re_plus_n-re_moins_n);
                    /* Calcul du Module Plus, Stockage ModPlus en memoire */
                    mod_square_plus= re_plus_n * re_plus_n + im_plus_n * im_plus_n ;
                    if (mod_square_plus>mem.max_mod_square) {
                        mem.max_mod_square=mod_square_plus;
                        mem.SeuilMod2=Math.max(mem.SeuilMod2,mod_square_plus*mem.seuil_mod2_relative_mod2_max);
                    }
                    /* recalage w_inst_plus= retard_de_groupe */
                    if (mod_square_plus >1.0f) {
                        w_inst_plus=w_inst_plus_mul_mod_square/mod_square_plus;
                        retard_de_groupe/=(mod_square_plus*mem.DeltaW);
                    } else {
                        w_inst_plus=w_inst_plus_mul_mod_square/(mod_square_plus+1); // ca n'a plus de sens, on est dans le bruit
                        retard_de_groupe/=((mod_square_plus+1)*mem.DeltaW);
                    }
                    /* passage des tests */
                    
                    
                    if (mod_square_plus <= mem.SeuilMod2) { mem.ok_detection= constantes.Mask_SeuilMod2;} else                                 {mem.ok_detection=0;}
                    
                    if (w_inst_plus > mem.seuil_plus_w_inst) { mem.ok_detection|= constantes.Mask_SeuilF;}
                    if (w_inst_plus < mem.seuil_moins_w_inst){ mem.ok_detection|= constantes.Mask_SeuilF;}
                    /* Calcul du Module Moins */
                    mod_square_moins=re_moins_n*re_moins_n+im_moins_n*im_moins_n;
                    if (mod_square_moins >1.0f) {
                        w_inst_moins=w_inst_moins_mul_mod_square/mod_square_moins;
                    } else {
                        w_inst_moins=w_inst_moins_mul_mod_square/(mod_square_moins+1); // ca n'a moins de sens, on est dans le bruit
                    }
                    /* difference entre les frequences */
                    delta_w_inst=w_inst_moins-w_inst_plus;
                    /* Stockage des resultats */
                    mem.tab_mod2_plus[i_ech_mem]=mod_square_plus;
                    mem.tab_w_inst_plus[i_ech_mem]=w_inst_plus;
                    mem.tab_delta_w_inst[i_ech_mem]=delta_w_inst;
                    mem.tab_mod2_moins[i_ech_mem]=mod_square_moins;
                    mem.tab_retard_de_groupe[i_ech_mem]=retard_de_groupe;
                    i_ech_mem++;
                    if (delta_w_inst>mem.SeuilPlusDeltaW ) {
                        mem.ok_detection|= constantes.Mask_SeuilDeltaF;
                    }
                    if (delta_w_inst<mem.SeuilMoinsDeltaW) {
                        mem.ok_detection|= constantes.Mask_SeuilDeltaF;
                    }
                    // ecart entre w_inst et w_inst_moyenne < 0.5 demi_tons
                    if ((mem.ok_detection==0)&&(mem.nb_ok_decim>mem.info_detection.seuil_nb_ok) ){
                        w_inst_plus_moy=mem.sum_w_inst_plus_mul_mod_square/mem.sum_square_mod_plus;
                        if (w_inst_plus-w_inst_plus_moy>mem.seuil_w_inst_w_init_attente) {
                            mem.ok_detection|=constantes.Mask_SeuilF_MOINS_FINI;
                        }
                    }
                    /* VALIDATION DES PISTES */
                    if (mem.nb_ok_decim>mem.info_detection.seuil_maxi_nb_ok) {
                        mem.ok_detection=mem.ok_detection|constantes.Mask_TEMPS_MAXI_DEPASSE;
                        mem.nb_attente=mem.info_detection.seuil_nb_attente;// pour forcer validation immediate de la pise
                    }
                    if (mem.ok_detection!=0) {// echantillon pas OK
                        // inc attente jusqu a seuil
                        if (mem.nb_ok_decim>0) {mem.nb_attente++;} else {mem.nb_attente=0;}
                        if (mem.nb_attente>=mem.info_detection.seuil_nb_attente) { // il y avait des echantillons OK
                            // on ne valide la piste qu'apres l'attente
                            if (mem.stock_info_ok==true) {
                                if (mem.nb_ok_decim>mem.info_detection.seuil_nb_ok) {
                                    // suffisament d'echantillons=> ajout a la liste de notes
                                    InfoTrack rec_info_ok=new InfoTrack(
                                            mem.n0_ok_decim,mem.nb_ok_decim,mem.sum_w_inst_plus_mul_mod_square,mem.sum_square_mod_plus,mem);
                                    mem.sender.infos_tracks.add((Object) rec_info_ok);
                                }
                            }
                            mem.nb_ok_decim=0;
                            mem.nb_attente=0;
                        }
                        // nb_ok_decim etait egal a 0, rien a faire
                    } else {  // echantillon OK
                        if (mem.nb_attente==0) {
                            ok_attente=true;
                        } else {
                            // on est dans l'attente, on verifie si la piste precedente peut etre liee a la nouvelle piste
                            if (mem.nb_ok_decim>mem.seuil_mini_nb_ok) {
                                mem.w_inst_ini_attente=mem.sum_w_inst_plus_mul_mod_square/mem.sum_square_mod_plus;
                            } else {// nb_attente>0 nb_ok_decim=0, ne devrait jamais se produire
                                mem.w_inst_ini_attente=w_inst_plus+2*mem.seuil_w_inst_w_init_attente;
                            }
                            ok_attente=Math.abs(mem.w_inst_ini_attente-w_inst_plus)<mem.seuil_w_inst_w_init_attente;
                            if (!ok_attente) {// les pistes doivent etre separees
                                //validation eventuelle de la piste precedente
                                if (mem.stock_info_ok==true) {
                                    if (mem.nb_ok_decim>mem.info_detection.seuil_nb_ok) {
                                        // suffisament d'echantillons=> ajout a la liste de notes
                                        InfoTrack rec_info_ok=new InfoTrack(
                                                mem.n0_ok_decim,mem.nb_ok_decim,mem.sum_w_inst_plus_mul_mod_square,mem.sum_square_mod_plus,mem);
                                        mem.sender.infos_tracks.add((Object) rec_info_ok);
                                    }
                                    // raz des infos
                                    mem.nb_ok_decim=0;
                                    mem.nb_attente=0;
                                }//if mem.stock_onfo_ok
                            }
                        } // else if mem.nb_attente==0
                        if ((mem.nb_ok_decim>0)&&(ok_attente==true)) {
                            //liaison des pistes
                            // nb_ok_decim >0 et echantillon OK
                            // mise a jour des indicateurs OK
                            mem.nb_ok_decim+=mem.nb_attente;// jonction des pistes
                            mem.sum_square_mod_plus+=mod_square_plus;
                            mem.sum_w_inst_plus_mul_mod_square+=w_inst_plus_mul_mod_square;
                        } else {
                            // nb_ok_decim=0 et echantillon OK
                            // init des indicateurs OK
                            mem.w_inst_ini=w_inst_plus;
                            mem.n0_ok_decim=mem.n_ech_decim;
                            mem.sum_square_mod_plus=mod_square_plus;
                            mem.sum_w_inst_plus_mul_mod_square=w_inst_plus_mul_mod_square;
                        }
                        mem.nb_ok_decim++;
                        mem.nb_attente=0; // remise attente a 0
                    }// if mem.ok_detection==0
                    k_ech+=2;
                    mem.n_ech_decim++;
                } // for i_ech
                mem.re_plus_n_1=re_plus_n;mem.im_plus_n_1=im_plus_n;
                mem.re_moins_n_1=re_moins_n;mem.im_moins_n_1=im_moins_n;
            }// if mem.is_in_interval
            else {// cas ou mem.is_in_interval est faux
                mem.ok_detection=constantes.Mask_NOT_IN_INTERVAL;
                k_ech+=2*nb_ech_local; //inc k_ech [re,im]
            }
            nb_ech_local/=2;
        } // for i_decim
    }
    
    public void met_a_jour_retard_de_groupe(ContexteFlts CONTEXTE,
            double retard_de_groupe) {
        MemoireClcDetect mem;
        /* Initialisation parametres Memoires */
        for (int i_decim = nb_decim ;i_decim>= 1;i_decim--) {
            mem=this.memoire[i_decim];
            mem.met_a_jour_retard_de_groupe(CONTEXTE,(float)retard_de_groupe,i_decim);
        }
        
    }
    
    
}

public class ContexteFlts {
    public ContexteFlts(
            float F_MINI_,     // Double_,/*= 50_,*/
            float F_MAXI_,     // Double_,/*= 440_,*/
            float F_ECH_,     // Double_,/*= 11025.0_,*/
            float F_LA_,     // Double_,/* FREQUENCE REELLE DU LA = 440.0 */
            int LGN_BUFFER_,   // Word_, /* RQ // CONTEXTE.LGN_BUFFER      <= 1024 */
            
            int NB_CEL_BES_,   // Word_,/*=2_,*/
            int NB_CEL_BUT_,   // Word_,/*=2_,*/
            int NB_FILTRES_,   // Byte_,/*= 6_,*/
            double DELTAF_DERIV_,      // Double_,/*=0.0025_,*/
            float SEUIL_MODU_,     // Single_,/*= 10.0_,*/
            float SEUIL_MOD2_RELATIVE_, // Seuil relatif / Module maxi
            float SEUIL_PLUS_DERIVF_,  // Single_,/* 1.5 */
            float SEUIL_MOINS_DERIVF_, // Single_,/* 0.5 */
            float TEMPS_MINI_NB_OK_,
            float SEUIL_NB_OK_RELATIVE_RETARD_GROUPE_,
            
            float TEMPS_MINI_NB_ATTENTE_,
            float SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE_,
            
            float TEMPS_MAXI_NB_OK_,//unused
            float SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE_,//unused
            
            
            float SEUIL_W_INST_RELATIVE_6DB_,
            float SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS_,
            float SEUIL_W_ATTENTE_RELATIVE_DEMI_TON_
            ){
        F_MINI=(float) F_MINI_;     // Double_;/*= 50_;*/
        F_MAXI=(float) F_MAXI_;     // Double_;/*= 440_;*/
        F_ECH=(float) F_ECH_;     // Double_;/*= 11025.0_;*/
        F_LA=(float) F_LA_;     // Double_;/* FREQUENCE REELLE DU LA = 440.0 */
        LGN_BUFFER=(int) LGN_BUFFER_;   // Word_; /* RQ // CONTEXTE.LGN_BUFFER      <= 1024 */
        
        NB_CEL_BES=(int) NB_CEL_BES_;   // Word_;/*=2_;*/
        NB_CEL_BUT=(int) NB_CEL_BUT_;   // Word_;/*=2_;*/
        NB_FILTRES=(int) NB_FILTRES_;   // Byte_;/*= 6_;*/
        DELTAF_DERIV=(double) DELTAF_DERIV_;      // Double_;/*=0.0025_;*/
        SEUIL_MODU=(float) SEUIL_MODU_;     // Single_;/*= 10.0_;*/
        SEUIL_MOD2_RELATIVE=(float) SEUIL_MOD2_RELATIVE_; // Seuil relatif / Module maxi
        SEUIL_PLUS_DERIVF=(float) SEUIL_PLUS_DERIVF_;  // Single_;/* 1.5 */
        SEUIL_MOINS_DERIVF=(float) SEUIL_MOINS_DERIVF_; // Single_;/* 0.5 */
        
        TEMPS_MINI_NB_OK=(float) TEMPS_MINI_NB_OK_;
        SEUIL_NB_OK_RELATIVE_RETARD_GROUPE=(float) SEUIL_NB_OK_RELATIVE_RETARD_GROUPE_;
        
        TEMPS_MINI_NB_ATTENTE=(float) TEMPS_MINI_NB_ATTENTE_;
        SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE=(float) SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE_;
        
        TEMPS_MAXI_NB_OK=(float) TEMPS_MAXI_NB_OK_;//unused
        SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE=(float) SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE_;//unused
        
        
        SEUIL_W_INST_RELATIVE_6DB=(float) SEUIL_W_INST_RELATIVE_6DB_;
        SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS=(float) SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS_;
        SEUIL_W_ATTENTE_RELATIVE_DEMI_TON=(float) SEUIL_W_ATTENTE_RELATIVE_DEMI_TON_;
        CONTEXTE_OK = INIT_CONTEXTE( );
        
    }
    
    public ContexteFlts(double FMini,double FMaxi,double FEch ,double FLa,int lgn_buffer) {
        CONTEXTE_OK = INIT_CONTEXTE( FMini,FMaxi,FEch ,FLa,lgn_buffer);
        
        //   this.GetAudioInfo(this);
    }
    public void met_a_jour_module_max(float square_module_max) {
        MemoireClcDetect[] memoires=this.tab_memoire_detect;
        MemoireClcDetect mem;
        
        for (int i=1;i<memoires.length;i++) {
            mem=memoires[i];
            //   mem.info_detection.
            mem.SeuilMod2=Math.max(mem.SeuilMod2,square_module_max*mem.seuil_mod2_relative_mod2_max);
        }
    }
    public void code_butterworth( LinkedList instructions,
            double f0_norm_6db ,
            int  nb_cellules ,
            float[]  tab_src,float [] tab_dst,
            int  longueur,
            int n0_src,int n0_dst,
            int  increment   ) {
        double angle , Cs   ;
        boolean fin     ;
        int k0;
        float moins_a1,moins_a2;
        int ordre_flt = 2 * nb_cellules ;
        my_transfert H=new my_transfert() ;
        double w0 = Math.sin(Math.PI* f0_norm_6db )/Math.cos(Math.PI* f0_norm_6db );
        /* w0 = w0 / ( 3^( 1 / (2. Ordre))), pour gain = 0.5 en w0 */
        double Trv = 0.5 / ordre_flt ; Trv = Math.exp( Math.log(3.0) * Trv );
        w0 /= Trv ;
        
        if ( (ordre_flt & 1 )==1)  {k0 = 2 * ordre_flt;    } // Ordre impair
        else                       {k0 = 2 * ordre_flt + 1;} // Ordre pair
        float[] local_src=tab_src;
        float gain_global = 1.0f ;
        for(; k0 < ( 3 * ordre_flt );) {    /* Math.PI * k0 / (2 Ord) < 3*Math.PI/2 */
            fin = ( k0 + 2 ) >= ( 3 * ordre_flt ) ;
            angle = Math.PI * k0 / ( 2 * ordre_flt );
            Cs = Math.cos( angle ) ;
            /* Determination coeffs du filtre ( Plan W ) ) */
            H.numerator.deg = 0 ; H.numerator.coef[0] = 1 ;
            if ( k0 == ( 2 * ordre_flt ) )  {
                H.denominator.deg = 1 ;
                H.denominator.coef[0] = 1;
                H.denominator.coef[1] = 1 / w0 ;
            } else {
                H.denominator.deg = 2 ;
                H.denominator.coef[0] = 1;
                H.denominator.coef[1] = -2 * Cs / w0 ;
                H.denominator.coef[2] = 1 / (w0*w0) ;
            }
            /* Passage de H dans le plan Z^-1 */
            H=H.transform_abcd(1.0,-1.0,1.0,1.0);            /**  p= (1-r)/(1+r) **/
            moins_a1=(float) (- H.denominator.coef[1]) ;
            moins_a2=(float) (- H.denominator.coef[2] );
            gain_global *=  ( 1 - moins_a1 - moins_a2 ) / 4.0 ;
            /* Codage Instruction */
    /* La decimation ne s'operant qu'a la derniere cellule,
            on optimise le tps de calcul en ne multipliant par gain_k que pour cette
            cellule , 1 Echantillon / Increment , Voir @Flt1z_float_floatK */
            if (!fin) {
                flt_1z_float_float rec_flt_1z_float_float=new flt_1z_float_float(
                        moins_a1,moins_a2,
                        local_src,tab_dst,
                        longueur,n0_src,n0_dst,1);
                instructions.add((Object) rec_flt_1z_float_float);
            } else {
                flt_1z_float_float_k rec_flt_1z_float_float_k=new flt_1z_float_float_k(
                        moins_a1,moins_a2,gain_global,
                        local_src,tab_dst,
                        longueur,n0_src,n0_dst,increment);
                instructions.add((Object) rec_flt_1z_float_float_k);
            }
            local_src=tab_dst; // sitot le premier tableau passe, src=dst
            n0_src=n0_dst;
            /* Cellule Suivante */
            k0 +=  2 ;
        }
    }
    public void liste_instructions(LinkedList instructions){
        LinkedList listeChainee = instructions;
        Iterator iterator = listeChainee.iterator();
        while (iterator.hasNext()) {
            System.out.println("objet = "+iterator.next());
        }
    }
    public void execute_instructions(LinkedList instructions){
        LinkedList listeChainee = instructions;
        Iterator iterator = listeChainee.iterator();
        while (iterator.hasNext()) {
            Object O=  (Object)(iterator.next());
            if (O instanceof flt_1z_re_im) {
                ((flt_1z_re_im) O).execute();
                continue;
            }
            if (O instanceof mul_sin_cos_k) {
                ((mul_sin_cos_k) O).execute();
                continue;
            }
            if (O instanceof flt_1z_float_float) {
                ((flt_1z_float_float) O).execute();
                continue;
            }
            if (O instanceof flt_1z_float_float_k) {
                ((flt_1z_float_float_k) O).execute();
                continue;
            }
            if (O instanceof flt_passe_haut_initial) {
                ((flt_passe_haut_initial) O).execute();
                continue;
            }
            if (O instanceof ClcDetect) {
                ((ClcDetect) O).execute();
                continue;
            }
            System.err.print("unkknow instruction, Object="+O);
        }
    }
    public void affiche_instructions(LinkedList instructions){
        LinkedList listeChainee = instructions;
        Iterator iterator = listeChainee.iterator();
        while (iterator.hasNext()) {
            Object O=  (Object)(iterator.next());
            if (O instanceof flt_1z_re_im) {
                ((flt_1z_re_im) O).affiche();
                continue;
            }
            if (O instanceof mul_sin_cos_k) {
                ((mul_sin_cos_k) O).affiche();
                continue;
            }
            if (O instanceof flt_1z_float_float) {
                ((flt_1z_float_float) O).affiche();
                continue;
            }
            if (O instanceof flt_1z_float_float_k) {
                ((flt_1z_float_float_k) O).affiche();
                continue;
            }
            if (O instanceof flt_passe_haut_initial) {
                ((flt_passe_haut_initial) O).affiche();
                continue;
            }
            if (O instanceof ClcDetect) {
                ((ClcDetect) O).affiche();
                continue;
            }
            System.err.print("unkknow instruction, Object="+O);
        }
    }
    public LinkedList tracks_synchrones(LinkedList l_infos_ok,InfoTrack info_ok_ref,int numero_groupe_) {
        if (l_infos_ok==null)    return null;
        if (info_ok_ref==null) return null;
        Iterator iterator= l_infos_ok.iterator();
        InfoTrack info_ok;
        // init du champ numero_super_track
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            info_ok.numero_super_track=0;
        }
        // appel fonction recursive
        return sous_notes_synchrones(l_infos_ok,info_ok_ref,numero_groupe_);
        
    }
    public LinkedList sous_notes_synchrones(LinkedList l_infos_ok,InfoTrack info_ok_ref,int numero_groupe_){
        LinkedList NotesSynchrones;
        Iterator iterator;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        boolean ok;
        int n0_ref,n1_ref;
        // si la note a deja ete traitee, degage
        if (info_ok_ref.numero_super_track!=0) return null;
        // on ne retraitera plus cette note
        info_ok_ref.numero_super_track=numero_groupe_;
        // traitement de la liste des notes
        int debut_recouvrement=0,fin_recouvrement=0,largeur_recouvrement=0;
        int largeur_2;
        NotesSynchrones=null;
        n0_ref=info_ok_ref.n0_reel;
        n1_ref=info_ok_ref.n1_reel;
        int delta_ref=(int)((n1_ref-n0_ref)*this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES);
        iterator = l_infos_ok.iterator();
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            // on ne s'occuppe pas des notes deja traitees
            ok =info_ok.numero_super_track==0;
            if (ok) {// DEBUT TEST
                // ETAPE 1: TEST NOTES SYNCHRONES
                if (ok) {ok =info_ok.f_reelle<= (info_ok_ref.f_reelle * this.COEFF_FREQ_SYNCHRONE);}
                if (ok) {ok =info_ok.f_reelle>= (info_ok_ref.f_reelle / this.COEFF_FREQ_SYNCHRONE);}
                // test recouvrement temporel
                if (ok) {
                    debut_recouvrement=max(info_ok.n0_reel,n0_ref);
                    fin_recouvrement=min(info_ok.n1_reel,n1_ref);
                    largeur_recouvrement=fin_recouvrement-debut_recouvrement;
                    ok=largeur_recouvrement>=0;
                }
                if (ok) {
                    largeur_2=info_ok.n1_reel-info_ok.n1_reel;
                    ok=largeur_recouvrement>=min(delta_ref,(int)(largeur_2*this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES));
                }
                // ETAPE 2: TEST NOTES ASYNCHRONES
                if (!ok) {
                    ok =info_ok.f_reelle<= (info_ok_ref.f_reelle * this.COEFF_FREQ_ASYNCHRONE);
                    if (ok) {ok =info_ok.f_reelle>= (info_ok_ref.f_reelle / this.COEFF_FREQ_ASYNCHRONE);}
                    // test recouvrement temporel
                    if (ok) {
                        debut_recouvrement=max(info_ok.n0_reel,n0_ref);
                        fin_recouvrement=min(info_ok.n1_reel,n1_ref);
                        largeur_recouvrement=fin_recouvrement-debut_recouvrement;
                        ok=largeur_recouvrement/F_ECH>=-SEUIL_TEMPS_NOTES_ASYNCHRONES;
                    }
                }// FIN TEST NOTES ASYNCHRONES
            } // FIN TEST
            // ajout eventuel de la note a la liste des notes synchrones
            if (ok) {
                if (NotesSynchrones==null) {
                    NotesSynchrones=new LinkedList();
                }
                NotesSynchrones.add((Object) info_ok);
                // on recupere la liste des notes proches de la note retenuee
                LinkedList notes_proches=this.sous_notes_synchrones(l_infos_ok,info_ok,numero_groupe_);
                if (notes_proches!=null){
                    // et on la concatene a la liste presente
                    Iterator sous_iterator=notes_proches.iterator();
                    while (sous_iterator.hasNext()) {
                        NotesSynchrones.add(sous_iterator.next());
                    }
                }
            }
        }
        return NotesSynchrones;
    }
    
    public void marque_better_track_as_super_track(LinkedList liste_notes){
        float sum_f_reelle_mod_square=0f,sum_mod_square=0f,max_mod_square=0f;
        
        Iterator iterator;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        float max_sum_mod_square=0f;
        float max_mean_mod_square_ok=0f;
        InfoTrack better=null;
        if (liste_notes==null) {return;}
        int nb_notes_dans_groupe=liste_notes.size();
        iterator = liste_notes.iterator();
        int n0_min=1;
        int n1_max=0;
        int n_total=0;
        int delta_n;
        float poids;
        while (iterator.hasNext()) {
            
            info_ok=  (InfoTrack)(iterator.next());
            if (info_ok!=null) {
                if (n0_min>n1_max) {
                    n0_min=info_ok.n0_reel;
                    n1_max=info_ok.n1_reel;
                } else {
                    n0_min=min(n0_min,info_ok.n0_reel);
                    n1_max=max(n1_max,info_ok.n1_reel);
                }
                // sum_mod_square est a l'echelle des echs reels, voir init_n0_n1...
                delta_n=info_ok.n1_reel-info_ok.n0_reel+1;
                n_total+=delta_n;
                max_mod_square=Math.max(max_mod_square,info_ok.mean_mod_square);
                poids=info_ok.sum_mod_square;
                sum_mod_square+=poids;
                sum_f_reelle_mod_square+=info_ok.f_reelle*poids;
                info_ok.nb_tracks_in_super_track=nb_notes_dans_groupe;
                if (info_ok.sum_mod_square>max_sum_mod_square) {
                    max_sum_mod_square=info_ok.sum_mod_square;
                    better =info_ok;
                }
            }
        }
        if (better!=null) {
            better.is_a_super_track=true;
            better.n0_reel_super_track=n0_min;
            better.n1_reel_super_track=n1_max;
            better.f_reelle_super_track=sum_f_reelle_mod_square/sum_mod_square;
            better.mean_mod_square_super_track=sum_mod_square/n_total;
            better.sum_mod_square_super_track=better.mean_mod_square_super_track*(better.n1_reel_super_track-better.n0_reel_super_track+1);
            better.max_mod_square_super_track=max_mod_square;
            better.mem.max_better_mean_mod_square=Math.max(better.mem.max_better_mean_mod_square,better.mean_mod_square_super_track);
            better.mem.max_better_mod_square=Math.max(better.mem.max_better_mod_square,better.max_mod_square_super_track);
        }
        
    }
    
    public LinkedList getListeEvt(LinkedList infos_ok_) {
        InfoTrack info_ok=null;
        Evt evt=null;
        Object O;
        boolean ok;
        LinkedList evts=null;
        Iterator iterator;
        if (infos_tracks==null) return null;
        iterator = infos_ok_.iterator();
        while (iterator.hasNext()) {
            O=iterator.next();
            ok=O!=null;
            if (ok) {
                info_ok=(InfoTrack) O;
                ok=(info_ok.is_a_super_track==true)
                &&(info_ok.nb_tracks_in_super_track>1)
                &&(info_ok.max_mod_square_relative_super_track>this.SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS);
            }
            if (ok) {
                if (evts==null) { evts=new LinkedList();}
                evt=new Evt(info_ok.n0_reel_super_track,constantes.DEB_NOTE,info_ok);
                evts.add((Object) evt);
                evt=new Evt(info_ok.n1_reel_super_track,constantes.FIN_NOTE,info_ok);
                evts.add((Object) evt);
            }
        }
        sort_evts_by_increasing_n(evts);
        //classement des evenements en ordre croissant
        return evts;
        
    }
    public void init_TAB_REF_AMP_HMS() {
        float lf=(float) ( Math.log((double)((NB_HMS+1))) / this.LOG_DEMI_TON);
        lf*=NB_PTS_PAR_DEMI_TON;
        I_HM_1=(int) Math.round(DEMI_LARGEUR_EN_DEMI_TON*NB_PTS_PAR_DEMI_TON);
        lf +=2*I_HM_1;
        int l=(int)Math.round(lf);
        TAB_REF_AMP_HMS=new float[l];
        for (int i_hm=1;i_hm<=NB_HMS;i_hm++) {
            float coeff_hm=1f-(i_hm-1f)/(10f*NB_HMS);
            int i_tab=(int) Math.round(( Math.log((double)i_hm) / this.LOG_DEMI_TON)) ;
            i_tab *=NB_PTS_PAR_DEMI_TON;
            i_tab+=(int)I_HM_1;
            for (int i_local=-I_HM_1+1;i_local<I_HM_1;i_local++) {
                TAB_REF_AMP_HMS[i_tab+i_local]=coeff_hm*(I_HM_1-Math.abs((float)i_local))/(float)I_HM_1;
                
            }
        }
    }
    public Interval[] getIntervals(LinkedList evts,float duree_min_interval_s,float seuil_disparition_note_prec_s,float seuil_apparition_hms_s,int nb_tracks_min_interval,int nb_pistes_energy) {
        boolean wait_for_next_evt=false;
        int old_max_n1_simultane_of_all_tracks=0;
        int debut_track=0;
        float COEFF_F_PLUS=(float) Math.exp(this.LOG_DEMI_TON/4);
        float COEFF_F_MOINS=1/COEFF_F_PLUS;
        int SEUIL_INTERFERENCE=(int) Math.round(this.SEUIL_TEMPS_INTERFERENCES_S*this.F_ECH);
        
        boolean ask_immediatly_interval=false;
        int dernier_n1_simultane=-50000;
        int max_n1_simultane_of_this_track = 0;
        int max_n1_simultane_of_all_tracks=0;
        int num_sim_track = 0;
        int n0_min_debut_note=-50000, n1_min_fin_note=-50000;
        int nb_evt_simultanes = 1,k_evt=0;
        LinkedList evts_fin=null;
        LinkedList intervals=null;
        Evt evt=null,dernier_evt=null,dernier_evt_deb=null;
        Object O;
        boolean ok;
        InfoDeltaF info_deltaf=null;
        LinkedList infos_ok=null;
        Iterator iterator;
        if (evts==null) return null;
        int SEUIL_APPARITION_HMS=(int) (seuil_apparition_hms_s*this.F_ECH);// 1 centieme de secondes
        int SEUIL_DISPARITION_NOTE_PRECEDENTE = (int)(seuil_disparition_note_prec_s*this.F_ECH);
        iterator = evts.iterator();
        int nb_pistes=0;
        int delta_n=0;
        Interval interval=null;
        if (nb_tracks_min_interval<=1) nb_tracks_min_interval=10000;// desactive dans ce cas
        float coeff_demi_ton=(float)Math.exp(this.LOG_DEMI_TON/2);
        float un_sur_coeff_demi_ton=1f/coeff_demi_ton;
        InfoNote[] meilleures_notes=null;
        InfoTrack[] tab_infos_tracks=null;
        evts_fin=new LinkedList();
        
        while (iterator.hasNext()) {
            O=iterator.next();
            ok=O!=null;
            if (ok) {
                k_evt++;
                evt=(Evt) O;
                if (evt.type_evt==constantes.DEB_NOTE) {
                    evt.info_track.num_simultaneous_track=-1;
                }
            }
            if (ok) ok=dernier_evt!=null;
            if (ok) ok=dernier_evt.nb_pistes>0;
            if (ok) {
                wait_for_next_evt=false;
                delta_n=evt.n-dernier_evt_deb.n;
                boolean find_hms=(delta_n<SEUIL_APPARITION_HMS);
                ask_immediatly_interval= (nb_evt_simultanes>=nb_tracks_min_interval)&&!(find_hms);
                // les evts de creation tres rapproches sont regroupes
                if (evt.type_evt==constantes.DEB_NOTE){
                    if (find_hms) {
                        wait_for_next_evt=true;
                        //mise en memoire 1er instant de creation, et nb de pistes
                        if (dernier_evt_deb.info_track.num_simultaneous_track==-1) {
                            num_sim_track++;
                            nb_evt_simultanes=2;// reset at each track beginning
                            max_n1_simultane_of_this_track=dernier_evt_deb.info_track.n1_reel_super_track;
                            debut_track=dernier_evt_deb.n;
                          /*  if (constantes.debug==true){
                                System.out.println(
                                        "init track "+String.valueOf(num_sim_track)
                                        + "evt from t="+String.valueOf(dernier_evt_deb.n/this.F_ECH)
                                        +" to t="+String.valueOf(evt.n/this.F_ECH)
                                        +",nb evts sim="+String.valueOf(nb_evt_simultanes)
                                        +" final time="+String.valueOf(max_n1_simultane_of_this_track/this.F_ECH))    ;
                            }*/
                            
                        } else {
                            nb_evt_simultanes++;
                        }
                        //icilesgars, remplace par debut_track evt.n=dernier_evt_deb.n;
                        
                        dernier_evt_deb.info_track.num_simultaneous_track=num_sim_track;
                        evt.info_track.num_simultaneous_track=num_sim_track;
                        max_n1_simultane_of_this_track=max(max_n1_simultane_of_this_track,evt.info_track.n1_reel_super_track);
                      /*  if (constantes.debug==true){
                            System.out.println(
                                    " augment track "+String.valueOf(num_sim_track)
                                    + "from init t="+String.valueOf(dernier_evt_deb.n/this.F_ECH)
                                    +",nb evts sim="+String.valueOf(nb_evt_simultanes)
                                    +" to final time="+String.valueOf(max_n1_simultane_of_this_track/this.F_ECH))    ;
                        }*/
                        
                    } else {
                        // reset sur creation de notes trop tardive
                        nb_evt_simultanes=1;
                    }
                }
            }
            if (ok) ok=!wait_for_next_evt;// debuts de notes tres rapproches
            if(ok) {
                // on ignore les evts isoles jusqu'a la fin de la piste
                if (!ask_immediatly_interval) {
                    ok=dernier_evt.n>=dernier_n1_simultane;
                }
                if (nb_evt_simultanes>1) {
                    // les intervalles multipistes ne sont generes que
                    // sur ask_immediatly_intervall
                    // <=> on a forcement detecte toutes les hms
                    ok=ask_immediatly_interval;
                    // generation d'intervalle multipiste sans hms...
                    if (!ok) {
                        ok=(evt.n-dernier_evt_deb.n)>=SEUIL_APPARITION_HMS;
                    }
                    if (ok) nb_evt_simultanes=1; // intervalle traite => plus considere comme simultane!...
                }
            }
            if (ok) {
               /* if (constantes.debug) {
                    System.out.print("Tentative creation intervalle"
                            + ", t_last="+String.valueOf(dernier_evt.n/this.F_ECH)
                            + ", t_new="+String.valueOf(evt.n/this.F_ECH)
                            + ", n_pist_last="+String.valueOf(dernier_evt.nb_pistes)
                            + ", n_pist_new="+String.valueOf(evt.nb_pistes)
                            +" : ")    ;
                    if (ask_immediatly_interval) {
                        System.out.println(" DEBUT MULTIPISTE");
                
                    } else {
                        switch(dernier_evt.type_evt) {
                            case constantes.DEB_NOTE:System.out.print("last= DEBUT NOTE");break;
                            case constantes.FIN_NOTE:System.out.print("last= FIN   NOTE");break;
                            default:                 System.out.print("last= INCONNU   ");
                        }
                        switch(evt.type_evt) {
                            case constantes.DEB_NOTE:System.out.println(",new= DEBUT NOTE");break;
                            case constantes.FIN_NOTE:System.out.println(",new= FIN   NOTE");break;
                            default:                 System.out.println(",new= INCONNU   ");
                        }
                    }
                }*/
                // creation d'intervalle
                // calcul des meilleures Notes uniquement si creation d'intervalle
                //min_max_float n0_n1=this.get_min_max_n0_n1_reel_groupe(infos_tracks);
                if (dernier_evt_deb!=null){
                    n1_min_fin_note=dernier_evt_deb.n+SEUIL_DISPARITION_NOTE_PRECEDENTE;
                }
                int num_track_to_get=-1;
                if (ask_immediatly_interval) {
                    // plus de 2 evts simultanes => nouvelle note ne prenant
                    // en compte que les pistes commencant posterieurement a dernier_evt.n
                    num_track_to_get=num_sim_track;
                    n0_min_debut_note=debut_track;// a la place de dernier_evt_deb.n
                    dernier_n1_simultane=n0_min_debut_note;
                  /*  if (constantes.debug==true){
                        System.out.println("MULTITRACK interv "+String.valueOf(num_sim_track)+", nb pistes="+String.valueOf(nb_evt_simultanes)+ ", evts from t="+String.valueOf(dernier_evt.n/this.F_ECH)+" to t="+String.valueOf(max_n1_simultane_of_this_track/this.F_ECH))    ;
                    }*/
                } else {
                    dernier_n1_simultane=max_n1_simultane_of_all_tracks;
                }
                
                n0_min_debut_note=this.max(n0_min_debut_note,dernier_n1_simultane);
                // recuperation des notes commencant apres n0_to_ingore, et finissant apres n1_min_fin_note
             /*   if (constantes.debug==true){
                    System.out.println("Getting infos_tracks from t0>="+String.valueOf(n0_min_debut_note/this.F_ECH)+" to t1>="+String.valueOf(n1_min_fin_note/this.F_ECH)+" track="+String.valueOf(num_track_to_get))    ;
                }*/
                
                tab_infos_tracks=this.sort_notes_by_increasing_better_f_reelle_and_return_array(infos_ok,n0_min_debut_note,n1_min_fin_note,num_track_to_get,nb_pistes_energy);
                if (ask_immediatly_interval) {
                    int old_length=tab_infos_tracks.length;
                 /*   if (constantes.debug) {
                       if ((dernier_evt_deb.n/this.F_ECH>=3.66f)
                         &&(dernier_evt_deb.n/this.F_ECH<=3.97f)) {
                           dernier_evt_deb.n*=1;
                       }
                  
                    }*/
                    // pas de prise en compte des pistes solitaires
                    // avant la fin de la plus longue piste simultanee
                    old_max_n1_simultane_of_all_tracks=max_n1_simultane_of_all_tracks;
                    dernier_n1_simultane=max_n1_simultane_of_this_track;
                    max_n1_simultane_of_all_tracks=max(max_n1_simultane_of_this_track,max_n1_simultane_of_all_tracks);
                    //filtrage de tab_infos_tracks pour elimination interferences
                    
                    if ((evts_fin!=null) && (tab_infos_tracks!=null)&&(SEUIL_INTERFERENCE>0)) {
                        // recup des pistes qui viennent d etre coupees
                        Iterator it_fin=evts_fin.iterator();
                        boolean fini=false;
                        LinkedList new_infos_ok=null;
                        while ((it_fin.hasNext())&&(!fini)) {
                            Evt evt_f=(Evt) it_fin.next();
                            fini=evt_f.n<n0_min_debut_note-SEUIL_INTERFERENCE;
                            if (!fini) {
                                if (evt_f.info_track.num_simultaneous_track!=num_track_to_get){
                                    float f_ref=evt_f.info_track.f_reelle_super_track;
                                    float f_ref_plus =f_ref*COEFF_F_PLUS;
                                    float f_ref_moins=f_ref*COEFF_F_MOINS;
                                    InfoTrack if_ref;
                                    // marquage a -1 de num_track_to_get dans les infos considerees comme 'coupees'
                                    for (int i=0;i<tab_infos_tracks.length;i++) {
                                        if_ref=tab_infos_tracks[i];
                                        if (if_ref.num_simultaneous_track==num_track_to_get) {
                                            if( (if_ref.f_reelle_super_track<=f_ref_plus)
                                            && (if_ref.f_reelle_super_track>=f_ref_moins))   {
                                                if_ref.num_simultaneous_track=-num_track_to_get;
                                            }
                                        }
                                    }
                                }
                            }
                        } // while
                        // creation de la liste des infos exploitables
                        for (int i=0;i<tab_infos_tracks.length;i++) {
                            if (tab_infos_tracks[i].num_simultaneous_track==num_track_to_get) {
                                if (new_infos_ok==null) new_infos_ok=new LinkedList();
                                new_infos_ok.add((Object)tab_infos_tracks[i]) ;
                                
                            }
                        }
                        if (new_infos_ok==null) {
                            tab_infos_tracks=null;
                        } else {
                            if (new_infos_ok.size()!=tab_infos_tracks.length) {
                                // mise a jour de tab_infos_tracks
                                tab_infos_tracks=this.sort_notes_by_increasing_better_f_reelle_and_return_array(new_infos_ok,n0_min_debut_note,n1_min_fin_note,num_track_to_get,nb_pistes_energy);
                            }
                        }
                    }
                    ok=tab_infos_tracks!=null;// si tout le monde a gicle => intervalle ignore
                    if (ok) {
                        ask_immediatly_interval=tab_infos_tracks.length>=nb_tracks_min_interval;
                    }
                    
                    if (ok && ask_immediatly_interval) {
                        if (tab_infos_tracks.length<old_length) {
                            // on a perdu des pistes => recalcul de dernier_n1_simultane
                            min_max_float n0_n1_g=this.get_min_max_n0_n1_reel_groupe(tab_infos_tracks);
                            dernier_n1_simultane=(int) n0_n1_g.max_data;
                            max_n1_simultane_of_all_tracks=max(old_max_n1_simultane_of_all_tracks,dernier_n1_simultane);
                            debut_track=(int) n0_n1_g.min_data;
                            
                        }
                    }
                    if ((!ok)||(!ask_immediatly_interval)) {
                        // traitement comme note ordinaire,
                        // et reinit dernier_n1, max_n1
                        dernier_n1_simultane=old_max_n1_simultane_of_all_tracks;
                        max_n1_simultane_of_all_tracks=old_max_n1_simultane_of_all_tracks;
                        ok=n0_min_debut_note>=dernier_n1_simultane;
                    }
                }// if ask_immediatly_interval
                if (ok) ok=tab_infos_tracks!=null;// si tout le monde a gicle => intervalle ignore
                
            }
            if (ok) {
                ok=tab_infos_tracks.length>=this.NB_TRACK_VALID_NOTE;
            }
            if (ok)  {
                
                meilleures_notes =getMeilleuresNotes3(tab_infos_tracks);
                //     sort_notes_by_decreasing_sum_square_module(meilleures_notes);
                // les  intervalles recouvrant les precedents
                // ne sont valides que s'ils contribuent a la meme frequence fondamentale
                // sauf s'il s'agit de multipistes
                Interval old_interval=null;
                boolean intersect_old=(interval!=null)&&(!ask_immediatly_interval)&&(meilleures_notes!=null);
                if (intersect_old) intersect_old=interval.n1>=meilleures_notes[0].n0_union+SEUIL_DISPARITION_NOTE_PRECEDENTE;
                if (intersect_old) intersect_old=interval.n0<=meilleures_notes[0].n1_union;
                float min_freq=0f;
                if (intersect_old) {
                    min_freq=Math.min(meilleures_notes[0].frequences,interval.notes[0].frequences);
                    float pgcd_f=this.PGCD(meilleures_notes[0].frequences,interval.notes[0].frequences,meilleures_notes[0].poids,interval.notes[0].poids);
                    float rf=pgcd_f/min_freq;
                    ok =(rf<=coeff_demi_ton)&&(rf>un_sur_coeff_demi_ton);
                    if (ok) {
                        old_interval=interval;
                        min_freq=pgcd_f;
                    } else {
                        ok=meilleures_notes[0].poids>interval.notes[0].poids;
                        if (ok) {
                            // le nouvel intervalle est meilleur que l'ancien!...
                            //=> on remplace
                            interval.notes=null;// indique pas de concatenation
                            old_interval=interval;
                        }
                    }
                }
                if ((meilleures_notes !=null)&&(ok)) {
                    if (old_interval!=null) {
                        interval=old_interval;
                        if (interval.notes!=null) {
                            // groupement acin et nopuvel intervalle
                            interval.n1=max(interval.n1,meilleures_notes[0].n1_union);
                            meilleures_notes[0].poids+=interval.notes[0].poids;
                            meilleures_notes[0].frequences=min_freq;
                        } else {
                            // oubli de l'ancienne piste et remplacement
                            // par la nouvelle
                            interval.n0=meilleures_notes[0].n0_union;
                            interval.n1=meilleures_notes[0].n1_union;
                        }
                    } else {
                        interval=new Interval();
                        interval.n0=meilleures_notes[0].n0_union;
                        interval.n1=meilleures_notes[0].n1_union;
                        if (ask_immediatly_interval) {
                            interval.n0=debut_track;
                            interval.n1=dernier_n1_simultane;
                        }
                    }
                    
                    interval.type_evt=dernier_evt.type_evt;
                    interval.nb_pistes=nb_pistes;
                    interval.notes=meilleures_notes;
                    interval.tab_infos_tracks=tab_infos_tracks;
                    if (intervals==null) intervals=new LinkedList();
                    if (old_interval==null) {
                        intervals.add((Object)interval);
                     /*   if (constantes.debug==true){
                            System.out.println("Creation interv from t="
                                    +String.valueOf(interval.n0/this.F_ECH)
                                    +" to t="
                                    +String.valueOf(interval.n1/this.F_ECH)
                                    +" nb pistes="
                                    +String.valueOf(interval.tab_infos_tracks.length  ))    ;
                        }*/
                    }else {
                      /*  if (constantes.debug) {
                            System.out.println("Mise a jour interv from t="
                                    +String.valueOf(interval.n0/this.F_ECH)
                                    +" to t="
                                    +String.valueOf(interval.n1/this.F_ECH)
                                    +" nb pistes="
                                    +String.valueOf(interval.tab_infos_tracks.length  ))    ;
                        }*/
                    }
                }
            }
            //mise a jour liste infos_tracks
            if (evt.type_evt==constantes.FIN_NOTE) {
                // evenement le plus recent en debut de liste pour efficacite
                evts_fin.add(0,(Object) evt);// pour detection des interferences
                infos_ok.remove((Object)evt.info_track);
                if (evt.info_track.num_simultaneous_track==num_sim_track)  {
                    nb_evt_simultanes--;
                }
                nb_pistes--;
            }
            if (evt.type_evt==constantes.DEB_NOTE) {
                dernier_evt_deb=evt;
                if (infos_ok==null) {
                    infos_ok=new LinkedList();
                }
                infos_ok.add((Object)evt.info_track);
                nb_pistes++;
            }
            evt.nb_pistes=nb_pistes;
            dernier_evt=evt;
        }
        if (intervals==null ) return null;
        interval=(Interval) intervals.getFirst();
        Object [] Obs=intervals.toArray();
        Interval[] its=new Interval[Obs.length];
        for (int i=0;i<its.length;i++) {
            its[i]=(Interval)  Obs[i];
            // SURTOUT PAS!..    this.sort_notes_by_decreasing_sum_square_module(its[i].notes);
        }
        //Interval[] final_intervals=its;//icilesgars
        Interval[] final_intervals=get_only_intervals_of_sufficient_length(its,duree_min_interval_s);
       /* if (constantes.debug) {
             this.affiche_notes(final_intervals);
        }*/
        return final_intervals;
        
    }
    
    public Interval[] get_intervals_from_infos_tracks(
            LinkedList infos_tracks,
            float duree_min_interval_s
            ,float seuil_disparition_note_prec_s
            ,float seuil_apparition_hms_s
            ,int nb_tracks_min_interval
            ,int nb_pistes_energetiques) {
        LinkedList fondamentales=null;
        Iterator iterator;
        if (infos_tracks==null) return null;
        // recuperation des evenements
        LinkedList evts=this.getListeEvt(infos_tracks);
        Interval[] Intervals=this.getIntervals(evts,duree_min_interval_s,seuil_disparition_note_prec_s,seuil_apparition_hms_s,nb_tracks_min_interval,nb_pistes_energetiques);
        return Intervals;
    }
    
    public void compute_super_tracks(LinkedList infos_tracks) {
        Iterator iterator;
        LinkedList TracksSynchrones=null,local_infos_tracks;
        InfoTrack info_track=null;
        MemoireClcDetect mem;
        
        if (infos_tracks==null) {return;}
        // copie de la liste dans var locale
        local_infos_tracks=new LinkedList();
        iterator = infos_tracks.iterator();
        while (iterator.hasNext()) {
            local_infos_tracks.add(iterator.next());
        }
        this.init_n0_n1_freel_is_better(local_infos_tracks);
        this.sort_notes_by_decreasing_sum_square_module(local_infos_tracks);
        int numero_groupe_=1;
        while (local_infos_tracks!=null) {// tant qu'il reste des notes non regroupees
            iterator = local_infos_tracks.iterator();
            if (iterator.hasNext()) {
                // liste des notes synchrones a info_track, ne contient pas info_track
                info_track=  (InfoTrack)(iterator.next());
                TracksSynchrones=this.tracks_synchrones(local_infos_tracks,info_track,numero_groupe_);
            }
            if (TracksSynchrones!=null) {
                TracksSynchrones.add(info_track);
            } else {
                TracksSynchrones=new LinkedList();
                TracksSynchrones.add(info_track);
            }
            this.marque_better_track_as_super_track(TracksSynchrones);
            iterator = TracksSynchrones.iterator();
            while (iterator.hasNext()) {
                local_infos_tracks.remove(iterator.next());
            }
            if (local_infos_tracks.size()==0) {
                local_infos_tracks=null;//termine
            }
            numero_groupe_++;
        }
        // mise a jour du champ max_better_mean_mod_square dans les memoires
        this.met_a_jour_max_better_mean_mod_square_dans_memoires();
        this.init_better_mean_mod_square_relative(infos_tracks);
        
    }
    public void sort_notes_by_decreasing_sum_square_module(LinkedList l_infos_tracks) {
        if (l_infos_tracks==null) return;
        Comparator comp = MyComparators.InfoTrack_decreasing_sum_square_module_Comparator();
        Object[] array_infos_tracks=l_infos_tracks.toArray();
        Arrays.sort(array_infos_tracks, comp);
        l_infos_tracks.clear();
        for (int i=0;i<array_infos_tracks.length;i++) {
            l_infos_tracks.add(array_infos_tracks[i]);
        }
    }
    
    public void sort_notes_by_decreasing_sum_square_module(InfoNote[] notes) {
        if (notes==null) return;
        Comparator comp = MyComparators.InfoNote_decreasing_module_Comparator();
        Arrays.sort((Object[]) notes, comp);
    }
    public void sort_evts_by_increasing_n(LinkedList evts) {
        if (evts==null) return;
        Comparator comp = MyComparators.evt_increasing_n_Comparator();
        Object[] array_evts=evts.toArray();
        Arrays.sort(array_evts, comp);
        evts.clear();
        for (int i=0;i<array_evts.length;i++) {
            evts.add(array_evts[i]);
        }
    }
    public void sort_notes_by_increasing_n0_reel(LinkedList l_infos_tracks) {
        if (l_infos_tracks==null) return;
        Comparator comp = MyComparators.InfoOK_increasing_n0_reel_Comparator();
        Object[] array_infos_tracks=l_infos_tracks.toArray();
        Arrays.sort(array_infos_tracks, comp);
        l_infos_tracks.clear();
        for (int i=0;i<array_infos_tracks.length;i++) {
            l_infos_tracks.add(array_infos_tracks[i]);
        }
    }
    public void sort_tracks_by_increasing_better_f_reelle(LinkedList l_infos_tracks) {
        if (l_infos_tracks==null) return;
        Comparator comp = MyComparators.InfoOK_increasing_better_f_reelle_Comparator();
        Object[] array_infos_tracks=l_infos_tracks.toArray();
        Arrays.sort(array_infos_tracks, comp);
        l_infos_tracks.clear();
        for (int i=0;i<array_infos_tracks.length;i++) {
            l_infos_tracks.add(array_infos_tracks[i]);
        }
    }
    public void sort_notes_by_decreasing_better_sum_square_module(LinkedList l_infos_tracks) {
        if (l_infos_tracks==null) return;
        Comparator comp = MyComparators.InfoTrack_decreasing_better_sum_square_module_Comparator();
        Object[] array_infos_tracks=l_infos_tracks.toArray();
        Arrays.sort(array_infos_tracks, comp);
        l_infos_tracks.clear();
        for (int i=0;i<array_infos_tracks.length;i++) {
            l_infos_tracks.add(array_infos_tracks[i]);
        }
    }
    public InfoTrack[] sort_notes_by_increasing_better_f_reelle_and_return_array(LinkedList l_infos_ok) {
        if (l_infos_ok==null) return null;
        Comparator comp = MyComparators.InfoOK_increasing_better_f_reelle_Comparator();
        Object[] array_infos_ok=l_infos_ok.toArray();
        Arrays.sort(array_infos_ok, comp);
        InfoTrack[] tab=new InfoTrack[array_infos_ok.length];
        for (int i=0;i<tab.length;i++) {
            tab[i]=(InfoTrack) array_infos_ok[i];
        }
        return tab;
    }
    
    public InfoTrack[] sort_notes_by_increasing_better_f_reelle_and_return_array(LinkedList l_infos_ok,int min_n0_debut_note,int min_n1_fin_note,int num_track,int nb_pistes_energy) {
        LinkedList ll_infos_ok=l_infos_ok;
        if (l_infos_ok==null) return null;
        boolean ok_track=num_track<=0;
        boolean ok;
        InfoTrack if_ok;
        if ((nb_pistes_energy>0)&&(!ok_track)) {
            // classement actif uniquement sur les nouvelles pistes
            // on ne garde que les nb_pistes_energy les plus energetiques
            this.sort_notes_by_decreasing_better_sum_square_module(l_infos_ok);
            if ((l_infos_ok.size()>nb_pistes_energy)&&(ok_track)) {
                ll_infos_ok=new LinkedList();
                Iterator  iterator=l_infos_ok.iterator();
                while ((iterator.hasNext())&&(nb_pistes_energy>0)) {
                    if_ok=(InfoTrack) iterator.next();
                    ok=if_ok.num_simultaneous_track==num_track;
                    if (ok) {
                        ll_infos_ok.add((Object) if_ok);
                        nb_pistes_energy--;
                    }
                }
            }
        }
        InfoTrack[] tab=this.sort_notes_by_increasing_better_f_reelle_and_return_array(ll_infos_ok);
        int k=0;
        for (int i=0;i<tab.length;i++) {
            if_ok=tab[i];
            ok =ok_track;
            if (!ok ) ok=if_ok.num_simultaneous_track==num_track;
            if (ok) ok=if_ok.n0_reel_super_track>=min_n0_debut_note;
            if (ok) ok=if_ok.n1_reel_super_track>=min_n1_fin_note;
            if (ok)    k++;
            if_ok.tmp_ok=ok;
        }
        if (k==0) return null;
        InfoTrack[] tab1=new InfoTrack[k];
        k=0;
        for (int i=0;i<tab.length;i++) {
            if_ok=tab[i];
            if (if_ok.tmp_ok) {
                tab1[k++]=if_ok;
                
            }
            
        }
        return tab1;
    }
    
    public void sort_deltaf_by_increasing_deltaf(LinkedList l_delta_f) {
        if (l_delta_f==null) return;
        Comparator comp = MyComparators.InfoDeltaF_increasing_delta_f_Comparator();
        Object[] array_delta_f=l_delta_f.toArray();
        Arrays.sort(array_delta_f, comp);
        l_delta_f.clear();
        for (int i=0;i<array_delta_f.length;i++) {
            l_delta_f.add(array_delta_f[i]);
        }
    }
    public Object[] sort_deltaf_by_decreasing_poids_and_return_array(LinkedList l_delta_f) {
        if (l_delta_f==null) return null;
        Comparator comp = MyComparators.InfoDeltaF_decreasing_poids_Comparator();
        Object[] array_delta_f=l_delta_f.toArray();
        Arrays.sort(array_delta_f, comp);
        return array_delta_f;
    }
    public void print_notes(Interval interval,double t_init,int k_note,NotesEtFrequences notes) {
        note_detaillee detail;
        InfoNote info_note;
        double t0,t1;
        if (interval==null) return;
        t0=interval.n0/this.F_ECH - t_init;
        t1=interval.n1/this.F_ECH - t_init;
        System.out.print("INTERVALLE "+String.valueOf(k_note));
        System.out.print(", t0="+String.valueOf(Math.round(100.0*(t0))/100.0));
        System.out.print(", t1="+String.valueOf(Math.round(100.0*(t1))/100.0));
        if (interval.tab_infos_tracks==null) {
            System.out.print(", nb tracks =0");
        } else {
            System.out.print(", nb tracks = "+String.valueOf(interval.tab_infos_tracks.length));
        }
        if (interval.notes==null) {
            System.out.println(", nb notes possibles=0");
            return;
        } else {
            System.out.println(", nb notes possibles= "+String.valueOf(interval.notes.length));
        }
        for (int i=0;i<interval.notes.length;i++) {
            info_note=interval.notes[i];
            
            detail =notes.details_note(info_note.frequences);
            if (i==0) {
                System.out.print("NOTE RETENUE : ");
            } else {
                System.out.print("       note possible : ");
            }
            System.out.println(detail.nom_note_global+" decalee de"+String.valueOf(detail.decalage_en_demi_ton)+" demis-tons, (poids = "+String.valueOf(info_note.poids)+")");
        }
    }
    public void print_first_note(Interval interval,double t_init,int k_note,NotesEtFrequences notes) {
        note_detaillee detail;
        InfoNote info_note;
        double t0,t1;
        if (interval==null) return;
        if (interval.notes==null) return;
        info_note=interval.notes[0];
        detail =notes.details_note(info_note.frequences);
        System.out.print(detail.nom_note_global+" decalee de"+String.valueOf(detail.decalage_en_demi_ton)+" demis-tons, (poids = "+String.valueOf(info_note.poids)+")");
        t0=interval.n0/this.F_ECH - t_init;
        t1=interval.n1/this.F_ECH - t_init;
        System.out.print(", t0="+String.valueOf(Math.round(100.0*(t0))/100.0));
        System.out.println(", t1="+String.valueOf(Math.round(100.0*(t1))/100.0));
    }
    
    public void print_note(InfoTrack info_ok,double t_init,int k_note,NotesEtFrequences notes) {
        note_detaillee detail;
        double t0,t1;
        detail =notes.details_note(info_ok.f_reelle);
        
        System.out.print("Note  "+String.valueOf(k_note));
        System.out.print(" : "+detail.nom_note_global+" decalee de"+String.valueOf(detail.decalage_en_demi_ton)+" demis-tons");
        t0=info_ok.n0_reel/this.F_ECH;
        t1=info_ok.n1_reel/this.F_ECH;
        System.out.print(", t0="+String.valueOf(Math.round(100.0*(t0-t_init))/100.0));
        System.out.print(", t1="+String.valueOf(Math.round(100.0*(t1-t_init))/100.0));
        System.out.print(" , numero groupe= "+String.valueOf(info_ok.numero_super_track));
        if (info_ok.is_a_super_track) {
            t0=info_ok.n0_reel_super_track/this.F_ECH;
            t1=info_ok.n1_reel_super_track/this.F_ECH;
            System.out.print(", t0_groupe="+String.valueOf(Math.round(100.0*(t0-t_init))/100.0));
            System.out.print(", t1_groupe="+String.valueOf(Math.round(100.0*(t1-t_init))/100.0));
            System.out.println(" , nb_notes= "+String.valueOf(info_ok.nb_tracks_in_super_track));
        }
    }
    public void affiche_notes_Assuming_First_is_DO_4(LinkedList l_infos_ok) {
        InfoTrack info_ok;
        NotesEtFrequences notes=null;
        double DO_REF,LA_REF;
        System.out.println("NOTES DETECTEES, EN SUPPOSANT QUE LA PREMIERE EST UN DO OCTAVE 4");
        if (l_infos_ok==null) return;
        Comparator comp = MyComparators.InfoOK_increasing_n0_reel_Comparator();
        Object[] array_infos_ok=l_infos_ok.toArray();
        Arrays.sort(array_infos_ok, comp);
        int k_note=1;
        double t_init=0;
        for (int i=0;i<array_infos_ok.length;i++) {
            info_ok=(InfoTrack) array_infos_ok[i];
            if ((notes==null)&&(info_ok.is_a_super_track)&&(info_ok.nb_tracks_in_super_track>1)) {
                DO_REF=info_ok.f_reelle_super_track;
                LA_REF=Math.exp(Math.log(DO_REF)+9*Math.log(2)/12);
                notes=new NotesEtFrequences(info_ok.f_reelle_super_track/4,info_ok.f_reelle_super_track*4,LA_REF);
            }
            
            if (notes!=null) {
                if ((info_ok.is_a_super_track)
                &&(info_ok.nb_tracks_in_super_track>1)) {
                    if (k_note==1) {t_init=info_ok.n0_reel/this.F_ECH;}
                    this.print_note(info_ok,t_init,k_note++,notes);
                }
            }
        }
        
        
        
    }
    public void affiche_notes_Assuming_First_is_GOOD(LinkedList l_infos_ok) {
        InfoTrack info_ok;
        note_detaillee detail;
        NotesEtFrequences notes=null;
        if (l_infos_ok==null) return;
        Comparator comp = MyComparators.InfoOK_increasing_n0_reel_Comparator();
        Object[] array_infos_ok=l_infos_ok.toArray();
        Arrays.sort(array_infos_ok, comp);
        int k_note=1;
        double t_init=0,t0,t1;
        System.out.println("NOTES DETECTEES, EN PARTANT DE LA NOTE ABSOLUE LA PLUS PROCHE DE LA PREMIERE");
        notes=new NotesEtFrequences(this.F_MINI,this.F_MAXI,this.F_LA);
        for (int i=0;i<array_infos_ok.length;i++) {
            info_ok=(InfoTrack) array_infos_ok[i];
            if ((k_note==1)&&(info_ok.is_a_super_track)) {
                // recalage des mesures sur premiere note perue
                detail =notes.details_note(info_ok.f_reelle);
                double coeff_decalage=Math.exp(detail.decalage_en_demi_ton*notes.LOG_DEMI_TON);
                notes=new NotesEtFrequences(this.F_MINI*coeff_decalage,this.F_MAXI*coeff_decalage,this.F_LA*coeff_decalage);
            }
            if ((info_ok.is_a_super_track)
            &&(info_ok.nb_tracks_in_super_track>1)){
                if (k_note==1) {t_init=info_ok.n0_reel/this.F_ECH;}
                this.print_note(info_ok,t_init,k_note++,notes);
            }
        }
    }
    public void affiche_notes(Interval[] intervals) {
        Interval interval;
        note_detaillee detail;
        NotesEtFrequences notes=null;
        if (intervals==null) return;
        int k_note=1;
        double t_init=0,t0,t1;
        if (intervals==null) {
            System.out.println("AUCUNE NOTE DETECTEE");
            return;
        }
        notes=new NotesEtFrequences(this.F_MINI,this.F_MAXI,this.F_LA);
        System.out.println("DETAIL DES NOTES DETECTEES");
        for (int i=0;i<intervals.length;i++) {
            interval=intervals[i];
            if (k_note==1) {t_init=interval.n0/this.F_ECH;}
            this.print_notes(interval,t_init,k_note++,notes);
        }
        System.out.println("RESUME DES NOTES DETECTEES");
        k_note=1;
        for (int i=0;i<intervals.length;i++) {
            interval=intervals[i];
            if (k_note==1) {t_init=interval.n0/this.F_ECH;}
            this.print_first_note(interval,t_init,k_note++,notes);
        }
    }
    
    
    public void set_parametres_regroupement(
            float COEFF_RECOUVREMENT_NOTES_SYNCHRONES_,
            float SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON_,
            float SEUIL_TEMPS_NOTES_ASYNCHRONES_,
            float SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON_  ){
        this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES=COEFF_RECOUVREMENT_NOTES_SYNCHRONES_;
        this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON=SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON_;
        this.SEUIL_TEMPS_NOTES_ASYNCHRONES=SEUIL_TEMPS_NOTES_ASYNCHRONES_;
        this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON=SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON_;
        COEFF_FREQ_SYNCHRONE=Math.exp(this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON*LOG_DEMI_TON);
        COEFF_FREQ_ASYNCHRONE=Math.exp(this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON*LOG_DEMI_TON);
        
    }
    
    
    public void init_n0_n1_freel_is_better(LinkedList l_infos_ok){
        Iterator iterator;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        if (l_infos_ok==null) {return;}
        iterator = l_infos_ok.iterator();
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            info_ok.is_a_super_track=false;
            info_ok.numero_super_track=0;
            mem = info_ok.mem;
            info_ok.n0_reel=(int) Math.round(info_ok.n0_ok_decim*mem.info_detection.coeff_decimation-mem.info_detection.retard_de_groupe_bessel);
            info_ok.n1_reel=(int) Math.round((info_ok.n0_ok_decim+info_ok.nb_ok_decim)*mem.info_detection.coeff_decimation-mem.info_detection.retard_de_groupe_bessel);
            info_ok.f_reelle=info_ok.sum_w_inst/info_ok.sum_mod_square;
            info_ok.f_reelle*=mem.freq_reelle_sur_w_inst;
            info_ok.f_reelle+=mem.info_detection.FCentraleReelle;
        }
        
    }
    public min_max_float get_min_max_n0_n1_reel(LinkedList l_infos_ok){
        Iterator iterator;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        int max_n1=0,min_n0=1;
        if (l_infos_ok==null) {return null ;}
        iterator = l_infos_ok.iterator();
        boolean debut=true;
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            if (info_ok!=null) {
                if (debut) {
                    max_n1=info_ok.n1_reel;
                    min_n0=info_ok.n0_reel;
                    debut=false;
                }else {
                    max_n1=info_ok.n1_reel>max_n1?info_ok.n1_reel:max_n1;
                    min_n0=info_ok.n0_reel<min_n0?info_ok.n0_reel:min_n0;
                }
            }
            
        }
        if (max_n1>=min_n0) {
            min_max_float f=new min_max_float((float) min_n0,(float)max_n1);
            return f;
        }else {
            return null;
        }
    }
    public min_max_float get_min_max_n0_n1_reel_groupe(LinkedList l_infos_ok){
        Iterator iterator;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        int max_n1=0,min_n0=1;
        if (l_infos_ok==null) {return null ;}
        iterator = l_infos_ok.iterator();
        boolean debut=true;
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            if (info_ok!=null) {
                if (debut) {
                    max_n1=info_ok.n1_reel_super_track;
                    min_n0=info_ok.n0_reel_super_track;
                    debut=false;
                }else {
                    max_n1=info_ok.n1_reel_super_track>max_n1?info_ok.n1_reel_super_track:max_n1;
                    min_n0=info_ok.n0_reel_super_track<min_n0?info_ok.n0_reel_super_track:min_n0;
                }
            }
            
        }
        if (!debut) {
            min_max_float f=new min_max_float((float) min_n0,(float)max_n1);
            return f;
        }else {
            return null;
        }
    }
    
    public min_max_float get_min_max_n0_n1_reel_groupe(InfoTrack[] tab_infos_ok){
        InfoTrack info_ok;
        int max_n1=0,min_n0=1;
        if (tab_infos_ok==null) {return null ;}
        if (tab_infos_ok.length<=0) {return null ;}
        int i=0;info_ok=  tab_infos_ok[i++];
        max_n1=info_ok.n1_reel_super_track;
        min_n0=info_ok.n0_reel_super_track;
        for (;i<tab_infos_ok.length;i++) {
            info_ok=  tab_infos_ok[i];
            max_n1=info_ok.n1_reel_super_track>max_n1?info_ok.n1_reel_super_track:max_n1;
            min_n0=info_ok.n0_reel_super_track<min_n0?info_ok.n0_reel_super_track:min_n0;
        }
        min_max_float f=new min_max_float((float) min_n0,(float)max_n1);
        return f;
    }
    public min_max_float get_min_max_n0_n1_Interval(Interval[] its){
        Interval it;
        int max_n1=0,min_n0=1;
        if (its==null) {return null ;}
        boolean debut=true;
        for (int i=0;i<its.length;i++) {
            it=  its[i];
            if (it!=null) {
                if (debut) {
                    max_n1=it.n1;
                    min_n0=it.n0;
                    debut=false;
                }else {
                    max_n1=it.n1>max_n1?it.n1:max_n1;
                    min_n0=it.n0<min_n0?it.n0:min_n0;
                }
            }
            
        }
        if (!debut) {
            min_max_float f=new min_max_float((float) min_n0,(float)max_n1);
            return f;
        }else {
            return null;
        }
    }
    /** **********************************************************************
     * Code a partir de AddrInst La suite d'intructions de Filtrage-Decim_tion
     * Du Tableau Source AddrSrcInt -> TableauDest AddrDst
     * EFFET DE BORD SUR LES VARIABLES GLOBALES
     * NB_DECIM_INIT
     * NB_DECIM
     * Entrees = FMaxATraiter / FEch
     *           FMinATraiter / FEch
     **************************************************************************/
    public void CALC_NBS_DECIM(  ){
        this.NB_DECIM_INIT = 0 ;
        double f_min_sur_fe = this.F_MINI / this.F_ECH ;
        double f_max_sur_fe = this.F_MAXI / this.F_ECH ;
        double Trv = 0.25 / Math.sqrt(2) * 1.1 ;
        for(; f_max_sur_fe < Trv ;) {
            this.NB_DECIM_INIT = this.NB_DECIM_INIT + 1 ;
            f_max_sur_fe *= 2 ;
            f_min_sur_fe *= 2 ;
        }
        Trv = 0.25 / Math.sqrt(2) / 1.1 ;
        this.NB_DECIM = 0 ;
        for(; f_min_sur_fe < Trv ;) {
            this.NB_DECIM +=  1 ;
            f_min_sur_fe *= 2 ;
        }
    }
    public int LongueurListeDecim( int LGN_BUFFER,int NB_DECIM_INIT, int NB_DECIM ){
        int nb_ech = LGN_BUFFER >> NB_DECIM_INIT ;
        int NTrv = nb_ech;
        for(int i_decim = 1 ;i_decim<=NB_DECIM;i_decim++) {
            NTrv  = NTrv >> 1  ;
            nb_ech += NTrv ;
        }
        return nb_ech ;
    }
    public void met_a_jour_seuils_sur_bruit() {
        MemoireClcDetect mem;
        int i;
        for (i=1;i<this.tab_memoire_detect.length;i++) {
            mem=this.tab_memoire_detect[i];
            mem.SeuilMod2=(float)Math.max(mem.SeuilMod2,mem.max_mod_square*this.SEUIL_MOD2_RELATIVE_NOISE);
        }
    }
    
    public void code_filtrage_decimation( LinkedList instructions   ){
        int increment_decim ;
        int i  ;
        int n0_src=0;
        int n0_dst=0;
        int longueur   = LGN_BUFFER ;
        float [] Dst_   = liste_decim ;
        double f0_norm_6db;
        /* Codage des filtres et decim_tions */
        /* FILTRAGE PASSE_HAUT INITIAL */
        /* Codage Dst = 1.0 * SrcInst, Sans Decim_tion */
        float A1        =  (float) (-Math.exp( - FREQU_COUPURE_PASSE_HAUT *  2 *Math.PI / F_ECH ) );
        /* 5 Hertz de frequence de coupure : exp(- Te / [ 1 / (2*Pi*FCut)] */
        float gain_k    =  (float) (( 1.0 - A1 ) / 2.0 );
        premier_traitement=new flt_passe_haut_initial(
                A1,gain_k,
                BufferSrcShort,liste_decim,
                longueur,this);
        instructions.add((Object) premier_traitement);
        /* 1- FILTRAGE_DECIMATION INITIAL */
        if ( NB_DECIM_INIT > 0 ) {
            /* FILTRE INITIAL */
            increment_decim = 1 << NB_DECIM_INIT ;
            f0_norm_6db  =(0.25 / increment_decim)         ;   /* Frequence de coupure a -6dB */
            code_butterworth( instructions,
                    f0_norm_6db       ,   /* F0Norm pour -6dB */
                    NB_CEL_BUT,   /* OrdreFltSur2     */
                    liste_decim,liste_decim,
                    longueur ,   /*  nb_ech           */
                    n0_src,n0_dst,
                    increment_decim   );
            longueur /=  increment_decim ;
        }
        /* FILTRES SUIVANTS */
        increment_decim = 2 ;
        for (i = 1 ;i<= NB_DECIM ;i++) {
            n0_src = n0_dst ; /* Entree Filtre(n+1) = Sortie Filtre(n) */
            /* Nouvelle Dest = Ancienne Dest + Taille Ancienne Dest */
            n0_dst+=longueur;
            code_butterworth( instructions,
                    0.25      ,   /* F0Norm pour -6dB */
                    NB_CEL_BUT,   /* OrdreFltSur2     */
                    liste_decim,liste_decim,
                    longueur  ,   /*  nb_ech           */
                    n0_src,n0_dst,
                    increment_decim   );
            longueur /= increment_decim ;
        }
    }
    /**************************************************************
     * Rajoute A La Liste D'instructions Pointee Par AddrInst :
     *  -le code correspondant a
     *  - u_n Multiplieur De liste_decim Par 2.[Math.sin(2*pi*f_centrale*n),Math.cos(...)]
     *  - u_n Filtre de Bessel
     *      D'ordre 2.nb_cellules, passe sur [X.Math.sin,X.Math.cos]
     *      De Frequence de coupure ( a -6dB ) F0/FEch = F0Norm
     *  - Le Resultat est range dans  Addrtab_srcDst_^
     *  VARIABLES GLOBALES UTILISEES
     *   NB_DECIM_INIT,NB_DECIM,LGN_BUFFER,liste_decim
     ***********************************************************************/
    public double code_mulsincos_bessel_et_renvoie_retgrp(  LinkedList instructions,
            double f_centrale,
            double f0_norm_6db,
            float [] tab_re_im,
            ClcDetect clc_detect
            ){
        /* Retard des groupes des filtres de bessel (s) , pour Wn = 1 */
        double RetGrpBess[]={1.2,2.6,3.6,4.36,4.99};
        double re_poles_bessel[]={
            -7.587481140709448e-001   /* ReP2 */,
            -7.289586444962712e-001   /* ReP4 */,
            -1.003530941850928e+000   /* ReP4 */,
            -1.140018898231797e+000   /* ReP6 */,
            -1.002452412251339e+000   /* ReP6 */,
            -6.751336320481554e-001   /* ReP6 */,
            -1.262635665508930e+000   /* ReP8 */,
            -1.176082970317012e+000   /* ReP8 */,
            -9.870562356130274e-001   /* ReP8 */,
            -6.414952559755986e-001   /* ReP8 */,
            -1.378645670443496e+000   /* ReP10*/,
            -1.317550286495251e+000   /* ReP10*/,
            -1.188537087791208e+000   /* ReP10*/,
            -9.731756356282508e-001   /* ReP10*/,
            -6.191947558634453e-001   /* ReP10*/};
        double im_poles_bessel[]={
            +4.380634279059808e-001   /* ImP2 */,
            -9.207898168175978e-001   /* ImP4 */,
            -3.004948194607824e-001   /* ImP4 */,
            -2.327904326657524e-001   /* ImP6 */,
            -7.047426519206190e-001   /* ImP6 */,
            -1.205578811370667e+000   /* ImP6 */,
            -1.960456842053748e-001   /* ImP8 */,
            -5.911495025792888e-001   /* ImP8 */,
            -9.974850061865084e-001   /* ImP8 */,
            -1.435726312058751e+000   /* ImP8 */,
            -1.728106190362116e-001   /* ImP10*/,
            -5.201391866523785e-001   /* ImP10*/,
            -8.733385205892487e-001   /* ImP10*/,
            -1.239814159144543e+000   /* ImP10*/,
            -1.639685327151712e+000   /* ImP10*/};
        double csi_bessel , wn_bessel    ;
        flt_1z_re_im   rec_flt_1z_re_im;
        float moins_a1,moins_a2;
        double retard_de_groupe;
        
        /* INITIALISATION MULSINCOSK ( Sauf Le Gain gain_k , dont on garde l'adresse */
        /* BufDstReImPlus <- liste_decim.[Math.sin,Math.cos] */
        /* Determination adresse gain gain_k */
        /* Init Multiplieur liste_decim / [Sinus,Cosinus] (f_centrale) */
        mul_sin_cos_k rec_mul_sin_cos_k = new mul_sin_cos_k(1.0f,lut_sin_cos,liste_decim,tab_re_im,
                LGN_BUFFER >> NB_DECIM_INIT,
                NB_DECIM + 1,
                (float) f_centrale ) ;
        instructions.add((Object) rec_mul_sin_cos_k);
        
        /* CALCUL FILTRE DE BESSEL */
        my_transfert H=new my_transfert() ;
        /* Largeur de bande a -6dB du filtre , dans le plan W */
        double w0_6db = Math.sin(Math.PI* f0_norm_6db )/Math.cos(Math.PI* f0_norm_6db );
        /* Calcul  du retard de groupe en echantillons */
        retard_de_groupe = RetGrpBess[NB_CEL_BES-1];
        retard_de_groupe = retard_de_groupe / w0_6db;
        retard_de_groupe = 1.0 / ( 2 * Math.atan( 1.0 / retard_de_groupe ) );
        /* CODAGE DES CELLULES */
        double gain_global = 1.0 ;
        /* Premier Indice k0 = Somme(1..NB_CEL_BES) n = NB_CEL_BES.(NB_CEL_BES+1)/2 */
        int k0= 1 + ( NB_CEL_BES * ( NB_CEL_BES - 1 ) / 2 );
        k0--; /* conversion delphi <-> java, les tableaux commencent en 0 */
        for (int i_cell_bess = 1;i_cell_bess<= NB_CEL_BES ;i_cell_bess++) {
            wn_bessel =re_poles_bessel[k0]*re_poles_bessel[k0]+im_poles_bessel[k0]*im_poles_bessel[k0];
            wn_bessel = Math.sqrt( wn_bessel ) ;
            csi_bessel    = -re_poles_bessel[k0] / wn_bessel ;
            /* Determination coeffs du filtre ( Plan W ) ) */
            H.numerator.deg = 0 ; H.numerator.coef[0] = 1 ;
            H.denominator.deg = 2 ;
            H.denominator.coef[0] = 1;
            H.denominator.coef[1] = 2 * csi_bessel / wn_bessel ;
            H.denominator.coef[2] = 1 /(wn_bessel*wn_bessel) ;
            H.denominator.coef[1] /= w0_6db ;
            H.denominator.coef[2] /= (w0_6db*w0_6db) ;
            
            /* Passage de H dans le plan Z^-1 */
            H=H.transform_abcd(1.0,-1.0,1.0,1.0);            /**  p= (1-r)/(1+r) **/
            /* Codage Instruction */
            moins_a1=(float) (- H.denominator.coef[1]) ;
            moins_a2=(float) (- H.denominator.coef[2] );
            rec_flt_1z_re_im = new flt_1z_re_im(
                    moins_a1,moins_a2,
                    tab_re_im,tab_re_im,
                    LGN_BUFFER >> NB_DECIM_INIT,
                    NB_DECIM + 1) ;
            instructions.add((Object) rec_flt_1z_re_im);
            /* mise a jour gain global */
            gain_global *=  ( 1 - moins_a1 - moins_a2 ) / 4.0 ;
            /* pole suivant */
            k0++ ;
        }
        /* GAIN DU FILTRE DE BESSEL * 2 DANS RECMulSINCOSK */
        rec_mul_sin_cos_k.gain_k = (float) (2 * gain_global) ;
        return retard_de_groupe;
    }
    public void init_tab_demodu( ) /* CONTEXTE.NB_FILTRES => TabRecDemodu */
    {
        int i_demodu;
        double LogCoeffNote = Math.log( 2.0 ) / 12 ;
        double PasMultF = Math.log(2) / this.NB_FILTRES; /*Math.log( 0.25 * Math.sqrt( 2.0 ) ) - Math.log( O.25 / Math.sqrt(2.0) );*/
        PasMultF = Math.exp( PasMultF );
        /* reservation memoire RecDemodu */
        tab_demodu =new RecDemodu[this.NB_FILTRES+1];
        /* FREQUENCE MAX DE DEMODU PAR DEFAUT */
        double F0     = 0.25 * Math.sqrt(2);
        double LogF0 = Math.log( F0 ) / LogCoeffNote ;
        /* ON DECALE un PEU POUR TOMBER EN PLEIN SUR une NOTE */
        double F0_LA    = this.F_LA / this.F_ECH ;
        double LogF0_LA = Math.log( F0_LA ) / LogCoeffNote ;
        LogF0 = Math.round( LogF0 - LogF0_LA ) + LogF0_LA ;
        LogF0 = LogF0 * LogCoeffNote ;
        F0    = Math.exp( LogF0 ) ;
        /* Calcul de toutes les autres frequences */
        for( int i_filtre = 1 ;i_filtre<= this.NB_FILTRES;i_filtre++) {
            i_demodu=this.NB_FILTRES - i_filtre + 1;
            tab_demodu[i_demodu]=new RecDemodu();
            tab_demodu[i_demodu].FPlus = F0 ;
            tab_demodu[i_demodu].FMoins= F0 /( 1 + this.DELTAF_DERIV );
            /* Le Filtre a u_n gain de 0.5 A F0 / PasMultF ) */
            tab_demodu[i_demodu].DeltaF_6db    = F0 * ( 1 - 1.0 / PasMultF );
            //icilesgars, forcage de Fmoins relativement a la largeur de bande du filtre
            // ce qui est plus logique
            //  tab_demodu[i_demodu].FMoins= F0 -tab_demodu[i_demodu].DeltaF_6db /4;
            
            F0 = F0 / PasMultF ;
        }
    }
    public void InitBuffers(  ) {
        int nb_ech = this.NB_ECH_LISTEDECIM ;
        /* Reservation memoire Pour BufferSrc */
        this.BufferSrcFloat = new float[this.LGN_SRC ];
        /* Reservation pour BufDStReImPlus Et BufDstReImMoins, DANS LA MEME PAGE!... */
        this.BufDstReImPlus   = new float[2 * nb_ech ];
        this.BufDstReImMoins  = new float[2 * nb_ech ];
        
    }
    
    public void InitListeDecimEtLutSinCos(  ){
        liste_decim    =  new float[2 * this.LGN_BUFFER];
        lut_sin_cos    =  new float[2*constantes.size_lut_sin_cos];
        for(int i= 0 ;i<constantes.size_lut_sin_cos ;i++) {
            lut_sin_cos[ 2*i     ] =(float) Math.sin( i * 2 * Math.PI / constantes.size_lut_sin_cos );
            lut_sin_cos[ 2*i + 1 ] =(float) Math.cos( i * 2 * Math.PI / constantes.size_lut_sin_cos );
        }
    }
    public void reset_max_mod_square_and_seuil_mod2() {
        MemoireClcDetect mem;
        for (int i=1;i<this.tab_memoire_detect.length;i++) {
            mem=this.tab_memoire_detect[i];
            mem.max_mod_square=0f;
            mem.SeuilMod2=this.SEUIL_MODU*this.SEUIL_MODU;
            mem.max_better_mean_mod_square=1f;
            mem.max_better_mod_square=1f;
        }
    }
    public float[] get_max_mod_square() {
        MemoireClcDetect mem;
        if (tab_memoire_detect.length<=0) {
            return null;
        }
        float []tab_max_mod_square=new float[tab_memoire_detect.length];
        
        for (int i=1;i<this.tab_memoire_detect.length;i++) {
            mem=this.tab_memoire_detect[i];
            tab_max_mod_square[i]=mem.max_mod_square;
        }
        return tab_max_mod_square;
    }
    
    public void init_traitements(  ) {
        //   this.init_TAB_REF_AMP_HMS(); // pour routine de detection plus rapide
        this.nb_trames=0;
        //  RecGain_float_float:Gain_float_float;
        ClcDetect clc_detect;
        RecDemodu demodu;
        int i_decim , l ,i_tab_memoire_detect ;
        double retard_de_groupe_plus,retard_de_groupe_moins  ;
        /* NB_FILTRES , DELTAF_DERIV => TabRecDemodu[1..NB_Filtres] */
        /* INIT DE NB_DETECT */
        this.NB_DETECT = ( this.NB_DECIM + 1 ) ;
        this.NB_DETECT *= this.NB_FILTRES ;
        
        /********************************************************
         * Debut Serie D'instructions
         ********************************************************/
        code_filtrage_decimation( this.instructions );
        this.tab_memoire_detect=new MemoireClcDetect[(this.NB_DECIM+1)*this.NB_FILTRES+1];
        this.init_tab_demodu( );
        for (int i_filtre=1 ; i_filtre<=this.NB_FILTRES;i_filtre++) { /* De PlusBasse Freq -> Plus Haute Freq */
            demodu= this.tab_demodu[i_filtre];
            retard_de_groupe_plus=0f;
            clc_detect=new ClcDetect(this,i_filtre,retard_de_groupe_plus);
            retard_de_groupe_plus=code_mulsincos_bessel_et_renvoie_retgrp( this.instructions,
                    demodu.FPlus     ,
                    demodu.DeltaF_6db,
                    this.BufDstReImPlus,
                    clc_detect);
            retard_de_groupe_moins=code_mulsincos_bessel_et_renvoie_retgrp( this.instructions,
                    demodu.FMoins     ,
                    demodu.DeltaF_6db,
                    this.BufDstReImMoins,
                    clc_detect);
            clc_detect.met_a_jour_retard_de_groupe(this,retard_de_groupe_plus);
            /* Codage Instruction Mesure ModPlus,FInstPlus,ModMoins,FInstMoins-FInstPlus,*/
            instructions.add((Object) clc_detect);
 /* Recuperation Adresse memoire Dans Tableau Global du Contexte, Pour
     Donner L'acces Au Programme Principal */
            i_tab_memoire_detect = i_filtre ;
            for( i_decim = clc_detect.nb_decim;i_decim>= 1 ;i_decim--) {
                this.tab_memoire_detect[i_tab_memoire_detect] = clc_detect.memoire[i_decim] ;
                if (clc_detect.memoire[i_decim].is_in_interval) {
                    clc_detect.memoire[i_decim].info_detection.indice_dans_tab_memoire_detect=i_tab_memoire_detect;
                }
                i_tab_memoire_detect +=  this.NB_FILTRES  ;
            }
        }
        
    }
    public void affiche_info_detection() {
        MemoireClcDetect mem;
        InfoDetection info_detection;
        for (int i=1;i<this.tab_memoire_detect.length;i++) {
            mem= this.tab_memoire_detect[i];
            info_detection=mem.info_detection;
            System.out.print("FCentrale =");
            System.out.print(info_detection.FCentraleReelle);
            System.out.print(", decim =");
            System.out.print(info_detection.coeff_decimation);
            System.out.print(", filtre =");
            System.out.print(info_detection.indice_filtre);
            
            System.out.print(", OK =");System.out.print(mem.ok_detection);
            if ((mem.ok_detection & constantes.Mask_SeuilF)==0){
                System.out.print(", SeuilF OK ");
            } else {
                System.out.print(", SeuilF BAD");
            }
            if ((mem.ok_detection & constantes.Mask_SeuilDeltaF)==0){
                System.out.print(", SeuilDeltaF OK ");
            } else {
                System.out.print(", SeuilDeltaF BAD");
            }
            if ((mem.ok_detection & constantes.Mask_SeuilMod2)==0){
                System.out.println(", SeuilMod2 OK ");
            } else {
                System.out.println(", SeuilMod2 BAD");
            }
            
        }
    }
    public void affiche_info_ok_detection() {
        float f_reelle;
        MemoireClcDetect mem;
        InfoDetection info_detection;
        InfoTrack info_ok;
        Iterator iterator;
        for (int i=1;i<this.tab_memoire_detect.length;i++) {
            mem= this.tab_memoire_detect[i];
            iterator = mem.sender.infos_tracks.iterator();
            while (iterator.hasNext()) {
                info_ok=  (InfoTrack)(iterator.next());
                f_reelle=info_ok.sum_w_inst/info_ok.sum_mod_square;
                f_reelle*=mem.freq_reelle_sur_w_inst;
                f_reelle+=mem.info_detection.FCentraleReelle;
                System.out.print("FCENTRALE =");System.out.print(mem.info_detection.FCentraleReelle);
                System.out.print(", FMESUREE =");System.out.print(f_reelle);
                System.out.print(", MODULE MOYEN=");System.out.print(Math.sqrt(info_ok.mean_mod_square));
                System.out.print(", debut =");
                System.out.print(info_ok.n0_ok_decim*mem.info_detection.coeff_decimation);
                System.out.print(", Fin =");
                System.out.print((info_ok.n0_ok_decim+info_ok.nb_ok_decim-1)*mem.info_detection.coeff_decimation);
                System.out.print(", Retard de Groupe =");
                System.out.println(mem.info_detection.retard_de_groupe_bessel);
                
            }
        }
    }
    public void set_new_source(short[] tab_src_,int n0_src_){
        premier_traitement.tab_src=tab_src_;
        premier_traitement.n0_src=n0_src_;
        this.BufferSrcShort=tab_src_;
    }
    public boolean INIT_CONTEXTE( double FMini,double FMaxi,double FEch ,double FLA, int lgn_buffer){
        this.F_MAXI=(float)FMaxi;
        this.F_MINI=(float)FMini;
        this.F_ECH =(float)FEch;
        this.F_LA  =(float)FLA;
        return INIT_CONTEXTE();
    }
    public boolean INIT_CONTEXTE( ){
        LGN_SRC=2*LGN_BUFFER;
        this.instructions =new LinkedList();
        this.infos_tracks=new LinkedList();
        CALC_NBS_DECIM(  );/* Calcule NB_DECIM et NB_DECIM_INIT = f( FMin,FMax,FEch )*/
        int nb_ech = LongueurListeDecim( this.LGN_BUFFER,this.NB_DECIM_INIT, this.NB_DECIM);
        this.NB_ECH_LISTEDECIM = nb_ech ;
        InitListeDecimEtLutSinCos(  );
        InitBuffers(  );
        /* ON FIXE LES PARAMETRES PAR DEFAUT A CE STADE */
/* VARIABLES FIXEES PAR INIT_CONTEXTE , MAIS QUE L'ON PEUT MODIFIER
  DANS CONTEXTE,
  PUIS PRENDRE EN COMPTE EN APPELANT Init_Traitements             */
//  effet de bord sur premier_traitement, qui permet de changer rapidement l'adresse du buffer a traiter
        double coeff_freq_synchrone,coeff_freq_asynchrone;
        LOG_DEMI_TON=Math.log(2.0)/12;
        COEFF_MEME_NOTE=(float)Math.exp(LOG_DEMI_TON/2f);
        
        COEFF_FREQ_SYNCHRONE=Math.exp(this.SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON*LOG_DEMI_TON);
        COEFF_FREQ_ASYNCHRONE=Math.exp(this.SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON*LOG_DEMI_TON);
        
        init_traitements();
        return true;
    }
    public void print_memoires(){
        for (int i=1;i<this.tab_memoire_detect.length;i++) {
            MemoireClcDetect mem=this.tab_memoire_detect[i];
            System.out.print("memoire["+String.valueOf(i)+"] : ");
            if (mem.is_in_interval==true) {
                System.out.println("OK , FC="+String.valueOf(mem.info_detection.FCentraleReelle));
                System.out.println("       Max Module="+String.valueOf(Math.sqrt(mem.max_mod_square)));
                System.out.println("       Seuil Module="+String.valueOf(Math.sqrt(mem.SeuilMod2)));
            } else {
                System.out.print("NOT OK , info_detect=");
                System.out.println(mem.info_detection);
                System.out.println("       Max Module="+String.valueOf(Math.sqrt(mem.max_mod_square)));
                System.out.println("       Seuil Module="+String.valueOf(Math.sqrt(mem.SeuilMod2)));
                
            }
        }
    }
    float [] liste_decim ;    // PVectSingle;
    float [] BufDstReImPlus;  // PVectSingle ;
    float [] BufDstReImMoins;  // PVectSingle ;
    flt_passe_haut_initial premier_traitement;
    int LGN_BUFFER      ;   // Word  ; /* RQ // CONTEXTE.LGN_BUFFER      <= 1024 */
    float F_ECH          ;     // Double ;/*= 11025.0  ;*/
    float F_MINI        ;     // Double ;/*= 50       ;*/
    float F_MAXI        ;     // Double ;/*= 440      ;*/
    float F_MAXI_A_GARDER;
    
    float F_LA          ;     // Double ;/* FREQUENCE REELLE DU LA = 440.0 */
    double FREQU_COUPURE_PASSE_HAUT=10;// Coupure a 10 Hz pour le passe haut
    
    /* VARIABLES RENVOYEES PAR INIT_CONTEXTE  */
    int NB_ECH_LISTEDECIM;  // Word          ;
    int NB_DECIM_INIT    ;  // Byte          ;
    int NB_DECIM         ;  // Byte          ;
    int LGN_SRC          ;  // Word  ;
    int NB_DETECT        ;  // Word ;
    short [] PTR_SRC       ;     // PVectInt16 ; // ATTENTION, PAS DE memoire RESERVEE
    RecDemodu [] tab_demodu   ;
     /* VARIABLES FIXEES PAR INIT_CONTEXTE , MAIS QUE L'ON PEUT MODIFIER
       DANS CONTEXTE,
       PUIS PRENDRE EN COMPTE EN APPELANT INIT_TRAITEMENTS             */
    int NB_CEL_BES  =4    ;   // Word    ;/*=2         ;*/
    int NB_CEL_BUT  =4    ;   // Word    ;/*=2         ;*/
    int NB_FILTRES  =6    ;   // Byte    ;/*= 6        ;*/
    double DELTAF_DERIV =0.0025;      // Double  ;/*=0.0025    ;*/
    float SEUIL_MODU    =10.0f;     // Single ;/*= 10.0      ;*/
    float SEUIL_MOD2_RELATIVE=0.03f*0.03f; // Seuil relatif / Module maxi
    float SEUIL_PLUS_DERIVF= 1.5f;  // Single ;/* 1.5 */
    float SEUIL_MOINS_DERIVF= 0.5f; // Single ;/* 0.5 */
    
    float TEMPS_MINI_NB_OK=0.1f;
    float SEUIL_NB_OK_RELATIVE_RETARD_GROUPE=1f;
    
    
    float TEMPS_MINI_NB_ATTENTE=0.05f;
    float SEUIL_NB_ATTENTE_RELATIVE_RETARD_GROUPE=0.5f;
    
    float TEMPS_MAXI_NB_OK=0.25f;//On Coupe les pistes apres 0,25s maxi
    float SEUIL_PREMIER_NB_OK_RELATIVE_RETARD_GROUPE=2f;//unused
    
    
    float SEUIL_W_INST_RELATIVE_6DB=3.0f;
    float SEUIL_W_ATTENTE_RELATIVE_SEUIL_W_PLUS=0.5f;
    float SEUIL_W_ATTENTE_RELATIVE_DEMI_TON=0.5f;
// les notes dont l'ecart est superieur a 2demi-tons
// ne sont pas considerees synchrones
    float  SEUIL_FREQ_NOTES_SYNCHRONES_EN_DEMI_TON=1f;
// les notes dont le recouvrement temporel est < 75% de la largeur
// ne sont pas considerees synchrones
    float  COEFF_RECOUVREMENT_NOTES_SYNCHRONES=0.75f;
// les notes dont l'ecart est superieur a 0.5demi-tons
// ne peuvent pas etre regroupees
    
    float  SEUIL_FREQ_NOTES_ASYNCHRONES_EN_DEMI_TON=0.5f;
// les notes dont l'ecart temporel 0.05s
// ne peuvent pas etre regroupees
    float  SEUIL_TEMPS_NOTES_ASYNCHRONES=0.05f;
    
    double COEFF_FREQ_SYNCHRONE,COEFF_FREQ_ASYNCHRONE,LOG_DEMI_TON;
    float SEUIL_TEMPS_INTERFERENCES_S=0f;//desactive
// les notes doivent se recouvrir au moins sur 75% de leur longueur
// pour etre considerees synchrones
    /** VARIABLES DYNAMIQUES, INITIALISEES PAR INIT_CONTEXTE(CONTEXTE), *
     *                       LIBEREES     PAR FREE_CONTEXTE(CONTEXTE) **/
    LinkedList instructions;
    LinkedList infos_tracks;
    float [] lut_sin_cos ;     // PVectSingle ;
    MemoireClcDetect [] tab_memoire_detect;//TabDetect   ;  // PTABRECPOURDETECT;
    short[] BufferSrcShort; // PVectInt16 ; /* Vector( 0  , CONTEXTE.LGN_SRC - 1   , SizeOf( short ) ); */
    float[] BufferSrcFloat; // PVectInt16 ; /* Vector( 0  , CONTEXTE.LGN_SRC - 1   , SizeOf( short ) ); */
    /*$IFDEF _AFFSINCOS*/
    float [] BuffAffRePlus ; // PVectSingle ; /* Vector( 0, nb_ech Div 2 - 1, SizeOf(Single) );*/
    float [] BuffAffImPlus ; // PVectSingle ; /* Vector( 0, nb_ech Div 2 - 1, SizeOf(Single) );*/
    float [] BuffAffReMoins; // PVectSingle ; /* Vector( 0, nb_ech Div 2 - 1, SizeOf(Single) );*/
    float [] BuffAffImMoins; // PVectSingle ; /* Vector( 0, nb_ech Div 2 - 1, SizeOf(Single) );*/
    /*$ENDIF*/
    /** Reservation  Dans La Meme Page memoire
     * BufferDstReImPlusMoins//= Vector( 0  , 2 * 4 * CONTEXTE.LGN_BUFFER -1, SizeOf( Single ) );
     * CONTEXTE.BufDstReImPlus     //= Addr( BufferDstReImPlusMoins^[0]);
     * CONTEXTE.BufDstReImMoins    //= Addr( BufferDstReImPlusMoins^[4*CONTEXTE.LGN_BUFFER]);
     **/
    boolean running; // put this to false to stop the threads
    boolean execution_en_cours; // this becomes false when the thread has effectivly stopped
    int count;
    
    public boolean CONTEXTE_OK;
    
    int nb_trames;// nb trames acquisition
    
    float mod_square_moy; // Module au carre moyen
    
    private float NB_HMS=10; // pour calcul tableau d'amplitude
    
    private int NB_PTS_PAR_DEMI_TON=10;// Nb Pts Du Tableau
    private float DEMI_LARGEUR_EN_DEMI_TON=0.5f;
    
    private int I_HM_1;
    
    private float[] TAB_REF_AMP_HMS;
    
    public float SEUIL_PGCD=1f/40f;
    float SEUIL_MOD2_RELATIVE_FOR_NOTES=0.1f;
    float SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS=0.0001f;
    float SEUIL_MOD2_RELATIVE_NOISE=3f*3f;
    
    public float NB_HMS_PGCD=2.1f; // nb d'hms max pour evaluation pgcd
    
    int NB_TRACK_VALID_NOTE=1;
    
    int NB_TRACKS_PGCD=3;
    
    
    
    public float COEFF_MEME_NOTE;
    
    
    
    
    
    
    
    
    public short[] buffer_short(byte[] b) {
        short[] d = new short[b.length/2];
        for (int cc = 0; cc < b.length/2; cc++) {
            d[cc] = (short) ((b[cc*2+1]*256 + (b[cc*2] & 0xFF))/32678.0);
        }
        return d;
    }
    
    public int min(int i1, int i2) {
        return  i1<i2?i1:i2;
    }
    public int max(int i1, int i2) {
        return  i1>i2?i1:i2;
    }
    
    LinkedList get_better_info_ok_containing_n_reel(LinkedList infos_ok_, int n_reel) {
        if (infos_ok_==null) return null;
        if (infos_ok_.size()==0) return null;
        Iterator iterator= infos_ok_.iterator();
        InfoTrack info_ok=null;
        LinkedList l=null;
        boolean ok;
        // init du champ numero_super_track
        while (iterator.hasNext()) {
            Object O= iterator.next();
            ok=O!=null;
            if (ok) {
                info_ok=  (InfoTrack) O;
                ok= info_ok.is_a_super_track;
            }
            if (ok) {
                ok= info_ok.nb_tracks_in_super_track>1;
            }
            if (ok) {
                ok= info_ok.n0_reel_super_track<=n_reel;
            }
            if (ok) {
                ok= info_ok.n1_reel_super_track>=n_reel;
            }
            if (ok) {
                // ajout a la liste
                if (l==null) l=new LinkedList();
                l.add(O);
            }
        }
        return l;
        
    }
    public LinkedList liste_better_notes(float f_min,float f_max,int n0_ref,int n1_ref,LinkedList l_infos_ok) {
        LinkedList NotesOK;
        Iterator iterator;
        InfoTrack info_ok;
        boolean ok;
        // traitement de la liste des notes
        int debut_recouvrement=0,fin_recouvrement=0,largeur_recouvrement=0;
        int largeur_2;
        NotesOK=null;
        int delta_ref=(int)((n1_ref-n0_ref)*this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES);
        Object [] tab=l_infos_ok.toArray();
        Comparator comp = MyComparators.InfoOK_increasing_n0_reel_Comparator();
        Arrays.sort(tab, comp);
        for (int i_array=0;i_array<tab.length;i_array++) {
            info_ok=  (InfoTrack)(tab[i_array]);
            // on ne s'occuppe pas des notes deja traitees
            ok =(info_ok.is_a_super_track)
            && (info_ok.nb_tracks_in_super_track>1);
            if (ok) {// DEBUT TEST
                // ETAPE 1: TEST NOTES SYNCHRONES
                if (ok) {ok =info_ok.f_reelle<= f_max;}
                if (ok) {ok =info_ok.f_reelle>= f_min;}
                // test recouvrement temporel
                if (ok) {
                    debut_recouvrement=max(info_ok.n0_reel,n0_ref);
                    fin_recouvrement=min(info_ok.n1_reel,n1_ref);
                    largeur_recouvrement=fin_recouvrement-debut_recouvrement;
                    ok=largeur_recouvrement>=0;
                }
                if (ok) {
                    largeur_2=info_ok.n1_reel-info_ok.n0_reel;
                    ok=largeur_recouvrement>=min(delta_ref,(int)(largeur_2*this.COEFF_RECOUVREMENT_NOTES_SYNCHRONES));
                }
            } // FIN TEST
            // ajout eventuel de la note a la liste des notes synchrones
            if (ok) {
                if (NotesOK==null) {
                    NotesOK=new LinkedList();
                }
                NotesOK.add((Object) info_ok);
            }
        }
        return NotesOK;
        
    }
    
    
    
    public InfoNote[] getMeilleuresNotes(InfoTrack[] tab_infos_ok) {
        
        if (tab_infos_ok==null)   return null;
        LinkedList infos_deltaf=getInfosDeltaF(tab_infos_ok);
        if (infos_deltaf==null) return null;
        Object [] tab_deltaf= infos_deltaf.toArray();
        InfoNote[] tab_notes=new InfoNote[tab_deltaf.length];
        for (int i=0;i<tab_deltaf.length;i++)  {
            tab_notes[i]=new InfoNote();
            InfoDeltaF df=(InfoDeltaF) tab_deltaf[i];
            tab_notes[i].frequences=df.delta_f;
            tab_notes[i].poids=df.poids;
        }
        return tab_notes;
    }
    public InfoNote[] getMeilleuresNotes2(InfoTrack[] tab_infos_ok) {
        
        if (tab_infos_ok==null)   return null;
        LinkedList infos_deltaf=getInfosDeltaF2(tab_infos_ok);
        if (infos_deltaf==null) return null;
        Object [] tab_deltaf= infos_deltaf.toArray();
        InfoNote[] tab_notes=new InfoNote[tab_deltaf.length];
        for (int i=0;i<tab_deltaf.length;i++)  {
            tab_notes[i]=new InfoNote();
            InfoDeltaF df=(InfoDeltaF) tab_deltaf[i];
            tab_notes[i].frequences=df.delta_f;
            tab_notes[i].poids=df.poids;
        }
        return tab_notes;
    }
    public InfoNote[] getMeilleuresNotes3(InfoTrack[] tab_infos_tracks) {
        InfoDeltaF if_d;
        if (tab_infos_tracks==null)   return null;
        // etape 1, get frequencies and poids
        LinkedList infos_deltaf=getInfosDeltaF3(tab_infos_tracks);
        if (infos_deltaf==null) return null;
        Object [] tab_deltaf=null;
        if (infos_deltaf.size()==1) {
            // une seule piste => degage si pas ok
            if_d=(InfoDeltaF) infos_deltaf.getFirst();
            if (if_d.poids<this.SEUIL_MOD2_RELATIVE_FOR_NOTES) return null;
        }
        if (infos_deltaf.size()>1) {
            // etape 2, sort by decreasing poids
            tab_deltaf=this.sort_deltaf_by_decreasing_poids_and_return_array(infos_deltaf);
            if_d=(InfoDeltaF) tab_deltaf[0];
            //   NOTE PASSE <=> poids > SEUIL_MOD2_REL ET POIDS/POIDS_MAX >=SEUIL_MOD2_REL
            float seuil_mod2=this.SEUIL_MOD2_RELATIVE_FOR_NOTES;
            if (if_d.poids>1f) seuil_mod2*=if_d.poids;
            // etape 3, recreate list for poids >=seuil
            infos_deltaf=new LinkedList();
            for (int i=0;i<tab_deltaf.length;i++) {
                if_d=(InfoDeltaF) tab_deltaf[i];
                if (if_d.poids>=seuil_mod2) {infos_deltaf.add((Object) if_d);} else { i=tab_deltaf.length;}
            }
        }
        // etape 3, tri par frequences croissantes
        
        if (infos_deltaf.size()<1) return null;
        if (infos_deltaf.size()>1) {
            this.sort_deltaf_by_increasing_deltaf(infos_deltaf);
        }
        tab_deltaf=infos_deltaf.toArray();
        InfoNote[] tab_notes=new InfoNote[tab_deltaf.length];
        InfoNote i_n;
        for (int i=0;i<tab_deltaf.length;i++)  {
            tab_notes[i]=i_n=new InfoNote();
            InfoDeltaF df=(InfoDeltaF) tab_deltaf[i];
            i_n.frequences=df.delta_f;
            i_n.poids=df.poids;
            
            i_n.n0_union=df.n0_union;
            i_n.n1_union=df.n1_union;
            i_n.n0_intersection=df.n0_intersection;
            i_n.n1_intersection=df.n1_intersection;
        }
        return tab_notes;
    }
    
    public InfoNote[] getMeilleuresNotes(LinkedList infos_ok,int min_n0_debut_note,int min_n1_fin_note) {
        
        if (infos_ok==null)   return null;
        LinkedList infos_deltaf=getInfosDeltaF(infos_ok,min_n0_debut_note,min_n1_fin_note);
        if (infos_deltaf==null) return null;
        Object [] tab_deltaf= infos_deltaf.toArray();
        InfoNote[] tab_notes=new InfoNote[tab_deltaf.length];
        for (int i=0;i<tab_deltaf.length;i++)  {
            tab_notes[i]=new InfoNote();
            InfoDeltaF df=(InfoDeltaF) tab_deltaf[i];
            tab_notes[i].frequences=df.delta_f;
            tab_notes[i].poids=df.poids;
        }
        return tab_notes;
    }
    public LinkedList regroupeInfosDeltaF(LinkedList infos_deltaf_) {
        float delta_f,f0,ampl;
        if (infos_deltaf_==null) return null;
        if (infos_deltaf_.size()<2) return infos_deltaf_;
        this.sort_deltaf_by_increasing_deltaf(infos_deltaf_);
        LinkedList infos_deltaf=null;
        InfoDeltaF old_df=null,info_df=null;
        Iterator iterator=infos_deltaf_.iterator();
        boolean regroupe=false;
        while (iterator.hasNext())   {
            Object O=iterator.next();
            if (O!=null) {
                info_df=(InfoDeltaF) O;
                if  (old_df!=null) {
                    regroupe=info_df.delta_f<= 1.25f*old_df.delta_f;
                    if (regroupe) {
                        info_df.nb_pistes++;
                        info_df.delta_f=(old_df.delta_f*old_df.poids
                                +info_df.delta_f*info_df.poids)/(old_df.poids+info_df.poids);
                        info_df.f0=Math.min(old_df.f0,info_df.f0);
                        info_df.poids=old_df.poids+info_df.poids;
                    } else{// pas de regroupement=> ecriture old_df
                        if (infos_deltaf==null)   infos_deltaf=new LinkedList();
                        infos_deltaf.add((Object) old_df);
                        
                    }
                    
                }// if  old_df!null
            }
            old_df=info_df;
        }
        if (old_df!=null) { // ne pas oublier d'ajouter le dernier
            if (infos_deltaf==null)   infos_deltaf=new LinkedList();
            infos_deltaf.add((Object) old_df);
        }
        return infos_deltaf;
    }
    
    public LinkedList supprime_hms(LinkedList infos_deltaf_) {
        float delta_f,f0,ampl;
        InfoDeltaF df,df_hm;
        if (infos_deltaf_==null) return null;
        if (infos_deltaf_.size()<2) return infos_deltaf_;
        Object []  tab_delta_f=(Object[])infos_deltaf_.toArray();
        for (int i=0;i<tab_delta_f.length;i++) {
            df=(InfoDeltaF) tab_delta_f[i];
            df.is_hm=false;
        }
        for (int i=0;i<tab_delta_f.length;i++) {
            df=(InfoDeltaF) tab_delta_f[i];
            float fond=df.delta_f;
            for (int i_hm=i+1;i_hm<tab_delta_f.length;i_hm++) {
                df_hm=(InfoDeltaF) tab_delta_f[i_hm];
                if (df_hm.is_hm==false) {
                    boolean is_hm =df_hm.delta_f<3.5f*fond;
                    if (is_hm) {
                        float delta_hm=(df_hm.delta_f/fond);
                        delta_hm-=(float)Math.round(delta_hm);
                        if (delta_hm<0f) delta_hm=-delta_hm;
                        is_hm=delta_hm<0.25;
                    }
                    if (is_hm) {
                        df.nb_pistes++;
                        df.poids+=df_hm.poids;
                    }
                    df_hm.is_hm=is_hm;
                }
            }
        }
        // ecriture sortie
        
        LinkedList infos_deltaf=null;
        for (int i=0;i<tab_delta_f.length;i++) {
            df=(InfoDeltaF) tab_delta_f[i];
            if (!df.is_hm) {
                if (infos_deltaf ==null) infos_deltaf=new LinkedList();
                infos_deltaf.add((Object)   df);
            }
        }
        return infos_deltaf;
    }
    
    public PoidsRelatifEntreInfos[]  getPoidsRelatif(InfoTrack[] if_ok){
        
        if (if_ok==null) return null;
        PoidsRelatifEntreInfos[] tab=new PoidsRelatifEntreInfos[if_ok.length];
        for (int i=0;i<if_ok.length;i++) {
            tab[i]=new PoidsRelatifEntreInfos();
            int nb_pds=(if_ok.length-i)>constantes.NB_POIDS_RELATIFS?constantes.NB_POIDS_RELATIFS:(if_ok.length-i);
            for (int j=0;j<nb_pds;j++) {
                tab[i].ComputePoidsRelatif(if_ok[i+j],j);//0-i[i],i[i]->i[i+1],..
            }
        }
        return tab;
    }
    public PoidsRelatifEntreInfos[]  getPoidsRelatif(LinkedList infos_ok){
        InfoTrack[] if_ok=this.sort_notes_by_increasing_better_f_reelle_and_return_array(infos_ok);
        return this.getPoidsRelatif(if_ok);
    }
    private PoidsRelatifEntreInfos[] getPoidsRelatif(LinkedList infos_ok, int min_n0_debut_note,int min_n1_fin_note) {
        InfoTrack[] if_ok=this.sort_notes_by_increasing_better_f_reelle_and_return_array(infos_ok,min_n0_debut_note,min_n1_fin_note,-1,-1);
        return this.getPoidsRelatif(if_ok);
    }
    
    public LinkedList getInfosDeltaF(LinkedList infos_ok,int min_n0_debut_note,int min_n1_fin_note) {
        float SEUIL_RELATIF_POIDS_DELTAF=constantes.SEUIL_RELATIF_POIDS_DELTAF;// module_square*duree
        if (infos_ok==null) return null;
        LinkedList infos_deltaf=null;
        float old_f=0f;
        int old_n0,old_n1;
        boolean debut=true;
        if (infos_ok==null) return null;
        PoidsRelatifEntreInfos[] poids=this.getPoidsRelatif(infos_ok,min_n0_debut_note,min_n1_fin_note);
        float poids_max=0f;
        if (poids==null) return null;
        for (int i=0;i<poids.length;i++) {
            poids_max=poids_max>poids[i].poids_max?poids_max:poids[i].poids_max;
        }
        float seuil_poids=poids_max*SEUIL_RELATIF_POIDS_DELTAF;
        int j0=0;
        InfoDeltaF info_deltaf;
        for (int i=0;i<poids.length;i++) {
            PoidsRelatifEntreInfos p=poids[i];
            if(p.poids_max>seuil_poids) {
                // on va garder une de ces pistes
                
                for(int j=j0;j<p.duree.length;j++) {
                    if (p.poids[j]>seuil_poids) {
                        if  (j==0) {
                            j0=1;//plus de notes fondamentales
                            info_deltaf=new InfoDeltaF(p.delta_f[j],0f,p.poids[j]/p.duree[j]);
                            
                        } else{
                            info_deltaf=new InfoDeltaF(p.delta_f[j],p.if_ok[0].f_reelle_super_track,p.poids[j]/p.duree[j]);
                            
                        }
                        // ajout des infos a InfodeltaF
                        if (infos_deltaf==null){
                            infos_deltaf=new LinkedList();
                        }
                        infos_deltaf.add((Object) info_deltaf);
                        
                    }
                }
                
                
            }
        }
        LinkedList info_df_grp=this.regroupeInfosDeltaF(infos_deltaf);
        LinkedList  info_df_sans_hms=this.supprime_hms(info_df_grp);
        return info_df_sans_hms;
    }
    public LinkedList getInfosDeltaF(InfoTrack[]tab_infos_ok) {
        float SEUIL_RELATIF_POIDS_DELTAF=constantes.SEUIL_RELATIF_POIDS_DELTAF;// module_square*duree
        if (tab_infos_ok==null) return null;
        LinkedList infos_deltaf=null;
        float old_f=0f;
        int old_n0,old_n1;
        boolean debut=true;
        PoidsRelatifEntreInfos[] poids=this.getPoidsRelatif(tab_infos_ok);
        float poids_max=0f;
        if (poids==null) return null;
        for (int i=0;i<poids.length;i++) {
            poids_max=poids_max>poids[i].poids_max?poids_max:poids[i].poids_max;
        }
        float seuil_poids=poids_max*SEUIL_RELATIF_POIDS_DELTAF;
        int j0=0;
        InfoDeltaF info_deltaf;
        for (int i=0;i<poids.length;i++) {
            PoidsRelatifEntreInfos p=poids[i];
            if(p.poids_max>seuil_poids) {
                // on va garder une de ces pistes
                
                for(int j=j0;j<p.duree.length;j++) {
                    if (p.poids[j]>seuil_poids) {
                        if  (j==0) {
                            j0=1;//plus de notes fondamentales
                            info_deltaf=new InfoDeltaF(p.delta_f[j],0f,p.poids[j]/p.duree[j]);
                            
                        } else{
                            info_deltaf=new InfoDeltaF(p.delta_f[j],p.if_ok[0].f_reelle_super_track,p.poids[j]/p.duree[j]);
                            
                        }
                        // ajout des infos a InfodeltaF
                        if (infos_deltaf==null){
                            infos_deltaf=new LinkedList();
                        }
                        infos_deltaf.add((Object) info_deltaf);
                        
                    }
                }
                
                
            }
        }
        LinkedList info_df_grp=this.regroupeInfosDeltaF(infos_deltaf);
        LinkedList  info_df_sans_hms=this.supprime_hms(info_df_grp);
        return info_df_sans_hms;
    }
    public float PGCD(float F1,float F2){
        float dividende=Math.max(F1,F2);
        float diviseur=Math.min(F1,F2);
        int quotient=1;
        float reste=0f;
        boolean fini=diviseur<=SEUIL_PGCD*dividende;
        while (( dividende >=this.F_MINI)
        &&(!fini)){
            quotient=(int) Math.round(dividende/diviseur);
            reste=dividende-quotient*diviseur;
            fini=Math.abs(reste)<=SEUIL_PGCD*dividende;
            if (!fini) {
                if (reste<0f) {
                    reste+=diviseur;
                    quotient-=1;
                }
            }
            dividende=diviseur;
            diviseur=reste;
        }
        float PGCD_=dividende+reste/quotient;
        return PGCD_;
    }
    public float PGCD(float F1,float F2,float Poids1,float Poids2){
        if (F1==F2) return F1;
        float dividende=Math.max(F1,F2);
        float diviseur=Math.min(F1,F2);
        if (diviseur ==F1) {
            float tmp=Poids2;
            Poids2=Poids1;
            Poids1=Poids2;
        }
        int quotient=1;
        float reste=0f;
        boolean fini=diviseur<=SEUIL_PGCD*dividende;
        while (( dividende >=this.F_MINI)
        &&(!fini)){
            quotient=(int) Math.round(dividende/diviseur);
            reste=dividende-quotient*diviseur;
            fini=Math.abs(reste)<=SEUIL_PGCD*dividende;
            if (!fini) {
                if (reste<0f) {
                    reste+=diviseur;
                    quotient-=1;
                }
            }
            dividende=diviseur;
            diviseur=reste;
        }
        float PGCD_=dividende+reste/quotient;
        F1/=Math.round(F1/PGCD_);
        F2/=Math.round(F2/PGCD_);
        return (F1*Poids1+F2*Poids2)/(Poids1+Poids2);
    }
    public LinkedList getInfosDeltaF2(InfoTrack[]tab_infos_ok) {
        float SEUIL_RELATIF_POIDS_DELTAF=constantes.SEUIL_RELATIF_POIDS_DELTAF;// module_square*duree
        InfoTrack if_ok_i=null,if_ok_j=null;
        LinkedList fondamentales;
        boolean ok;
        float f_fond_i,f_fond_ij=0f;
        int nb_pistes=0;
        if (tab_infos_ok==null) return null;
        LinkedList infos_deltaf=null;
        float poids_i=0f,poids_j;
        float[] f_fond=new float[tab_infos_ok.length];
        boolean[] used=new boolean[tab_infos_ok.length];
        for (int i=0;i<tab_infos_ok.length;i++) {
            ok =!used[i];
            if (ok) {
                if_ok_i=(InfoTrack)tab_infos_ok[i];
                ok=if_ok_i.f_reelle_super_track>=this.F_MINI;
            }
            if (ok) {
                f_fond_i=if_ok_i.f_reelle_super_track;
                poids_i=if_ok_i.mean_mod_square_super_track;
                nb_pistes=1;
                for (int j=i+1;j<tab_infos_ok.length;j++) {
                    ok=!used[j];
                    if (ok) {
                        if_ok_j=(InfoTrack)tab_infos_ok[j];
                        ok=if_ok_j.f_reelle_super_track>this.F_MINI;
                        if (!ok) used[j]=true;
                    }
                    if (ok) {
                        f_fond_ij=this.PGCD(f_fond_i,if_ok_j.f_reelle_super_track);
                        ok =f_fond_ij>=this.F_MINI;
                        if (ok) {
                            ok= if_ok_i.f_reelle_super_track/f_fond_ij <= NB_HMS_PGCD;
                        }
                    }
                    if (ok) {
                        nb_pistes++;
                        poids_j=if_ok_j.mean_mod_square_super_track;
                        int quotient=Math.round(f_fond_i/f_fond_ij);
                        f_fond_i=(f_fond_i/quotient*poids_i+f_fond_ij*poids_j);
                        poids_i+=poids_j;
                        f_fond_i/=poids_i;
                    }
                } // for j
                if (poids_i>0f) {
                    f_fond[i]=f_fond_i;
                    InfoDeltaF df=new InfoDeltaF();
                    df.poids=poids_i;
                    df.nb_pistes=nb_pistes;
                    df.delta_f=f_fond_i;
                    df.f0=f_fond_i;
                    df.nb_pistes=nb_pistes;
                    if (infos_deltaf ==null) infos_deltaf=new LinkedList();
                    infos_deltaf.add((Object)   df);
                }
            } // if ok
        }// for i
//       LinkedList  info_df_sans_hms=this.supprime_hms(info_df_grp);
  /*      if (infos_deltaf!=null) {
          this.sort_deltaf_by_increasing_deltaf(infos_deltaf);
        // pourrait etre classe pas poids decroissant,ce serait plus logique
        } */
        return infos_deltaf;
    }
    public InfoDeltaF find_dans_infos_delta_f(float freq,LinkedList infos_delta_f){
        if (infos_delta_f==null) return null;
        Iterator it=infos_delta_f.iterator();
        InfoDeltaF if_delta;
        while (it.hasNext()) {
            if_delta=(InfoDeltaF) it.next();
            if (if_delta.delta_f<=freq*this.COEFF_MEME_NOTE) {
                if (if_delta.delta_f>=freq/this.COEFF_MEME_NOTE) {
                    return if_delta;// sort de la boucle
                }
            }
        }
        return null;
    }
    public LinkedList getInfosDeltaF3(InfoTrack[]tab_infos_ok) {
        InfoTrack if_ok_i=null,if_ok_j=null;
        InfoDeltaF df=null;
        boolean ok;
        float f_fond_i,f_fond_j=0f,f_fond_ij=0f;
        if (tab_infos_ok==null) return null;
        LinkedList infos_deltaf=null;
        float poids_i=0f,poids_j,poids_ij;
        
        
       /* if (constantes.debug) {
            if (tab_infos_tracks.length==1) {
                poids_i*=1;
            }
        }*/
        for (int i=0;i<tab_infos_ok.length;i++) {
            if_ok_i=(InfoTrack)tab_infos_ok[i];
            ok=if_ok_i.f_reelle_super_track>=this.F_MINI;
            if (ok) {
                f_fond_i=if_ok_i.f_reelle_super_track;
                poids_i=if_ok_i.max_mod_square_relative_super_track;
                int j_max=min(i+this.NB_TRACKS_PGCD-1,tab_infos_ok.length-1);
                for (int j=i;j<=j_max;j++) {//[i,i],[i,i+1],[i,i+2]
                    if_ok_j=(InfoTrack)tab_infos_ok[j];
                    f_fond_j=if_ok_j.f_reelle_super_track;
                    if (j!=i){
                        ok=Math.abs(f_fond_i-f_fond_j)>this.F_MINI;
                    }
                    if (ok) {
                        f_fond_ij=this.PGCD(f_fond_i,f_fond_j);
                        ok =f_fond_ij>=this.F_MINI;
                    }
                    if (ok) {
                        ok=f_fond_ij<=this.F_MAXI_A_GARDER;
                    }
                    if (ok) {
                        df=find_dans_infos_delta_f(f_fond_ij,infos_deltaf);
                        if (df==null) {
                            df=new InfoDeltaF();
                            if (infos_deltaf ==null) infos_deltaf=new LinkedList();
                            infos_deltaf.add((Object)   df);
                            df.n0_intersection=df.n0_union=if_ok_i.n0_reel_super_track;
                            df.n1_intersection=df.n1_union=if_ok_i.n1_reel_super_track;
                            
                        }
                        df.nb_pistes++;
                        poids_j=if_ok_j.max_mod_square_relative_super_track;
                        poids_ij=(float)Math.sqrt(poids_i*poids_j);
                        //  poids_ij*=f_fond_ij*f_fond_ij/(f_fond_i*f_fond_j);
                        df.f0*=df.poids;
                        df.f0+=poids_ij*f_fond_ij;
                        df.poids+=poids_ij;
                        df.f0/=df.poids;
                        df.delta_f=df.f0;
                        // calcul debut et fin de l'union des pistes mises en jeu
                        df.n0_union=min(df.n0_union,if_ok_i.n0_reel_super_track);
                        df.n0_union=min(df.n0_union,if_ok_j.n0_reel_super_track);
                        df.n1_union=max(df.n1_union,if_ok_i.n1_reel_super_track);
                        df.n1_union=max(df.n1_union,if_ok_j.n1_reel_super_track);
                        // calcul debut et fin de l'intersection des pistes mises en jeu
                        df.n0_intersection=max(df.n0_intersection,if_ok_i.n0_reel_super_track);
                        df.n0_intersection=max(df.n0_intersection,if_ok_j.n0_reel_super_track);
                        df.n1_intersection=min(df.n1_intersection,if_ok_i.n1_reel_super_track);
                        df.n1_intersection=min(df.n1_intersection,if_ok_j.n1_reel_super_track);
                        
                    }
                } // for j
            } // if ok
        }// for i
        return infos_deltaf;
    }
    
    private Interval[] regroupe_intervals(Interval[] its,float duree_min_interval_s) {
        int DUREE_MIN_INTERVAL_ECHS=(int)(duree_min_interval_s*this.F_ECH);
        LinkedList new_its=null;
        float coeff_demi_ton=(float)Math.exp(this.LOG_DEMI_TON/2);
        float un_sur_coeff_demi_ton=1f/coeff_demi_ton;
        if (its==null) return null;
        if (its.length<2) return its;
        Interval old_it=its[0];
        for (int i=1;i<its.length;i++) {
            Interval it=its[i];
            boolean ok=it.notes!=null;
            if (ok) ok=it.n0==old_it.n1;
            if (ok) ok=old_it.notes!=null;
            if (ok) {
                float rf=old_it.notes[0].frequences/it.notes[0].frequences;
                ok=(rf<=coeff_demi_ton)&&(rf>=un_sur_coeff_demi_ton);
            }
            if (ok) {
                float f_moy=it.notes[0].frequences*it.notes[0].poids
                        +old_it.notes[0].frequences*old_it.notes[0].poids;
                f_moy/=(it.notes[0].poids+old_it.notes[0].poids);
                it.n0=old_it.n0;
                it.notes[0].poids+=old_it.notes[0].poids;
                it.notes[0].frequences=f_moy;
            }
            if (!ok) {
                //ecriture old_it, si suffisament long
                if ((old_it.n1-old_it.n0+1)>DUREE_MIN_INTERVAL_ECHS) {
                    if (new_its==null) new_its=new LinkedList();
                    new_its.add((Object)old_it);
                }
            }
            old_it=it;
        }
        
        if ((old_it.n1-old_it.n0+1)>DUREE_MIN_INTERVAL_ECHS) {
            //ne pasoublier d'ajouter le dernier
            if (new_its==null) new_its=new LinkedList();
            new_its.add((Object)old_it);
        }
        if (new_its==null) return null;
        Object[] Obs=new_its.toArray();
        Interval[] out_its =new Interval[Obs.length];
        for (int i=0;i<Obs.length;i++) {
            out_its[i]=(Interval) Obs[i];
        }
        return out_its;
    }
    private Interval[]get_only_intervals_of_sufficient_length(Interval[] its,float duree_min_interval_s) {
        int DUREE_MIN_INTERVAL_ECHS=(int)(duree_min_interval_s*this.F_ECH);
        LinkedList new_its=null;
        float coeff_demi_ton=(float)Math.exp(this.LOG_DEMI_TON/2);
        float un_sur_coeff_demi_ton=1f/coeff_demi_ton;
        if (its==null) return null;
        if (its.length<1) return null;
        for (int i=0;i<its.length;i++) {
            Interval it=its[i];
            boolean ok=it.notes!=null;
            if (ok) ok=(it.notes[0].n1_union-it.notes[0].n0_union)>=DUREE_MIN_INTERVAL_ECHS;
            if (ok) {
                if (new_its==null) new_its=new LinkedList();
                new_its.add((Object)it);
            }
        }
        
        if (new_its==null) return null;
        Object[] Obs=new_its.toArray();
        Interval[] out_its =new Interval[Obs.length];
        for (int i=0;i<Obs.length;i++) {
            out_its[i]=(Interval) Obs[i];
        }
        return out_its;
    }
    
    public Interval getInterval_containing_n_reel(Interval[] Intervals, int n_reel) {
        if (Intervals==null) return null;
        for (int i=0;i<Intervals.length;i++) {
            if (Intervals[i].n0<=n_reel){
                if (Intervals[i].n1>=n_reel){
                    return Intervals[i];
                }
                
            }
        }
        return null;
    }
    
    private void met_a_jour_max_better_mean_mod_square_dans_memoires() {
        int i;
        MemoireClcDetect mem,mem_prec=null;
        float max_better_mean_mod_square=0f,max_better_mod_square=0f,tmp;
        // parcours des memoires, sens montant
        for(i=1;i<this.tab_memoire_detect.length;i++) {
            mem=tab_memoire_detect[i];
            if (mem!=null) {
                if (mem.is_in_interval) {
                    if (mem_prec!=null) {
                        // precedent, avec poids (Fi-1/Fi)^2
                        tmp=mem_prec.info_detection.FCentraleReelle/mem.info_detection.FCentraleReelle;
                        tmp=tmp*tmp;// Oubli en F^2
                        max_better_mean_mod_square*=tmp;
                        max_better_mod_square*=tmp;
                    }
                    // courant =max precedent, courant
                    max_better_mean_mod_square=Math.max(mem.max_better_mean_mod_square,max_better_mean_mod_square);
                    mem.max_better_mean_mod_square=max_better_mean_mod_square;
                    max_better_mod_square=Math.max(mem.max_better_mod_square,max_better_mod_square);
                    mem.max_better_mod_square=max_better_mod_square;
                    mem_prec=mem;
                }
            }
        }
        // parcours des memoires, sens descendant
        mem_prec=null;max_better_mean_mod_square=0f;max_better_mod_square=0f;
        for(i=this.tab_memoire_detect.length-1;i>=1;i--) {
            mem=tab_memoire_detect[i];
            if (mem!=null) {
                if (mem.is_in_interval) {
                    if (mem_prec!=null) {
                        // precedent, avec poids (Fi/Fi+1)^2
                        tmp=mem.info_detection.FCentraleReelle/mem_prec.info_detection.FCentraleReelle;
                        tmp=tmp*tmp;// Oubli en F^2
                        max_better_mean_mod_square*=tmp;
                        max_better_mod_square*=tmp;
                    }
                    // courant =max precedent, courant
                    max_better_mean_mod_square=Math.max(mem.max_better_mean_mod_square,max_better_mean_mod_square);
                    mem.max_better_mean_mod_square=max_better_mean_mod_square;
                    max_better_mod_square=Math.max(mem.max_better_mod_square,max_better_mod_square);
                    mem.max_better_mod_square=max_better_mod_square;
                    mem_prec=mem;
                }
            }
        }
    }
    
    private void init_better_mean_mod_square_relative(LinkedList infos_ok) {
        InfoTrack info_ok;
        if (infos_ok==null) return;
        Iterator it=infos_ok.iterator();
        while (it.hasNext()) {
            info_ok=(InfoTrack) it.next();
            if (info_ok.is_a_super_track) {
                info_ok.mean_mod_square_relative_super_track=info_ok.mean_mod_square_super_track/info_ok.mem.max_better_mean_mod_square;
                info_ok.max_mod_square_relative_super_track=info_ok.max_mod_square_super_track/info_ok.mem.max_better_mod_square;
            }
        }
    }
    
    
    
    
}
