/*
 * MyComparators.java
 *
 * Created on 18 octobre 2006, 15:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

/**
 *
 * @author ygorra
 */

import java.util.*;


public class MyComparators {

  public static Comparator stringComparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        String s1 = (String)o1;
        String s2 = (String)o2;
        int len1 = s1.length();
        int len2 = s2.length();
        int n = Math.min(len1, len2);
        char v1[] = s1.toCharArray();
        char v2[] = s2.toCharArray();
        int pos = 0;

        while (n-- != 0) {
          char c1 = v1[pos];
          char c2 = v2[pos];
          if (c1 != c2) {
            return c1 - c2;
          }
          pos++;
        }
        return len1 - len2;
      }
    };
  }
  public static Comparator InfoNote_decreasing_module_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
          float val1 = -((InfoNote)o1).poids;
        float val2 = -((InfoNote)o2).poids;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
    
}
public static Comparator InfoTrack_decreasing_better_sum_square_module_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        InfoTrack if_ok;
        float val1 = -((InfoTrack) o1).sum_mod_square_super_track;
        float val2 = -((InfoTrack) o2).sum_mod_square_super_track;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
    
}  
public static Comparator InfoTrack_decreasing_sum_square_module_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        float val1 = -((InfoTrack) o1).sum_mod_square;
        float val2 = -((InfoTrack) o2).sum_mod_square;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
    
}
public static Comparator InfoOK_increasing_n0_reel_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        int val1 = ((InfoTrack) o1).n0_reel;
        int val2 = ((InfoTrack) o2).n0_reel;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }
public static Comparator InfoOK_increasing_better_f_reelle_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        float val1 = ((InfoTrack) o1).f_reelle_super_track;
        float val2 = ((InfoTrack) o2).f_reelle_super_track;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }
public static Comparator InfoDeltaF_increasing_delta_f_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        float val1 = ((InfoDeltaF)o1).delta_f;
        float val2 = ((InfoDeltaF)o2).delta_f;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }
public static Comparator InfoDeltaF_decreasing_poids_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        float val1 = ((InfoDeltaF)o1).poids;
        float val2 = ((InfoDeltaF)o2).poids;
        return (val1>val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }

public static Comparator evt_increasing_n_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        int val1 = ((Evt)o1).n;
        int val2 = ((Evt)o2).n;
        if (val1==val2) {
            val1 = ((Evt)o1).type_evt;
            val2 = ((Evt)o2).type_evt;
            
        }
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }
public static Comparator InfoOK_n1_Comparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        int val1 = ((InfoTrack) o1).n1_reel;
        int val2 = ((InfoTrack) o2).n1_reel;
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }

  public static Comparator integerComparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        int val1 = ((Integer)o1).intValue();
        int val2 = ((Integer)o2).intValue();
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }

  public static Comparator dateComparator() {
    return new Comparator() {

      public int compare(Object o1, Object o2) {
        long val1 = ((Date)o1).getTime();
        long val2 = ((Date)o2).getTime();
        return (val1<val2 ? -1 : (val1==val2 ? 0 : 1));
      }
    };
  }
}
