/*
 * NotesDictee.java
 *
 * Created on 21 novembre 2006, 17:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

/**
 *
 * @author ygorra
 */
class NoteDictee {
    public int note_en_demi_ton;
    public boolean note_is_ok=false;
    public float ecart_en_demi_ton=0f;
    
    public boolean note_is_entendue=false;
    
    int n0_reel=0;
    int n1_reel=0;
    
    public boolean affiche_sous_forme_de_diese=true;
    
    int nb_essais=0;
    

    String msg_real=null;
    String msg_ref=null;
    /** Creates a new instance of NotesDictee */
    public NoteDictee() {
    }
    
}
public class NotesDictee {
    public final int seconde_mineure=1;
    public final int seconde_majeure=2;
    public final int tierce_mineure=3;
    public final int tierce_majeure=4;
    public final int quatrieme=5;
    public final int cinquieme_mineure=6;
    public final int cinquieme=7;
    public final int sixieme_mineure=8;
    public final int sixieme=9;
    public final int septieme_mineure=10;
    public final int septieme=10;
    public final int septieme_majeure=11;
    public final int huitieme=12;
    public final int neuvieme_bemol=seconde_mineure+12;
    public final int neuvieme= seconde_majeure+12;
    public boolean ascendant=false;
    public boolean begin_at_0=true;
    public boolean descendant=false;
    public boolean accord_majeur=false;
    public boolean accord_mineur=false;
    public boolean accord_septieme_majeur=false;
    public boolean accord_septieme=false;
    public int nb_notes=2;
    public boolean accords;
    public void reset_dictee() {
        intervalles=new boolean[neuvieme+1];
        ascendant=true;
        descendant=false;
        accord_majeur=false;
        accord_mineur=false;
        accord_septieme_majeur=false;
        accord_septieme=false;
        nb_notes=2;
    }
    public void set_intervalles(boolean[] itvs) {
        if (itvs==null) return;
        if (itvs.length!=intervalles.length) return;
        for (int i=0;i<itvs.length;i++) intervalles[i]=itvs[i];
    }
    public void add_intervalle(int intervalle) {
        if (intervalle<1) return;
        if (intervalles==null) return;
        if (intervalle>=intervalles.length) return;
        intervalles[intervalle]=true;
    }
    public NoteDictee[] getDictee_n_notes_from_intervalles(int nb_notes,int note_min_demi_ton,int note_max_demi_ton){
        if (nb_notes<=0) return null;
        if (intervalles==null) return null;
        int nb_ecarts_possibles=0;
        int nb_ecarts_meme_note=0;
        if (intervalles[0]==true) nb_ecarts_meme_note=1;
        int nb_ecarts_descendants=0,nb_ecarts_ascendants=0;
        for (int i=1;i<intervalles.length;i++) {
            if (intervalles[i]==true) {
                nb_ecarts_ascendants++;
            }
        }
        nb_ecarts_descendants=nb_ecarts_ascendants;
        if (this.ascendant==false) {
            nb_ecarts_ascendants=0;
        }
        if (this.descendant==false) {
            nb_ecarts_descendants=0;
        }
        nb_ecarts_possibles=nb_ecarts_meme_note+nb_ecarts_descendants+nb_ecarts_ascendants;
        if (nb_ecarts_possibles<=0) return null;
        
        int []ecart=new int[nb_ecarts_possibles];
        int k=0;
        for (int i=0;i<nb_ecarts_meme_note;i++) {
            ecart[k++]=0;
        }
        
        if (this.ascendant==true)  {
            // intervalles ascendants
            for (int i=1;i<intervalles.length;i++) {
                if (intervalles[i]==true) ecart[k++]=i;
            }
        }
        if (this.descendant==true)  {
            // intervalles descendants
            for (int i=1;i<intervalles.length;i++) {
                if (intervalles[i]==true) ecart[k++]=-i;
            }
        }
        NoteDictee[] nd=new NoteDictee[nb_notes];
        boolean affiche_diese=Math.random()>=0.5;
        int i0=0;
        int max_ecart=0;
        int min_ecart=0;
        if (this.begin_at_0) {
            nd[0]=new NoteDictee();
            nd[0].note_en_demi_ton=0;
            nd[0].affiche_sous_forme_de_diese=affiche_diese;
            i0=1;
        }
        for (int i=i0;i<nd.length;i++) {
            
            int numero_ecart=(int) Math.floor(nb_ecarts_possibles*0.9999*Math.random());
            nd[i]=new NoteDictee();
            nd[i].affiche_sous_forme_de_diese=affiche_diese;
            nd[i].note_en_demi_ton=ecart[numero_ecart];
            if (i==0) {
                min_ecart=max_ecart=ecart[numero_ecart];
            } else{
                
                max_ecart=ecart[numero_ecart]>max_ecart?ecart[numero_ecart]:max_ecart;
                min_ecart=ecart[numero_ecart]<min_ecart?ecart[numero_ecart]:min_ecart;
            }
        }
        // note de depart
        note_max_demi_ton-=max_ecart;
        note_min_demi_ton-=min_ecart;
        if (note_max_demi_ton<note_min_demi_ton) return null;
        int note_depart=(int) Math.floor((note_max_demi_ton-note_min_demi_ton+1)*0.9999*Math.random());
        note_depart+=note_min_demi_ton;
        for (int i=0;i<nd.length;i++) {
            nd[i].msg_ref=String.valueOf(nd[i].note_en_demi_ton);
            nd[i].note_en_demi_ton+=note_depart;
        }
        return nd;
        
    }
    
    public boolean[] intervalles=new boolean[neuvieme+1];
    /** Creates a new instance of NotesDictee */
    public NotesDictee() {
        
    }
    
}
