/*
 * PlotFiltersAndDataCanvas.java
 *
 * Created on 18 octobre 2006, 08:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Graphics;
import java.util.Iterator;

/**
 *
 * @author ygorra
 */
public class PlotFiltersAndDataCanvas extends Canvas {
    private PlotFiltersAndData sender;
    private MemoireClcDetect memoire;
    private min_max_float[] min_max_float_mod2_plus;
    
    private min_max_float[] min_max_float_w_inst_plus;
    
    private min_max_float[] min_max_float_mod2_moins;
    private min_max_float[] min_max_float_w_inst_moins;
    
    private min_max_float[] min_max_float_delta_w_inst;
    private min_max_float[] min_max_float_retard_de_groupe;
    private min_max_float[] min_max_float_x;
    
    private min_max_short min_max_buffer_short;
    
    private int i_memoire;
    
    public void init_min_max_float(){
        min_max_buffer_short=new min_max_short(sender.buffer_short);
        min_max_float_mod2_plus=new min_max_float[sender.tab_mod2_plus.length];
        for (int i=1;i<sender.tab_mod2_plus.length;i++) {
            if (sender.tab_mod2_plus[i]!=null) {
                min_max_float_mod2_plus[i]=new min_max_float(sender.tab_mod2_plus[i]);
            }
        }
        min_max_float_w_inst_moins=new min_max_float[sender.tab_w_inst_moins.length];
        for (int i=1;i<sender.tab_w_inst_moins.length;i++) {
            if (sender.tab_w_inst_moins[i]!=null) {
                min_max_float_w_inst_moins[i]=new min_max_float(sender.tab_w_inst_moins[i]);
            }
        }
        min_max_float_w_inst_plus=new min_max_float[sender.tab_w_inst_plus.length];
        for (int i=1;i<sender.tab_w_inst_plus.length;i++) {
            if (sender.tab_w_inst_plus[i]!=null) {
                min_max_float_w_inst_plus[i]=new min_max_float(sender.tab_w_inst_plus[i]);
            }
        }
        min_max_float_delta_w_inst=new min_max_float[sender.tab_delta_w_inst.length];
        for (int i=1;i<sender.tab_delta_w_inst.length;i++) {
            if (sender.tab_delta_w_inst[i]!=null) {
                min_max_float_delta_w_inst[i]=new min_max_float(sender.tab_delta_w_inst[i]);
            }
        }
        min_max_float_mod2_moins=new min_max_float[sender.tab_mod2_moins.length];
        for (int i=1;i<sender.tab_mod2_moins.length;i++) {
            if (sender.tab_mod2_moins[i]!=null) {
                min_max_float_mod2_moins[i]=new min_max_float(sender.tab_mod2_moins[i]);
            }
        }
        min_max_float_retard_de_groupe=new min_max_float[sender.tab_retard_de_groupe.length];
        for (int i=1;i<sender.tab_retard_de_groupe.length;i++) {
            if (sender.tab_retard_de_groupe[i]!=null) {
                min_max_float_retard_de_groupe[i]=new min_max_float(sender.tab_retard_de_groupe[i]);
            }
        }
        min_max_float_x=new min_max_float[sender.tab_x.length];
        for (int i=1;i<sender.tab_x.length;i++) {
            MemoireClcDetect mem=sender.Contexte.tab_memoire_detect[i];
            boolean ok=mem!=null;
            if (ok){ok=mem.is_in_interval;}
            if (ok) {ok=this.sender.stocke_data==true;}
            if (ok) {
                min_max_float_x[i]=new min_max_float(sender.tab_x[i]);
                // decalage  min et max sur echelles, pour prise en compte du retard de groupe
                min_max_float_x[i].max_data+=mem.info_detection.retard_de_groupe_bessel/mem.info_detection.coeff_decimation;
                min_max_float_x[i].min_data+=mem.info_detection.retard_de_groupe_bessel/mem.info_detection.coeff_decimation;
            }
        }
        
    }
    PlotFiltersAndDataCanvas(PlotFiltersAndData sender_) {
        sender=sender_;
        init_min_max_float();
        set_memoire(1);
    }
    public void set_memoire(int i_mem_) {
        i_memoire=0;
        memoire=null;
        if (sender==null) return;
        if (sender.Contexte==null) return;
        if (sender.Contexte.tab_memoire_detect==null) return;
        i_memoire=i_mem_;
        if (i_memoire<1) {i_memoire=0;return;}
        if (i_memoire>sender.Contexte.tab_memoire_detect.length) {i_memoire=0;return;}
        memoire=sender.Contexte.tab_memoire_detect[i_memoire];
        this.repaint();
    }
    
    public void draw_info_ok_detection(Graphics g,echelle_graphique echelle_x,echelle_graphique echelle_w,echelle_graphique echelle_m) {
        float f_reelle;
        float w_inst_moyenne;
        float module_moyen;
        float debut;
        float fin;
        int x0,x1;
        int y_w,y_m;
        MemoireClcDetect mem;
        InfoDetection info_detection;
        InfoTrack info_ok;
        Iterator iterator;
        mem= memoire;
        this.sender.Contexte.compute_super_tracks(this.sender.Contexte.infos_tracks);
        iterator = sender.Contexte.infos_tracks.iterator();
        while (iterator.hasNext()) {
            info_ok=  (InfoTrack)(iterator.next());
            if (info_ok.mem.info_detection.indice_dans_tab_memoire_detect==mem.info_detection.indice_dans_tab_memoire_detect){
                if (info_ok.is_a_super_track) {
                    g.setColor(Color.RED);// La meilleure note en rouge
                } else {
                    g.setColor(Color.BLUE);
                    
                }
                // calcul debut et fin
                debut =(float) (info_ok.n0_ok_decim);
                fin =(float) (info_ok.n0_ok_decim+info_ok.nb_ok_decim-1);
                x0=echelle_x.getPixel(debut);
                x1=echelle_x.getPixel(fin);
                // calcul w_inst_moyenne
                w_inst_moyenne=info_ok.sum_w_inst/info_ok.sum_mod_square;
                y_w=echelle_w.getPixel(w_inst_moyenne);
                f_reelle=w_inst_moyenne*mem.freq_reelle_sur_w_inst;
                f_reelle+=mem.info_detection.FCentraleReelle;
                // calcul module moyen
                module_moyen=(float)Math.sqrt(info_ok.mean_mod_square);
                y_m=echelle_m.getPixel(module_moyen);
                // traces des infos
                g.drawLine(x0,y_w,x1,y_w);
                g.drawLine(x0,y_m,x1,y_m);
            }// if meme memoire
            
        }
        
    }
    public void paint(Graphics g){
        int i,width,height;
        width = getSize().width;
        height = getSize().height;
        int x0,x1;
        int y0,y1;
        
        // draw the rows
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        if (sender==null) return;
        if (memoire==null) return;
        if (i_memoire==0) {
            g.drawString("PAS DE DATA POUR LE FILTRE"+String.valueOf(i_memoire),20,this.getHeight()/2);
            return;
        }
        int nb_courbes=5;
        float h_courbe=1.0f/nb_courbes;
        int i_courbe=0;
        int n0=0;
        if (sender.tab_mod2_plus[i_memoire]==null) {
            g.setColor(Color.WHITE);
            g.fillRect(1,1,this.getWidth()-1,this.getHeight()-1);
            g.setColor(Color.RED);
            g.drawString("UNUSED MEMORY",10,this.getHeight()/2);
            return;
        }
        int n1=sender.tab_mod2_plus[i_memoire].length-1;
        Drawing.draw_float_xy("module plus",g,
                Color.RED,Color.LIGHT_GRAY,Color.DARK_GRAY,
                sender.tab_x[i_memoire],sender.tab_mod2_plus[i_memoire],
                this.min_max_float_x[i_memoire],this.min_max_float_mod2_plus[i_memoire],
                0.0f,i_courbe*h_courbe,
                1.0f,(i_courbe+1)*h_courbe,
                n0,n1,this.getWidth(),this.getHeight());
        echelle_graphique ech_m=new echelle_graphique(i_courbe*h_courbe,(i_courbe+1)*h_courbe,
                getHeight()-1,1,
                min_max_float_mod2_plus[i_memoire].min_data,min_max_float_mod2_plus[i_memoire].max_data);
        i_courbe++;
        Drawing.draw_float_xy("w_inst_plus",
                g,Color.RED,Color.WHITE,Color.DARK_GRAY,
                sender.tab_x[i_memoire],sender.tab_w_inst_plus[i_memoire],
                this.min_max_float_x[i_memoire],this.min_max_float_w_inst_plus[i_memoire],
                0.0f,i_courbe*h_courbe,
                1.0f,(i_courbe +1)*h_courbe,
                n0,n1,this.getWidth(),this.getHeight());
        echelle_graphique ech_w=new echelle_graphique(i_courbe*h_courbe,(i_courbe+1)*h_courbe,
                getHeight()-1,1,
                min_max_float_w_inst_plus[i_memoire].min_data,min_max_float_w_inst_plus[i_memoire].max_data);
        i_courbe++;
        Drawing.draw_float_xy("delta_w_inst",
                g,Color.RED,Color.ORANGE,Color.BLACK,
                sender.tab_x[i_memoire],sender.tab_delta_w_inst[i_memoire],
                this.min_max_float_x[i_memoire],this.min_max_float_delta_w_inst[i_memoire],
                0.0f,i_courbe*h_courbe,
                1.0f,(i_courbe+1)*h_courbe,
                n0,n1,this.getWidth(),this.getHeight());
        i_courbe++;
        Drawing.draw_float_xy("retard de groupe",
                g,Color.RED,Color.LIGHT_GRAY,Color.BLACK,
                sender.tab_x[i_memoire],sender.tab_retard_de_groupe[i_memoire],
                this.min_max_float_x[i_memoire],this.min_max_float_retard_de_groupe[i_memoire],
                0.0f,i_courbe*h_courbe,
                1.0f,(i_courbe+1)*h_courbe,
                n0,n1,this.getWidth(),this.getHeight());
        i_courbe++;
        int n0_buffer=n0*memoire.info_detection.coeff_decimation;
        int n1_buffer=n1*memoire.info_detection.coeff_decimation;
        Drawing.draw_short("data",
                g,Color.RED,Color.LIGHT_GRAY,Color.BLACK,
                sender.buffer_short,
                this.min_max_buffer_short,
                0.0f,i_courbe*h_courbe,
                1.0f,(i_courbe+1)*h_courbe,
                n0_buffer,n1_buffer,this.getWidth(),this.getHeight());
        i_courbe++;
        // AFFICHAGE infos_tracks
        echelle_graphique ech_x=new echelle_graphique(0.0f,1.0f,1,getWidth()-1,min_max_float_x[i_memoire].min_data,min_max_float_x[i_memoire].max_data);
        this.draw_info_ok_detection(g,ech_x,ech_w,ech_m);
        // AFFICHAGE RETARD DE GROUPE DU FILTRE
        echelle_graphique echelle_temps=new echelle_graphique(0.0f,1.0f,1,getWidth()-1,n0_buffer,n1_buffer);
        x0=(n0_buffer+n1_buffer)/2;
        x1=echelle_temps.getPixel((float)(x0+memoire.info_detection.retard_de_groupe_bessel/2));
        x0=echelle_temps.getPixel((float)(x0-memoire.info_detection.retard_de_groupe_bessel/2));
        g.setColor(Color.RED);
        g.drawLine(x0,getHeight()-1,x1,getHeight()-1);
        g.drawLine(x0,1,x0,getHeight()-1);
        g.drawLine(x1,1,x1,getHeight()-1);
        
        
    }
}