/*
 * PlotNotesPlotPanel.java
 *
 * Created on 9 octobre 2006, 12:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package AnaSon;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Iterator;
import java.util.LinkedList;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.LineUnavailableException;
import javax.sound.sampled.TargetDataLine;
import javax.swing.JPanel;

/**
 *
 * @author ygorra
 */
public class PlotNotesPlotPanel extends JPanel implements MouseListener{
    public void mousePressed(MouseEvent e) {
        
    }
    
    public void mouseReleased(MouseEvent e) {
        
    }
    
    public void mouseEntered(MouseEvent e) {
        
    }
    public void mouseExited(MouseEvent e) {
        
    }
    
    public void mouseClicked(MouseEvent e) {
        if (e.getButton()==e.BUTTON1) mouseClickedButton1(e);
        if (e.getButton()==e.BUTTON2) mouseClickedButton2(e);
        if (e.getButton()==e.BUTTON3) mouseClickedButton3(e);
    }
    public void mouseClickedButton1(MouseEvent e) {
        n_reel_mouse=0;
        if (e.getButton()!=e.BUTTON1) return;
        if (this.notes==null) return;
        int x=e.getPoint().x;
        int y=e.getPoint().y              ;
        echelle_graphique echelle_x = new echelle_graphique(
                0f,1f,
                notes.echelle_x_partition.x0     ,notes.echelle_x_partition.x1    ,
                min_n0_reel, max_n1_reel);
        int n_reel=(int) Math.round(echelle_x.getRealValue(x));
        if (n_reel>=max_n1_reel) return;
        if (n_reel<=min_n0_reel) return;
        if (ne_pas_utiliser_notes_a_afficher==true){return;}
        notes_a_afficher=Contexte.get_better_info_ok_containing_n_reel(this.infos_ok,n_reel);
        interval_a_afficher=this.Contexte.getInterval_containing_n_reel(this.Intervals,n_reel);
        if ((notes_a_afficher==null)&&(interval_a_afficher==null)) return;
        n_reel_mouse=n_reel;
        
        // Trace des touches piano actives
        this.repaint();
        //     MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,infos_tracks);
        
    }
    public void mouseClickedButton2(MouseEvent e) {
        this.adjust_notes=false;
        if (this.notes==null) return;
        
        MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,this.Intervals,this.adjust_notes);
        
    }
    public void mouseClickedButton3(MouseEvent e) {
        this.adjust_notes=false;
        if (this.notes==null) return;
        
        //   MyPlayer m=new MyPlayer(this.sender,this.Contexte, this.format,this.Fondamentales,this.adjust_notes);
        
    }
    
    LinkedList infos_ok;
    int width, height;
    final int SIGNAL=0;
    final int FREQUENCE=1;
    
    MemoireClcDetect [] local_tab_memoire_detect;
    short min_value,max_value;
    short [] local_data;
    short [] local_buffer_short;
    byte [] local_buffer_byte;
    /* for frequency */
    
    float MIN_LOG_FREQUENCE;
    float MAX_LOG_FREQUENCE;
    float [] frequ_en_demi_ton;
    Object [] tab_infos_ok;
    float amp_frequence[];
    int ind_frequence[];
    float max_frequence_en_demi_ton;
    
    float min_frequence_en_demi_ton;
    
    private float min_amp_frequence;
    
    private float max_amp_frequence;
    
    int max_n0_reel;
    
    int min_n0_reel;
    
    int min_n1_reel;
    
    int max_n1_reel;
    NotesEtFrequences notes;
    float[] tab_f_moins_en_demi_ton;
    float[] tab_f_plus_en_demi_ton;
    
    
    float F_ECH;
    
    ContexteFlts Contexte;
    
    float x0_partition_relative=0f;
    float x1_partition_relative=0.9f;
    float x0_module_relative=0.9f;
    float x1_module_relative=1f;
    float y0_partition_relative=0f;
    float y1_partition_relative=1f;
    
    int min_frequence_en_demi_ton_int;
    
    
    int max_frequence_en_demi_ton_int;
    
    public AnalyseDeSon sender;
    
    private boolean ne_pas_utiliser_notes_a_afficher=true;
    
    private LinkedList notes_a_afficher=null;
    public Interval interval_a_afficher=null;
    
    public AudioFormat format;
    
    private LinkedList Fondamentales=null;
    
    private boolean adjust_notes;
    
    public Interval[] Intervals;
    
    private int n_reel_mouse=0;

    private echelle_graphique echelle_x_module=null;
    
    
    
    
    int n0,n1;
    
    
    
    public PlotNotesPlotPanel(AnalyseDeSon sender_,ContexteFlts Contexte_,int w,int h,AudioFormat format_){
        sender=sender_;
        Contexte=Contexte_;
        F_ECH=Contexte.F_ECH;
        format =format_;
        notes =new NotesEtFrequences(Contexte.F_MINI,Contexte.F_MAXI,Contexte.F_LA);
        max_frequence_en_demi_ton_int=notes.NOTE_MAXI_FROM_DO_0_EN_COURS;
        min_frequence_en_demi_ton_int=notes.NOTE_MINI_FROM_DO_0_EN_COURS;;
        
        setSize(width = w, height = h);
        init_info_ok_detection();
        this.n0=0;
        this.n1=-1;
        if ( frequ_en_demi_ton!=null ) {
            this.n1=frequ_en_demi_ton.length-1;
        }
        addMouseListener(this);
        
    }
    public void compute_min_max_frequence(int n0,int n1) {
        InfoTrack info_ok;
        if (this.frequ_en_demi_ton==null) {return;}
        if (n0<0) {n0=0;}
        if (n1>frequ_en_demi_ton.length-1) {n1=frequ_en_demi_ton.length-1;}
        if ( n1<n0 ) {return;}
        min_frequence_en_demi_ton=frequ_en_demi_ton[n0];
        max_frequence_en_demi_ton=frequ_en_demi_ton[n0];
        info_ok=(InfoTrack ) (tab_infos_ok[n0]);
        max_n0_reel=min_n0_reel=info_ok.n0_reel;
        max_n1_reel=min_n1_reel=info_ok.n1_reel;
        min_amp_frequence=amp_frequence[n0];
        max_amp_frequence=amp_frequence[n0];
        for (int i=n0;i<=n1;i++){
            info_ok=(InfoTrack) tab_infos_ok[i];
            min_n0_reel=Math.min(min_n0_reel,info_ok.n0_reel);
            max_n0_reel=Math.max(max_n0_reel,info_ok.n0_reel);
            min_n1_reel=Math.min(min_n1_reel,info_ok.n1_reel);
            max_n1_reel=Math.max(max_n1_reel,info_ok.n1_reel);
            min_frequence_en_demi_ton=Math.min(min_frequence_en_demi_ton,frequ_en_demi_ton[i]);
            max_frequence_en_demi_ton=Math.max(max_frequence_en_demi_ton,frequ_en_demi_ton[i]);
            min_amp_frequence=Math.min(min_amp_frequence,amp_frequence[i]);
            max_amp_frequence=Math.max(max_amp_frequence,amp_frequence[i]);
        }
        if (max_frequence_en_demi_ton==min_frequence_en_demi_ton) { max_frequence_en_demi_ton+=0.5f ;min_frequence_en_demi_ton-=0.5f;}
        if (max_n1_reel==min_n0_reel) { max_n1_reel+=1 ;min_n0_reel-=1;}
    }
    
    public void compute_min_max(int n0,int n1) {
        if (n1>=n0) {
            min_value=local_data[n0];
            max_value=local_data[n0];
        } else {
            min_value=-1;
            max_value=1;
            
        }
        for (int i=n0;i<=n1;i++){
            if (local_data[i]<min_value) { min_value=local_data[i];}
            if (local_data[i]>max_value) { max_value=local_data[i];}
        }
        if (max_value==min_value) { max_value+=1 ;min_value-=1;}
    }
    public int GetNB_FREQUENCES() {
        if (infos_ok==null) {return 0;}
        return infos_ok.size();
    }
    public void init_info_ok_detection() {
        MemoireClcDetect[] tab_mem=Contexte.tab_memoire_detect;
        MemoireClcDetect mem;
        float f_reelle,f_reelle_en_demi_ton;
        int i,i_f;
        InfoDetection info_detection;
        InfoTrack info_ok;
        Iterator iterator;
        max_frequence_en_demi_ton=-1000.0f;
        min_frequence_en_demi_ton=1000.0f;
        if (tab_mem==null) {
            infos_ok=null;
            frequ_en_demi_ton=null;
            amp_frequence=null;
            ind_frequence=null;
            return;
        }
        
        Contexte.compute_super_tracks(Contexte.infos_tracks);// marquage des meilleures notes
        infos_ok=Contexte.infos_tracks;
        Fondamentales=null;
        Contexte.SEUIL_MOD2_RELATIVE_FOR_NOTES=sender.SEUIL_MOD2_RELATIVE_FOR_NOTES;
         Contexte.SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS=sender.SEUIL_MOD2_RELATIVE_FOR_SUPER_TRACKS;
       Contexte.SEUIL_TEMPS_INTERFERENCES_S=sender.SEUIL_TEMPS_INTERFERENCES_S;
        Contexte.F_MAXI_A_GARDER=sender.F_MAXI_A_GARDER;
        Contexte.NB_TRACK_VALID_NOTE=sender.NB_TRACK_VALID_NOTE;
        Intervals=Contexte.get_intervals_from_infos_tracks(infos_ok
                ,sender.SEUIL_DUREE_MIN_INTERVAL_S
                ,sender.SEUIL_DISPARITION_NOTE_PREC_S
                ,sender.SEUIL_APPARITION_HMS_S
                ,sender.NB_PISTES_MIN_INTERVAL
                ,sender.NB_TRACK_ENERGY);
        Contexte.affiche_notes(Intervals);
        //  Contexte.affiche_notes_Assuming_First_is_DO_4(this.Fondamentales);
        //  Contexte.affiche_notes_Assuming_First_is_GOOD(this.Fondamentales);
        //  notes.CalculeNotesJustes(this.Fondamentales);
        int NB_FREQUENCES=GetNB_FREQUENCES();
        if (NB_FREQUENCES >0) {
            tab_infos_ok= infos_ok.toArray();
            frequ_en_demi_ton  =new float[NB_FREQUENCES];
            amp_frequence  =new float[NB_FREQUENCES];
            ind_frequence  =new int[NB_FREQUENCES];
            i_f=0;
            iterator = infos_ok.iterator();
            while (iterator.hasNext()) {
                info_ok=  (InfoTrack)(iterator.next());
                mem=info_ok.mem;
                info_detection=mem.info_detection;
                f_reelle=info_ok.sum_w_inst/info_ok.sum_mod_square;
                f_reelle*=mem.freq_reelle_sur_w_inst;
                f_reelle+=mem.info_detection.FCentraleReelle;
                ind_frequence[i_f]=mem.info_detection.indice_filtre;
                frequ_en_demi_ton[i_f]=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                
                amp_frequence[i_f]=(float) Math.sqrt(info_ok.mean_mod_square);
                i_f++;
                compute_min_max_frequence(0,frequ_en_demi_ton.length-1);
            }
        } else {
            tab_infos_ok=null;
            frequ_en_demi_ton=null;
            amp_frequence=null;
            ind_frequence=null;
        }
        if (tab_mem !=null) {
            tab_f_plus_en_demi_ton=new float[tab_mem.length-1];
            tab_f_moins_en_demi_ton=new float[tab_mem.length-1];
            for (i=1;i<tab_mem.length;i++) {
                mem= tab_mem[i];
                if (mem.is_in_interval) {
                    f_reelle= (float)(mem.seuil_plus_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    tab_f_plus_en_demi_ton[i-1]=f_reelle_en_demi_ton;
                    
                    f_reelle= (float)(mem.seuil_moins_w_inst*mem.freq_reelle_sur_w_inst+mem.info_detection.FCentraleReelle);
                    f_reelle_en_demi_ton=(float) notes.frequence_note_from_do0_en_demi_ton(f_reelle);
                    max_frequence_en_demi_ton=Math.max(f_reelle_en_demi_ton,max_frequence_en_demi_ton);
                    min_frequence_en_demi_ton=Math.min(f_reelle_en_demi_ton,min_frequence_en_demi_ton);
                    tab_f_moins_en_demi_ton[i-1]=f_reelle_en_demi_ton;
                }
            }
        } else {
            tab_f_plus_en_demi_ton=null;
            tab_f_moins_en_demi_ton=null;
        }
        if (max_frequence_en_demi_ton <=min_frequence_en_demi_ton) {
            max_frequence_en_demi_ton=0.5f;
            min_frequence_en_demi_ton=-0.5f;
        }
        if (Intervals!=null) {
           PlotNotesCle p_cle=        new PlotNotesCle("Notes Detectees =f(t) en CLE DE SOL", 500, 500,this); 
        }
        
    }
    
    public void paintComponent(Graphics g) {
        InfoTrack info_ok;
        int i;
        int i_color=0;
        width = getSize().width;
        height = getSize().height;
        int x0,x1;
        int y0,y1;
        // w ou h peuvent changer => reinit systematique des echelles
        notes.init_echelles_partition(this.min_frequence_en_demi_ton_int,
                this.max_frequence_en_demi_ton_int,
                width,height,
                this.x0_partition_relative,this.y0_partition_relative,
                this.x1_partition_relative,this.y1_partition_relative,
                0.05f);
        echelle_graphique echelle_x = new echelle_graphique(
                0f,1f,
                notes.echelle_x_partition.x0     ,notes.echelle_x_partition.x1    ,
                min_n0_reel, max_n1_reel);
        echelle_x_module = new echelle_graphique(
                this.x0_module_relative,this.x1_module_relative,
                1,width-1,
                0f,this.max_amp_frequence);    
        
        g.setColor(Color.WHITE);
        g.fillRect(0,0,width,height);
        g.setColor(Color.WHITE);
        g.fillRect(notes.echelle_x_partition.x0     ,notes.echelle_y_partition.x0,
                notes.echelle_x_partition.largeur,notes.echelle_y_partition.largeur);
        if (this.sender.stocke_data_wav==true) {
            if (tab_f_moins_en_demi_ton!=null){
                i_color=0;
                for (i = 0; i < tab_f_moins_en_demi_ton.length; i++) {
                    i_color=(i+1) & 1;
                    switch(i_color){
                        case 0:g.setColor(Color.YELLOW);break;
                        case 1:g.setColor(Color.ORANGE);break;
                    }
                    i_color++;
                    if (i_color==2) {i_color=0;}
                    y0=notes.echelle_y_partition.getPixel(tab_f_moins_en_demi_ton[i]);
                    y1=notes.echelle_y_partition.getPixel(tab_f_plus_en_demi_ton[i]);
                    
                    x0=echelle_x.getPixel(min_n0_reel);
                    x1=echelle_x.getPixel(max_n1_reel);
                    g.fillRect(x0, y0, x1-x0+1, y0-y1+1);
                    
                    
                }
            }
        }
        notes.draw_partition(g,min_frequence_en_demi_ton_int,max_frequence_en_demi_ton_int);
        draw_touches_piano_actives(g);
        draw_amp_frequences(g);
        if (n_reel_mouse >0) {
            x0=echelle_x.x0;
            g.setColor(Color.RED);
            y0=notes.echelle_y_partition.min_pixel;
            String S="t="+String.valueOf(n_reel_mouse/Contexte.F_ECH);
            if (interval_a_afficher!=null) {
                S=S+",deb="+String.valueOf(interval_a_afficher.n0/Contexte.F_ECH);
                S=S+",Fin="+String.valueOf(interval_a_afficher.n1/Contexte.F_ECH);
                S=S+",Duree="+String.valueOf((interval_a_afficher.n1-interval_a_afficher.n0)/Contexte.F_ECH);
                
                
            }
            g.drawString(S,x0,y0-10);
        }
        if (frequ_en_demi_ton==null) {
            g.setColor(Color.RED);
            g.drawString("NO FREQUENCY TRACK TO DRAW",width/2,height/2);
        } else {
            // trace des intervalles
            if (this.Intervals!=null) {
                Interval it;
                InfoNote nt;
                for (i=0;i<Intervals.length;i++) {
                    it=Intervals[i];
                    if (it.notes!=null) {
                        x0=echelle_x.getPixel(it.n0);
                        x1=echelle_x.getPixel(it.n1);
                        // affiche seulement meilleure note
                        for (int in=0;(in<it.notes.length)&&(in<1);in++) {
                            nt=it.notes[in];
                            if ((nt.frequences>Contexte.F_MINI)&&(nt.frequences<Contexte.F_MAXI)) {
                                y0=notes.echelle_y_partition.getPixel((float) notes.frequence_note_from_do0_en_demi_ton(nt.frequences));
                                y1=y0;
                                g.setColor(Color.ORANGE);
                                g.fillRect(x0,y0-5,x1-x0,10);
                                g.setColor(Color.MAGENTA);
                                g.drawRect(x0,y0-5,x1-x0,10);
                                //    g.drawLine(x0,y0-5,x0,y0+5);
                                //    g.drawLine(x1,y0-5,x1,y0+5);
                                
                            }
                        }
                    }
                }
            }
            // trace des meilleures notes synchrones
            int k_sim;
            for (i = n0; i < n1; i++) {
                info_ok=(InfoTrack) tab_infos_ok[i];
                if ((info_ok.is_a_super_track==true)&&(info_ok.nb_tracks_in_super_track!=1)) {
                    g.setColor(Color.RED);                    
                    y0=notes.echelle_y_partition.getPixel((float) notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track));
                    y1=y0;
                    x0=echelle_x.getPixel(info_ok.n0_reel_super_track);
                    x1=echelle_x.getPixel(info_ok.n1_reel_super_track);
                    g.drawLine(x0, y0, x1, y0);
                    g.drawLine(x0, y0-3, x0, y0+3);
                    g.drawLine(x1, y0-3, x1, y0+3);
                    k_sim=info_ok.num_simultaneous_track;
                    if (k_sim>0) {
                      switch(k_sim&1){
                         case 0:g.setColor(Color.BLUE);break;
                         case 1:g.setColor(Color.RED);break;
                       }
                       g.fillRect(x0-1,y0-3,4,7);               
                   }
                   if (k_sim<-1) {
                     g.setColor(Color.BLACK);
                     g.drawLine(x0-2,y0-3,x0+2,y0+3);
                     g.drawLine(x0-2,y0+3,x0+2,y0-3);
                   }
                    else if (k_sim<0) {
                     g.setColor(Color.RED);
                     g.drawLine(x0-2,y0-3,x0+2,y0+3);
                     g.drawLine(x0-2,y0+3,x0+2,y0-3);
                   }

                }
            }
            // trace de toutes les notes
            for (i = n0; i < n1; i++) {
                info_ok=(InfoTrack) tab_infos_ok[i];
                if ( !info_ok.is_a_super_track ) {
                    i_color=(int) (info_ok.numero_super_track&3);
                    switch(i_color){
                        case 0:g.setColor(Color.CYAN);break;
                        case 1:g.setColor(Color.BLUE);break;
                        case 2:g.setColor(Color.GREEN);break;
                        case 3:g.setColor(Color.LIGHT_GRAY);break;
                    }
                } else {
                    g.setColor(Color.BLACK); // reserve aux notes solitaires
                }
                y0=notes.echelle_y_partition.getPixel(this.frequ_en_demi_ton[i]);
                y1=y0;
                x0=echelle_x.getPixel(info_ok.n0_reel);
                x1=echelle_x.getPixel(info_ok.n1_reel);
                g.drawLine(x0, y0, x1, y1);
            }
        }
        
        if ((frequ_en_demi_ton!=null)||(tab_f_moins_en_demi_ton!=null)) {
        /*
            g.setColor(Color.RED);
            // note maxi
            double f_reelle= notes.frequence_note(this.max_frequence_en_demi_ton);
            note_detaillee detail=notes.details_note(f_reelle);
            y0=notes.echelle_y_partition.getPixel(detail.note_modulo_octave+notes.NB_NOTES_PAR_OCTAVE*detail.octave);
            g.drawString("Note Maxi ="+detail.nom_note_global+", Frequence ="+String.valueOf(Math.round(100.0*detail.frequence_note)/100.0),1,y0+g.getFontMetrics().getHeight());
            // note mini
            f_reelle= notes.frequence_note(this.min_frequence_en_demi_ton);
            detail=notes.details_note(f_reelle);
            y0=notes.echelle_y_partition.getPixel(detail.note_modulo_octave+notes.NB_NOTES_PAR_OCTAVE*detail.octave);
            g.drawString("Note Mini ="+detail.nom_note_global+", Frequence ="+String.valueOf(Math.round(100.0*detail.frequence_note)/100.0),1,y0);
         */
        }
        
    }
    
    private void draw_touches_piano_actives(Graphics g) {
        Color old_color;
        note_detaillee detail;
        InfoTrack info_ok;
        // trace des touches de piano active
        this.ne_pas_utiliser_notes_a_afficher=true ;
        old_color=g.getColor();
        boolean ok;
        float f_reelle_en_demi_ton;
        String noms_notes="";
        if (notes_a_afficher!=null ) {
            
            Contexte.sort_tracks_by_increasing_better_f_reelle(notes_a_afficher);
            Iterator iterator= notes_a_afficher.iterator();
            while (iterator.hasNext()) {
                Object O= iterator.next();
                ok=O!=null;
                if (ok) {
                    
                    info_ok=  (InfoTrack) O;
                    f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track);
                    detail= notes.details_note(notes.frequence_note(f_reelle_en_demi_ton));
                    if (noms_notes=="") {
                        noms_notes="notes reperees = "+detail.nom_note_global;
                    } else{
                        noms_notes=noms_notes+","+detail.nom_note_global;
                    }
                    notes.draw_touche_piano_active(g,f_reelle_en_demi_ton);
                }
            }
        }
        if (interval_a_afficher!=null) {
            if (interval_a_afficher.notes!=null) {
            f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(interval_a_afficher.notes[0].frequences);
            detail= notes.details_note(notes.frequence_note(f_reelle_en_demi_ton));
            if (noms_notes=="") {
                noms_notes="note retenue  = "+detail.nom_note_global;
            } else{
                noms_notes="note retenue = "+detail.nom_note_global+" , "+noms_notes;
            }
            notes.draw_touche_piano_active(g,f_reelle_en_demi_ton);
            }
        }
        if (noms_notes!="") {
            g.setColor(Color.RED);
            g.drawString(noms_notes,notes.echelle_x_partition.x0,notes.echelle_y_partition.x0+g.getFontMetrics().getHeight());
        }
        g.setColor(old_color);
        
        this.ne_pas_utiliser_notes_a_afficher=false ;
    }
    private void draw_amp_frequences(Graphics g) {
        Color old_color;
        note_detaillee detail;
        InfoTrack info_ok;
        MemoireClcDetect mem;
        int x0=0,x1=0,y0=0,y1=0;
        // trace des touches de piano active
        this.ne_pas_utiliser_notes_a_afficher=true ;
        if (notes==null) return;
        if (this.echelle_x_module==null) return;
        if (this.Contexte==null) return;
        if (this.Contexte.tab_memoire_detect==null) return;
        old_color=g.getColor();
        boolean ok;
        float f_reelle_en_demi_ton;
        String noms_notes="";
        // trace des amplitudes maxi
        g.setColor(Color.LIGHT_GRAY);
        g.fillRect(echelle_x_module.x0     ,notes.echelle_y_partition.x0,
                echelle_x_module.largeur,notes.echelle_y_partition.largeur);
        MemoireClcDetect[] tab_mem=Contexte.tab_memoire_detect;
        g.setColor(Color.BLUE);
        for (int i=1;i<tab_mem.length;i++) {
          if (tab_mem[i]!=null) {
            mem=tab_mem[i];
            if (mem.is_in_interval) {
                x0=x1;
                x1=echelle_x_module.getPixel((float)Math.sqrt(mem.max_better_mod_square)); 
                f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(mem.info_detection.FCentraleReelle);
                y0=y1;
                y1=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
            }
          }  
          if ((y0>0)&&(y1>0)) {
            g.drawLine(x0,y0,x1,y1);  
          }
        }  
        g.setColor(Color.RED);
        x0=0;x1=0;y0=0;y1=0;
        for (int i=1;i<tab_mem.length;i++) {
          if (tab_mem[i]!=null) {
            mem=tab_mem[i];
            if (mem.is_in_interval) {
                x0=x1;
                x1=1+echelle_x_module.getPixel((float)Math.sqrt(mem.max_better_mod_square)); 
                f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(mem.info_detection.FCentraleReelle);
                y0=y1;
                y1=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
            }
          }  
          if ((y0>0)&&(y1>0)) {
            g.drawLine(x0,y0,x1,y1);  
          }
        }
        if (notes_a_afficher!=null ) {
            x0=echelle_x_module.getPixel(0f); 
            Iterator iterator= notes_a_afficher.iterator();
            while (iterator.hasNext()) {
                Object O= iterator.next();
                ok=O!=null;
                if (ok) {
                    
                    info_ok=  (InfoTrack) O;
                    if (info_ok.is_a_super_track) {
                      f_reelle_en_demi_ton=(float)notes.frequence_note_from_do0_en_demi_ton(info_ok.f_reelle_super_track);
                      y0=notes.echelle_y_partition.getPixel(f_reelle_en_demi_ton);
                      g.setColor(Color.RED);
                      x1=echelle_x_module.getPixel((float)Math.sqrt(info_ok.max_mod_square_super_track)); 
                      g.drawLine(x0,y0,x1,y0);
                      g.setColor(Color.BLUE);
                      x1=echelle_x_module.getPixel((float)Math.sqrt(info_ok.mean_mod_square_super_track)); 
                      g.drawLine(x0,y0,x1,y0);
                    }
                }
            }
        }
        g.setColor(old_color);
        
        this.ne_pas_utiliser_notes_a_afficher=false ;
    }
    
    
    
    
}

